new;
library pgraph;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "bis-otc-2019";

data = loadd(datFileName);
dates = data[.,1];
total = data[.,2 3 4 5];

n = rows(data);
t = seqa(1998.5,0.5,n);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {3,1};
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pltype = 6; _plwidth = 0;
  xtics(1998.25,2018.5,2,2);
  let xlab = "00" "02" "04" "06" "08" "10" "12" "14" "16" "18";
  asclabel(xlab,0);
  xlabel("\216Year");

  indx = 1;
  setwind(indx);
    _pbartyp = {6 1};
    title("\216Total");
    ytics(0,800,200,2);
    bar(t,total[.,indx]/1e6);

  indx = 2;
  setwind(indx);
    _pbartyp = {6 2};
    title("\216Forwards");
    ytics(0,150,25,2);
    bar(t,total[.,indx]/1e6);

  indx = 3;
  setwind(indx);
    _pbartyp = {6 3};
    title("\216Swaps");
    ytics(0,600,200,2);
    bar(t,total[.,indx]/1e6);

  indx = 4;
  setwind(indx);
    _pbartyp = {6 4};
    title("\216Options");
    ytics(0,100,20,2);
    bar(t,total[.,indx]/1e6);

  endwind;

indx = maxindc(total[.,1]);
t_max = dates[indx];
n_max = total[indx,1]/1e6;
print ftos(t_max,"Date = %lf",3,2);
print ftos(n_max,"Amount = %lf",3,1);