new;
library frm,pgraph;

rndseed 123;

t = seqa(0,1/200,200);
S1 = simulate_GBM(100,-0.50,0.20,t,1);
S1 = S1|60;

x1 = 40; y1 = 40/20;

S2 = simulate_GBM(100,0.10,0.025,t,1);
S2 = S2|S2[rows(S2)]*0.80;

x2 = 20; y2 = 20/2.5;

t = t | 1;

x = seqa(0,1,100);
y = x/100*10;

graphset;
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  xtics(0,1.2,0.2,2);

  setwind(1);
    title("\216Normal risk\L\216DD = 40%");
    _pcolor = 1;
    ytics(50,110,10,2);
    xy(t,S1);

  setwind(2);
    title("\216Abnormal risk\L\216DD = 20%");
    _pcolor = 4;
    ytics(85,115,5,2);
    xy(t,S2);

  setwind(3);
    title("\216Characterization of tail risk");
    xtics(0,80,20,2);
    ytics(0,10,1,2);
    xlabel("\216Drawdown (in %)");
    ylabel("\216Ratio DD/volatility");
    _pline = 1~6~0~3.5~100~3.5~1~0~10;
    s = seqa(0,3,34);
    e = ones(rows(s),1);
    _pline = _pline |
             e.*(1~6)~s~e.*3.5~(s+5)~e.*(4~1~0~6);
    _psym = x1~y1~8~5~1~1~10 |
            x2~y2~8~5~4~1~10 ;
    _pmsgstr = "Tail risk region";
    _pmsgctl = 25~6~0.25~0~1~0~08;


    xy(x,-y);

  endwind;

