new;
library frm,pgraph;

cls;

let w     = 139  75   81;
let mu    = 0.0  0.0  0.0;
let sigma = 0.10 0.12 0.15;

alpha = 0.95;

rho_scalar = seqa(0,1/100,101);
nIters = rows(rho_scalar);
Results = zeros(nIters,3);

iter = 1;
do until iter > nIters;
  rho = diagrv(rho_scalar[iter]*ones(3,3),1.0); 
  cov = rho .* sigma .* sigma';
  {Delta_CoVaR,VaR,CoVaR1,CoVaR0} = Compute_Gaussian_CoVaR(w,mu,cov,alpha); 
  Results[iter,.] = Delta_CoVaR';
  iter = iter + 1;
endo;

VaR = Results[1,.]';
Sum_VaR = sumc(VaR);
e = ones(3,1);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|4;
  xlabel("\216\202r\201 (in %)");
  ylabel("\216\202D\201CoVaR");
  xtics(-25,100,25,2);
  let xlab = "" "0" "25" "50" "75" "100";
  asclabel(xlab,0);
  ytics(10,60,10,2);
  _plegstr = "Bank 1\000Bank 2\000Bank 3";
  _plegctl = {2 5.5 6 2};
  _pmsgstr = "VaR]\202a\201[(Bank 1)\000VaR]\202a\201[(Bank 2)\000VaR]\202a\201[(Bank 3)\000VaR]\202a\201[(Bank 1) + VaR]\202a\201[(Bank 2) + VaR]\202a\201[(Bank 3)";
  _pmsgctl = e*(-23)~VaR-0.25~e.*(0.13~0~1)~_pcolor~e*7|
             25~Sum_VaR+1~0.11~0~1~0~7;
  _pline = 1~3~-25~Sum_VaR~100~sum_VaR~1~0~10;
  xy(100*rho_scalar,Results);
  