new;
library frm,pgraph,optmum;

S = seqa(90,1,21);
K = 100;
sigma = 0.10;
r = 0.05;
b = r;
tau = 0.25;
let S_star = 95 97 99 101 103 105;
e_star = ones(rows(S_star),1);
S_Gamma = seqa(90,0.5,10) |
          seqa(95.5,0.5,3) |
          seqa(97.5,0.5,3) |
          seqa(99.5,0.5,3) |
          seqa(101.5,0.5,3) |
          seqa(103.5,0.5,4) |
          seqa(105.5,0.5,10) ;
e_Gamma = ones(rows(S_Gamma),1);

C = EuropeanBS(S,K,sigma,tau,b,r);
C_star = EuropeanBS(S_star,K,sigma,tau,b,r);
C_Gamma = EuropeanBS(S_Gamma,K,sigma,tau,b,r);

S0 = 98;
C0 = EuropeanBS(S0,K,sigma,tau,b,r);
Delta0 = EuropeanBS_Delta(S0,K,sigma,tau,b,r);
C_Delta = C0 + Delta0 * (S - S0);
C_Delta_Gamma = C0 + Delta0 * (S_Gamma - S0);

pline_Gamma =  e_Gamma.*(1~2)~S_Gamma~C_Gamma~S_Gamma~C_Delta_Gamma~e_Gamma.*(1~2~6);

tau = 0.10;
C_Theta = EuropeanBS(S,K,sigma,tau,b,r);
C_Theta_star = EuropeanBS(S_star,K,sigma,tau,b,r);
C_Theta_Gamma = EuropeanBS(S_Gamma,K,sigma,tau,b,r);

pline_Theta = e_Gamma.*(1~2)~S_Gamma~C_Theta_Gamma~S_Gamma~C_Delta_Gamma~e_Gamma.*(1~4~6);
pline_Theta = selif(pline_Theta,C_Theta_Gamma .<= C_Delta_Gamma);

proc f(S);
  local C1,C2;
  C1 = C0 + Delta0 * (S - S0);
  C2 = EuropeanBS(S,K,sigma,tau,b,r);
  retp((C1 - C2)^2);
endp;

{S1,fmin,grd,retcode} = optmum(&f,90);
C1 = C0 + Delta0 * (S1 - S0);
{S2,fmin,grd,retcode} = optmum(&f,110);
C2 = C0 + Delta0 * (S2 - S0);

S_PnL = seqa(90,0.125,64) |
        seqa(98.125,0.125,101) ;
S_PnL = seqa(90,0.175,165);
e_PnL = ones(rows(S_PnL),1);
C_Delta_PnL = C0 + Delta0 * (S_PnL - S0);
C_Theta_PnL = EuropeanBS(S_PnL,K,sigma,tau,b,r);
clr = C_Delta_PnL .<= C_Theta_PnL;
clr = 2 .* clr + 4 .* (1-clr);
pline_PnL =  e_PnL.*(1~6)~S_PnL~C_Delta_PnL~S_PnL~C_Theta_PnL~e_PnL*1~clr~e_PnL*0;

graphset;
  window(1,2,1);

  fonts("simplex simgrma"); 
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|4;
  _pnumht = 0.20; _paxht = 0.20; _ptitlht = 0.25;
  xlabel("\216Asset price"); 
  xtics(90,110,5,2);
  ytics(-2,8,2,2);
 
  setwind(1);
    title("\216Gamma-theta impact");
    _plegstr = "Option price at time t]0[\000Delta hedging at time t]0[\000Option price at time t";
    _plegctl = {2 5 1.2 5.5};
    _pline = 1~3~S0~-2~S0~C0~1~0~10 |
             1~3~90~C0~S0~C0~1~0~10 |
             pline_Gamma |
             pline_Theta;
    _parrow = S_star~C_star~S_Star~C_Theta_Star~e_star.*(2.0~0.10~21~4~1~6~7) |
              94.25~4.55~104.5~5.5~2.0~0.10~21~2~1~6~10 | 
              94.25~4.55~91.5~-0.5~2.0~0.10~21~2~1~6~10 | 
              104.5~0.50~100~2~1.0~0.10~21~4~1~6~10 ;
    _pmsgstr = "S]0[\000C]0[\000Gamma impact (+)\000Theta impact (-)";
    _pmsgctl = 1.002*S0~-1.8~0.20~0~1~0~6 |
               90.5~1.08*C0~0.175~0~1~0~6 |
               91.5~4.15~0.20~35~1~2~5  |
               103.0~-0.35~0.20~35~1~4~5  ;
    _psym = S0~C0~8~3.5~0~1~10 | 
            94.25~4.55~8~4.5~2~1~10 |
            104.5~0.50~8~4.5~4~1~10 ;

    xy(S,C~C_Delta~C_Theta);

    _pline = 0;
    _parrow = 0;
    _pmsgctl = 0;
    _psym = 0;

  setwind(2);
    title("\216Expected P&L");
    _pline = 1~6~S0~-2~S0~C0~1~0~7 |
             1~6~S1~-2~S1~C1~1~0~7 |
             1~6~S2~-2~S2~C2~1~0~7 |
             pline_PnL;
    _pmsgstr = "+\000-\000-\000+";
    _pmsgctl =  90.50~-0.70~0.50~0~1~2~15  |
                96.350~0.50~0.40~0~1~4~15  |
                99.50~2.00~0.40~0~1~4~15  |
                107.00~6.50~0.50~0~1~2~15  ;
    xy(S,C~C_Delta~C_Theta);

  endwind;

