new;
library frm,pgraph;

S0 = 100;
sigma = 0.20;
r = 0.05;
b = r;
tau = 1.0;

let K  = 90     95      98        100     101     102     105     110;
let C1 = 16.7	13.35	11.55	  10.45	  9.93    9.42	  8.02	  6.04;
let C2 = 18.5   14.5    12.0      10.45   9.6     9.0     7.5     5.7; 
let C3 = 18.0   14      11.8      10.45   9.9     9.5     8.4     7.4; 

ImpVol1 = EuropeanBS_ImpVol(S0,K,tau,b,r,C1);
ImpVol2 = EuropeanBS_ImpVol(S0,K,tau,b,r,C2);
ImpVol3 = EuropeanBS_ImpVol(S0,K,tau,b,r,C3);

C = C1'|C2'|C3';
ImpVol = 100*(ImpVol1'|ImpVol2'|ImpVol3');

print ftosa(C,"%lf",3,2);
print;
print ftosa(ImpVol,"%lf",3,2);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|5;
   _plctrl = 1; _pstype = 8|9|12; _psymsiz = 5;
  xlabel("\216K");
  xtics(88,112,4,2);
  ylabel("\216\202S\201(T,K) (in %)");
  ytics(18,28,2,2);
  _plegstr = "C]1[\000C]2[\000C]3[";
  _plegctl = {2 5 6 5};
  xy(K,100*(ImpVol1~ImpVol2~ImpVol3));