/*
**> Converts a smile curve into a pdf
**
*/

new;
library frm,optmum,pgraph;

S0 = 100;
tau = 10;
r = 0.05;

Sk = 90;
fn smile(K) = 0.25 + ln(1 + 1e-6 .* (K - 90)^2 + 1e-6 .* (K - 180)^2);

K = seqa(1,3,100);

{Sigma,CDF,PDF} = Smile_to_Density(S0,K,&smile,tau,r);

{cdf_ln,pdf_ln} = EuropeanBS_Density(S0,K,0.25,tau,r);

graphset;
  window3u;

  fonts("simplex simgrma");
  _pltype = 6|3; _pframe = 0; _pnum = 2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pcolor = 1|4; _plwidth = 10; _pltype = 6|3;
  xtics(0,300,50,5);
  xlabel("\216K");

setwind(1);
  title("\216Volatility surface");
  ytics(25,27,0.5,2);
  ylabel("\216\202S\201(T,K) (in %)");
  xy(K,100*sigma);

  ylabel("");

setwind(2);
  title("\216Risk-neutral CDF");
  ytics(0,1,0.2,2);
  xy(K,cdf~cdf_ln);

setwind(3);
  _pysci = 1;
  title("\216Risk-neutral PDF");
  ytics(0,7e-3,1e-3,2);
  _plegstr = "Breeden-Litzenberger\000Black-Scholes";
  _plegctl = {2 5 4 4.75};
  xy(K,pdf~pdf_ln);

endwind;