new;
library frm,pgraph,optmum;

cls;

rndseed 123456;
Notional = 100;

S0 = 100;
sigma = 0.20;
K = 100; 
r = 0.05; 
b = r;
mu = r;

tau = 130/260;
C0 = EuropeanBS(S0,K,sigma,tau,r,r);

nS = 100000;

fn Premium_Proc(t,S,r) = EuropeanBS(S,K,sigma,tau-t,r,r);
fn Delta_Proc(t,S,r) = EuropeanBS_Delta(S,K,sigma,tau-t,r,r);

let dt = 1;
t = seqa(0,dt/260,130/dt+1);
PnL_Ratio = zeros(nS,3);
i = 1;
do until i > 3;
  if i == 1;
    sigma = 0.20;
  elseif i == 2;
    sigma = 0.25;
  elseif i == 3;
    sigma = 0.15;
  endif;
  S = Simulate_GBM(S0,mu,sigma,t,nS);
  {Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
  PnL = PnL[rows(PnL),.]';
  PnL_Ratio[.,i] = PnL / (Notional * C0);
  i = i + 1;
endo;

x = seqa(-1.00,2.00/500,501);
d = zeros(rows(x),3);
Pr = zeros(3,1);
i = 1;
do until i > 3;
  {tmp,Pr[i]} = regKernelDensity(PnL_Ratio[.,i],0.0);
  {d[.,i],F} = regKernelDensity(PnL_Ratio[.,i],x);
  i = i + 1;
endo;
d_miss = missex(d, d .<= 1e-2);
  
graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|4;
  xtics(-50,50,10,2);
  ytics(0,11,1,2);
  xlabel("\216\202p\201 (in %)");
  _plegstr = "\202s\201(t) = 20%\000\202s\201(t) = 25%\000\202s\201(t) = 15%";
  _plegctl = {2 5 1.5 5};
  xy(100*x,d_miss);

print ftosa(100*Pr,"%lf",3,2);