new;
library frm,pgraph;

cls;

rndseed 123;
Notional = 100;

S0 = 100;
sigma = 0.20;
K = 100; 
r = 0.05; 
b = r;
mu = r;

tau = 20/52;
t = seqa(0,1,21)/52;
nS = 1;
S = Simulate_GBM(S0,mu,sigma,t,nS);
S = trunc(100*S)/100;

C0 = EuropeanBS(S0,K,sigma,tau,b,r);

fn Premium_Proc(t,S,r) = EuropeanBS(S,K,sigma,tau-t,r,r);
fn Delta_Proc(t,S,r) = EuropeanBS_Delta(S,K,sigma,tau-t,r,r);

{Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,1);

print "       i          ti      S(ti)    Delta(ti)   V_S(ti)    V_B(ti)      V(ti)      C(ti)      X(ti)    PnL(ti)";
print ftosa(Results,"%lf",3,2);

PnL = PnL[rows(PnL)];
PnL_Ratio = PnL / (Notional * C0);

print;
str = ftosa(100*PnL_Ratio,"PnL = %lf",3,2) $+ " (in %)";
print str;


