new;
library frm,pgraph,optmum;

cls;

rndseed 123456;
Notional = 100;

S0 = 100;
sigma = 0.20;
K = 100; 
r = 0.05; 
b = r;
mu = r;

tau = 130/260;
C0 = EuropeanBS(S0,K,sigma,tau,r,r);

nS = 10000;

fn Premium_Proc(t,S,r) = EuropeanBS(S,K,sigma,tau-t,r,r);
fn Delta_Proc(t,S,r) = EuropeanBS_Delta(S,K,sigma,tau-t,r,r);

let dt = 26 13 10 5 2 1;
PnL_Ratio = zeros(nS,rows(dt));
i = 1;
do until i > rows(dt);
  t = seqa(0,dt[i]/260,130/dt[i]+1);
  S = Simulate_GBM(S0,mu,sigma,t,nS);
  {Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
  PnL = PnL[rows(PnL),.]';
  PnL_Ratio[.,i] = PnL / (Notional * C0);
  i = i + 1;
endo;

Hedge_Efficiency = stdc(PnL_Ratio);
print dt~Hedge_Efficiency;

x = seqa(-0.50,1.00/255,256);

d = zeros(256,rows(dt));
i = 1;
do until i > rows(dt);
  {d[.,i],F} = regKernelDensity(PnL_Ratio[.,i],x);
  i = i + 1;
endo;
  
graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 0|1|2|3|4|5|6;
  _pstype = 8|9|10; _plctrl = 0|0|0|50|50|50; _plctrl = _plctrl / 3;
  xtics(-50,50,10,2);
  xlabel("\216\202p\201 (in %)");
  _plegstr = "dt = 26 days\000dt = 13 days\000dt = 10 days\000dt = 5 days\000dt = 2 days\000dt = 1 day";
  _plegctl = {2 5 6.25 4.5};
  xy(100*x,d);
