new;
library frm,pgraph;

cls;

rndseed 123456;
Notional = 100;

S0 = 100;
sigma = 0.20;
K = 100; 
r = 0.05; 
b = r;
mu = r;

tau = 130/260;
C0 = EuropeanBS(S0,K,sigma,tau,r,r);

nS = 10000;

fn Premium_Proc(t,S,r) = EuropeanBS(S,K,sigma,tau-t,r,r);
fn Delta_Proc(t,S,r) = EuropeanBS_Delta(S,K,sigma,tau-t,r,r);

let dt = 26 13 10 5 2 1 0.5 0.25 0.125 0.0625;
PnL_Ratio = zeros(nS,rows(dt));
i = 1;
do until i > rows(dt);
  t = seqa(0,dt[i]/260,130/dt[i]+1);
  S = Simulate_GBM(S0,mu,sigma,t,Ns);
  {Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
  PnL = PnL[rows(PnL),.]';
  PnL_Ratio[.,i] = PnL / (Notional * C0);
  i = i + 1;
endo;

Hedge_Efficiency = stdc(PnL_Ratio) | 0;
dt = dt |0;

x = seqa(0,1,30);
y = fspline(csspline(rev(dt),rev(Hedge_Efficiency),1,0.999),x);
y[1] = 0.0;
  
graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; 
  _pcolor = 1; _plwidth = 10;
  xtics(0,25,5,2);
  ytics(0,30,5,2);
  xlabel("\216dt (in trading days)");
  ylabel("\216\202s\201(\202p\201) (in %)");
  xy(x,100*y);
