new;
library frm,pgraph;

cls;

rndseed 123;
Notional = 100;

S0 = 100;
sigma = 0.20;
K = 100; 
r = 0.05; 
b = r;
mu = r;

tau = 130/260;
C0 = EuropeanBS(S0,K,sigma,tau,r,r);

nS = 2;

fn Premium_Proc(t,S,r) = EuropeanBS(S,K,sigma,tau-t,r,r);
fn Delta_Proc(t,S,r) = EuropeanBS_Delta(S,K,sigma,tau-t,r,r);

dt = 0.0625;
t = seqa(0,dt/260,130/dt+1);
nt = rows(t);
indx_break = indnv1(0.25,t);
indx2 = seqa(indx_break,1,nt-indx_break+1);
t_break = t[indx_break];

i = 1;
S = Simulate_GBM(S0,mu,sigma,t,1);
{Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
PnL_Ratio = PnL / (Notional * C0);

S1 = S; pi1 = PnL_Ratio; Delta1 = Delta/Notional;

i = 2;
S = S1;
S[indx2] = S[indx2] + 5;

{Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
PnL_Ratio = PnL / (Notional * C0);

S2 = S; pi2 = PnL_Ratio; Delta2 = Delta/Notional;

i = 3;
S = S1;
S[indx2] = S[indx2] - 5;

{Delta,PnL,Results} = Compute_Delta_Hedging(Notional,C0,&Premium_Proc,&Delta_Proc,t,S,r,0);
PnL_Ratio = PnL / (Notional * C0);

S3 = S; pi3 = PnL_Ratio; Delta3 = Delta/Notional;
  
graphset;
  begwind;
  window(2,3,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; 
  _pcolor = 1|2|3|4; _plwidth = 10;
  _pnumht = 0.275; _paxht = 0.325; _ptitlht = 0.40; 

  xtics(0,0.50,0.10,2);

  ytics(90,130,10,2);
  xlabel("\216t");
  ylabel("\216S(t)");

  margin(0.175,0,0,0);    

  setwind(1);
    title("\216No jump");
    _pcolor = 1;
    xy(t,S1);

  _pline = 1~1~t_break~90~t_break~140~1~0~8;

  setwind(2);
    title("\216Positive jump (+5)");
    _pcolor = 2;
    xy(t,S2);

  setwind(3);
    title("\216Negative jump (-5)");
    _pcolor = 4;
    xy(t,S3);

  ytics(-5,5,2.5,2);
  _pcross = 0;
  title("");
  ylabel("\216\202p\201(t)");
  margin(0,0,0,0); 
  _pline = 0;   

  setwind(4);
    _pcolor = 1;
    xy(t,100*pi1);

  _pline = 1~1~t_break~-5~t_break~6~1~0~8;

  setwind(5);
    _pcolor = 2;
    xy(t,100*pi2);

  setwind(6);
    _pcolor = 4;
    xy(t,100*pi3);

  endwind;