new;
library frm,pgraph,optmum;

cls;

Notional = 1e6;

t = 0;
nCaps = 6;
T1 = seqa(0.25,0.25,nCaps);
T2 = T1 + 0.25;

let F0         = 0.0305 0.0315 0.0330 0.0340 0.0345 0.0355;
let K          = 0.03;
let R_T2       = 0.0305 0.0310 0.0315 0.0320 0.0325 0.0330;
B_T2 = exp(-T2 .* R_T2);
let cap_prices = 151.50 529.74 1259.55 2221.99 3295.59 4594.84;
let cap_prices =  151.50           529.74          1259.38          2221.82          3295.31          4594.40  ;

flat_ImpVol = zeros(nCaps,1);

i = 1;
do until i > nCaps;
  flat_ImpVol[i] = Cap_Flat_Implied_Volatility(F0[1:i],K,T1[1:i],T2[1:i],B_T2[1:i],cap_prices[i]/Notional);
  i = i + 1;
endo;

proc rss(sigma);
  local prices,i,caplets,u;

  prices = zeros(nCaps,1);

  i = 1;
  do until i > nCaps;
    {prices[i],caplets} = Cap_Pricing(F0[1:i],K,sigma[1:i],T1[1:i],T2[1:i],B_T2[1:i]);
    i = i + 1; 
  endo;

  prices = Notional * prices;
  u = prices - cap_prices;

  retp(u'u);
endp;

sv = 0.05*ones(nCaps,1);
{spot_ImpVol,fmi,grd,retcode} = optmum(&rss,sv);

gamma_volatility = Spot_to_Gamma_Volatility(spot_ImpVol,T1);

results = flat_ImpVol~Spot_ImpVol~gamma_volatility;
print ftosa(100*results,"%lf",3,3);

e = ones(nCaps,1);
pline1 = e .* (1~6)~lag1(T1)~100*gamma_volatility~T1~100*gamma_volatility~e.*(1~2~10);
pline1[1,3] = 0.0;

pline2 = e .* (1~2)~T1~100*gamma_volatility~T1~100*lagn(gamma_volatility,-1)~e.*(1~2~15);
pline2 = packr(pline2);

x = lag1(T1);
x[1,1] = 0.0;
y = 100*(gamma_volatility);
x = vecr(x);
y = vecr(y);
e = ones(nCaps,1);
psym = x~y~e.*(12~3.5~2~1~10);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|6; _pcolor = 1|4|2; _plwidth = 10; _plctrl = 1; _pstype = 8|9|12;
  xtics(0,2.00,0.25,2);
  xlabel("\216Maturity");
  ylabel("\216Volatility (in %)");
  let xlab = "" "3M" "6M" "9M" "1Y" "15M" "18M" "21M";
  asclabel(xlab,0);
  ytics(4.9,5.95,0.1,2);
  _plegstr = "Flat volatility\000Spot volatility\000\202g\201(t)";
  _plegctl = {2 5 6.5 2.95}; 
  _pline = pline1|pline2;
  _psym = psym;
  xy(T2~T1~T1,100*(flat_ImpVol~Spot_ImpVol~-gamma_volatility));

proc (1) = Spot_to_Gamma_Volatility(spot_Sigma,T);
  local delta,nSigma,gamma_volatility,i;

  delta = T - lag1(T);
  delta[1] = T[1];
  nSigma = rows(spot_Sigma);
  gamma_volatility = zeros(nSigma,1);
//  gamma_volatility[1] = sqrt(spot_sigma[1]^2);
  gamma_volatility[1] = spot_sigma[1];
  i = 2;
  do until i > nSigma;
    gamma_volatility[i] = sqrt( ((spot_sigma[i]^2)*T1[i] - sumc( (gamma_volatility[1:i-1]^2) .* delta[1:i-1]) ) / (T[i]-T[i-1]) );
    gamma_volatility[i] = sqrt( ((spot_sigma[i]^2)*T1[i] - (spot_sigma[i-1]^2)*T1[i-1])/(T[i] - T[i-1]) );
    i = i + 1;
  endo;

  retp(gamma_volatility);
endp;

    