new;
library frm,pgraph;
frmset;

cls;

sigma_min = 0.20;
sigma_max = 0.30;
sigma_mid = 0.5*(sigma_min + sigma_max);
d = 0;
r = 0.03;
b = r - d;
global_floor = 0.16;
local_cap = 0.08;
nFixing = 5;
Fixing_Period = 1;
Maturity = 5;
nX = 50;
nQ = 0;

{x1,Q1,price1,info} = cliquet_option_uvm(sigma_min,sigma_min,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
{x2,Q2,price2,info} = cliquet_option_uvm(sigma_mid,sigma_mid,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
{x3,Q3,price3,info} = cliquet_option_uvm(sigma_max,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
{x4,Q4,price4,info} = cliquet_option_uvm(sigma_min,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,1);
{x5,Q5,price5,info} = cliquet_option_uvm(sigma_min,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,-1);

nX = vread(info,"nX");
nQ = vread(info,"nQ");
nT = vread(info,"nT");
d_x = vread(info,"d_x");
d_Q = vread(info,"d_Q");
d_t = vread(info,"d_t");
t = vread(info,"t");

print ftos(nX,"nX = %lf",3,0);
print ftos(nQ,"nQ = %lf",3,0);
print ftos(nT,"nT = %lf",3,0);
print ftos(d_x,"d_x = %lf",3,4);
print ftos(d_Q,"d_Q = %lf",3,4);
print ftos(d_t,"d_t = %lf",3,4);

price = price1[.,1]~price2[.,1]~price3[.,1]~price4[.,1]~price5[.,1];

bounds = (global_floor~local_cap*nFixing)*exp(-r*Maturity);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|6|6|1|3; _pcolor = 1|2|3|4|5; _plctrl = 10|10|10|0|0; _plwidth = 10; _pstype = 8|9|10|8|8;
  xtics(0.5,1.5,0.2,2);
  ytics(0.1,0.24,0.02,2);
  _plegstr = "\202s\201 = 20%\000\202s\201 = 25%\000\202s\201 = 30%\000V[+]\000V[-]";
  _plegctl = {2 5 6 1};
  _pline = 1~1~0.5~bounds[1]~1.5~bounds[1]~1~0~10 |
           1~1~0.5~bounds[2]~1.5~bounds[2]~1~0~10 ;
  xy(x1,price);