new;
library frm,pgraph;
frmset;

cls;

sigma_min = 0.20;
sigma_max = 0.30;
sigma_mid = 0.5*(sigma_min + sigma_max);
d = 0;
r = 0.05;
b = r - d;
global_floor = 0.10;
local_cap = 0.12;
nFixing = 5;
Fixing_Period = 1;
Maturity = 5;
nX = 40;
nQ = 20;

cap = 0.001|seqa(0.01,0.005,30);
nIters = rows(cap);
price = zeros(nIters,5);

iter = 1;
do until iter > nIters;
  local_cap = cap[iter];
  {x1,Q1,price1,info} = cliquet_option_uvm(sigma_min,sigma_min,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
  {x2,Q2,price2,info} = cliquet_option_uvm(sigma_mid,sigma_mid,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
  {x3,Q3,price3,info} = cliquet_option_uvm(sigma_max,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,0);
  {x4,Q4,price4,info} = cliquet_option_uvm(sigma_min,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,1);
  {x5,Q5,price5,info} = cliquet_option_uvm(sigma_min,sigma_max,b,r,global_floor,local_cap,nFixing,Fixing_Period,Maturity,nX,nQ,-1);
  price[iter,.] = price4[nX+1,1]~price1[nX+1,1]~price2[nX+1,1]~price3[nX+1,1]~price5[nX+1,1];
  iter = iter + 1;
endo;

cap[1] = 0.0;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3|6|6|6|1; _pcolor = 1|2|3|4|5; _plctrl = 0|2|2|2|0; _plwidth = 10; _pstype = 8|8|9|10|8;
  xtics(0,15,1,2);
  ytics(5,30,5,2);
  xlabel("\216Cap (in %)");
  ylabel("\216Price (in %)");
  _plegstr = "V[+]\000\202s\201 = 20%\000\202s\201 = 25%\000\202s\201 = 30%\000V[-]";
  _plegctl = {2 5 1.75 4.75};
  xy(100*cap,100*price);

