new;
library frm,pgraph,optmum;
frmset;

cls;

S0 = 100;
let K_BS = 80 90 100 110 120;
let ImpVol_BS = 0.21 0.19 0.1825 0.185 0.19;
tau = 1;
b = 0.0;
r = 0.05;
model = 3;

C_BS = EuropeanBS(S0,K_BS,ImpVol_BS,tau,b,r);

K = seqa(70,1,61);
nK = rows(K);
nIters = 3;
results = zeros(5,nIters);
C_SLN2 = zeros(nK,nIters);
ImpVol_SLN2 = zeros(nK,nIters);

_Option_Calibration_ImpVol = 0;

iter = 1;
do until iter > nIters;

  if iter == 1;
    // alpha1 = alpha2 & p = 0.5
    let C_RR[5,3] = 1 0 0
                    0 1 0
                    0 0 1
                    0 0 1
                    0 0 0;
    let C_r = 0 0 0 0 0.5;
    let sv = 0.05 0.09 -5;
  elseif iter == 2;
    // p = 0.5
    let C_RR[5,4] = 1 0 0 0
                    0 1 0 0
                    0 0 1 0
                    0 0 0 1
                    0 0 0 0;
    let C_r = 0 0 0 0 0.25;
    sv = 0.15|0.20|-60|40;
  elseif iter == 3;
    // p = 0.25
    let C_RR[5,4] = 1 0 0 0
                    0 1 0 0
                    0 0 1 0
                    0 0 0 1
                    0 0 0 0;
    let C_r = 0 0 0 0 0.50;
    sv = 0.10|0.05|-100|-50;
    w = 1|1|4.0|4.0|4.0;
    w = 1 ./ C_BS;
    _Option_Calibration_w = w;
  endif;

  {sigma1,sigma2,alpha1,alpha2,p} = EuropeanSLN2_calibration(S0,K_BS,tau,b,r,model,C_BS,sv,C_RR,C_r);
  results[.,iter] = sigma1|sigma2|alpha1|alpha2|p;

  C_SLN2[.,iter] = EuropeanSLN2(S0,K,sigma1,sigma2,tau,b,r,alpha1,alpha2,p,model);        
  ImpVol_SLN2[.,iter] = EuropeanBS_ImpVol(S0,K,tau,b,r,C_SLN2[.,iter]);

  iter = iter + 1;
endo;

print ftosa(results,"%lf",3,4);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2|0; _pstype = 8; _plctrl = 0|0|0|-1;
  _psym = K_BS~100*ImpVol_BS~ones(5,1).*(8~4.5~0~1~10);
  xtics(70,130,10,2);
  ytics(18,22,1,2); 
  xlabel("\216Strike");
  ylabel("\216Implied volatility (in %)");
  _plegstr = "#1\000#2\000#3\000Market volatilities";
  _plegctl = {2 5 5.5 4.5}; 
  xy(K,100*ImpVol_SLN2~0*K);