new;
library frm,pgraph,optmum;
frmset;

S0 = 100;
K = seqa(60,1,81);
sigma = 0.20;
tau = 0.5;
r = 0.05;
b = 0.05;

n = rows(K);
ImpVol1 = zeros(n,3);
ImpVol2 = zeros(n,3);
C1 = zeros(n,3);
C2 = zeros(n,3);

let zeta = 0 -0.002 0.002;
i = 1;
do until i > 3;
  ImpVol1[.,i] = sigma * ones(n,1);
  C1[.,i] = Binary_SkewModel(S0,K,ImpVol1[.,i],tau,b,r,zeta[i]); 
  ImpVol2[.,i] = sigma + zeta[i] .* (K - S0);
  C2[.,i] = Binary_SkewModel(S0,K,ImpVol2[.,i],tau,b,r,zeta[i]); 
  i = i + 1;
endo;

graphset;
  window3u;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2;
    _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
    xtics(80,130,10,2);
    xlabel("\216Strike");

  setwind(1);
    title("\216Volatility = 20%");
    ytics(0,1,0.2,2);
    ylabel("\216BCC(0,S]0[)");
    xy(K,C1);

  setwind(2);
    title("\216Linear implied volatility");
    ytics(14,26,2,2);
    ylabel("\216\202S\201(T,K) (in %)");
    xy(K,100*ImpVol2);

  setwind(3);
    ytics(0,1,0.2,2);
    ylabel("\216BCC(0,S]0[)");
    _plegstr = "\202w\201(T,K) = 0\000\202w\201(T,K) = -20 bps\000\202w\201(T,K) = +20 bps";
    _plegctl = {2 6 4.0 9.5}; 
    xy(K,C2);

  endwind;