new;
library frm,pgraph,optmum;
frmset;

S0 = 100;
K = seqa(80,1,41);
nK = rows(K);
tau = 1;
r = 0.05;
b = 0.05;

sigma = 0.15;
alpha = -50;

model = 2;
C = EuropeanSLN(S0,K,sigma,tau,b,r,alpha,model);
ImpVol = EuropeanBS_ImpVol(S0,K,tau,b,r,C);
Skew = EuropeanSLN_ImpVolSkew(S0,K,sigma,tau,b,r,alpha,model,1);

BCC0 = BinaryBS(S0,K,ImpVol,tau,b,r);
BCC1 = BinaryBS(S0-alpha,K-alpha*exp(b*tau),sigma,tau,b,r);
BCC2 = Binary_SkewModel(S0,K,ImpVol,tau,b,r,Skew); 

model = 2;
dK = 3;
C1 = EuropeanSLN(S0,K,sigma,tau,b,r,alpha,model);
ImpVol1 = EuropeanBS_ImpVol(S0,K,tau,b,r,C);

C2 = EuropeanSLN(S0,K+dK,sigma,tau,b,r,alpha,model);
ImpVol2 = EuropeanBS_ImpVol(S0,K+dK,tau,b,r,C2);

Skew1 = EuropeanSLN_ImpVolSkew(S0,K,sigma,tau,b,r,alpha,model,1);
Skew2 = (ImpVol2 - ImpVol1)/dK;

ImpVol3 = EuropeanSLN_ImpVol(S0,K,sigma,tau,b,r,alpha);
ImpVol4 = EuropeanSLN_ImpVol(S0,K + dK,sigma,tau,b,r,alpha);
Skew3 = (ImpVol4 - ImpVol3)/dK;

fn ImpVol_SLN(K) = EuropeanSLN_ImpVol(S0,K,sigma,tau,b,r,alpha);
Skew4 = diag(gradp(&ImpVol_SLN,K));

{Skew5,ImpVol5} = EuropeanSLN_ImpVolSkew2(S0,K,sigma,tau,b,r,alpha);
BCC5 = Binary_SkewModel(S0,K,ImpVol5,tau,b,r,Skew5); 


proc (2) = EuropeanSLN_ImpVolSkew2(S0,K,sigma,tau,b,r,alpha);
  local n,F0,indx,ImpVol,Skew;

  n = _max_(rows(S0),rows(K));
  F0 = S0 .* exp(-b.*tau);
  indx = selif(seqa(1,1,n), dotfeq(F0,K));
  ImpVol = sigma .* (ln(F0) - ln(K)) ./ (ln(F0 - alpha) - ln(K - alpha) );
  if not scalmiss(indx);
    ImpVol[indx,.] = submat(sigma .* (1 - alpha ./ F0) .* ones(n,1),indx,0);
  endif;
  
  Skew = (-sigma ./ K .* ln( (F0 - alpha) ./ (K - alpha) ) + sigma .* ln(F0./K) ./ (K - alpha)) ./ 
         ((ln( (F0 - alpha) ./ (K - alpha) ))^2);

  Skew = sigma .* ln(F0./K) ./ (K - alpha) ./ ((ln( (F0 - alpha) ./ (K - alpha) ))^2) - 
         sigma ./ K .* ln( (F0 - alpha) ./ (K - alpha) ) ./ ((ln( (F0 - alpha) ./ (K - alpha) ))^2);

  Skew = sigma .* ln(F0./K) ./ (K - alpha) ./ ((ln( (F0 - alpha) ./ (K - alpha) ))^2) - 
         sigma ./ K ./ ln( (F0 - alpha) ./ (K - alpha) );

  Skew = ImpVol ./ (K - alpha) ./ ln( (F0 - alpha) ./ (K - alpha) ) - 
         sigma ./ K ./ ln( (F0 - alpha) ./ (K - alpha) );

  Skew = (ImpVol ./ (K - alpha) - sigma ./ K) ./ ln( (F0 - alpha) ./ (K - alpha) );

  retp(Skew,ImpVol);
endp;

graphset;
  begwind;
  window(2,2,0);
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2|3|0;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xtics(80,120,10,2);
  xlabel("\216Strike");

  setwind(1);
    title("\216BCC(0,S]0[)");
    xy(K,BCC0~BCC1~BCC2);

  setwind(2);
    title("\216\202S\201(T,K)");
    xy(K,ImpVol1~ImpVol2~ImpVol3~ImpVol5);

  setwind(3);
    title("\216\202x\201(T,K)");
    xy(K,Skew1~Skew2~Skew3~Skew4~Skew5);

  setwind(4);
    title("\216BCC(0,S]0[)");
    xy(K,BCC1~BCC2~BCC5);

  endwind;

