new;
library frm,pgraph;
frmset;

cls;

S0 = 100;
b = 0.05;
r = 0.05;

alpha = 1e-4;

proc SigmaProc(T,K);
 local r,c,e,ImpVol;
 r = _max_(rows(T),rows(K));
 c = _max_(cols(T),cols(K));
 e = ones(r,c);
 ImpVol = 0.20 + alpha*(S0 - K)^2;
 retp(e .* ImpVol);  
endp;

proc dT_SigmaProc(T,K);
 local r,c,e;
 r = _max_(rows(T),rows(K));
 c = _max_(cols(T),cols(K));
 e = ones(r,c);
 retp(e .* 0);  
endp;

proc dK_SigmaProc(T,K);
 local r,c,e,dK_ImpVol;
 r = _max_(rows(T),rows(K));
 c = _max_(cols(T),cols(K));
 e = ones(r,c);
 dK_ImpVol = -2*alpha*(S0 - K);
 retp(e .* dK_ImpVol);  
endp;

proc d2K_SigmaProc(T,K);
 local r,c,e,d2K_ImpVol;
 r = _max_(rows(T),rows(K));
 c = _max_(cols(T),cols(K));
 e = ones(r,c);
 d2K_ImpVol = 2*alpha;
 retp(e .* d2K_ImpVol);  
endp;

K = seqa(68,1,71);
T = 1/12~0.5~3;
ImpVol = SigmaProc(T[1],K);
LocalVol = ImpVol_to_LocalVol(&SigmaProc,&dK_SigmaProc,&d2K_SigmaProc,&dT_SigmaProc,T,K,S0,b);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|6; _plwidth = 10; _pcolor = 1|2|4|3; _pstype = 8; _plctrl = 5|0|0|0;
  xtics(70,130,10,2);
  ytics(10,50,10,2);
  xlabel("\216K");
  ylabel("\216\202s\201(T,K) (in %)");
  _plegstr = "Implied volatility\000T = 1M\000T = 6M\000T = 3Y";
  _plegctl = {2 5 6.25 5.4};
  xy(K,100*(ImpVol~LocalVol));

