new;
library frm,pgraph;
frmset;

cls;

proc SigmaProc(T,K);
  local ImpVol0,alpha,ImpVol;

  ImpVol0 = 0.20 + 0.005*(T - 1.0);
  alpha = T/20*1e-4;

  ImpVol = ImpVol0 + alpha .* (K - 100)^2;

  retp(ImpVol);
endp;

K = seqa(70,1,61);
Tm = seqa(1,1,5);
Sigma = zeros(rows(K),rows(Tm));

i = 1;
do until i > rows(Tm);
  Sigma[.,i] = SigmaProc(Tm[i],K);
  i = i + 1;
endo;

T = seqa(0,1/10,81);
ImpVol = ImpVol_Time_Interpolation(&SigmaProc,Tm,T,K,0.05);
Strike = 80|100|130;
indx_K = closest_index(Strike,K);

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|2|5; _plwidth = 10; _pcolor = 1|4|2|3|5; _plctrl = 0|0|0|10|10; _pstype = 8|8|8|8|9; _psymsiz = 5;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;

  setwind(1);
    title("\216\202S\201(T]m[,K)");
    xtics(70,130,10,2);
    xlabel("\216K");
    ytics(20,25,1,2);
    _plegstr = "T]m[ = 1\000T]m[ = 2\000T]m[ = 3\000T]m[ = 2\000T]m[ = 3";
    _plegctl = {2 6 9.0 3.0};
    xy(K,100*Sigma);

  _plegctl = 0;

  setwind(2);
    title("\216\202S\201(T,K)");
    xtics(70,130,10,2);
    ytics(0,8,1,2);
    ztics(20,25,1,2);
    xlabel("\216K");
    ylabel("\216T");
    surface(K',T,100*ImpVol');

  setwind(3);
    title("\216\202S\201(T,K)");
    xtics(0,8,1,2);
    xlabel("\216T");
    ytics(20,25,1,2);
    ylabel("");
    _plegstr = "K = 80\000K = 100\000K = 130";
    _plegctl = {2 5 1.5 4.5};
    e = ones(rows(Tm),1);
    _pline = e.*(1~3)~Tm~0*e~Tm~e*(30~1~0~6);
    xy(T,100*ImpVol[indx_K,.]');

  endwind;