/*
**> chap13-2-3-7
** 
*/

new;
library frm,optmum,pgraph;
//OptionSet;

cls;

Smile_T = 1/12|1/4|1/2|1|2;
let Smile_K[9,5] = 
        87         77         66         53        37 
        92         85         78         69        56 
        96         93         89         86        80 
        98         97         96         96        96 
       100        101        102        104        103 
       103        106        111        119        137 
       106        111        119        133        163 
       110        121        136        166        229 
       116        134        161        217        347; 

let Smile_ImpVol[9,5] = 
      0.137       0.149       0.168       0.190       0.219 
      0.137       0.149       0.168       0.190       0.219 
      0.133       0.141       0.155       0.170       0.200 
      0.132       0.140       0.150       0.160       0.185 
      0.130       0.135       0.145       0.155       0.185 
      0.131       0.138       0.150       0.165       0.190 
      0.132       0.142       0.155       0.175       0.195 
      0.135       0.151       0.168       0.185       0.208 
      0.135       0.151       0.168       0.185       0.208;

S0 = 100;
b = 0.05;
r = 0.05;

Tau = 1.0;
K = 100;
L = 90;
H = 115;

let string OptionType[10,1] = "call" "put" "doc" "dop" "uoc" "uop" "koc" "kop" "bcc" "bcp";
nIters = rows(OptionType);

__output = 0;

nModels = 3;
Prices = zeros(nIters,nModels+2);

model = 1;
do until model > 3;
  FileName = "chap13-2-3-7";
  if model == 2;
    Smile_ImpVol = 0.160 + 0*Smile_ImpVol;
  elseif model == 3;
    Smile_ImpVol = 0.155 + 0*Smile_ImpVol;
  endif;
  call LocalVol_Init(Smile_K,Smile_ImpVol,Smile_T,0,200,2001,1,2001,S0,b,r,FileName);

  i = 1;
  do until i > nIters;
    {tmp_S0,tmp_Tau,C} = LocalVol_Backward_PDE_Solve(OptionType[i],K,L,H,tau,0.5);
    str = upper(OptionType[i]) $+ ftos(C," = %lf",5,4);
    print /flush str;
    Prices[i,model] = C;
    i = i + 1;
  endo;

  model = model + 1;
endo;

sigma = 0.160;
_Option_Type = "call";
prices[1,model] = EuropeanBS(S0,K,sigma,tau,b,r);
_Option_Type = "put";
prices[2,model] = EuropeanBS(S0,K,sigma,tau,b,r);
prices[3,model] = EuropeanBS_DOC(S0,K,sigma,tau,b,r,tau,L,0);
prices[4,model] = EuropeanBS_DOP(S0,K,sigma,tau,b,r,tau,L,0);
prices[5,model] = EuropeanBS_UOC(S0,K,sigma,tau,b,r,tau,H,0);
prices[6,model] = EuropeanBS_UOP(S0,K,sigma,tau,b,r,tau,H,0);
prices[7,model] = EuropeanBS_KOC(S0,K,sigma,tau,b,r,tau,L,H);
prices[8,model] = EuropeanBS_KOP(S0,K,sigma,tau,b,r,tau,L,H);
_Option_Type = "call";
prices[9,model] = BinaryBS(S0,K,sigma,tau,b,r);
_Option_Type = "put";
prices[10,model] = BinaryBS(S0,K,sigma,tau,b,r);

model = model + 1;

sigma = 0.155;
_Option_Type = "call";
prices[1,model] = EuropeanBS(S0,K,sigma,tau,b,r);
_Option_Type = "put";
prices[2,model] = EuropeanBS(S0,K,sigma,tau,b,r);
prices[3,model] = EuropeanBS_DOC(S0,K,sigma,tau,b,r,tau,L,0);
prices[4,model] = EuropeanBS_DOP(S0,K,sigma,tau,b,r,tau,L,0);
prices[5,model] = EuropeanBS_UOC(S0,K,sigma,tau,b,r,tau,H,0);
prices[6,model] = EuropeanBS_UOP(S0,K,sigma,tau,b,r,tau,H,0);
prices[7,model] = EuropeanBS_KOC(S0,K,sigma,tau,b,r,tau,L,H);
prices[8,model] = EuropeanBS_KOP(S0,K,sigma,tau,b,r,tau,L,H);
_Option_Type = "call";
prices[9,model] = BinaryBS(S0,K,sigma,tau,b,r);
_Option_Type = "put";
prices[10,model] = BinaryBS(S0,K,sigma,tau,b,r);

results = OptionType $~ ftosa(Prices,"%lf",3,2);
print results;

/*
            call             8.85             8.96             8.78             8.96             8.78 
             put             3.97             4.08             3.90             4.08             3.90 
             doc             7.98             8.14             8.05             8.11             8.02 
             dop             0.26             0.27             0.28             0.25             0.27 
             uoc             0.99             0.88             0.94             0.83             0.89 
             uop             3.81             3.90             3.75             3.89             3.74 
             koc             0.65             0.56             0.64             0.52             0.59 
             kop             0.20             0.20             0.22             0.19             0.21 
             bcc             0.58             0.56             0.57             0.56             0.57 
             bcp             0.37             0.39             0.38             0.39             0.38 
*/