new;
library frm,pgraph,optmum;

cls;
datPathName = "..\\..\\Data\\";

let string datasets[9,1] = "sabr1y1y" "sabr1y5y" "sabr1y10y"
                           "sabr5y1y" "sabr5y5y" "sabr5y10y"
                           "sabr10y1y" "sabr10y5y" "sabr10y10y";

indx = seqa(1,1,9);
 
i = 1;
do until i > rows(indx);
  name = datasets[indx[i]];
  dataset = datPathName $+ name;
  data = loadd(dataset);

  F = data[.,2];
  Sigma_B = data[.,4];

  {beta,beta_hat,stderr,R2,R2c} = sabr_beta_estimation(F,sigma_B,1);

  beta = selif(beta, beta .> -10 .and beta .< 10);

  beta = packr(beta);
  results = beta_hat[1]~R2c[1]~beta_hat[2]~R2c[2]~quantile(beta,0.10)~quantile(beta,0.25)~median(beta)~quantile(beta,0.75)~quantile(beta,0.90);
  print name$~ftosa(results,"%lf",6,2);

  i = i + 1;
endo;

