new;
library frm,pgraph,optmum;

cls;
datPathName = "..\\..\\Data\\";

let string datasets[9,1] = "sabr1y1y" "sabr1y5y" "sabr1y10y"
                           "sabr5y1y" "sabr5y5y" "sabr5y10y"
                           "sabr10y1y" "sabr10y5y" "sabr10y10y";

let indx = 1 5 7 9;

x = seqa(-0.6,1.8/2000,2001);
y1 = zeros(rows(x),4);
y2 = zeros(rows(x),4);
 
i = 1;
do until i > 4;
  dataset = datPathName $+ datasets[indx[i]];
  data = loadd(dataset);

  F = data[.,2];
  Sigma_B = data[.,4];

  {beta,beta_hat,stderr,R2,R2c} = sabr_beta_estimation(F,sigma_B,1);

  results = beta_hat~stderr~R2~R2c;
  print ftosa(results,"%lf",3,2);

  beta = selif(beta, beta .> -10 .and beta .< 10);

  y1[.,i] = pdfn2(x,beta_hat[1],stderr[1]);
  y2[.,i] = pdfn2(x,beta_hat[2],stderr[2]);

  i = i + 1;
endo;

y1 = missex(y1,y1 .<= 1e-5);
y2 = missex(y2,y2 .<= 1e-5);

graphset;
  begwind;
  window(2,2,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10; _pcolor = 1|2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _plegstr = "\202b\201]1[\000\202b\201]2[";
  _plegstr = "Level\000Difference";
  xlabel("\214\202b\201");

  i = 1;
  setwind(i);
    title("\2161Y1Y");
    xtics(-0.10,0.70,0.1,2);
    ytics(0,50,10,2);
    xy(x,y1[.,i]~y2[.,i]);

  i = 2;
  setwind(i);
    title("\2165Y5Y");
    xtics(-0.10,0.40,0.10,2);
    ytics(0,25,5,2);
    xy(x,y1[.,i]~y2[.,i]);

  i = 3;
  setwind(i);
    title("\21610Y5Y");
    xtics(0.0,1.20,0.3,3);
    ytics(0,12,3,2);
    xy(x,y1[.,i]~y2[.,i]);

  i = 4;
  setwind(i);
    title("\21610Y10Y");
    xtics(-0.60,0.40,0.2,2);
    ytics(0,20,4,2);
    _plegctl = {2 5 6 4};
    xy(x,y1[.,i]~y2[.,i]);

  endwind;