new;

#ifdef USE_OPTMUM
  library frm,pgraph,optmum;
#else
  library frm,pgraph;
#endif

cls;

F0 = 0.05;
tau = 1;

N = 101;
K = seqa(0.02,0.001,N);

let Strike = 0.028 0.030 0.035 0.037 0.040 0.045 0.050 0.070;
let ImpVol = 0.132 0.128 0.120 0.116 0.110 0.100 0.090 0.100;
ATM = 0.09;

beta = 1.0;

{alpha1,beta1,nu1,rho1} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0,1);
rss1 = _sabr_rss;
ATM1 = SABR_ATM(F0,alpha1,beta1,nu1,rho1,tau);

sv = 0.4|-0.15;
{alpha2,beta2,nu2,rho2} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,sv,2);
rss2 = _sabr_rss;
ATM2 = SABR_ATM(F0,alpha2,beta2,nu2,rho2,tau);

cls;

results = 100*alpha1~beta1~nu1~100*rho1~1e4*rss1~100*ATM1 |
          100*alpha2~beta2~nu2~100*rho2~1e4*rss2~100*ATM2 ;
let fmt[1,3] = "%lf" 10 3;
call printfm(results,1,fmt);

ImpVol_K = SABR_ImpVol(F0,K,alpha1,beta1,nu1,rho1,tau) ~ 
           SABR_ImpVol(F0,K,alpha2,beta2,nu2,rho2,tau) ;
graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|2|4;
  ylabel("\216\202S\201(T,K) (in %)");
  xlabel("\216K (in %)"); 
  xtics(2,8,1,2);
  _psym = 100*strike~100*ImpVol~ones(rows(Strike),1).*(11~6.5~0~1~10);
  _pline = 1~3~100*F0~90*ATM~100*F0~210*ATM~1~4~10;
  _pmsgstr = "Put wing\000Call wing";
  _pmsgctl = 3.6~15~0.20~0~1~4~10 |
             5.3~15~0.20~0~1~4~10 ;
  _parrow =  4.9~14.7~3.3~14.7~3~0.20~21~4~1~6~15 |
             5.1~14.7~6.7~14.7~3~0.20~21~4~1~6~15 ;

  ytics(8,16,2,2);
  _plegstr = "Calibration #1\000Calibration #2";
  _plegctl = {2 6 5.5 3.4};
  xy(100*K,100*ImpVol_K);




