/*
**> Durrleman Approximation of the Heston Model
**
*/

new;
library frm,pgraph;

S0 = 100;
r = 0.05;

kappa = 0.5;
sigma = 0.20;
theta = sigma^2;
ksi = 0.2;
rho = -0.75~-0.50~-0.25~0~0.25;

K = seqa(80,1,41);

_Durrleman_order = 4;

tau = 1/12;
Smile1 = Durrleman_HestonSmile(S0,K,sigma,kappa,theta,ksi,rho,tau,r);

tau = 6/12;
Smile2 = Durrleman_HestonSmile(S0,K,sigma,kappa,theta,ksi,rho,tau,r);

tau = 12/12;
Smile3 = Durrleman_HestonSmile(S0,K,sigma,kappa,theta,ksi,rho,tau,r);

tau = 2;
Smile4 = Durrleman_HestonSmile(S0,K,sigma,kappa,theta,ksi,rho,tau,r);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pltype = 6|3|1; _pframe = 0; _pnum = 2;
  _paxht = 0.225; _pnumht = 0.225; _pcolor = 1|2|3|4|5;
  _plctrl = 0|0|0|5|5; _pstype = 8|8|8|8|9; _psymsiz = 6.0;
  _plwidth = 10; _ptitlht = 0.275;

  xtics(80,120,10,2);
  ytics(0.16,0.24,0.02,2);
  xlabel("\216Strike K");

  setwind(1);
    title("\216T = 1M");
    xy(K,smile1);

  setwind(2);
    title("\216T = 6M");
    xy(K,smile2);

  setwind(3);
    title("\216T = 1Y");
    xy(K,smile3);

  setwind(4);
    title("\216T = 2Y");
    _plegstr = "\202r\201 = -0.75\000\202r\201 = -0.50\000\202r\201 = -0.25\000\202r\201 = 0\000\202r\201 = 0.25";
    _plegctl = {2 5 5.5 3.75};
    xy(K,smile4);
 
  endwind;