/*
**> Durrleman Approximation of the Heston Model
**
*/

new;
library frm,pgraph;

_Durrleman_order = 4;

S0 = 100;
tau = 1/2;
r = 0.0;

kappa = 1;
sigma = 0.20;
theta = sigma^2;
ksi = 0.2;
rho = -0.75;

K = seqa(50,1,101);
{smile,cdf,pdf} = Durrleman_HestonDensity(S0,K,sigma,kappa,theta,ksi,rho,tau,r);
{cdf_ln,pdf_ln} = EuropeanBS_Density(S0,K,_Durrleman_ATM_volatility,tau,r);

graphset;
  _pdate = "";
  _pltype = 6|3|1; _pframe = 0; _pnum = 2;
  _pcolor = 1|4; _plwidth = 10;
  xlabel("\216Strike K");
  xtics(50,150,25,2);
  _plegstr = "Heston Model\000ATM BS Model";
  _plegctl = {2 5 6.25 5.0};
  xy(K,pdf~pdf_ln);