new;
library frm,optmum,pgraph;
cls;

#define USE_OPTMUM

_Durrleman_order = 4;

S0 = 100;
tau = 1/2;
r = 0.05;

kappa = 0.980;
sigma = 0.201;
theta_Heston = sigma^2;
ksi = 0.192;
rho = -0.207;

fn SmileProc(K) = Durrleman_HestonSmile(S0,K,sigma,kappa,theta_Heston,ksi,rho,tau,r);
K = 90|95|100|105|110;

MarketSmile = SmileProc(K);

proc (9) = ModelParams(theta);
  theta[1:4] = sqrt(theta[1:4]^2);
  retp(Durrleman_Heston_Parameters(theta[1],theta[2],theta[3],theta[4],theta[5]));
endp;

__output = 1;

sv = 0.22|1|0.1^2|0.2|-0.1;
sv = 0.22|1.00|0.1^2|0.2|-0.2;

{theta,fmin,grd,retcode} = Durrleman_Calibraton(S0,K,MarketSmile,tau,&ModelParams,sv,0);
theta[1:4] = sqrt(theta[1:4]^2);

cls;
results = K~100*MarketSmile;
print ftosa(results',"%lf",3,2);
params_Heston = sigma|kappa|theta_Heston|ksi|rho;
params_Durrleman = theta;
results = params_Heston~params_Durrleman;
print ftosa(results',"%lf",3,3);

x = seqa(70,1,61);

Smile1 = Durrleman_HestonSmile(S0,x,sigma,kappa,theta_Heston,ksi,rho,tau,r);
Smile2 = Durrleman_HestonSmile(S0,x,theta[1],theta[2],theta[3],theta[4],theta[5],tau,r);

graphset;
  _pdate = ""; _pframe = 0; _pnum = 2; 
  _pltype = 1|6|3; _plwidth = 10; _plctrl = -1|0|0;
  _pcolor = 2|1|4; _pstype = 8;
  xlabel("\216Strike K");
  ylabel("\216Implied volatility (in %)");
  ytics(19,23,1,2);
  e = ones(rows(K),1);
  _psym = K~100*MarketSmile~e.*(8~5~2~1~10);
  _plegstr = "Market prices\000Heston smile\000Durrleman smile";
  _plegctl = {2 5 5 4};
  xy(x,100*(-smile1~smile1~smile2));
