new;
library frm,pgraph;
frmset;

cls;

K_star = seqa(0.8,0.01,41);
nK = rows(K_star);
ImpVol = zeros(nK,4);
let string str[4,1] = "#1" "#2" "#3" "#4";

r = 0.01;
t = seqa(0,0.10,50);
zcTable = t~exp(-r*t);

let bTable[3,2] =
0.0	    0.30
0.5     0.40
1.0	    0.50;

let SigmaTable[3,2] = 
0.0	     3.0
0.5      3.2
1.0      3.5;

iter = 1;
do until iter > 4;

  if iter == 1;

    let GammaTable[3,2] = 
    0.0   -20.0
    0.5   -10.0
    1.0    10.0;

  elseif iter == 2;

    let GammaTable[3,2] = 
    0.0	   20.0
    0.5    15.0
    1.0    10.0;

  elseif iter == 3;

    let GammaTable[3,2] = 
    0.0	 5.0
    0.5  5.0
    1.0  5.0;

    let SigmaTable[3,2] = 
    0.0	 4.0
    0.5  3.5
    1.0  3.0;

  elseif iter == 4;

    let GammaTable[3,2] = 
    0.0	   -10.0
    0.5    -10.0
    1.0    -10.0;

    let SigmaTable[3,2] = 
    0.0	 6.0
    0.5  5.0
    1.0  4.0;

  endif;

  T0 = 180/365;
  T1 = T0 + 2/365;
  T2 = T1 + 1;

  Sw = _qg_Forward_Swap_Rate(zcTable,T1,T2);
  K = K_star .* Sw;

  _qg_PDE_nX = 500;
  _qg_PDE_nT = 500;

  caplet = qg_caplet(zcTable,sigmaTable,gammaTable,bTable,T0,T1,T2,K);

  B_T2 = _qg_zcProc(T2);

  i = 1;
  do until i > nK;
    ImpVol[i,iter] = Cap_Flat_Implied_Volatility(Sw,K[i],T1,T2,B_T2,Caplet[i,1]);
    i = i + 1;
  endo;

  iter = iter + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
    _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.30;
    xtics(0.80,1.20,0.10,2);
    xlabel("\216K[*]");

  iter = 1;
  do until iter > 4;

    setwind(iter);

      _pcolor = iter;
      _ptitle = "\216" $+ str[iter];
      if iter == 1;
        ytics(12,20,2,2);
      elseif iter == 2;
        ytics(21.5,24,0.5,2);
      elseif iter == 3;
        ytics(27,30,1,2);
      elseif iter == 4;
        ytics(29,34,1,2);
      endif;

      xy(K_star,100*ImpVol[.,iter]);

    iter = iter + 1;
  endo;

  endwind;

