new;
library frm,pgraph;
frmset;

cls;

nRho = 9;
nIters = 5;

basket_prices = zeros(nRho,nIters);

iter = 1;
do until iter > nIters;

  if iter == 1;
    alpha1 = 1.0; alpha2 = -1.0; K = 1;
    indx = 2;
  elseif iter == 2;
    alpha1 = 1.0; alpha2 = -1.0; K = 5;
    indx = 2;
  elseif iter == 3;
    alpha1 = 0.5; alpha2 = 0.5; K = 100;
    indx = 4;
  elseif iter == 4;
    alpha1 = 0.5; alpha2 = 0.5; K = 110;
    indx = 4;
  elseif iter == 5;
    alpha1 = 0.1; alpha2 = 0.1; K = -5;
    indx = 4;
  endif;

  S1 = 100; 
  S2 = 100;

  sigma1 = 0.20; 
  sigma2 = 0.20; 

  T = 1; 

  r = 0.05; 
  b1 = 0.10; 
  b2 = 0.00;

  _BasketOption2D_bounds = 5|-5;
  _BasketOption2D_order = 128;

  let rhoVector = -0.90 -0.75 -0.50 -0.25 0.00 0.25 0.50 0.75 0.90;

  nRho = rows(rhoVector);
  C = miss(zeros(nRho,5),0);

  i = 1;
  do until i > nRho;

    rho = rhoVector[i];

    _BasketOption2D_mtd  = 1; // 1D
    _BasketOption2D_int  = 0; // Hermite
    C[i,1] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
    _BasketOption2D_int  = 1; // Legendre
    C[i,2] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

    _BasketOption2D_mtd  = 2; // 2D
    _BasketOption2D_int  = 0; // Hermite
    C[i,3] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
    _BasketOption2D_int  = 1; // Legendre
    C[i,4] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

    nS = 1000000;
    {S1_T,S2_T} = simulate_GBM2(S1,S2,b1,b2,sigma1,sigma2,rho,T,nS);
    Payoff = _max_(alpha1*S1_T' + alpha2*S2_T' - K,0);
    Cs = exp(-r*T) * meanc(Payoff);
    C[i,5] = Cs;

    i = i + 1;
  endo;

  print "            rho       1D-Hermite      1D-Legendre       2D-Hermite      2D-Legendre       Monte-Carlo";
  print /flush ftosa(rhoVector~C,"%lf",10,2~4*ones(1,5));
  print "-----------------------------------------------------------------------------------------------------";

  basket_prices[.,iter] = C[.,indx];

  iter = iter + 1;
endo;

print "-----------------------------------------------------------------------------------------------------";
print /flush ftosa(rhoVector~basket_prices,"%lf",10,2~2*ones(1,nIters));

