new;
library frm,pgraph;
frmset;

cls;

let rho_Vector    = -0.20  0.05 0.20  0.35 0.40 0.45 0.425 0.35;
let Strike_Vector =  0.10  0.15 0.20  0.40 0.60 0.80 1.00 1.20; 
nIters = rows(rho_Vector);

y = rho_vector;
x = Strike_Vector;
x = ones(nIters,1)~x~x^2;
beta = y/x;
x = seqa(0.10,0.10,12);
y = beta[1] + beta[2] * x + beta[3] * x^2;

rho_vector = y;
Strike_Vector = x;
nIters = rows(rho_Vector);

basket_prices = zeros(nIters,5);
C = zeros(5,1);

iter = 1;
do until iter > nIters;

  alpha1 = 1.0; 

  alpha2 = -Strike_Vector[iter];
  rho = rho_Vector[iter];

  K = 0;

  S1 = 100; 
  S2 = 100;

  sigma1 = 0.20; 
  sigma2 = 0.20; 

  T = 1; 

  r = 0.05; 
  b1 = 0.10; 
  b2 = 0.00;

  _BasketOption2D_bounds = 5|-5;
  _BasketOption2D_order = 128;

  _BasketOption2D_mtd  = 1; // 1D
  _BasketOption2D_int  = 0; // Hermite
  C[1] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
  _BasketOption2D_int  = 1; // Legendre
  C[2] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  _BasketOption2D_mtd  = 2; // 2D
  _BasketOption2D_int  = 0; // Hermite
  C[3] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
  _BasketOption2D_int  = 1; // Legendre
  C[4] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  nS = 1000000;
  {S1_T,S2_T} = simulate_GBM2(S1,S2,b1,b2,sigma1,sigma2,rho,T,nS);
  Payoff = _max_(alpha1*S1_T' + alpha2*S2_T' - K,0);
  Cs = exp(-r*T) * meanc(Payoff);
  C[5] = Cs;

  print "        1D-Hermite      1D-Legendre       2D-Hermite      2D-Legendre       Monte-Carlo";
  print /flush ftosa(C',"%lf",10,4*ones(1,5));
  print "-----------------------------------------------------------------------------------------------------";

  basket_prices[iter,.] = C';

  iter = iter + 1;
endo;

print /flush ftosa(Strike_Vector~rho_Vector~basket_prices,"%lf",10,2);

print /flush ftosa(Strike_Vector~basket_prices[.,2],"%lf",10,2);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6; _plwidth = 10; _pcolor = 1; _plctrl = 1; _pstype = 2; _psymsiz = 4;
  xtics(0,1.25,0.25,2);
  xlabel("\216k");
  ytics(-10,60,10,2);
  ylabel("\216\202r\201]imp[ (in %)");
  xy(Strike_Vector,100*rho_Vector);


