new;
library frm,pgraph;
frmset;

cls;

let K1_Vector  =  104 103 102 101 100;
let K2_Vector  =  100  99  98  97  96;
let Sigma1_Vector  =  0.16 0.17 0.18 0.19 0.20;
let Sigma2_Vector  =  0.20 0.22 0.24 0.26 0.28;

nIters = rows(K1_Vector);

basket_prices = zeros(nIters,5);
C = zeros(5,1);

iter = 1;
do until iter > nIters;

  alpha1 = 1.0; 
  alpha2 = -1;
  rho = 0.5;

  K = 4;

  S1 = 100; 
  S2 = 100;

  sigma1 = Sigma1_Vector[iter]; 
  sigma2 = Sigma2_Vector[iter]; 

  T = 1; 

  r = 0.05; 
  b1 = 0.10; 
  b2 = 0.00;

  _BasketOption2D_bounds = 5|-5;
  _BasketOption2D_order = 128;

  _BasketOption2D_mtd  = 1; // 1D
  _BasketOption2D_int  = 0; // Hermite
  C[1] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
  _BasketOption2D_int  = 1; // Legendre
  C[2] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  _BasketOption2D_mtd  = 2; // 2D
  _BasketOption2D_int  = 0; // Hermite
  C[3] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
  _BasketOption2D_int  = 1; // Legendre
  C[4] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  nS = 1000000;
  {S1_T,S2_T} = simulate_GBM2(S1,S2,b1,b2,sigma1,sigma2,rho,T,nS);
  Payoff = _max_(alpha1*S1_T' + alpha2*S2_T' - K,0);
  Cs = exp(-r*T) * meanc(Payoff);
  C[5] = Cs;

  print "        1D-Hermite      1D-Legendre       2D-Hermite      2D-Legendre       Monte-Carlo";
  print /flush ftosa(C',"%lf",10,4*ones(1,5));
  print "-----------------------------------------------------------------------------------------------------";

  basket_prices[iter,.] = C';

  iter = iter + 1;
endo;

print /flush ftosa(basket_prices,"%lf",10,2);

print /flush ftosa(basket_prices[.,2],"%lf",10,2);



