new;
library frm,pgraph;
frmset;

cls;

alpha1 = -0.8; 
alpha2 = 0.8; 
K = 5;

S1 = 100; 
S2 = 100;

sigma1 = 0.20; 
sigma2 = 0.20; 

T = 1; 

r = 0.05; 
b1 = 0.10; 
b2 = 0.00;
rho = 0.50;

let orders = 2 4 8 16 32 64 128;
n = rows(orders);
C = miss(zeros(n,5),0);

i = 1;
do until i > n;

  _BasketOption2D_bounds = 5|-5;
  _BasketOption2D_order = orders[i];

  _BasketOption2D_mtd  = 1; // 1D

  _BasketOption2D_int  = 0; // Hermite
  C[i,1] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);
 
  _BasketOption2D_int  = 1; // Legendre
  C[i,2] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  _BasketOption2D_mtd  = 2; // 2D

  _BasketOption2D_int  = 0; // Hermite
  C[i,3] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  _BasketOption2D_int  = 1; // Legendre
  C[i,4] = BasketOption2D_BS(alpha1,S1,sigma1,b1,alpha2,S2,sigma2,b2,rho,K,T,r);

  i = i + 1;
endo;

nS = 10000000;
{S1_T,S2_T} = simulate_GBM2(S1,S2,b1,b2,sigma1,sigma2,rho,T,nS);
Payoff = _max_(alpha1*S1_T' + alpha2*S2_T' - K,0);
Cs = exp(-r*T) * meanc(Payoff);
C[n,5] = Cs;

print "           order       1D-Hermite      1D-Legendre       2D-Hermite      2D-Legendre       Monte-Carlo";
print ftosa(orders~C,"%lf",10,1~4*ones(1,5));