new;
library frm,pgraph;
frmSet;

cls;

rndseed 123;

n = 20;
sigma = 0.5;
x = 5 + rndn(n,1);
x = 3.1 + 3.8 * (x - minc(x))/(maxc(x) - minc(x));
u = rndn(n,1)*sigma;
y = 5 + 2 * x + u;

data = y~x;
data = trunc(data*10)/10;
print ftosa(data[1:10,.]',"%lf",3,1);
print ftosa(data[11:20,.]',"%lf",3,1);

y = data[.,1];
x = data[.,2];
n = rows(data);
c = ones(n,1);

xmin = 3;
xmax = 7;
x1 = seqa(xmin,(xmax-xmin)/(n-1),n);
x2 = x1;

print "--------- beta with constant -------";
beta1 = y/(x~c);
y1 = (x1~c)*beta1;
u1 = y - (x~c)*beta1;
mu1 = meanc(u1);
sigma1 = sqrt(sumc(u1^2)/(n-2));
print ftosa(beta1,"%lf",3,4);
print ftosa(mu1,"mu(u) = %lf",3,4);
print ftosa(sigma1,"sigma(u) = %lf",3,4);

print "--------- beta without constant -------";
beta2 = y/x;
y2 = x2*beta2;
u2 = y - x*beta2;
mu2 = meanc(u2);
sigma2 = sqrt(sumc(u2^2)/(n-1));
print ftosa(beta2,"beta = %lf",3,4);
print ftosa(mu2,"mu(u) = %lf",3,4);
print ftosa(sigma2,"sigma(u) = %lf",3,4);

print "--------- ratio of the means -------";
mu_x = meanc(x);
mu_y = meanc(y);
ratio_mu = mu_y/mu_x;
print ftosa(ratio_mu,"Ratio of the means = %lf",3,4);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|6|3; _pcolor = 1|2|4; _plwidth = 10;
  _plctrl = -1|0|0; _pstype = 8;
  xtics(3,7,0.5,2);
  ytics(10,20,2,2);
  _plegstr = "Data\000OLS with intercept\000OLS without intercept";
  _plegctl = {2 5 1 5};
  xy(x~x1~x2,y~y1~y2);