new;
library frm,optmum;

cls;

declare matrix _em_E_Z;
declare matrix _em_V_Z;

let data[40,3] =

150 8064 1  150 8064 1  150 8064 1  150 8064 1  150 8064 1
150 8064 1  150 8064 1  150 8064 1  150 8064 1  150 8064 1

170 1764 0  170 2772 0  170 3444 0  170 3542 0  170 3780 0
170 4860 0  170 5196 0  170 5448 1  170 5448 1  170 5448 1

190  408 0  190  408 0  190 1344 0  190 1344 0  190 1440 0
190 1680 1  190 1680 1  190 1680 1  190 1680 1  190 1680 1

220  408 0  220  408 0  220  504 0  220  504 0  220  504 0
220  528 1  220  528 1  220  528 1  220  528 1  220  528 1;

t = data[.,1]; 
d = data[.,2];

data_x = 1000 / (t + 273.2);
data_y = log(d);
data_c = data_y;
data_truncated = data[.,3];

fn H(x) = pdfn(x) ./ (1 - cdfn(x));

proc E_Z(theta);
  local mu,c_star;
  mu = theta[1] + theta[2] * data_x;
  c_star = (data_c - mu) / theta[3];
  retp( mu + theta[3] * H(c_star) );
endp;

proc V_Z(theta);
  local mu,c_star;
  mu = theta[1] + theta[2] * data_x;
  c_star = (data_c - mu) / theta[3];
  retp( mu^2 + theta[3]^2 + theta[3] .* (data_c + mu) .* H(c_star) );
endp;

proc ml_proc(theta);
  local sigma2,u,logl1,logl2,mu,LogL;

  sigma2 = theta[3]^2;
  mu = theta[1] + theta[2] * data_x;
  u = data_y - mu;
  logl1 = -0.5*ln(sigma2) - 0.5*(u^2)/sigma2;
  logl2 = -0.5*ln(sigma2) - 0.5*(_em_V_Z - 2 * mu .* _em_E_Z + mu^2)/sigma2;

  LogL = data_truncated .* logl2 + (1-data_truncated) .* logl1;

  retp(-sumc(Logl));
endp;

beta_ml = zeros(3,50);
theta = ones(3,1);

__ouput = 0;

i = 1;
do until i > 50;
  _em_E_Z = E_Z(theta);
  _em_V_Z = V_Z(theta);
  {theta,fmin,grd,retcode} = optmum(&ml_proc,theta);
  beta_ml[.,i] = theta;
  i = i + 1;
endo;

cls;

print "       iteration          beta0            beta1            sigma ";
print "--------------------------------------------------------------------";
__fmtnv  = { "*.*lf " 10 3};
call printfmt(seqa(1,1,50)~beta_ml',1);

Z = data_truncated .* _em_E_Z + (1-data_truncated) .* data_y;
D = 10^Z;
data = data~D;
iter = 1;
do until iter > 4;
  results = reshape(data[.,iter],8,5);
  print ftosa(results,"%lf",3,0);
  iter = iter + 1;
endo;


