new;
library frm,pgraph,optmum;

cls;

PathName = "..\\..\\data\\";
datFileName = PathName $+ "carry.dat";

data = loadd(datFileName);
data = selif(Data,Data[.,1] .>= 20000101);
vnames = "" $+ getname(datFileName);

Dates = data[.,1];
nDates = rows(Dates);

let indx = 2 3 4;
data = data[.,indx];
vnames = vnames[indx];
let string varnames = "Bonds" "Equities" "Carry";

_Mixture_EM_PrintIters = 0;
_Mixture_EM_MaxIters = 1000;
_Mixture_EM_Tol = 1e-7;
_Mixture_EM_Debug = 0;
__output = 0;

asset = 2;
nLags = 22;
dt = nLags/260;
dt = 1;

R_Data = Data ./ lagn(Data,nLags) - 1.0;      
R = packr(R_Data[.,asset]); 

mu0 = meanc(R)/dt;
sigma0 = stdc(R)/sqrt(dt);     

pi1 = 0.70;
pi2 = 0.30;
mu1 = 0.10;
Sigma1 = 0.20^2;    
mu2 = -0.10;
Sigma2 = 0.20^2;    
 
{pi1,pi2,mu1,mu2,Sigma1,Sigma2,retcode,LogL} = Mixture_EM_Algorithm(R,pi1,pi2,mu1,mu2,Sigma1,Sigma2,0);

if retcode /= 0;
  print "The EM algorithm has not converged!";
endif; 
 
mu1 = mu1/dt;
sigma1 = sqrt(Sigma1/dt);
mu2 = mu2/dt;
sigma2 = sqrt(Sigma2/dt);

{mu3,sigma3,gamma3} = Mixture_Skewness(pi1,pi2,mu1,mu2,sigma1,sigma2);
   
Results = mu0|sigma0|pi1|pi2|mu1|sigma1|mu2|sigma2|mu3|sigma3;      
str = ftosa(100*Results,"%lf",3,2);
print /flush str;

x = seqa(-0.30,0.50/200,201);
pdf0 = pdfn((x - mu0)./sigma0)./sigma0;
pdf1 = pdfn((x - mu1)./sigma1)./sigma1;
pdf2 = pdfn((x - mu2)./sigma2)./sigma2;
pdf = pi1 .* pdf1 + pi2 .* pdf2;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 1|3|6|2; _plwidth = 10|10|10|15; _pcolor = 1|2|4|5; _pstype = 8; _plctrl = 0|0|0|10;
  xlabel("\216Return (in %)");
  xtics(-25,20,5,2);
//  ytics(0,4,0.5,2);
  _plegstr = "Regime 1\000Regime 2\000Mixture\000Gaussian";
  _plegctl = {2 5 1.5 5.0};
  xy(100*x,pdf1~pdf2~pdf~pdf0);
