new;
library frm,pgraph,optmum;
frmSet;

cls;

__output = 0;

declare matrix _gmm_W;

lambda = 4;

rndseed 123;
nS = 10;
u = rndu(nS,1);
y = -ln(1-u)/lambda;

y = trunc(100*y)/100;
print ftosa(y,"%lf",3,2);

m1 = meanc(y);
m2 = meanc(y^2);

proc (1) = gmm_h(theta);
  local lambda,lambda2,h;
  lambda = sqrt(theta^2);
  lambda2 = lambda^2;
  h = zeros(nS,2);
  h[.,1] = y - 1/lambda;
  h[.,2] = y^2 - 2/lambda2;
  retp(h);
endp;

proc gmm_g(theta);
  local g;
  g = meanc(gmm_h(theta));
  retp(g);
endp;

proc gmm_Q(theta);
  local lambda,lambda2,g,W,Q;
  lambda = sqrt(theta^2);
  lambda2 = lambda^2;
  g = zeros(2,1);
  g[1] = m1 - 1/lambda;
  g[2] = m2 - 2/lambda2;
  W = _gmm_W;
  Q = g'*W*g;
  retp(Q);
endp;

S = eye(2);

nIters = 6;
theta = zeros(nIters,1);

k = 1;
do until k > nIters;
  W = invpd(S);
  _gmm_W = W;
  {theta[k],fmin,grd,retcode} = optmum(&gmm_Q,4);
  h0 = gmm_h(theta[k]);
  S = (h0'h0)/nS;
  print "-----------------------------------------------";
  print ftosa(W,"%lf",3,2);
  print ftosa(1e4*S,"%lf",3,2);
  k = k + 1;
endo;

print ftosa(theta,"%lf",3,2);

__output = 1;
_reg_PrintIters = 0;
{theta,fmin,grd,Qmin} = regGMM(0,0,&gmm_h,4,0,0);
D = gradp(&gmm_g,theta);
print "D = " 1e4*D;
print "S = " 1e4*S;
cov = inv(10*D'*inv(S)*D);
sqrt(cov);

_regGMM_Jtest
