new;
library frm,pgraph,optmum;

cls;

declare matrix nS,seed;

n = 10;
rndseed 123456;
X = rndn(n,1);
U = rndu(n,1);
Y = X .* U;
print ftosa(Y,"%lf",3,3);

let Y = 
          -0.320 
          -0.262 
          -0.284 
          -0.296 
           0.636 
           0.547 
           0.024 
           0.483 
          -1.045 
          -0.030;

mu = 2*meanc(Y);
sigma = sqrt(3*meanc(Y^2) - mu^2);
results = mu|sigma;
print ftosa(results,"%lf",3,3);

__output = 0;

proc (1) = gmm_h(theta);
  local mu,sigma2,h;
  mu = theta[1];
  sigma2 = theta[2]^2;
  h = zeros(n,2);
  h[.,1] = Y - mu/2;
  h[.,2] = Y^2 - 1/3*(sigma2 + mu^2);
  retp(h);
endp;

__output = 1;
_reg_PrintIters = 0;
sv = rndu(2,1);
{theta0,stderr0,cov,Qmin} = regGMM(0,0,&gmm_h,sv,0,0);

proc (1) = smm_h(theta);
  local mu,sigma,Xs,Us,Ys,h;
  mu = theta[1];
  sigma = sqrt(theta[2]^2);

  rndseed seed;
  Xs = mu + sigma .* rndn(nS,1);
  Us = rndu(nS,1);
  Ys = Xs .* Us;
  
  h = zeros(n,2);
  h[.,1] = Y - meanc(Ys);
  h[.,2] = Y^2 - meanc(Ys^2);
  retp(h);
endp;

__output = 0;
_reg_PrintIters = 0;
sv = 0|1;

nIters = 1000;
theta1 = zeros(2,nIters);
theta2 = zeros(2,nIters);
stderr1 = zeros(2,nIters);
stderr2 = zeros(2,nIters);

iter = 1;
do until iter > nIters;
  seed = trunc(100000*rndu(1,1));
  nS = 50;
  {theta1[.,iter],stderr1[.,iter],grd,Qmin} = regGMM(0,0,&smm_h,sv,0,0);
  nS = 1000;
  {theta2[.,iter],stderr2[.,iter],grd,Qmin} = regGMM(0,0,&smm_h,sv,0,0);
  iter = iter + 1;
endo;

theta1 = theta1';
theta2 = theta2';
stderr1 = stderr1';
stderr2 = stderr2';

print ftosa(theta0~meanc(theta1)~meanc(theta2),"%lf",3,3);
print ftosa(stderr0~meanc(stderr1)~meanc(stderr2)~stdc(theta1)~stdc(theta2),"%lf",3,3);




