new;
library frm,pgraph,optmum;

cls;

__output = 0;

declare matrix nS,seed,Threshold;

rndseed 123;
nObs = 20;
nLoss = 5;
x_ln = exp(5.65 + rndn(nLoss,nObs));
agg_loss = trunc(sumc(x_ln));

sv = 5|1;

proc GMM_LN(theta);
  local mu,sigma,m1,m2,M;

  mu = theta[1];
  sigma = sqrt(theta[2]^2);

  m1 = nLoss * exp(mu + 0.5 * sigma^2);
  m2 = nLoss * exp(2 * mu + sigma^2) * (exp(sigma^2) - 1);

  M = zeros(nObs,2);
  M[.,1] = agg_loss - m1;
  M[.,2] = (agg_loss - m1)^2 - m2;

  retp(M);
endp;

proc SMM_LN(theta);
  local mu,sigma,y,m1,m2,M;

  mu = theta[1];
  sigma = sqrt(theta[2]^2);

  rndseed seed;
  y = sumc(exp(mu + sigma .* rndn(nLoss,nS)));
  y = selif(y,y .>= threshold);
  m1 = meanc(y);
  m2 = stdc(y)^2;

  M = zeros(nObs,2);
  M[.,1] = agg_loss - m1;
  M[.,2] = (agg_loss - m1)^2 - m2;

  retp(M);
endp;

theta = zeros(2,3);

seed = 12346;
nS = 2000;
Threshold = 0;
{theta[.,1],stderr,Mcov,Qmin} = regGMM(0,0,&GMM_LN,sv,0,0);
{theta[.,2],stderr,Mcov,Qmin} = regGMM(0,0,&SMM_LN,sv,0,0);
Threshold = 1000;
{theta[.,3],stderr,Mcov,Qmin} = regGMM(0,0,&SMM_LN,sv,0,0);

cls;

print ftosa(agg_loss,"%lf",3,0);

print ftosa(abs(theta),"%lf",3,3);


