new;
library frm,pgraph,optmum;

cls;

PathName = "..\\..\\data\\";
datFileName = PathName $+ "carry.dat";

data = loadd(datFileName);
data = selif(Data,Data[.,1] .>= 20000101);
vnames = "" $+ getname(datFileName);

Dates = data[.,1];
nDates = rows(Dates);

let indx = 2 3 4;
data = data[.,indx];
vnames = vnames[indx];
let string varnames = "Bonds" "Equities" "Carry";

asset = 2;
nLags = 5;
R_Data = Data ./ lagn(Data,nLags) - 1.0;      
R = 100*packr(R_Data[.,asset]); 

min_R = minc(R);
max_R = maxc(R);

mu = meanc(R);
sigma = stdc(R);

x1 = seqa(-10,20/20,21);
x2 = seqa(-10,20/200,201);
x3 = seqa(-10,20/2000,2001);

graphset;
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  ylabel("\216Frequency (in %)");
  xlabel("\216Return (in %)");
  xtics(-12,12,3,1);
  _ptitlht = 0.30; _pnumht = 0.225; _paxht = 0.225;

  setwind(1);
    _pbartyp = {6 1};
    title("\216h = 1%");
    ytics(0,25,5,2);
    call histp(R,x1);

  setwind(2);
    _pbartyp = {6 2};
    title("\216h = 10 bps");
    ytics(0,2.5,0.5,2);
    call histp(R,x2);

  setwind(3);
    _pbartyp = {6 3};
    title("\216h = 1 bp");
    ytics(0,0.5,0.1,2);
    call histp(R,x3);

  endwind;