new;
library frm,pgraph,optmum;

cls;

PathName = "..\\..\\data\\";
datFileName = PathName $+ "carry.dat";

data = loadd(datFileName);
data = selif(Data,Data[.,1] .>= 20000101);
vnames = "" $+ getname(datFileName);

Dates = data[.,1];
nDates = rows(Dates);

let indx = 2 3 4;
data = data[.,indx];
vnames = vnames[indx];
let string varnames = "Bonds" "Equities" "Carry";

asset = 2;
nLags = 5;
R_Data = Data ./ lagn(Data,nLags) - 1.0;      
R = 100*packr(R_Data[.,asset]); 

x = seqa(-12,24/200,201);
mu = meanc(R);
sigma = stdc(R);
sv = mu|sigma;

d1 = pdfn((x - mu)/sigma)/sigma;
F1 = cdfn((x - mu)/sigma);

declare matrix nu; 
fn gen_pdft(x,mu,sigma,nu) = pdft((x - mu)/sigma,nu)/sigma;
fn gen_cdft(x,mu,sigma,nu) = cdft((x - mu)/sigma,nu);

proc (1) = ml_t(theta);
  local mu,sigma,logl;
  mu = theta[1];
  sigma = sqrt(theta[2]^2);
  logl = ln(gen_pdft(R,mu,sigma,nu));
  retp(logl);
endp;

nu = 4;
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d2 = gen_pdft(x,mu,sigma,nu);
F2 = gen_cdft(x,mu,sigma,nu);

nu = 2; 
{theta,stderr,Mcov,LogL} = regML(0,0,&ml_t,sv,0,0);
mu = theta[1];
sigma = sqrt(theta[2]^2);
d3 = gen_pdft(x,mu,sigma,nu);
F3 = gen_cdft(x,mu,sigma,nu);

{d4,F4} = regKernelDensity(R,x);
h = 1.0;
_Kernel_h = 1|h;
{d4,F4} = regKernelDensity(R,x);

graphset;
  begwind;
  window(2,2,1);

    _pdate = ""; _pnum = 2; _pframe = 0;
    xlabel("\216Return (in %)");
    xtics(-12,12,3,1);
    ytics(0,0.25,0.05,2);
    _ptitlht = 0.30; _pnumht = 0.225; _paxht = 0.225;
    _pltype = 6; _plwidth = 10;

  setwind(1);
    _pcolor = 1;
    title("\216Gaussian distribution");
    xy(x,d1);

  setwind(2);
    _pcolor = 2;
    title("\216Student t]4[");
    xy(x,d2);

  setwind(3);
    _pcolor = 3;
    title("\216Student t]2[");
    xy(x,d3);

  setwind(4);
    _pcolor = 4;
    title("\216Gaussian kernel");
    xy(x,d4);

  endwind;