new;
library frm,pgraph;

rndseed 123;
n = 1000;
x = rndu(n,1);
y = sin(9*x) + (rndu(n,1) - 0.5);
m = 50;
t = seqa(0,1/(m-1),m);

alpha = 0.90;
m_x = sin(9*t);
q_x = sin(9*t) + (alpha' - 0.5);

m0 = regNadarayaWatson(y,x,t);
m1 = regKernelLocal(y,x,1,t);
m2 = regKernelLocal(y,x,2,t);
m = m0~m1~m2;

q1 = regKernelLocalQuantile(y,x,alpha,1,t);
q2 = regKernelLocalQuantile(y,x,alpha,2,t);

graphset;
  begwind;
  window(2,2,1);
  window(2,2,1);

  _pdate = 0; _pframe = 0; _pnum = 2; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275; 
  _plwidth = 10; _pltype = 6|1|3; _pcolor = 1|2|4;

  xlabel("\216x]i["); 
  ylabel("\216y]i[");
  xtics(0,1,0.2,1);
  ytics(-1.5,1.5,0.5,1);
  fonts("simplex simgrma");

  setwind(1);
    title("\216Conditional expectation\L\216Nadaraya-Watson");
    xy(t,m_x~m0);

  setwind(2);
    title("\216Conditional expectation\L\216Local quadratic model");
    xy(t,m_x~m2);

  setwind(3);
    title("\216Conditional quantile (\202a\201 = 90\%)\L\216Local linear model");
    xy(t,q_x~q1);

  setwind(4);
    title("\216Conditional quantile (\202a\201 = 90\%)\L\216Local quadratic model");
    _plegstr = "True\000Estimate";
    _plegctl = {2 5 6.25 1.25};
    xy(t,q_x~q2);

  _plegctl = 0; 
  _plctrl  = -1; _pstype  = 3; _psymsiz = 0.75; _pcolor = 8;

  setwind(5);  
    title("\216Conditional expectation\L\216Nadaraya-Watson");
    xy(x,y);

  setwind(6);
    title("\216Conditional expectation\L\216Local quadratic model");
    xy(x,y);

  setwind(7);  
    title("\216Conditional quantile (\202a\201 = 90\%)\L\216Local linear model");
    xy(x,y);

  setwind(8);
    title("\216Conditional quantile (\202a\201 = 90\%)\L\216Local quadratic model");  
    xy(x,y);

  endwind;
