new;
library frm,pgraph;

rndseed 156;

x1 = seqa(1,1,200);
x2 = rndu(200,1)*5;
x = ones(200,1)~x1~x2;
y1 = 2 + x1[1:100] + 3*x2[1:100] + rndn(100,1);
y2 = 10 + x1[101:200] + 3*x2[101:200] + rndn(100,1);
y = y1 | y2;

{beta_t,stderr_t,residuals,sigma_t,RSS_t} = regRLS(y,x);

K = 3;
nT = 200;
t = seqa(1,1,nT);

residuals = missrv(residuals,0);

u_t = residuals[.,1];
v_t = residuals[.,2];
w_t = residuals[.,3];

sigma2 = sumc(u_t^2)/(nT - K); 
cusum = cumsumc(w_t)/sqrt(sigma2);
stderr_cusum = sqrt(t - K);
cusumsq = cumsumc(w_t^2) / sumc(w_t^2);

tstudent_t = miss(beta_t ./ stderr_t,__Infp);
beta_bound = beta_t[.,1]~(beta_t[.,1] - 2*stderr_t[.,1])~(beta_t[.,1] + 2*stderr_t[.,1]);
v_bound = v_t~(-2*sigma_t)~(2*sigma_t);
cusum_bound = cusum~(cusum - 2*stderr_cusum)~(cusum + 2*stderr_cusum);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|3; _plwidth = 10; _pcolor = 1|4|4;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  xlabel("\216t");
  xtics(0,200,50,2);

  _ptitlht = 0.275;

  setwind(1);
    title("\216c]t[");
    ytics(-2,4,2,0);
    xy(t,beta_bound);
  setwind(2);
    title("\216v]t[");
    ytics(-6,9,3,0);
    xy(t,v_bound);

  _ptitlht = 0.25;

  setwind(3);
    title("\216CUSUM");
    ytics(-25,100,25,0);
    xy(t,cusum_bound);
  setwind(4);
    title("\216CUSUMSQ");
    ytics(0,1.0,0.20,0);
    xy(t,cusumsq~(t/nT));

endwind;

