new;
library qam,pgraph,optmum;
qamSet;

rndseed 123;

proc (1) = simulate_unit_root(y0,sigma,nt);
  local k,u,y;

  k = maxc(rows(y0)|rows(sigma)); 
  u = rndn(nt,k) .* sigma';
  y0 = y0' .* ones(1,k);
  y = recserar(u,y0,ones(1,k));

  retp(y);
endp;

y = simulate_unit_root(100|50,0.5|5,100);
y1 = y[.,1];
y2 = y[.,2];
y3 = -10 + 2*y1 - y2 + 0.25*rndn(100,1);
y4 = 2*y1 - y2 - y3;

graphset;
  begwind;
  window(2,2,0);
   _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pltype = 6|1;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.325;
  xlabel("\216t");

  setwind(1);
    title("\216y]1,t[");
    _pcolor = 1;
    ytics(98,106,2,2);
    xy(0,y1);

  setwind(2);
    title("\216y]2,t[");
    _pcolor = 2;
    ytics(30,80,10,2);
    xy(0,y2);

  setwind(3);
    title("\216y]3,t[");
    _pcolor = 3;
    ytics(110,170,10,2);
    xy(0,y3);

  setwind(4);
    title("\216z]t[");
    _pcolor = 4;
    _pline = 1~3~1~10~100~10~1~0~10;
    ytics(9.2,10.6,0.2,2);
    xy(0,y4);

  endwind;


