new;
library frm,pgraph;
cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "monthly-data-spx";
datFileName = datPathName $+ "equity-indices-2017-monthly";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

BeginDate = 19500101;
EndDate = 20191231;
Dates = data[.,1];
Index = data[.,2];

Rt = ln(Index) - ln(lag1(Index));
Rt = selif(Rt, (Dates .>= BeginDate) .and (Dates .<= EndDate));
Dates = selif(Dates, (Dates .>= BeginDate) .and (Dates .<= EndDate));
nDates = rows(Dates);

graphset;
  window(2,1,0);
  _pdate = 0; _pframe = 0; _pnum = 2;
  _plwidth = 7; _pltype = 6;
  _ptitlht = 0.30; _pnumht = 0.225; _paxht = 0.225;
  xtics(1,nDates,12*10,1);

  let xlab = "1950" "60" "70" "80" "90" "2000" "10" "20";
  asclabel(xlab,0);
 
  setwind(1);
    _pcolor = 1;
    title("\216R]t[");
    ytics(-25,15,5,2);
    xy(0,100*Rt);

  nextwind;
   margin(0.25,0,0,0);
    _pcolor = 4;
    title("\216R]t[[2]");
    ytics(0,6,1,2);
    xy(0,100*Rt^2);

  endwind;
