new;
library cml,optmum,frm,pgraph;
cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "equity-indices-2017-monthly";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

BeginDate = 19500101;
EndDate = 20191231;
Dates = data[.,1];
Index = data[.,2];

Rt = ln(Index) - ln(lag1(Index));
Rt = selif(Rt, (Dates .>= BeginDate) .and (Dates .<= EndDate));
Dates = selif(Dates, (Dates .>= BeginDate) .and (Dates .<= EndDate));
nDates = rows(Dates);
T = nDates;

// Garch ML
p = 1; 
q = 1;
{theta,cl,cov,Logl} = regGarch(Rt,1,p,q,0);
stderr = sqrt(diag(cov));
tstudent = theta ./ stderr;
nParam = rows(theta);
df = T - nParam;
pvalue = 2*cdftc(abs(tstudent),df);

cls;

cn = T|0|T|nParam|nParam|df|Logl;
parnm = 0 $+ "P" $+ ftocv(seqa(1,1,nParam),2,0);
parnm = "Const" | 
        "alpha0" |
        (0 $+ "gamma" $+ ftocv(seqa(1,1,p),1,0)) |
        (0 $+ "alpha" $+ ftocv(seqa(1,1,q),1,0)) ;
call _reg_print(parnm,theta,stderr,tstudent,pvalue,cn,1,2);

