new;
library frm,pgraph,optmum,tsm;

phi = 0.5;
sigma = 0.20;

n = 300;
_fourier = 1;

nS = 250;
sv = phi|sigma;
coeffs = zeros(nS,2);

__output = 0;

iter = 1;
do until iter > nS;
  x = recserar(sigma * rndn(n,1),0,phi);
  {theta,fmin,grd,retcode} = optmum(&ar1_tdml,sv);
  coeffs[iter,1] = theta[1];

  {theta,fmin,grd,retcode} = optmum(&ar1_fdml,theta);
  coeffs[iter,2] = theta[1];

  iter = iter + 1;
endo;

proc ar1_tdml(theta);
  local phi,sigma2,u,logl;

  phi = theta[1];
  sigma2 = theta[2]^2;
  u = x - phi * lag1(x);
  logl = -0.5*ln(2*pi)-0.5*ln(sigma2)-0.5*u^2/sigma2;
  retp(-sumc(packr(logl)));
endp;

proc ar1_fdml(theta);
  local phi,sigma,lambda,I,f,logl;

  phi = theta[1];
  sigma = sqrt(theta[2]^2);

  {lambda,I} = PDGM(x);
  f = spectral_density_arma(phi,0,sigma,lambda);
  logl = -rows(x)/2*ln(2*pi) - 0.5 * sumc(ln(f))  - 0.5 * sumc(I./f);

  retp(-logl);
endp;

phi = seqa(0,1/100,101);
{d1,F} = regKernelDensity(Coeffs[.,1],phi);
{d2,F} = regKernelDensity(Coeffs[.,2],phi);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|4;
  xtics(0.2,0.8,0.10,2);
  _plegstr = "Time domain\000Frequency domain";
  _plegctl = {2 5 6 5};
  xlabel("\216Parameter \202F\201");
  ylabel("\216PDF");
  xy(phi,d1~d2);

  