new;
library frm,tsm,optmum,pgraph;
TSMset;

rndseed 123;

phi = 0.75; theta = 0.2; sigma_u = 1; sigma_v = 0.5;
true_parameters = phi|sigma_u|theta|sigma_v;

n = 1000;
u = rndn(n,1)*sigma_u;
x = recserar(u,0,phi);
v = rndn(n,1)*sigma_v;
y = v - theta*lag1(v); y[1] = v[1];
z = x + y;

{lambda,I} = PDGM(z);
I = I/(2*pi);

sv = 0.75|1|0.2|0.5;
_tsm_parnm = "phi"|"sigma_u"|"theta"|"sigma_v";
{estimated_parameters,stderr,Mcov,Logl} = FD_ml(z,&sgf,sv);

f1 = sdf(true_parameters,lambda);
f2 = sdf(estimated_parameters,lambda);

q = trunc(rows(lambda)/2);

graphset;
  window3u;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2; 
  _pltype = 6; _plwidth = 8; 
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;

  setwind(1);
    title("\216Simulation of z]t[");
    _pcolor = 1;
    xtics(0,1000,200,2);
    ytics(-6,6,2,2);
    xy(0,z);

  setwind(2);
    title("\216Periodogram I]z[(\202l\201)");
    _pcolor = 2;
    xlabel("\216\202l\201");
    xtics(0,pi,pi/4,0);
    ytics(0,6,1,2);
    lab = " 0 \202p\201/4 \202p\201/2 \2013\202p\201/4 \202p\201";
    asclabel(lab,0);
    xy(lambda[1:q],I[1:q]);

  setwind(3);
    title("\216Spectral density function f]z[(\202l\201)");
    _pcolor = 3|4; _pltype = 6|3;
    _plegstr = "True\000Estimated";
    _plegctl = {2 5 5 4};
    xy(lambda[1:q],f1[1:q]~f2[1:q]);

  endwind;

proc sgf(coeff,lambda);
  local phi,theta,sigma_u,sigma_v;
  local w,g;
  phi = coeff[1];
  sigma_u = coeff[2];
  theta = coeff[3];
  sigma_v = coeff[4];
  w = cos(lambda);
  g = (sigma_u^2) ./ (1 - 2*phi*w + phi^2) +
      (sigma_v^2) .* (1 - 2*theta*w + theta^2);
  retp(g);
endp;

proc sdf(coeff,lambda);
  local g;
  g = sgf(coeff,lambda);
  retp(g/(2*pi));
endp;
