new;
library frm,pgraph,optmum;

cls;

#define USE_OPTMUM

rndseed 123;

n = 30;

beta = 5|1|1;
x = 20*rndu(n,2)-10;
x = ones(n,1)~x;
x = trunc(10*x)/10;
u = 5*rndn(n,1);
y_star = x*beta + u;
y_star = trunc(10*y_star)/10;
y = _max_(y_star,0.0);

data = seqa(1,1,n)~y~x;
print ftosa(data[1:10,.]',"%lf",3,1);
print ftosa(data[11:20,.]',"%lf",3,1);
print ftosa(data[21:30,.]',"%lf",3,1);


let sv = {1,1,1,0.5};
__title = "Tobit Model";

_reg_cov = 1; 
_reg_PrintIters = 0;
{theta,stderr,cov,logl} = regTobit(0,y,x,sv,0,0);
beta_ml = theta[1:3];
sigma_ml = theta[4];

z = x*beta_ml/sigma_ml;

D0 = delif(seqa(1,1,n),y .> 0);
D1 = selif(seqa(1,1,n),y .> 0);
y0_star = y_star[D0];
y0 = y[D0];
y1_star = y_star[D1];
y1 = y[D1];
x0 = x[D0,.];
x1 = x[D1,.];
z0 = x0*beta_ml/sigma_ml;
z1 = x1*beta_ml/sigma_ml;

alpha = -z;
lambda = pdfn(-alpha)./cdfn(-alpha);

alpha = z0;
lambda0 = pdfn(-alpha)./cdfn(-alpha);

alpha = -z1;
lambda1 = pdfn(-alpha)./cdfn(-alpha);

beta1 = invpd(x1'x1)*x1'y1;
sigma1 = sqrt(meanc( (y1 - x1*beta_ml) .* y1));
beta2 = beta1 - sigma1*invpd(x1'x1)*x0'lambda0;
sigma2 = sigma1;
beta3 = beta1 - sigma1*invpd(x1'x1)*x1'lambda1;
sigma3 = sigma1;
print ftosa((beta1|error(0))~(beta2|sigma2)~(beta3|sigma3),"%lf",5,5);

print "------------------------------------------------------------------";

y0_hat = x0*beta_ml - sigma_ml*lambda0;
print ftosa(y0_star~y0~y0_hat,"%lf",5,3);

y1_hat = x1*beta_ml + sigma_ml*lambda1;
print ftosa(y1_star~y1~y1_hat,"%lf",5,3);

print "------------------------------------------------------------------";

y_hat = x*beta_ml;
data = zeros(n,4);
data[.,1] = y_star;
data[.,2] = y;
data[D0,3] = y0_hat;
data[D1,3] = y1_hat;
data[.,4] = y_hat;

print ftosa(data,"%lf",5,3);

data = seqa(1,1,n)~data[.,2 3 4];
print ftosa(data[1:10,.]',"%lf",3,1);
print ftosa(data[11:20,.]',"%lf",3,1);
print ftosa(data[21:30,.]',"%lf",3,1);



