new;
library frm,pgraph;
frmSet;

proc (1) = rho_LN(sigma1,sigma2,rho);
  local cor;
  cor = (exp(rho .* sigma1 .* sigma2)-1.0) ./ sqrt( (exp(sigma1^2)-1.0) .* (exp(sigma2^2)-1.0) );
  retp(cor);
endp;

sigma1 = 1;
sigma2 = 3;

rho = -1.0|-0.7|0|0.7|1.0;

results = rho_LN(sigma1,sigma2,rho)~KendallCopulaNormal(rho)~SpearmanCopulaNormal(rho);

print ftosa(results,"%lf",3,3);

sigma1 = 0.1~1~2~4; 
sigma2 = seqa(0.01,0.02,250);
rho_min = rho_LN(sigma1,sigma2,-1);
rho_max = rho_LN(sigma1,sigma2,1);

sigma = seqa(0.01,0.02,250);
rho_min2 = rho_LN(sigma,sigma,-1);
rho_max2 = rho_LN(sigma,sigma,1);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  fonts("simplex simgrma");
  xlabel("\216\202s\201]2[");
  xtics(0,5,1,2);

  setwind(1);
    title("\216\202s\201]1[ = 0.1");
    ytics(-1,1,0.5,2);
    xy(sigma2,rho_max[.,1]~rho_min[.,1]);

  setwind(2);
    title("\216\202s\201]1[ = 1");
    xy(sigma2,rho_max[.,2]~rho_min[.,2]);

  setwind(3);
    title("\216\202s\201]1[ = 2");
    xy(sigma2,rho_max[.,3]~rho_min[.,3]);

  setwind(4);
    title("\216\202s\201]1[ = \202s\201]2[ = \202s\201");
    _plegstr = "Upper bound \202r\201[+]\000Lower bound \202r\201[-]";
    _plegctl = {2 6 4 1};
    xlabel("\216\202s\201");
    xtics(0,3,0.5,2);
    xy(sigma,rho_max2~rho_min2);

  endwind;
