new;
library frm,pgraph;
frmSet;

cls;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 20060101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M1EU" "M2US" "LGAGTRUH" "LUACTRUU" "BCOMTR";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

rho1 = corrx(Rt);
rho2 = miss(zeros(5,5),0);
rho3 = rho2;

i = 1;
do until i > 5;
  j = 1; 
  do until j > 5;
    x1 = Rt[.,i]; 
    x2 = Rt[.,j]; 
    tau = KendallTau(x1,x2);
    varrho = SpearmanRho(x1,x2);
    rho2[i,j] = sin(pi*tau/2);
    rho3[i,j] = 2*sin(pi*varrho/6);
    j = j + 1;
  endo;
  i = i + 1;
endo;

print ftosa(100*lowmat2(rho1,error(0)),"%lf",3,1);
print ftosa(100*lowmat2(rho2,error(0)),"%lf",3,1);
print ftosa(100*lowmat2(rho3,error(0)),"%lf",3,1);