new;
library optmum,frm,pgraph;
frmSet;

cls;

/*
**> mle
**
*/

declare matrix _mle_mlProc,_mle_data;

proc (1) = mle(data,mlProc,sv);
  local theta,f,g,retcode;
  _mle_mlProc = mlProc;
  _mle_data = data;
  {theta,f,g,retcode} = optmum(&__mlProc,sv);
  retp(theta);
endp;

proc (1) = __mlProc(theta);
  local mlProc;
  mlProc = _mle_mlProc;
  local mlProc:proc;
  retp( -sumc(mlProc(_mle_data,theta)) );
endp;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 20060101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M1EU" "M2US";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

_copula_rankindx = 1;
x = Rt;
x1 = x[.,1]; x2 = x[.,2]; 
u = Dependogram(Rt);
u1 = u[.,1]; u2 = u[.,2];

proc pdfCopula(u1,u2,theta);
  retp( pdfCopulaFrank(u1,u2,theta) );
endp;

proc omProc(data,theta);
  retp( ln(pdfCopula(data[.,1],data[.,2],theta)) );
endp;

theta_om = mle(u,&omProc,2);

m = meanc(Rt);
sigma = stdc(Rt);
u1 = cdfn((x1-m[1])/sigma[1]);
u2 = cdfn((x2-m[2])/sigma[2]);
u = u1~u2;

theta_ifm = mle(u,&omProc,2);

sv = m[1]|sigma[1]|m[2]|sigma[2]|theta_ifm;

proc mlProc(data,theta);
  local m1,sigma1,m2,sigma2,thetaCopula,u1,u2;
  m1 = theta[1];
  sigma1 = sqrt(theta[2]^2);
  m2 = theta[3];
  sigma2 = sqrt(theta[4]^2);
  thetaCopula = theta[5];
  u1 = cdfn((data[.,1]-m1)/sigma1);
  u2 = cdfn((data[.,2]-m2)/sigma2);
  retp( ln( pdfCopula(u1,u2,thetaCopula) ) + 
        ln(pdfn((data[.,1]-m1)/sigma1)/sigma1) +
        ln(pdfn((data[.,2]-m2)/sigma2)/sigma2) );
endp;

theta_ml = submat(mle(x,&mlProc,sv),5,1);

tau = KendallTau(x1,x2);

proc FindParameter1(theta);
  retp((-KendallCopulaFrank(theta) + tau)^2);
endp;

{theta_kendall,f0,g0,retcode} = Qnewton(&FindParameter1,2);

varrho = SpearmanRho(x1,x2);

proc FindParameter2(theta);
  retp((-SpearmanCopulaFrank(theta) + varrho)^2);
endp;

{theta_spearman,f0,g0,retcode} = Qnewton(&FindParameter2,2);

theta = theta_ml | theta_ifm | theta_om | theta_kendall | theta_spearman;
tau = zeros(5,1);
varrho = zeros(5,1);
i = 1;
do until i > 5;
  tau[i] = KendallCopulaFrank(theta[i]);
  varrho[i] = SpearmanCopulaFrank(theta[i]);
  i = i + 1;
endo;

Results = theta~tau~varrho;
print ftosa(Results',"%lf",3,3);
