new;
library frm,pgraph,optmum;

__output = 0;

proc cdf(x,gamma_);
  retp(x^gamma_);
endp;

proc pdf(x,gamma_);
  gamma_ = sqrt(gamma_^2);
  retp(gamma_ .* x^(gamma_-1) );
endp;

x = seqa(1/1000,1/100,101);
d = pdf(x,1~ln(2));

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|2;
  xtics(0,100,20,2);
  ytics(0.5,3.0,0.5,2);
  xlabel("\216LGD (in %)");
  ylabel("\216Density function");
  _plegstr = "\202g\201 = 1\000\202g\201 = ln(2)";
  _plegctl = {2 5 6 4};
  xy(100*x,d);

rndseed 123;

let x = 0.5 0.4 0.6 0.7 0.8 0.9 0.9 0.2 0.5 0.5;
let y = 0.6 0.5 0.8 0.7 0.8 0.9 0.9 0.1 0.4 0.4;

let x = 0.5 0.4 0.6 0.5 0.8 0.9 0.7 0.1 0.4 0.4;
let y = 0.6 0.5 0.8 0.7 0.8 0.9 0.8 0.3 0.5 0.7;


print ftosa(100*x'|100*y',"%lf",3,0);

declare theta;

proc ml1(theta);
  retp( ln(pdf(x,theta)) );
endp;

proc ml2(theta);
  retp( ln(pdf(y,theta)) );
endp;

sv = 1.0;
{gamma1,logl,stderr,cov} = regML(0,0,&ml1,sv,0,0);
gamma1_ml = -1/meanc(ln(x));

{gamma2,logl,stderr,cov} = regML(0,0,&ml2,sv,0,0);
gamma2_ml = -1/meanc(ln(y));

proc mlProc(params);
  local gamma1,gamma2,theta,u1,u2;
 
  params = sqrt(params^2);
  gamma1 = params[1];
  gamma2 = params[2];
  theta = params[3];  

  u1 = cdf(x,gamma1);
  u2 = cdf(y,gamma2);

  retp( -sumc(real(ln(pdfCopulaGumbelBarnett(u1,u2,theta) .* pdf(x,gamma1) .* pdf(y,gamma2)))) );
endp;

let sv = 0.5 0.4 2.1;
let sv = 0.5 0.4 1.1;
{params,logl,grd,retcode} = optmum(&mlProc,sv);
params = abs(params);

print "--------------------------------";
print gamma1~gamma1_ml;
print gamma2~gamma2_ml;
print params;