new;
library qam,frm,pgraph,optmum;

rndseed 123;

cls;

proc (1) = cdfCopulaPareto2(u1,u2,alpha);
  local cdf;
  cdf = u1 + u2 - 1 + ( (1-u1)^(-1./alpha) + (1-u2)^(-1./alpha) - 1 )^(-alpha);
  retp(cdf);
endp;

proc (1) = pdfCopulaPareto2(u1,u2,alpha,mtd);
  local pdf;
  if mtd == 1;
    pdf = ((alpha+1)./alpha) .* ( (1-u1)^(-1./alpha) + (1-u2)^(-1./alpha) - 1 )^(-alpha-2) .*
          (1 - u1 - u2 + u1 .* u2)^(-1./alpha-1);
  else;
    pdf = ((alpha+1)./alpha) .* ( (1-u1)^(1./alpha) + (1-u2)^(1./alpha) - (1-u1)^(1./alpha) .* (1-u2)^(1./alpha) )^(-alpha-2) .*
          (1 - u1 - u2 + u1 .* u2)^(1./alpha);
  endif;
  retp(pdf);
endp;

u1 = seqa(0,1/100,99)';
u2 = u1';

alpha = 1.00;
pdf = pdfCopulaPareto2(u1,u2,alpha,0);
pdf1 = pdf;

alpha = 10.0;
pdf = pdfCopulaPareto2(u1,u2,alpha,0);
pdf2 = pdf;

fn cdfCopula(u1,u2) = cdfCopulaPareto2(u1,u2,alpha);

alpha = seqa(0.01,0.1,100);
lambda_plus = 2^(-alpha);
lambda_minus = zeros(rows(alpha),1);

graphset;
  window3d;

    _pdate = ""; _pframe = 0; _pnum = 2;
    _paxht = 0.25; _ptitlht = 0.275;
    fonts("simplex simgrma");

  setwind(1);
    xtics(0,1,0.2,2);
    xlabel("\216u]1[");
    ylabel("\216u]2[");
    ytics(0,1,0.2,2);
    _pzclr = reshape(seqa(1,1,7),20,1);
    title("\216\202a\201 = 1");
    surface(u1,u2,pdf1);

  setwind(2);
    title("\216\202a\201 = 10");
    surface(u1,u2,pdf2);

  setwind(3);
    _pcolor = 1|4; _pltype = 6|3; _plwidth = 8|10;
    xtics(0,10,1,2);
    ytics(0,1,.2,2);
    xlabel("\216\202a\201");
    ylabel("");
    title("\216Tail dependence");
    _plegstr = "Upper\000Lower";
    _plegctl = {2 6 7 3.5};
    xy(alpha,lambda_plus~lambda_minus);

  endwind;