new;
library frm,pgraph;
frmSet;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 19950101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M2EF" "M2US";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

Rt = Rt[.,2];

mu_G = meanc(Rt);
sigma_G = stdc(Rt);

fn cdfProc1(x) = cdfn((x - mu_G)/sigma_G);
fn pdfProc1(x) = pdfn((x - mu_G)/sigma_G)/sigma_G;

n = 1~22~262~262*10;
x = seqa(-0.20,0.50/1000,1001);
pdf1 = pdfMaximumStatistic(x,n,&cdfProc1,&pdfProc1);

nu = 3; 
mu_T = meanc(Rt);   
sigma_T = stdc(Rt)/sqrt(nu/(nu-2));

fn cdfProc2(x) = cdft((x - mu_T)/sigma_T,nu);
fn pdfProc2(x) = pdft((x - mu_T)/sigma_T,nu)/sigma_T;

pdf2 = pdfMaximumStatistic(x,n,&cdfProc2,&pdfProc2);

nu = 6;
mu_T = meanc(Rt);   
sigma_T = stdc(Rt)/sqrt(nu/(nu-2));

fn cdfProc3(x) = cdft((x - mu_T)/sigma_T,nu);
fn pdfProc3(x) = pdft((x - mu_T)/sigma_T,nu)/sigma_T;

pdf3 = pdfMaximumStatistic(x,n,&cdfProc3,&pdfProc3);

pdf1 = missex(pdf1,pdf1 .<= 1e-2);
pdf2 = missex(pdf2,pdf2 .<= 1e-1);
pdf3 = missex(pdf3,pdf3 .<= 1e-1);

graphset;
  begwind;
  window(2,2,0);

  _pframe = 0; _pnum = 2; _pltype = 6|3|1; _plwidth = 10; _pcolor = 2|3|4;
  _pnumht = 0.20; _ptitlht = 0.25; _paxht = 0.25;
  xlabel("\216Return (in %)");

  setwind(1);
    title("\216One trading day (n = 1)");
    xtics(-5,10,5,2);
    ytics(0,60,10,2);
    xy(100*x,pdf1[.,1]~pdf2[.,1]~pdf3[.,1]);

  setwind(2);
    title("\216One trading month (n = 22)");
    xtics(0,15,5,2);
    ytics(0,75,25,2);
    xy(100*x,pdf1[.,2]~pdf2[.,2]~pdf3[.,2]);

  setwind(3);
    title("\216One trading year (n = 262)");
    xtics(0,20,5,2);
    ytics(0,100,20,2);
    xy(100*x,pdf1[.,3]~pdf2[.,3]~pdf3[.,3]);

  setwind(4);
    title("\216Ten trading years (n = 2620)");
    xtics(0,25,5,2);
    ytics(0,120,30,2);
    _plegstr = "Gaussian\000t]3[\000t]6[";
    _plegctl = {2 5 5 3};
    xy(100*x,pdf1[.,4]~pdf2[.,4]~pdf3[.,4]);

  endwind;

