new;
library frm,optmum,pgraph;
frmSet;

declare matrix gamma_,lambda0,N;

proc (1) = h(t);
  retp( lambda0 .* gamma_ .* gpower(t,gamma_-1) );
endp;

proc (1) = S(t);
  retp( exp(-lambda0 .* (t^gamma_ )) );
endp;

proc (1) = pdf(t);
  retp( h(t) .* S(t) );
endp;

proc (1) = cdf(t);
  local F;
  F = 1 - S(t);
  retp(F);
endp;

proc (1) = S_tau(t,theta,n,lambda0,gamma_);
  local y;
  y = exp(-(n^(1./theta)) .* lambda0 .* (t^gamma_) );
  retp(y);
endp;

proc (1) = pdf_tau(t,theta,n,lambda0,gamma_);
  local y;
  y = n .* ((lambda0 .* (t^gamma_))^theta);
  y = (y^(1./theta-1)) .* (gamma_ ./ t .* y) .* exp(-y^(1./theta));  
  retp(y);
endp;  

proc multivariateSurvival(t);
  t = t .* ones(1,n);
  retp( S(t) );
endp;
  
t = 0.001|seqa(1/10,1/10,205);   
lambda0 = 0.03; 
gamma_ = 2;

n = 10;
y = pdf_tau(t,1.0,n,lambda0,gamma_)~
    pdf_tau(t,1.5,n,lambda0,gamma_)~
    pdf_tau(t,2.0,n,lambda0,gamma_)~
    pdf(t);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5; _plwidth = 10; _pcolor = 1|2|3|4; _pstype = 8; _plctrl = 0|0|0|15;
  fonts("simplex simgrma");
  xlabel("\216t");
  xtics(0,12,2,2);
  ytics(0,0.5,0.1,2);
  _plegstr = "C[\202\74\201]\000\202Q\201 = 1.5\000\202Q\201 = 2\000C[+]";
  _plegctl = {2 5 5 4};
  xy(t,y);

