new;
library frm,pgraph,optmum;
frmSet;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 19950101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M2EF" "M2US";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

Rt = Rt[.,2];

mu_G = meanc(Rt);
sigma_G = stdc(Rt);

fn cdfProc(x) = cdfn((x - mu_G)/sigma_G);
fn pdfProc(x) = pdfn((x - mu_G)/sigma_G)/sigma_G;

n = 22;
x = seqa(-0.20,0.50/1000,1001);
pdf1 = pdfMaximumStatistic(x,n,&cdfProc,&pdfProc);

max = Ordering_Data(Rt,n,n);
{mu_GEV,sigma_GEV,xi_GEV} = regGEV(max,0);
pdf2 = pdfGEV(x,mu_GEV,sigma_GEV,xi_GEV);

graphset;
  fonts("simplex simgrma");
  _pframe = 0; _pdate = ""; _pnum = 2;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(0,8,1,2);
  xlabel("\216Return (in %)");
  _plegstr = "F]22:22[\000GEV";
  _plegctl = {2 5 6 5};
  xy(100*x,pdf1~pdf2);

let alpha = 0.90 0.95 0.96 0.97 0.98 0.99;
x1 = mu_G + sigma_G .* cdfni(alpha^(1/22));
x2 = cdfGEVi(alpha,mu_GEV,sigma_GEV,xi_GEV);

results = x1'|x2';
print ftosa(100*results,"%lf",3,2);


