new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 19950101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M2US" "M2EF";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

Rt = Rt[.,1 2];

let w[4,2] = 1   0 
             0   1
             1  -1
            -1   1;
Rt = Rt * w';

n = 22;    
let alpha_VaR = 0.99 0.995 0.999;
alpha_VaR = alpha_VaR';
alpha_GEV = 1 - (1-alpha_VaR) * n;
nAlpha = cols(alpha_VaR);

__output = 0;

VaR1 = zeros(4,nAlpha);
VaR2 = zeros(4,nAlpha);
VaR3 = zeros(4,nAlpha);

i = 1;
do until i > 4;

  mu = meanc(Rt[.,i]);
  sigma = stdc(Rt[.,i]);
  VaR1[i,.] = -mu + sigma*cdfni(alpha_VaR);       /* Gaussian VaR   */

  VaR2[i,.] = -quantile(Rt[.,i],1-alpha_VaR')';   /* Historical VaR */

  min = Ordering_Data(Rt[.,i],1,n);
  max = - min;
  {mu_GEV,sigma_GEV,xi_GEV} = regGEV(max,0);
  VaR3[i,.] = cdfGEVi(alpha_GEV,mu_GEV,sigma_GEV,xi_GEV);    /* GEV VaR        */

  i = i + 1;
endo;

print ftosa(100*VaR1',"%lf",5,2); 
print ftosa(100*VaR2',"%lf",5,2); 
print ftosa(100*VaR3',"%lf",5,2); 