new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 19950101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M2US" "M2EF";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

Rt = Rt[.,1 2];

let w[4,2] = 1   0 
             0   1
             1  -1
            -1   1;
Rt = Rt * w';

Loss = -100 * Rt;

u = seqa(-5,0.05,200);
n_u = rows(u);

e = zeros(n_u,4);
n = zeros(n_u,4);
a = zeros(4,1);
b = zeros(4,1);

i = 1;
do until i > 4;
  x = Loss[.,i];
  e[.,i] = sumc( (x - u') .* (x .> u') ) ./ sumc( (x .> u') );
  n[.,i] = sumc( (x .> u') );
  data = selif(u~e[.,i],u .>= 2);
  y = data[.,2];
  x = data[.,1];
  x = ones(rows(x),1)~x;
  beta = y/x;
  a[i] = beta[1];
  b[i] = beta[2];
  i = i + 1;
endo;

xi = b ./ (1 + b);
sigma = a .* (1 - xi);
sigma2 = a ./ (1 + b);
print ftosa(a'|b'|sigma'|xi',"%lf",3,3);

u = u .* ones(1,4);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pframe = 0; _pnum = 2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _plwidth = 10; _pltype = 6;
  xtics(-3,5,1,2);
  ytics(0.5,3.5,0.5,2);
  xlabel("\216Return (in %)");
  xlabel("\216Threshold u (in %)");
  ylabel("\216e(u)");
  _pline = 1~4~0.02~0.013~0.045~0.05~1~9~5;

  i = 1;
  setwind(i);
    _pcolor = i;
    title("\216Long US");
    _pline = 1~3~2~a[i]+b[i]*2~5~a[i]+b[i]*5~1~0~10;
    xy(u[.,i],e[.,i]);

  i = 2;
  setwind(i);
    _pcolor = i;
    title("\216Long EM");
    _pline = 1~3~2~a[i]+b[i]*2~5~a[i]+b[i]*5~1~0~10;
    xy(u[.,i],e[.,i]);

  i = 3;
  setwind(i);
    _pcolor = i;
    title("\216Long US/Short EM");
    _pline = 1~3~2~a[i]+b[i]*2~5~a[i]+b[i]*5~1~0~10;
    xy(u[.,i],e[.,i]);

  i = 4;
  setwind(i);
    _pcolor = i;
    title("\216Long EM/Short US");
    _pline = 1~3~2~a[i]+b[i]*2~5~a[i]+b[i]*5~1~0~10;
    xy(u[.,i],e[.,i]);

  endwind;

