new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

datFileName = "..\\..\\data\\benchmark";
Data = loadd(datFileName);
Dates = Data[.,1];
data = selif(data,(Dates .>= 19950101) .and (Dates .<= 20151231));

vnames = "" $+ getname(datFileName);
let string selected_names = "M2US" "M2EF";

indx = indsav(selected_names,vnames);
data = data[.,indx];

dt = 1;
Rt = packr(data ./ lagn(data,dt) - 1.0);

Rt = Rt[.,1 2];

let w[4,2] = 1   0 
             0   1
             1  -1
            -1   1;
Rt = Rt * w';

Loss = -100 * Rt;

u = seqa(-5,0.05,200);
n_u = rows(u);

e = zeros(n_u,4);
a = zeros(4,1);
b = zeros(4,1);

i = 1;
do until i > 4;
  x = Loss[.,i];
  e[.,i] = sumc( (x - u') .* (x .> u') ) ./ sumc( (x .> u') );
  data = selif(u~e[.,i],u .>= 2);
  y = data[.,2];
  x = data[.,1];
  x = ones(rows(x),1)~x;
  beta = y/x;
  a[i] = beta[1];
  b[i] = beta[2];
  i = i + 1;
endo;

xi = b ./ (1 + b);
sigma = a .* (1 - xi);

u = 2.0;
n = rows(Loss) .* ones(4,1);
n_u = sumc(Loss .> u);

let alpha = 0.99 0.995 0.999;
alpha = alpha';
VaR = u + sigma ./ xi .* ( (n ./ n_u .* (1 - alpha))^(-xi) - 1.0);
ES = u - sigma ./ xi + sigma ./ (xi .* (1 - xi)) .* ( (n ./ n_u .* (1 - alpha))^(-xi) );

ES2 = VaR + (sigma + xi .* (VaR - u)) ./ (1 - xi);

print ftosa(n'|n_u'|sigma'|xi'|100*(1 - n_u./n)',"%lf",3,3);

print ftosa(VaR',"%lf",3,2);

print ftosa(ES',"%lf",3,2);

print ftosa(ES2',"%lf",3,2);
