new;
library frm,pgraph;
frmSet;

cls;

rndseed 123456;

proc f(x);
  retp(pdfn(x));
endp;

proc g(x);
  local pdf;
  pdf = 1 / (pi * (1 + x^2));
  retp(pdf);
endp;

c = sqrt(2*pi)/exp(0.5);
print ftos(c,"c = %lf",3,2);

seed = 123456;
nS = 10;
u = simulate_LCM(seed,2*nS);
u = reshape(u,nS,2);
u = trunc(1e4*u)/1e4;
u1 = u[.,1];
u2 = u[.,2];
x = tan(pi*(u1-0.5));
v = f(x) ./ (c * g(x));
z = missex(x,u2 .> v);

results = u1~u2~x~v~z;
print ftosa(results,"%lf",3,4);

nS = 1000;
u = rndu(nS,2);
u1 = u[.,1];
u2 = u[.,2];
x = tan(pi*(u1-0.5));
y = c * g(x) ./ f(x);
z = u2 .* y;
x = missex(x,z .> 1);
x = packr(x);

ratio = rows(x) / nS;
print ftos(ratio,"%lf",3,2);

data = x;
x = seqa(-5,10/100,101);
{pdf,cdf} = regKernelDensity(data,x);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(-5,5,1,2);
  _plegstr = "Exact density\000Simulated density";
  _plegctl = {2 5 6 5};
  xy(x,pdfn(x)~pdf);




