new;
library frm,pgraph,optmum;

cls;

declare matrix theta;

proc (2) = rndCopulaClayton2(theta,v);
  local u1,u2;
  u1 = v[.,1];
  u2 = (1 + u1^(-theta) .* (v[.,2]^(-theta/(1+theta)) - 1))^(-1/theta);
  retp(u1,u2);
endp;

proc (2) = rndCopula3(cdfCopula,cndCopula,v);
  local u1,u2;
  _copula_function = cdfCopula|cndCopula;
  _copula_v = v;
  u1 = v[.,1];
  u2 = rndCopulaFindZero(&_rndCopula2,0+__macheps,1-__macheps);
  retp(u1,u2);
endp;

proc cdf(u1,u2);
  retp(cdfCopulaClayton(u1,u2,theta));
endp;

rndseed 123;
theta = 1.5;
v = rndu(5,2);
v = trunc(v*1e4)/1e4;
{u1,u2} = rndCopula3(&cdf,0,v);
print ftosa(v~u1~u2,"%lf",3,4);
{u1,u2} = rndCopulaClayton2(theta,v);
print ftosa(v~u1~u2,"%lf",3,4);

rndseed 123;
theta = 0.01;
v = rndu(5,2);
v = trunc(v*1e4)/1e4;
{u1,u2} = rndCopula3(&cdf,0,v);
print ftosa(v~u1~u2,"%lf",3,4);
{u1,u2} = rndCopulaClayton2(theta,v);
print ftosa(v~u1~u2,"%lf",3,4);
