new;
library frm,pgraph,optmum;

cls;

rndseed 123456;

x0 = 100;
mu = 0.00;
sigma = 0.15;

nS = 10000;

dt = 0.1;
tau = 1;
nT = round(tau/dt) + 1;
t = seqa(0,dt,nT);

Xt = simulate_GBM(x0,mu,sigma,t,nS);
max_Xt = maxc(Xt);

max_Xt = max_Xt ~ zeros(nS,1);
indx_max = maxindc(Xt);
i = 1;
do until i > nS;
  indx = indx_max[i];
  if indx == nT;
    indx_su = (indx-1)|indx;
  elseif indx == 1;
    indx_su = indx|(indx+1);
  else;
    indx_su = (indx-1)|indx|(indx+1);
  endif;
  su = t[indx_su];
  x_su = Xt[indx_su,i];
  w_su = ((ln(x_su) - ln(x0)) - (mu - 0.5*sigma^2)*su)/sigma;
  n_su = rows(su);
  d_su = (su[n_su] - su[1])/200;
  t_B = seqa(su[1],d_su,201);
  {t_B,w_B} = Simulate_Brownian_Bridge(su,w_su,t_B,1);
  x_B = x0 .* exp( (mu - 0.5*sigma^2)*t_B + sigma * w_B);
  max_Xt[i,2] = maxc(x_B);
  i = i + 1;
endo;

x_max = seqa(80,90/500,501);
x_max = x_max;
nMax = rows(x_max);
d_max = zeros(nMax,2);

_Kernel_h = 1|3.5;
i = 1;
do until i > 2;
  {d_max[.,i],F} = _regKernelDensity(max_Xt[.,i],x_max);
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4;
  xtics(80,160,10,2);
  ytics(0,0.05,0.01,2);
  xlabel("\216max X(t)");
  _plegstr = "Exact scheme\000Diffusion bridge";
  _plegctl = {2 5 5.5 5};
  xy(x_max,d_max);
