new;
library frm,pgraph,optmum;

S0 = 100; 
mu = 0.10;
sigma = 0.50;
nS = 1;

fn procMu(t,S) = mu .* S;
fn procSigma(t,S) = sigma .* S;
fn procGradSigma(t,S) = sigma .* ones(rows(S),cols(S));

dt = 2*22;
nYears = 50;
t = seqa(0,dt/260,nYears*260/dt+1);

rndseed 1234568;
S1 = simulate_GBM(S0,mu,sigma,t,nS);

rndseed 1234568;
S2 = simulate_SDE(S0,&procMu,&procSigma,t,nS);

rndseed 1234568;
S3 = simulate_SDE_Milstein(S0,&procMu,&procSigma,&procGradSigma,t,nS);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _plwidth = 8; _pcolor = 1|2|4; _pltype = 6|1|3;
  xtics(0,50,10,2);
  _plegstr = "Exact scheme\000Euler-Maruyama\000Milstein";
  _plegctl = {2 5 6 5};
  xy(t,S1~S2~S3);