new;
library frm,pgraph,optmum;

rndseed 123;

fn lambdaProc(t) = 80 * sin(1.2*pi*t) + 90;
lambda_max = 200;

{t,N} = Simulate_NHPP(&lambdaProc,lambda_max,3000); 

t_max = 20;
t = selif(t,t .<= t_max);
N = N[1:rows(t)];
dt = 0.10;
x = seqa(0,dt,t_max/dt + 1);
c = counts(t,x);
lambda = lambdaProc(x);

graphset;
  window3u;
  makewind(9/2,6.855/2,9/2,0,1);

    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6; _plwidth = 10; _pcolor = 2;
    _ptitlht = 0.275; _paxht = 0.22; _pnumht = 0.22;

  setwind(1);
    title("\216Simulated Poisson process");
    xlabel("\216t");
    xtics(0,10,1,2);
    ytics(0,1000,200,2);
    xy(t,N);

  setwind(2);
    title("\216Observed arrival frequency\L(dt = 1/10)");
    _pbartyp = {6 4};
    ytics(0,25,5,2);
    bar(x,c);

  setwind(3);
    title("\216Expected arrival frequency\L(dt = 1/10)");
    _pbartyp = {6 1};
    bar(x,lambda*dt);

  setwind(4);
    _pcolor = 1;
    xy(x,lambda*dt);

  endwind;


