new;
library frm,pgraph,optmum;

rndseed 123;

proc mu(t,x);
   retp(0.15*x);
endp;

proc sigma(t,x);
   retp(0.20*x);
endp;

proc eta(t,x);
   retp(-0.30*(x-100));
endp;

x0 = 100;
lambda = 2;
t = seqa(0,1/260,3*260+1);
nS = -1;

rndseed 1234568;
{t,x,J} = simulate_JDP(x0,&mu,&sigma,&eta,lambda,t,nS);

t_J = selif(seqa(1,1,rows(t)),J);
e = ones(rows(t_J),1);
x[t_J,.] = error(0) .* x[t_J,.];

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _plwidth = 8; _pcolor = 1|2|3|4; _pltype = 6|1|3;
  xtics(0,3,0.5,2);
  _pline = e.*(1~3)~t[t_J]~e.*0~t[t_J]~e.*200~e.*(1~4~10);
  xy(t,x);