new;
library frm,pgraph,optmum;

cls;

rndseed 123;

r = 1;

n = 1000;

u = 2*rndu(n,2)-1;
x = u[.,1];
y = u[.,2];

s = (x^2 + y^2) .<= r^2;
data1 = selif(x~y,s);
data2 = delif(x~y,s);
n_c = sumc(s);
estimate = 4*n_c / n;
print ftos(pi,"pi = %lf",3,5);
print ftos(estimate,"n_c / n = %lf",3,5);
 
data2 = data2 | miss(zeros(n_c-rows(data2),2),0);

theta = seqa(0,2*pi/n_c,n_c);
x = r * cos(theta);
y = r * sin(theta);

x = x ~ data1[.,1] ~data2[.,1];
y = y ~ data1[.,2] ~data2[.,2];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6; _pstype = 1|4|2; _plctrl = 0|-1|-1;
  _pcolor = 12|12|1; _plwidth = 10; _psymsiz = 2;
  xtics(-1.25,1.25,0.25,2);
  ytics(-1.25,1.25,0.25,2);
  _pline = 1~6~-1~-1~-1~1~1~0~10 |
           1~6~-1~1~1~1~1~0~10 |
           1~6~1~1~1~-1~1~0~10 |
           1~6~1~-1~-1~-1~1~0~10 ;
  xlabel("\216U");
  ylabel("\216V");
  xy(x,y);
