new;
library frm,pgraph,optmum;

cls;

rndseed 123456;

nS = 1e6;

fn f(x,y,z) = (x^2 + y^2 + z^2) ;

u = rndu(ns,3)*5;

x = u[.,1];
y = u[.,2];
z = u[.,3];

cnd = ((x^2 + y^2 + z^2) .<= 25) .and ((x + y + z) .>= 0);

h = f(x,y,z) .* cnd;
sigma = stdc(h);

s = seqa(1,1,nS);

I = cumsumc(h)./s;

std = sigma ./ sqrt(s);

bounds = I + (-1.96~0~1.96) .* std;

indx = seqa(1,0.02,500);
indx = 10^indx;
indx = delif(indx, indx .> ns);

bounds = trimr(bounds[indx,.],0,0);
s = trimr(s[indx],0,0);

e = ones(rows(s),1);
pline = e.*(1~6)~s~bounds[.,1]~s~bounds[.,3]~e.*(1~8~0);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3|6|3; _pcolor = 0|1|0; _plwidth = 10;
  ytics(4,13,1,2);
  xlabel("\216Number of simulations");

  setwind(1);
    _pline = pline;
    logx(s,-bounds);

  setwind(2);
    _plegstr = "Upper limit CI\000Estimate\000Lower limit CI";
    _plegctl = {2 5 5 5};
    _pline = 0;
    logx(s,bounds);

  endwind;









