new;
library frm,pgraph,optmum;

cls;

S0 = 100;
K = 100;
sigma = 0.20;
r = 0.05;
b = r;
tau = 3/12;  // 3 Months

fn lookback_payoff(ST,Smin) = (ST - Smin) .* (ST .>= Smin);

nS = 100000;
nT = 60*10;
t = seqa(0,tau/nT,nT+1);
LBC = zeros(10,1);
iter = 1;
do until iter > 10;
  S = simulate_GBM(S0,b,sigma,t,nS/10);
  nT = rows(t);
  ST = S[nT,.]';
  Smin = minc(S);
  LBC[iter] = exp(-r*tau)*meanc(lookback_payoff(ST,Smin));
  iter = iter + 1;
endo;
LBC = meanc(LBC);

print ftos(LBC,"Look-back call = %lf",6,5);

nT = seqa(5,1,96);
LBC_MC = zeros(rows(nT),1);
sigma_MC = zeros(rows(nT),1);

i = 1;
do until i > rows(nt);
  t = seqa(0,tau/(nT[i]-1),nT[i]);
  S = simulate_GBM(S0,b,sigma,t,nS);
  ST = S[nT[i],.]';
  Smin = minc(S);
  LBC_MC[i] = exp(-r*tau)*meanc(lookback_payoff(ST,Smin));
  sigma_MC[i] = exp(-r*tau)*stdc(lookback_payoff(ST,Smin));
  print /flush i;
  i = i + 1;
endo;

e = ones(rows(nT),1);
std = sigma_MC ./ sqrt(nS);
bounds = LBC_MC + (-2.57~0~2.57) .* std;
pline = e.*(1~6)~nT~bounds[.,1]~nT~bounds[.,3]~e.*(1~4~10);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xlabel("\216Number of discretization points");
  xtics(0,100,10,2);
  ytics(6,8.5,0.5,2);

  setwind(1);
    _pline = pline;
    xy(nT,-LBC_MC);

  setwind(2);
    _pline = 1~3~0~LBC~100~LBC~1~0~10;
    _pmsgstr = "Price obtained with the diffusion bridge";
    _pmsgctl = 10~LBC+0.05~0.15~0~1~0~8;
    xy(nT,LBC_MC);

  endwind;

