new;
library frm,pgraph;

cls;

rndseed 123456;

declare matrix x_star;

fn pdf(x,mu,sigma) = pdfn((x-mu)./sigma)./sigma;
fn phi(x) = (x .>= x_star);

x_star = 3; mu_x = 0; sigma_x = 1;

I = cdfnc(3);
print ftos(1e4*I,"I = %lf",3,4);

nS = 1000;
nR = 2000;

mu = seqa(0,0.1,51);
nIters = rows(mu);
mu_IS = zeros(nIters,2);
sigma_IS = zeros(nIters,2);

iter = 1;
do until iter > nIters;
  mu_z = mu[iter];
  sigma_z = 1;
  Z = mu_z + rndn(nS,nR) * sigma_z;
  LR = pdf(Z,mu_x,sigma_x) ./ pdf(Z,mu_z,sigma_z);
  I_IS = meanc(phi(Z) .* LR);
  mu_IS[iter,1] = meanc(I_IS);
  sigma_IS[iter,1] = stdc(I_IS);

  mu_z = mu[iter];
  sigma_z = 3;
  Z = mu_z + rndn(nS,nR) * sigma_z;
  LR = pdf(Z,mu_x,sigma_x) ./ pdf(Z,mu_z,sigma_z);
  I_IS = meanc(phi(Z) .* LR);
  mu_IS[iter,2] = meanc(I_IS);
  sigma_IS[iter,2] = stdc(I_IS);

  iter = iter + 1;
endo;

x_smooth = seqa(0,5/50,51);
y_smooth = spline(mu,sigma_IS,0.90|0.999,x_smooth);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|3|6; _pcolor = 1|4; _plwidth = 10;
  xtics(0,5,1,2);
  xlabel("\216\202m\201]z[");
  ytics(0,0.12,0.02,2);
  _plegstr = "\202s\201]z[ = 1\000\202s\201]z[ = 3";
  _plegctl = {2 6 6 5};
  _psym = 0~100*y_smooth[1,1]~8~4.0~0~1~10;
  _pmsgstr = "MC";
  _pmsgctl = 0.1~100*y_smooth[1,1]~0.15~0~1~0~10;
  xy(x_smooth,100*y_smooth);