new;
library rpb,pgraph;

cls;


nS = 1e8;

a = 1;
let rho = -0.9 -0.75 -0.5 -0.25 0.0 0.25 0.5 0.75 0.9;
let b   =  0.0  1.0  2.0  3.0;

n_rho = rows(rho);
n_b  = rows(b);
ratio = zeros(n_b,n_rho);

i = 1;
do until i > n_rho;
  X1 = rndn(nS,1);
  X3 = rndn(nS,1);
  X2 = rho[i] * X1 + sqrt(1-rho[i]^2) * X3;
  p_MC = (X1 .<= a * X2 + b');
  var_MC = stdc(p_MC)^2;
  p_CMC = (a*sqrt(1-rho[i]^2)*X3 + b') /(1 - a*rho[i]);
  p_CMC = cdfn(p_CMC);
  var_CMC = stdc(p_CMC)^2;
  ratio[.,i] = var_CMC ./ var_MC;
  i = i + 1;
endo;

results = (error(0)~100*rho')|(b~100*ratio);
print ftosa(results,"%lf",3,1);
      
a = 2;
let rho = -0.9 -0.7 -0.5 -0.2 0.0 0.2 0.50 0.7 0.9;
let b   =  0.0  1.0  2.0  3.0;

n_rho = rows(rho);
n_b  = rows(b);
ratio = zeros(n_b,n_rho);

i = 1;
do until i > n_rho;
  X1 = rndn(nS,1);
  X3 = rndn(nS,1);
  X2 = rho[i] * X1 + sqrt(1-rho[i]^2) * X3;
  p_MC = (X1 .<= a * X2 + b');
  var_MC = stdc(p_MC)^2;
  if rho == 0.5;
    p_CMC = 0 .<= (a*sqrt(1-rho[i]^2)*X3 + b');
  else;
    p_CMC = (a*sqrt(1-rho[i]^2)*X3 + b') /(1 - a*rho[i]);
  endif;  
  p_CMC = cdfn(p_CMC);
  var_CMC = stdc(p_CMC)^2;
  ratio[.,i] = var_CMC ./ var_MC;
  i = i + 1;
endo;

results = (error(0)~100*rho')|(b~100*ratio);
print ftosa(results,"%lf",3,1);
      
/*

            -90.0    -75.0    -50.0    -25.0      0.0     25.0     50.0     75.0     90.0 
     0.0      3.2      8.0     16.1     24.5     33.3     43.0     54.0     67.8     79.8 
     1.0      2.9      7.3     14.8     22.5     30.6     39.3     48.9     60.0     67.6 
     2.0      2.2      5.6     11.3     17.2     23.3     29.5     36.0     42.1     52.2 
     3.0      1.4      3.4      7.1     10.7     14.4     18.0     21.6     23.9     +INF 

            -90.0    -70.0    -50.0    -20.0      0.0     20.0     50.0     70.0     90.0 
     0.0      5.6     16.8     28.2     46.1     59.0     73.4    100.0     75.6     36.5 
     1.0      5.4     16.3     27.4     45.1     58.1     72.6    100.0     74.1     32.6 
     2.0      4.8     14.8     25.2     42.3     55.2     70.2    100.0     69.8     22.6 
     3.0      4.0     12.5     21.8     37.9     50.7     66.3    100.0     63.4     11.9 
*/

/*

            -90.0    -75.0    -50.0    -25.0      0.0     25.0     50.0     75.0     90.0 
     0.0      3.2      8.0     16.1     24.5     33.3     43.0     54.0     67.8     79.8 
     1.0      2.9      7.3     14.8     22.5     30.6     39.3     48.9     60.0     67.6 
     2.0      2.2      5.6     11.3     17.2     23.3     29.6     35.9     41.9     48.8 
     3.0      1.4      3.4      7.0     10.7     14.4     18.1     21.4     24.6     +INF 

            -90.0    -70.0    -50.0    -20.0      0.0     20.0     50.0     70.0     90.0 
     0.0      5.6     16.8     28.2     46.1     59.0     73.4    100.0     75.6     36.5 
     1.0      5.4     16.3     27.4     45.1     58.1     72.6    100.0     74.1     32.6 
     2.0      4.8     14.8     25.2     42.3     55.2     70.2    100.0     69.9     22.6 
     3.0      4.0     12.5     21.8     37.9     50.7     66.4    100.0     63.5     12.0 
*/





