new;
library frm,pgraph;

cls;

m = 10;
j = seqa(1,1,m-1)/m;
e = ones(m-1,1);

x1 = seqa(0,1/100,101);
y1 = ones(rows(x1),1);
z1 = j;
t1 = ones(rows(z1),1);

mu = 3;
sigma = 2;
x2 = seqa(-4,15/100,101);
y2 = pdfn((x2-mu)/sigma)/sigma;
z2 = mu + sigma * cdfni(j);
t2 = pdfn((z2-mu)/sigma)/sigma;

mu = 1;
sigma = 1;
x3 = seqa(0.001,21/100,101);
y3 = pdfLN(x3,mu,sigma);
z3 = exp(mu + sigma * cdfni(j));
t3 = pdfLN(z3,mu,sigma);

lambda = 0.3;
x4 = seqa(0.01,20/100,101);
y4 = lambda .* exp(-lambda * x4);
z4 = -ln(1-j)/lambda;
t4 = lambda .* exp(-lambda * z4);

graphset;
  begwind;
  window(2,2,0);

    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
    _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  setwind(1);
    title("\216Uniform");
    _pcolor = 1;
    xtics(0,1,0.2,2);
    ytics(0,2,0.5,2);
    _pline = e.*(1~3)~z1~e*0~z1~t1~e*(1~0~10);
    xy(x1,y1);

  setwind(2);
    title("\216Gaussian N(3,2)");
    _pcolor = 2;
    xtics(-4,10,2,2);
    ytics(0,0.2,0.05,2);
    _pline = e.*(1~3)~z2~e*0~z2~t2~e*(1~0~10);
    xy(x2,y2);

  setwind(3);
    title("\216Log-normal LN(1,1)");
    _pcolor = 3;
    xtics(0,21,3,2);
    ytics(0,0.3,0.1,2);
    _pline = e.*(1~3)~z3~e*0~z3~t3~e*(1~0~10);
    xy(x3,y3);

  setwind(4);
    title("\216Exponential (\202l\201 = 0.3)");
    _pcolor = 4;
    xtics(0,14,2,2);
    ytics(0,0.3,0.1,2);
    _pline = e.*(1~3)~z4~e*0~z4~t4~e*(1~0~10);
    xy(x4,y4);

  endwind;
