new;
library frm,pgraph;

rndseed 12345678;

K = 5;
S1_0 = 100; 
S2_0 = 100;
sigma1 = 0.20; 
sigma2 = 0.20; 
tau = 1;
r = 0.05; 
rho = 0.50;
nS = 1000;

nR = 10000;
S1 = zeros(nS,nR);
S2 = S1; 
S1_AV = S1; 
S2_AV = S2;

i = 1;
do until i > nR;
  {x1,x2,x1_AV,x2_AV} = simulate_GBM2_AV(S1_0,S2_0,r,r,sigma1,sigma2,rho,tau,nS);
  S1[.,i] = x1';
  S2[.,i] = x2';
  S1_AV[.,i] = x1_AV';
  S2_AV[.,i] = x2_AV';
  i = i + 1;
endo;

G = _max_(0,S1 - S2 - K);
G_AV = _max_(0,S1_AV - S2_AV - K);
G_star = (g + G_AV)/2;

C_MC = exp(-r*tau) * meanc(G);
C_AV = exp(-r*tau) * meanc(G_star);

ratio = stdc(C_AV)/stdc(C_MC);
print ftos(ratio,"ratio = %lf",3,4);
ratio = ratio^2;
print ftos(ratio,"ratio = %lf",3,4);

x_C = seqa(4.5,2.5/255,256);
{d_C_MC,F} = regKernelDensity(C_MC,x_C);
{d_C_AV,F} = regKernelDensity(C_AV,x_C);

C = meanc(C_MC|C_AV);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  xtics(4.5,7,0.5,2);
  ytics(0,2.25,0.25,2);
  xlabel("\216Option price");
  _plegstr = "MC\000AV";
  _plegctl = {2 5 7 5};
  _pline = 1~6~C~0~C~2.5~1~0~10;
  xy(x_C,d_C_MC~d_C_AV);

