new;
library frm,pgraph;

cls;

E_V = 1/2;
E_Y = exp(1) - 1;
print ftos(E_Y,"E[Y] = %lf",3,4);

var_V = 1/12;
var_Y = (-exp(1)^2 + 4*exp(1) - 3)/2;
print ftos(var_Y,"var(Y) = %lf",3,4);

cov_VY = (3-exp(1))/2;
print ftos(cov_VY,"cov(Y,V) = %lf",3,4);

beta = cov_VY / var_V;
print ftos(beta,"beta = %lf",3,4);

beta = 18 - 6*exp(1);
print ftos(beta,"beta = %lf",3,4);

var_Z = var_Y - (cov_VY^2)/var_V;
print ftos(var_Z,"var(Z) = %lf",3,4);

print ftos(100*var_Z/var_Y,"ratio = %lf",3,4);

nS = 1000000;
X = rndu(nS,1);
Y = exp(X);
m_Y = meanc(Y);
var_Y = stdc(Y)^2;
Z = Y - beta * (X - 0.5);
m_Z = meanc(Z);
var_Z = stdc(Z)^2;

ratio = 100 * var_Z / var_Y;

results = (m_Y~var_Y~error(0)) |
          (m_Z~var_Z~ratio);

print ftosa(results,"%lf",3,4);

x = seqa(0,1/100,101);
y = exp(x);
bx = beta * x;
bx_prime = beta * (x - 0.5) + E_Y;
z = y - beta * (x - 0.5);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|4|5|3; _pcolor = 1|2|3|5|4; _plwidth = 10;
  xtics(0,1,0.2,2);
  ytics(0,2.5,0.5,2);
  xlabel("\216X");
  _plegstr = "Y\000V (or X)\000\202b\201V\000E\202@[\201Y\202@]\201+\202b\34\201V-E\202@[\201V\202@]\118\201\000Z";
  _plegctl = {2 5 6.0 1.0};
  xy(x,y~x~bx~bx_prime~z);
