new;
library frm,pgraph;

cls;

rndseed 123456;

declare matrix x_star;

fn pdf(x,mu,sigma) = pdfn((x-mu)./sigma)./sigma;
fn phi(x) = (x .>= x_star);

x_star = 3; mu_x = 0; sigma_x = 1;

I = cdfnc(3);
print ftos(1e4*I,"I = %lf",3,4);

nS = 1000;
nR = 1000;

X = rndn(nS,nR);
I_MC = meanc(phi(X));

mu_z = 3; sigma_z = 1;
Z = mu_z + rndn(nS,nR) * sigma_z;
LR = pdf(Z,mu_x,sigma_x) ./ pdf(Z,mu_z,sigma_z);
I_IS = meanc(phi(Z) .* LR);

x = seqa(-3,9/100,101);
pdf_x = pdf(x,mu_x,sigma_x) ~ pdf(x,mu_z,sigma_z); 
LR_x = pdf(x,mu_x,sigma_x) ./ pdf(x,mu_z,sigma_z);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pframe = 0; _pnum = 2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xlabel("\216p");
  ylabel("\216Frequency (in %)");
  xtics(-10,60,10,2);
  ytics(0,40,10,2);

  setwind(3);
    title("\216MC estimator (n]S[ = 1000)");
    _pbartyp = {6 1};
    call histp(1e4*I_MC,50);

  setwind(4);
    title("\216IS estimator (n]S[ = 1000)");
    _pbartyp = {6 4};
    call histp(1e4*I_IS,50);

  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  xtics(-3,6,1,2);
  ytics(error(0),0,0,error(0));
  ylabel("");
  xlabel("\216x");

  setwind(1);
    title("\216PDF");
    ytics(0,0.40,0.10,2);
    _plegstr = "f(x)\000g(x)";
    _plegctl = {2 5 7 5};
    xy(x,pdf_x);

    _plegctl = 0; _pltype = 1; _pcolor = 2;

  setwind(2);
    title("\216Likelihood ratio");
    ytics(1e-5,1e5,100,0);
    logy(x,LR_x);

  endwind;