new;
library frm,pgraph;

rndseed 1234;

n_burn = 200;
nS = 800;
nT = n_burn + nS;

nR = 1000;
x = zeros(nT,nR);
y = zeros(nT,nR);

n = 5; alpha = 2; beta = 4;
xt = 5 * ones(1,nR);
yt = 0.5 * ones(1,nR);
x[1,.] = xt;
y[1,.] = yt;

t = 2;
do until t > nT;
  xt = rndb(1,nR,yt,n) ;
  yt = rndbeta(1,nR,xt + alpha,n - xt + beta);
  x[t,.] = xt;
  y[t,.] = yt;
  t = t + 1;
endo;

g_all = x .* y;
g = trimr(g_all,n_burn,0);
x_g = seqa(0.5,0.5/200,201);
d_g = zeros(201,2);
{d_g,F_g} = regKernelDensity(meanc(g),x_g);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25;_pnumht = 0.20; _ptitlht = 0.30;
  fonts("simplex simgrma");

  setwind(1); 
    title("\216The 50 first iterations");
    _pcolor = 1; _plctrl = 1; _pstype = 4;
    xtics(-1,6,1,2);
    xlabel("\216x[(t)]");
    ylabel("\216y[(t)]");
    ytics(0,1.0,0.2,2); 
    _psym = 5~0.5~8~3.5~4~1~10; 
    xy(x[1:50,1],y[1:50,1]);

  _psym = 0;
  _pline = 1~1~n_burn~-1~n_burn~6~1~0~10;

  xtics(0,1000,200,2); _plctrl = -1;
  xlabel("\216Iteration t");
  ylabel("");

  setwind(2); 
    title("\216x[(t)]");
    _pcolor = 1;
    ytics(-1,6,1,2);
    let ylab = "  " " 0" " 1" " 2" " 3" " 4" " 5" "  ";
    asclabel(0,ylab); 
    xy(0,x[.,1]);

  setwind(3);
    title("\216y[(t)]");
    _pcolor = 2;
    asclabel(0,0);   
    ytics(0,1.0,0.2,2); 
    _pmsgctl = 4.02~0.36~0.07~45~2~0~6 ;  
    xy(0,y[.,1]);

  setwind(4);
    title("\216x[(t)]y[(t)]");
    _pcolor = 3;
    ytics(0,5,1,2); 
    _pmsgctl = 3.90~0.36~0.07~45~2~0~6 ;  
    xy(0,g_all[.,1]);

  endwind;

g_hat = meanc(meanc(g));

rho = zeros(nR,1);

i = 1;
do until i > nR;
  data = g[.,i]~lag1(g[.,i]);
  data = packr(data);
  rho[i] = submat(corrx(data),2,1);
  i = i + 1;
endo;

print ftos(g_hat,"g = %lf",3,4);
print ftos(meanc(rho),"rho = %lf",3,4);

Y = g[nS,.]';
var_Y = stdc(Y)^2;
var_MC1 = var_Y / nS;
Y = meanc(g);
var_MC2 = stdc(Y)^2;
ratio = var_MC2 / var_MC1;

print ftos(var_MC1,"var1 = %lf",3,4);
print ftos(var_MC2,"var2 = %lf",3,4);
print ftos(ratio,"ratio = %lf",3,4);




