new;
library frm,pgraph,optmum;
dlibrary frm-sobol,frm-faure;

rndseed 123;

K = 5;
S10 = 100; 
S20 = 100;
sigma1 = 0.20; 
sigma2 = 0.20; 
Tau = 1;
r = 0.05; 
rho = 0.50;
nS = 2e6;

mu1 = r; mu2 = r;
dt = Tau;
k1 = (mu1-0.5*sigma1^2)*dt;
k2 = (mu2-0.5*sigma2^2)*dt;
sqrt_dt = sqrt(dt);
rho2 = rho^2;

nR = 10;

simul1 = zeros(nS,nR);
simul2 = zeros(nS,nR);

proc (2) = uniform_to_normal(u1,u2);
  local n1,n2;

  u1 = _min_(_max_(u1,__macheps),1-__macheps);
  u2 = _min_(_max_(u2,__macheps),1-__macheps);

  if 1;
    {n1,n2} = rndn_Box_Muller(u1,u2);
  else;
    n1 = cdfni(u1); n2 = cdfni(u2);
  endif;

  retp(n1,n2);
endp;

i = 1;
simul1[.,i] = rndn(nS,1); simul2[.,i] = rndn(nS,1); 
i = i + 1;

simul1[.,i] = rndn(nS,1); simul2[.,i] = rndn(nS,1); 
i = i + 1;

simul1[.,i] = rndn(nS,1); simul2[.,i] = rndn(nS,1); 
i = i + 1;

_frm_rnd_primes = 2; u = rndu_Hammersley(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

_frm_rnd_primes = 7; u = rndu_Hammersley(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

_frm_rnd_primes = 2|3; u = rndu_Halton(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

_frm_rnd_primes = 17|19; u = rndu_Halton(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

_frm_rnd_primes = 2|19; u = rndu_Halton(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

call init_Sobol(2); u = rndu_Sobol(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

call init_GrayFaure(2); u = rndu_GrayFaure(nS,2);
{simul1[.,i],simul2[.,i]} = uniform_to_normal(u[.,1],u[.,2]); 
i = i + 1;

save simul1,simul2;
clear simul1,simul2;

s = seqa(1,1,ns);
let indx = 1e2 1e3 1e4 1e5 1e6 2e6;
results = zeros(rows(indx),nR);

i = 1;
do until i > nR;

  loadm simul1;
  eta1 = simul1[.,i];
  clear simul1;

  loadm simul2;
  eta2 = simul2[.,i];
  clear simul2;

  u1 = eta1;
  u2 = rho .* u1 + sqrt(1-rho2) * eta2;
  S1 = S10 .* exp(k1 + sigma1 .* sqrt_dt .* u1);
  S2 = S20 .* exp(k2 + sigma2 .* sqrt_dt .* u2);

  G = _max_(0,S1 - S2 - K);
  C = exp(-r*tau) * cumsumc(G) ./ s;
  results[.,i] = C[indx];

  clear S1,S2,G,C;

  i = i + 1;
endo;

results = indx~results;

cls;
print ftosa(results',"%lf",8,4);