new;
library frm,pgraph;

cls;

rndseed 123456;

c = 3; 
p = 1 - cdfn(c);

mu = seqa(-1,7/2000,2001);
n = rows(mu);
sigma = 0.8~1~2~3;

mu2 = mu^2;
sigma2 = sigma^2;

sigma_tilde = sigma ./ sqrt(2*sigma2 - 1);
mu_tilde = mu ./ (1 - 2*sigma2);
c_star = (c - mu_tilde)./sigma_tilde;
c_star2 = (c .* (2*sigma2 - 1) + mu) ./ (sigma .* sqrt(2*sigma2 - 1));

var_MC = p .* (1 - p);
var_IS = sigma2 ./ sqrt(2*sigma2-1) .* exp(-mu2./(1-2*sigma2)) .* exp(lncdfnc(c_star)) - p^2;
indx_opt = minindc(var_IS);
min_opt = subvec(var_IS',indx_opt);
ratio_opt = min_opt / var_MC;

stats = sigma'~mu[indx_opt]~1e4*min_opt~100*ratio_opt;
print ftos(1e4*var_MC,"var(MC) = %lf",1,2);
print ftosa(stats,"%lf",1,2~5~2~2);

graphset;
  begwind;
  window(2,2,0);  
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|3|4; _plwidth = 10;
  _paxht = 0.275; _pnumht = 0.225; _ptitlht = 0.275;
  
  xtics(-1,6,1,2);
  xlabel("\216\202m\201");
  ytics(0.0,1.40,0.20,2);        

  setwind(1);
    _pcolor = 1;
    title("\216\202s\201 = 0.8");      
    _pline = 1~3~mu[indx_opt[1]]~0~mu[indx_opt[1]]~1.4~1~0~10;
    xy(mu,1e4*var_IS[.,1]);

  setwind(2);
    _pcolor = 2;  
    title("\216\202s\201 = 1");      
    _pline = 1~3~mu[indx_opt[2]]~0~mu[indx_opt[2]]~1.4~1~0~10;    
    xy(mu,1e4*var_IS[.,2]);

  setwind(3);
    _pcolor = 3;
    title("\216\202s\201 = 2");      
    _pline = 1~3~mu[indx_opt[3]]~0~mu[indx_opt[3]]~1.4~1~0~10;    
    xy(mu,1e4*var_IS[.,3]);

  setwind(4);
    _pcolor = 4;  
    title("\216\202s\201 = 3");      
    _pline = 1~3~mu[indx_opt[4]]~0~mu[indx_opt[4]]~1.4~1~0~10;    
    xy(mu,1e4*var_IS[.,4]);

  endwind;



