new;
library frm,pgraph;

cls;

rndseed 123456;

declare matrix c;

proc (1) = optimal_IS(mu);
  local v;
  if c > 2;
    v = 2 * mu .* exp(lncdfnc(c + mu)) - pdfn(c + mu);
  else;
    v = 2 * mu .* cdfnc(c + mu) - pdfn(c + mu);
  endif;
    
  retp(v);
endp;

c_vector = seqa(-1,7/100,101); 

n_c = rows(c_vector);
mu_star = zeros(n_c,1);

i = 1;
do until i > n_c;
  c = c_vector[i];
  mu_star[i] = bisection(&optimal_IS,c-2,c+2);  
  i = i + 1;
endo;

mu = mu_star~c_vector;
   
sigma = 1;
mu2 = mu^2;
sigma2 = sigma^2;
sigma_tilde = sigma ./ sqrt(2*sigma2 - 1);
mu_tilde = mu ./ (1 - 2*sigma2);
c_star = (c - mu_tilde)./sigma_tilde;
c_star2 = (c .* (2*sigma2 - 1) + mu) ./ (sigma .* sqrt(2*sigma2 - 1));

p = 1 - cdfn(c);
var_MC = p .* (1 - p);
var_IS = sigma2 ./ sqrt(2*sigma2-1) .* exp(-mu2./(1-2*sigma2)) .* exp(lncdfnc(c_star)) - p^2;
ratio = var_IS / var_MC;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/2.5,6.855/2.5,1,4,1);
  
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  
  setwind(1);
    xtics(0,6,1,2);
    ytics(0,6,1,2);        
    ylabel("\216\202m\201[*]");
    xlabel("\216c");
    _pline = 1~3~-1~-1~6~6~1~0~10;
    xy(c_vector,mu_star);
    
    _pline = 0; _paxht = 0.27; _pnumht = 0.27; _ptitlht = 0.35;
  setwind(2);
    title("\216Variance ratio (in %)");
    ylabel("");
    ytics(0,10,2,2);
    _plegstr = "\202m\201 = \202m\201[*]\000\202m\201 = c";
    _plegctl = {2 5 6 3};
    xy(c_vector,100*ratio);  
    
  endwind;  
  