new;
library frm,pgraph;
frmSet;

cls;

rndseed 12;

alpha = 1.5~3~1~5;
beta  = 1.5~2~8~7;

proc f(x);
  retp(pdfBeta(x,alpha,beta));
endp;

proc g(x);
  local pdf;
  pdf = ones(rows(x),cols(x));
  retp(pdf);
endp;

c = (gamma(alpha+beta) ./ (gamma(alpha) .* gamma(beta))) .* ((alpha-1)^(alpha-1)) .* ((beta-1)^(beta-1)) ./ ((alpha+beta-2)^(alpha+beta-2));

print ftosa(c',"c = %lf",3,2);

x = 0.001|0.002|0.003|0.005|0.006|0.007|0.009|seqa(1/100,1/100,99)|0.991|0.992|0.995|0.996|0.999;
pdf1 = f(x);
pdf2 = c.*g(x);

graphset;
  begwind;
  window(2,2,1);

    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pltype = 1|3; _plwidth = 12; _pcolor = 1|4;
    xtics(0,1,0.2,2);
    xlabel("\216x");
    _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
    e = ones(rows(x),1);

  iter = 1;
  setwind(iter);
    str = ftos(alpha[1,iter],"\216\202a\201 = %lf",1,1) $+ ftos(beta[1,iter],", \202b\201 = %lf",1,1);
    title(str);
    ytics(0,1.5,0.5,2);
    _pline = e.*(1~6)~x~pdf1[.,iter]~x~pdf2[.,iter]~e.*(1~7~5);
    xy(x,pdf1[.,iter]~pdf2[.,iter]);

  iter = 2;
  setwind(iter);
    str = ftos(alpha[1,iter],"\216\202a\201 = %lf",1,1) $+ ftos(beta[1,iter],", \202b\201 = %lf",1,1);
    title(str);
    ytics(0,2.0,0.5,2);
    _pline = e.*(1~6)~x~pdf1[.,iter]~x~pdf2[.,iter]~e.*(1~7~5);
    xy(x,pdf1[.,iter]~pdf2[.,iter]); 

  iter = 3;
  setwind(iter);
    str = ftos(alpha[1,iter],"\216\202a\201 = %lf",1,1) $+ ftos(beta[1,iter],", \202b\201 = %lf",1,1);
    title(str);
    ytics(0,10.0,2.0,2);
    _pline = e.*(1~6)~x~pdf1[.,iter]~x~pdf2[.,iter]~e.*(1~7~5);
    xy(x,pdf1[.,iter]~pdf2[.,iter]);

  iter = 4;
  setwind(iter);
    str = ftos(alpha[1,iter],"\216\202a\201 = %lf",1,1) $+ ftos(beta[1,iter],", \202b\201 = %lf",1,1);
    title(str);
    ytics(0,3.0,0.5,2);
    _pline = e.*(1~6)~x~pdf1[.,iter]~x~pdf2[.,iter]~e.*(1~7~5);
    _plegstr = "f(x) - Beta\000c\202\46\201g(x) - Uniform";
    _plegctl = {2 5 4 3};
    xy(x,pdf1[.,iter]~pdf2[.,iter]);

  endwind;



