new;
library frm,pgraph;
frmSet;

cls;

rndseed 12;

alpha = 2;
beta  = 2;

proc f(x);
  retp(pdfBeta(x,alpha,beta));
endp;

proc g(x);
  local pdf;
  pdf = ones(rows(x),cols(x));
  retp(pdf);
endp;

c = (gamma(alpha+beta) ./ (gamma(alpha) .* gamma(beta))) .* ((alpha-1)^(alpha-1)) .* ((beta-1)^(beta-1)) ./ ((alpha+beta-2)^(alpha+beta-2));

nS = 10000;
u = rndu(nS,2);
u1 = u[.,1];
u2 = u[.,2];
x = u1;
v = f(x) ./ (c * g(x));
v2 = (u1^(alpha-1)) .* ((1-u1)^(beta-1)) .* ((alpha+beta-2)^(alpha+beta-2)) ./ (((alpha-1)^(alpha-1)) .* ((beta-1)^(beta-1)));
x = missex(x,u2 .> v);
x = packr(x);

ratio = rows(x) / nS;
print ftos(ratio,"%lf",3,2);

data = x;
x = seqa(0,1/100,101);
{pdf,cdf} = regKernelDensity(data,x);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(0,1,0.20,2);
  _plegstr = "Exact density\000Simulated density";
  _plegctl = {2 5 6 2};
  xy(x,f(x)~pdf);




