new;
library frm,pgraph;
frmSet;

cls;

rndseed 12;

alpha = 0.5;
beta  = 1.5;

proc f(x);
  retp(pdfBeta(x,alpha,beta));
endp;

proc g(x);
  local pdf;
  pdf = alpha .* x^(alpha-1);
  retp(pdf);
endp;

c = (gamma(alpha+beta) ./ (gamma(alpha) .* gamma(beta))) ./ alpha;

print ftosa(c',"c = %lf",3,2);

x = seqa(1/100,1/200,200);
pdf1 = f(x);
pdf2 = c.*g(x);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 1|3; _plwidth = 12; _pcolor = 1|4;
  xtics(0,1,0.2,2);
  xlabel("\216x");
  e = ones(rows(x),1);
  ytics(0,5,0.5,2);
  _pline = e.*(1~6)~x~pdf1~x~pdf2~e.*(1~7~5);
  xy(x,pdf1~pdf2);

