new;
library frm,pgraph;
frmSet;

cls;

rndseed 12;

proc c_cauchy(alpha);
  local c;
  c = (2*pi) ./ gamma(alpha) .* ((alpha+1)^(alpha+1)) .* exp(-(alpha+1));
  retp(c);
endp;

proc c_student(alpha);
  local c;
  c = sqrt(3*(4*alpha-1))./gamma(alpha) .* ((alpha-1)^(alpha-1)) .* exp(-(alpha-1));
  retp(c);
endp;

alpha = seqa(1,0.1,200);
c = c_cauchy(alpha)~c_student(alpha);

p = 1 ./ c;

graphset;
  xy(alpha,c);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 12; _pcolor = 1|4;
  xtics(1,10,1,2);
  ytics(0,1.0,0.1,2);
  xlabel("\216\202a\201");
  _plegstr = "Cauchy\000Student";
  _plegctl = {2 5 6 5.5};
  xy(alpha,p);

