new;
library frm,pgraph;
frmSet;

cls;

rndseed 12;

let k = 1    2    3    4    5;
let p_k = 0.10 0.20 0.40 0.20 0.10;
n_k = 5;

proc pmf_p(x);
  local pmf;
  pmf = sumr(p_k' .* (x .== k'));
  retp(pmf);
endp;

proc pmf_q(x);
  local pmf;
  pmf = ones(rows(x),cols(x)) ./ n_k;
  retp(pmf);
endp;

c = n_k * maxc(p_k);

nS = 1000;
u = rndu(nS,2);
u1 = u[.,1];
u2 = u[.,2];

x = ceil(n_k * u1);

v = pmf_p(x) ./ (c * pmf_q(x));
e = u2 .<= v;
y = delif(x,e);
x = selif(x,e);

freqs = counts(x,k)~counts(y,k);

ratio = rows(x) / nS;
print ftos(ratio,"%lf",3,1);

results = freqs/nS~freqs./sumc(freqs)';
results = results[.,1 3 2 4];
results = results | sumc(results)';

print ftosa(100*results,"%lf",3,1);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pbarwid = -0.50; _pbartyp = {6 1, 3 4};
  _plegstr = "Accepted\000Rejected";
  _plegctl = {2 5 7 5.75};
  xtics(0,6,1,2);
  let xlab = "0" "1.5" "3.3" "5.6" "8.9";
  asclabel(xlab,0);
  call bar(0,freqs);




