new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123456;

let alpha = 0.90 0.95 0.99 0.999;
nAlpha = rows(alpha);

nS = 1e6; 

lambda = 50;
mu = 7;
sigma = 1.5;
S1 = rndLDA_LN(lambda,mu,sigma,nS);
CaR1 = quantile(S1,alpha);
EL1 = meanc(S1);

lambda = 100;
mu = 5.5;
sigma = 1.8;
S2 = rndLDA_LN(lambda,mu,sigma,nS);
CaR2 = quantile(S2,alpha);
EL2 = meanc(S2);

rndCopulaSobol(0);

L1 = S1 + S2;
CaR_L1 = quantile(L1,alpha);

{u1,u2} = rndCopulaNormal2(0.99,nS);
S = rndCopulaEmpiricalQuantile(u1~u2,S1~S2);
L2 = S[.,1]+S[.,2];
CaR_L2 = quantile(L2,alpha);
CaR_L3 = CaR1 + CaR2;

let CaR_L4[4,2] = 251660   183560 
                  294030   218950 
                  414810   332870 
                  708840   662420; 
CaR_L4 = CaR_L4[.,1] + CaR_L4[.,2];

print ftosa(CaR_L1~CaR_L2~CaR_L3~CaR_L4,"%lf",3,0);
ratio = (CaR_L1~CaR_L2~CaR_L3~CaR_L4)./CaR_L4 - 1.00;
print ftosa(100*ratio,"%lf",3,2);

/*
          400240           434686           435088           435220 
          453864           511922           512496           512980 
          605927           743972           747523           747680 
          993535          1359598          1365647          1371260 

           -8.04            -0.12            -0.03             0.00 
          -11.52            -0.21            -0.09             0.00 
          -18.96            -0.50            -0.02             0.00 
          -27.55            -0.85            -0.41             0.00 

*/
x = seqa(11,4/200,201);
{d1,F1} = regKernelDensity(ln(L1),x);
{d2,F2} = regKernelDensity(ln(L2),x);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1; _pcolor = 1|4; _plwidth = 10;
  xtics(11,14,1,2);
  xlabel("\216ln(S1 + S2)");
  _plegstr = "Copula C[\202\74\201]\000Copula C[+]";
  _plegctl = {2 5 6.5 5.5};
  xy(x,d1~d2);

