new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123456;

let alpha = 0.90 0.95 0.99 0.999;
nAlpha = rows(alpha);

nS = 1e6; 

lambda = 50;
mu = 7;
sigma = 1.5;
S1 = rndLDA_LN(lambda,mu,sigma,nS);
CaR1 = quantile(S1,alpha)';
EL1 = meanc(S1);

lambda = 100;
mu = 5.5;
sigma = 1.8;
S2 = rndLDA_LN(lambda,mu,sigma,nS);
CaR2 = quantile(S2,alpha)';
EL2 = meanc(S2);

rndCopulaSobol(0);
rho = seqa(0,0.1,10)|0.99;
nRho = rows(rho);
CaR = zeros(nRho,nAlpha);

i = 1;
do until i > nRho-1;
  {u1,u2} = rndCopulaNormal2(rho[i],nS);
  S = rndCopulaEmpiricalQuantile(u1~u2,S1~S2);
  L = S[.,1]+S[.,2];
  CaR[i,.] = quantile(L,alpha)';
  i = i + 1;
endo;
CaR[i,.] = CaR1 + CaR2;

CaR_Gaussian = (EL1 + EL2) + sqrt( (CaR1 - EL1)^2 + (CaR2 - EL2)^2 + 2 * rho .* (CaR1 - EL1) .* (CaR2 - EL2));

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1; _plctrl = 1; _pcolor = 1|4; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.30; _pstype = 8|9; _psymsiz = 6.5;
  xtics(0,100,20,2);
  xlabel("\216\202r\201 (in %)");

  i = 1;
  setwind(i);
    str = ftos(100*alpha[i],"\216\202a\201 = %lf",1,1) $+ "%";
    title(str);
    ytics(3.9e5,4.4e5,0.1e5,2);
    xy(100*rho,CaR[.,i]~CaR_Gaussian[.,i]);

  i = 2;
  setwind(i);
    str = ftosa(100*alpha[i],"\216\202a\201 = %lf",1,1) $+ "%";
    title(str);
    ytics(4.4e5,5.2e5,0.2e5,2);
    xy(100*rho,CaR[.,i]~CaR_Gaussian[.,i]);

  i = 3;
  setwind(i);
    str = ftosa(100*alpha[i],"\216\202a\201 = %lf",1,1) $+ "%";
    title(str);
    ytics(6.0e5,7.5e5,0.5e5,2);
    xy(100*rho,CaR[.,i]~CaR_Gaussian[.,i]);

  i = 4;
  setwind(i);
    str = ftosa(100*alpha[i],"\216\202a\201 = %lf",1,1) $+ "%";
    title(str);
    _plegstr = "Copula\000Gaussian";
    _plegctl = {2 5 6 1.5};
    ytics(0.9e6,1.4e6,0.1e6,2);
    xy(100*rho,CaR[.,i]~CaR_Gaussian[.,i]);

  endwind;