new;
library frm,pgraph;

datFileName = "..\\..\\data\\dfast_stress_scenario";

loadm databuf = ^datFileName;

baseline_scenario = vread(databuf,"baseline");
adverse_scenario = vread(databuf,"adverse");
severely_scenario = vread(databuf,"severely");
t = vread(databuf,"date");

indx = 1;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
gdp = data;

indx = 5;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
unemployment = data;

indx = 6;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
cpi = data;

indx = 7;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
short_rate = data;

indx = 14;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
housing = data;

indx = 16;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
vix = data;

t = seqa(1,1,13);

graphset;
  window(2,3,1);
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4;
  _ptitlht = 0.40; _pnumht = 0.30; _paxht = 0.30; _plctrl = 1; _psymsiz = 8; _pstype = 8|9|10;
  xtics(1,13,4,1);
  let xlab = "2017" "18" "19" "20";
  asclabel(xlab,0); 

  setwind(1);
    title("\216Real GDP growth");
    xy(t,gdp);

  setwind(2);
    title("\216Unemployment rate");
    xy(t,unemployment);

  setwind(3);
    title("\216CPI inflation rate");
    xy(t,cpi);

  setwind(4);
    title("\2163-month Treasury rate");
    xy(t,short_rate);

  setwind(5);
    title("\216House Price Index");

    xy(t,housing);

  setwind(6);
    title("\216Market Volatility Index");
    _plegstr = "Baseline\000Adverse\000Severely";
    _plegctl = {2 6.5 5 4};
    xy(t,vix);

  endwind;
