new;
library frm,pgraph;

datFileName = "..\\..\\data\\dfast_stress_scenario";

loadm databuf = ^datFileName;

baseline_scenario = vread(databuf,"baseline");
adverse_scenario = vread(databuf,"adverse");
severely_scenario = vread(databuf,"severely");
t = vread(databuf,"date");

indx_baseline = 16;

indx = indx_baseline + 1;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
euro_gdp = data;

indx = indx_baseline + 2;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
euro_inflation = data;

indx = indx_baseline + 7;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
japan_gdp = data;

indx = indx_baseline + 8;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
japan_inflation = data;

indx = indx_baseline + 10;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
uk_gdp = data;

indx = indx_baseline + 11;
data = baseline_scenario[.,indx]~adverse_scenario[.,indx]~severely_scenario[.,indx];
uk_inflation = data;

t = seqa(1,1,13);

graphset;
  window(2,3,1);
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4;
  _ptitlht = 0.40; _pnumht = 0.30; _paxht = 0.30; _plctrl = 1; _psymsiz = 8; _pstype = 8|9|10;
  xtics(1,13,4,1);
  let xlab = "2017" "18" "19" "20";
  asclabel(xlab,0); 

  setwind(1);
    title("\216Euro area real GDP growth");
    xy(t,euro_gdp);

  setwind(2);
    title("\216Japan real GDP growth");
    xy(t,japan_gdp);

  setwind(3);
    title("\216UK real GDP growth");
    xy(t,uk_gdp);

  setwind(4);
    title("\216Euro area inflation");
    xy(t,euro_inflation);

  setwind(5);
    title("\216Japan inflation");
    xy(t,japan_inflation);

  setwind(6);
    title("\216UK inflation");
    _plegstr = "Baseline\000Adverse\000Severely";
    _plegctl = {2 6.5 5 1};
    xy(t,uk_inflation);

  endwind;
