new;
library frm,pgraph;
cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "equity-indices-2017-daily";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

BeginDate = 19500101;
EndDate = 20191231;
Dates = data[.,1];
Index = data[.,2];

Index = selif(Index, (Dates .>= BeginDate) .and (Dates .<= EndDate));
Dates = selif(Dates, (Dates .>= BeginDate) .and (Dates .<= EndDate));
nDates = rows(Dates);

nLags = 1|5|21|43|65|130;
nIters = rows(nLags);
nScenarios = 5;
results = zeros(nScenarios,2*nIters);

i = 1;
do until i > nIters;
  {date_wcs,Rt_wcs} = worst_case_selection(Dates,Index,nLags[i],nScenarios);
  results[.,2*i-1:2*i] = date_wcs~100*Rt_wcs;
  i = i + 1;
endo;

print ftosa(results[.,1:6],"%lf",3,2);

print ftosa(results[.,7:12],"%lf",3,2);