new;
library frm,pgraph;
cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "equity-indices-2017-daily";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

BeginDate = 19500101;
EndDate = 20191231;
Dates = data[.,1];
Index = data[.,2];

Index = selif(Index, (Dates .>= BeginDate) .and (Dates .<= EndDate));
Dates = selif(Dates, (Dates .>= BeginDate) .and (Dates .<= EndDate));
nDates = rows(Dates);

nLags = seqa(1,1,800);
nIters = rows(nLags);
Loss = zeros(nIters,1);

i = 1;
do until i > nIters;
  Rt = Index ./ lagn(Index,nLags[i]) - 1.0;
  Loss[i] = minc(Rt);
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {3,1};
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xtics(0,30,4,2);
  xlabel("\216Number of months");
  ytics(-60,-20,10,2);
  xy(12*nLags/260,100*Loss);