new;
library frm,optmum,pgraph;
frmset;
cls;

rndseed 123;

let beta = -2.5 -5 -3 2;
sigma = 0.5;

g_long_run  = 0.02;
pi_long_run = 0.02;
u_long_run  = 0.05;

PD_long_run = stress_testing_calculate_PD(beta,g_long_run,pi_long_run,u_long_run,sigma);

g_stress  = seqa(-0.10,0.15/100,101);
pi_stress  = seqa(-0.01,0.07/100,101);
u_stress  = seqa(0.02,0.10/100,101);

mu_PD = zeros(101,3);

iter = 1;
do until iter > 3;
  if iter == 1;
    g_t = g_stress;
    pi_t = pi_long_run;
    u_t = u_long_run;
  elseif iter == 2;
    g_t = g_long_run;
    pi_t = pi_stress;
    u_t = u_long_run;
  elseif iter == 3;
    g_t = g_long_run;
    pi_t = pi_long_run;
    u_t = u_stress;
  endif;

  mu_PD[.,iter] = stress_testing_calculate_PD(beta,g_t,pi_t,u_t,sigma);

  iter = iter + 1;
endo;

mu_PD = 100 * mu_PD;

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|4;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;
  ylabel("\216PD]t[ (in %)");
  ytics(6,14,2,2);

  iter = 1;
  _pcolor = 1;
  setwind(1);
    title("\216Impact of the GDP growth");
    xlabel("\216g]t[ (in %)");
    _pline = 1~1~100*g_long_run~6~100*g_long_run~14~1~0~10 |
             1~1~-10~100*PD_long_run~6~100*PD_long_run~1~0~10 ;
    xy(100*g_stress,mu_PD[.,iter]);

  ytics(7,9,0.5,2);

  iter = 2;
  _pcolor = 2;
  setwind(iter);
    title("\216Impact of the inflation rate");
    xlabel("\216\202p\201]t[ (in %)");
    _pline = 1~1~100*pi_long_run~7~100*pi_long_run~9~1~0~10 |
             1~1~-1~100*PD_long_run~8~100*PD_long_run~1~0~10 ;
    xy(100*pi_stress,mu_PD[.,iter]);

  iter = 3; 
  _pcolor = 4;
  setwind(iter);
    title("\216Impact of the unemployment rate");
    xlabel("\216u]t[ (in %)");
    xtics(2,12,2,2);
    _pline = 1~1~100*u_long_run~7~100*u_long_run~9~1~0~10 |
             1~1~2~100*PD_long_run~12~100*PD_long_run~1~0~10 ;
    xy(100*u_stress,mu_PD[.,iter]);

  endwind;