new;
library frm,optmum,pgraph;
frmset;
cls;

rndseed 123;

let beta = -2.5 -5 -3 2;
sigma = 0.5;
nS = 1000000;

let g_t  = 0.02 -0.06 -0.07 -0.09 -0.07 -0.07 -0.06 -0.04 -0.02 -0.01 0.02 0.04 0.04;
let pi_t = 0.02  0.02  0.01  0.01  0.01  0.02  0.02  0.04  0.03  0.03 0.03 0.03 0.03;
let u_t  = 0.05  0.06  0.07  0.09  0.10  0.11  0.10  0.09  0.08  0.07 0.06 0.06 0.06;

nIters = rows(g_t);
PD_t = zeros(nIters,3);
PD_t[.,1]  = stress_testing_calculate_PD(beta,g_t,pi_t,u_t,sigma);

iter = 1;
do until iter > rows(g_t); 
  {Z,mean_Z,PD,mean_PD} = stress_testing_simulate_PD(beta,g_t[iter],pi_t[iter],u_t[iter],sigma,nS);
  PD_t[iter,2] = quantile(PD,0.50);
  PD_t[iter,3] = quantile(PD,0.90);
  iter = iter + 1;
endo;

t = seqa(0,1,rows(g_t));
Results = t~100*(g_t~pi_t~u_t~PD_t);

output file = chap18-2-3-3.out reset;

print ftosa(Results,"%lf",3,0~2~2~2~2~2~2);

output off;
