new;
library frm,optmum,pgraph;
frmset;
cls;

mu1 = 0.03;
mu2 = 0.05;
sigma1 = 0.10;
sigma2 = 0.20;
rho = -0.50;

nu = 1;

x = seqa(-0.30,0.60/200,201);
beta = rho*sigma2/sigma1;
tau = mu2 - beta * mu1;
y_OLS = tau + beta * x;

let p[1,4] = 0.10 0.25 0.50 0.60;
x1 = x;
u1 = cdft((x1-mu1)/sigma1,nu);
u2 = qrCopulaNormal(u1,rho,p);
x2 = mu2 + sigma2 * cdfti(u2,nu);
y_QR = x2;
y = y_QR~y_OLS;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 3|1|6|6|6; _pcolor = 1|2|3|4|0; _plwidth = 10;
  _pstype = 8|8|8|8|9; _plctrl = 0|0|0|10|5;
  xtics(-25,25,5,2);
  ytics(-25,25,5,2);
  xlabel("\216R]1,t[ (in %)");
  ylabel("\216R]2,t[ (in %)");
  _plegstr = "\202a\201 = 10%\000\202a\201 = 25%\000\202a\201 = 50%\000\202a\201 = 60%\000OLS";
  _plegctl = {2 5 5.75 4.75};
  xy(100*x,100*y);