new;
library frm,optmum,pgraph;
frmset;
cls;

n = 10;
rho = 0.5;
rho = diagrv(rho*ones(n+1,n+1),1);
sigma = 0.20 + 0.20 * rndu(n+1,1);
mu = 0.03 + 0.15 * rndu(n+1,1);
cov = rho .* sigma .* sigma';

nS = 1000;
data = rndmvn_chol(mu,cov,nS);
L = data[.,n+1];
data = data[.,1:n];
L_max = quantile(L,0.90);
x = selif(data,L .>= L_max);
nobs = rows(x);

mu_x = 0.25*meanc(x);

proc (1) = profile_empirical_likelihood(w);
  w = sqrt(1e-8 + w^2);
  retp(sumc(ln(w)));
endp;

theta = mu_x;

A = ones(1,nobs) |
    x'        ;
B = 1|theta   ;
bounds = 0~100;

sv = ones(nobs,1)/nobs;

_sqp_A = A;
_sqp_B = B;
_sqp_bounds = bounds;
{w,fmin,grd,retcode} = sqpsolve(&profile_empirical_likelihood,sv);
A*w~B;

proc (1) = reverse_stress(xt,w,loss);
  local mu,Sigma,mu_loss,sigma_loss,beta,x_star;
 
  xt = packr(xt);
  mu = meanc(xt);
  Sigma = vcx(xt);
  mu_Loss = w'mu;
  sigma_Loss = w'*Sigma*w;
  beta = (Sigma*w)/sigma_loss;
  x_star = mu + beta * (loss - mu_loss); 

  retp(x_star);
endp;

