new;
library frm,optmum,pgraph;

cls;

Let Y = 1 1 1 1 0 1 0 1 1 1
        0 0 0 0 1 0 0 0 0 1
        1 1 1 1 1 1 1 0 1 1
        0 0 0 0 0 1 0 0 0 0;
let X = -5.2 -4.3 -3.6 -1.0 -2.0 -1.8 -0.3 -1.5 -1.2 -2.7
        -1.0 -1.1 -0.5 -0.5 -0.8 -0.2 -0.2 -0.4 -0.7 -0.1
         0.0  0.5  0.7  0.2  0.3  0.2  0.5  0.7  0.5  0.8
         0.8  0.9  1.0  0.4  0.0  0.9  1.2  1.7  1.8  1.9;  

nSlice = 11;
nClass = 4;

_dataset_slicing_min = 0;

min = -5.0;
max =  1.4;

slices = seqa(min,(max-min)/(nSlice-1),nSlice);
{val_Y,frq} = dataset_slicing_frequency(0,Y,X,slices);
print "----------------------------------------------------------------------------------------------";
print ftosa(error(0)~slices',"%f",10,3);
print "----------------------------------------------------------------------------------------------";
print ftosa(val_Y~frq,"%f",10,2);
print "----------------------------------------------------------------------------------------------";

iter = 2;
do until iter > nClass;
  {bounds,chi2} = dataset_slicing(frq,slices,iter);
  {val_Y,opt_frq} = dataset_slicing_frequency(0,Y,X,bounds);
  chi2 = dataset_slicing_chi2(opt_frq);
  print ftos(chi2,"chi2 = %lf",5,3);
  print; 
  if iter == nClass;
    opt_bounds = bounds;
  endif;
  iter = iter + 1;
endo;

{val_Y,opt_frq} = dataset_slicing_frequency(0,Y,X,opt_bounds);
print opt_bounds';
print opt_frq;
print "----------------------------------------------------------------------------------------------";
frq1 = opt_frq;
bound1 = opt_bounds;

q = seqa(1/nClass,1/nClass,nClass-1);
bound2 = quantile(X,q);
{val_Y,frq2} = dataset_slicing_frequency(0,Y,X,bound2);
print bound2';
print frq2;
print "----------------------------------------------------------------------------------------------";

if 1;
  g_frq = frq1;
  g_bounds = bound1;
else;
 g_frq = frq2;
 g_bounds = bound2;
endif;

graphset;
  begwind;
  makewind(7,6.855,0,0,1);
  makewind(2,6.855,7,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;

  setwind(1);
    _pbarwid = -0.5;
    _pbartyp = {1 4, 3 1};
    ylabel("Frequency (in %)"); 
    _plegstr = "";
    i = 1;
    do until i >= rows(val_Y);
      _plegstr = _plegstr $+ ftos(val_Y[i],"Y = %lf",1,0);
      _plegstr = _plegstr $+ "\000";
      i = i + 1;
    endo;
    _plegstr = _plegstr $+ ftos(val_Y[rows(val_Y)],"Y = %lf",1,0);
    _plegctl = {2 6 9 5.75};  
    xlab = 0 $+ "#" $+ ftocv(seqa(1,1,cols(g_frq)),1,0);
    asclabel(xlab,0);
    bar(0,g_frq');

    setwind(2);
      graphset;
      _pframe = 0; _paxes = 0; 
      sa = ftosa(lagn(g_bounds,1),"%lf",1,2) $+ " / " $+
           ftosa(g_bounds,"%lf",1,2);    
      sa[1] = ftosa(g_bounds[1],"%lf",1,2) $+ " <" ;
      sa = sa $| ("> " $+ ftosa(g_bounds[rows(g_bounds)],"%lf",1,2));
      sa = ("" $+ xlab) $+ " : " $+ sa;

      xtics(0,1,1,0);
      ytics(-1,rows(sa)+1,rows(sa)+3,0);
      e = ones(rows(sa),1);

      _pmsgstr = MakeMsgStr(sa);
      _pmsgctl = -0.15*e~seqa(rows(sa),-1,rows(sa))~e.*(0.6~0~1~0~8);

      draw;

  endwind;