new;
library frm,optmum,pgraph;

PathName = "..\\..\\data\\";
datFileName = PathName $+ "prostate.dat";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

let selected_names = "lcavol"	"lweight"	"age"	"lbph"	"svi"	"lcp"	"gleason"	"pgg45"	"lpsa";
selected_names = "" $+ selected_names;
indx = indsav(selected_names,vnames);

data = data[.,indx];
y = data[.,cols(data)];
x = data[.,1:cols(data)-1];
m = cols(x);

y = regStandardize(y);
x = regStandardize(x);

beta_ols = y/x;
tau = sumc(abs(beta_ols));
nTau = 101;
tau = seqa(tau,-tau/nTau,nTau+1);

lambda = seqa(0,10,51)|750|1000|2000|10000|100000;
{beta,tau,df,complexity} = regRidge(y,x,lambda);
u = y - x*beta';
rss = meanc(u^2);

s = tau./tau[1];

graphset;
  begwind;
  makewind(6.855,6.855,0,0,0);
  makewind(2.8,2.8,6.25,0.5,0);
  makewind(2.8,2.8,6.25,6.855-2.8-0.5,0);

  fonts("simplex simgrma");

  _pnum = 2; _pframe = 0; _pdate = "";
  _pltype = 6|1|3; _plwidth = 10; _pcolor = reshape(seqa(1,1,7),m,1);
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.22;  
  xtics(0,8,1,2);
  xlabel("\216           df(\202l\201)");
  ylabel("\216\202b\201(\202l\201)");

  setwind(1);
    _pcross = 1;
    ytics(-0.2,0.6,0.2,2);
    xy(df,beta);

  _pcross = 0;
  _paxht = 0.35; _pnumht = 0.25; _ptitlht = 0.22;  
  xlabel("\216\202l\201");
  xtics(0,500,100,2);
  setwind(2);
    ytics(1,8,1,2);
    ylabel("\216df(\202l\201)");
    xy(lambda,df);

  setwind(3);
    ytics(0.30,0.70,0.10,2);
    ylabel("\216RSS(\202l\201)");
    xy(lambda,rss);

  endwind;

