new;
library frm,optmum,pgraph;

cls;

rndseed 123;

N = 15;
K = 5;
sigma = 0.40;

x = trunc(100*rndu(N,K))/10;
u = rndu(N,1) * sigma;
beta3 = 3 + 2*rndu(N,1);

y = 3*x[.,1] - 1.5*x[.,2] + beta3 .* x[.,3] - 0.5*x[.,4] + 0.2* x[.,5] + u;
x = trunc(10*x)/10;
y = trunc(10*y)/10;

print ftosa(seqa(1,1,N)~y~x,"%lf",3,1);

m = cols(x);
y = regStandardize(y);
x = regStandardize(x);

beta_ols = y/x;
lambda = 0|0.9|2.5|5.5|7.5;
{beta_lasso,tau,df,complexity} = regLasso2(y,x,lambda);
u = y - x*beta_lasso';
rss = meanc(u^2);
tss = meanc(y^2);
R2 = 1 - rss / tss;
results = lambda' | beta_lasso' | tau' | rss' | R2' | df';
print ftosa(results,"%lf",5,4);


tau = sumc(abs(beta_ols));
nTau = 501;
tau = seqa(tau,-tau/nTau,nTau+1);

lambda = seqa(0,0.01,5001)|60|70|80|90|100;

{beta,tau,df,complexity} = regLasso2(y,x,lambda);
u = y - x*beta';
rss = meanc(u^2);

s = tau./tau[1];

beta = missex(beta,abs(beta) .<= 1e-25);

graphset;
  begwind;
  makewind(6.755,6.855,0,0,0);
  makewind(2.8,2.8,6.25,0.5,0);
  makewind(2.8,2.8,6.25,6.855-2.8-0.5,0);

  fonts("simplex simgrma");

  _pnum = 2; _pframe = 0; _pdate = "";
  _pltype = 6|1|3|2; _plwidth = 10; _pcolor = reshape(seqa(1,1,7),m,1);
  _plctrl = 0|0|0|30|20; _pstype = 8;
  _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.22;  
  xtics(0,1,0.20,2);
  xlabel("\216\202t\201[*]");
  ylabel("\216\202b\201");

  setwind(1);
    _pcross = 1;
    ytics(-0.3,0.9,0.3,2);
    _plegstr = "\202b\201]1[\000\202b\201]2[\000\202b\201]3[\000\202b\201]4[\000\202b\201]5[";
    _plegctl = {2 5 2 5};
    xy(s,beta);

  _plegctl = 0;
  _pcross = 0;
  _paxht = 0.40; _pnumht = 0.30; _ptitlht = 0.45;  
  ylabel("");
  setwind(2);
    ytics(0,5,1,2);
    title("\216df");
    xy(s,df);

  setwind(3);
    ytics(0.0,0.90,0.20,2);
    title("\216RSS");
    xy(s,rss);

  endwind;

