new;
library frm,optmum,pgraph;

cls;

rndseed 1;

N = 20;
K = 5;
sigma = 0.40;

x = trunc(100*rndn(N,K))/10;
u = rndn(N,1) * sigma;
beta = 3|-1.5|1.0|-0.5|0.2;
beta = beta' .* rndu(N,K);
y = sumr(x .* beta) + u;
beta = invpd(x'x + 50.5 * eye(5))*x'y;
y = x*beta + u;
y = trunc(10*y)/10;

print ftosa(seqa(1,1,N)~y~x,"%lf",3,1);

lambda = seqa(0.0,0.01,801);
nLambda = rows(Lambda);
y_hat = zeros(N,nLambda);

iter = 1;
do until iter > N;
  cnd = zeros(N,1);
  cnd[iter] = 1.0;
  y_cv = delif(y,cnd);
  x_cv = delif(x,cnd);
  {beta_cv,tau,df,complexity} = regRidge(y_cv,x_cv,lambda);
  y_hat[iter,.] = x[iter,.]*beta_cv';
  iter = iter + 1;
endo;

Press = meanc((y - y_hat)^2);
indx = minindc(Press);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  xlabel("\216\202l\201");
  ylabel("\216Press(\202l\201)");
  ytics(0.2900,0.2950,1/1000,0);
  _pline = 1~3~lambda[indx]~0~lambda[indx]~Press[indx]~1~4~10 |
           1~3~0~Press[indx]~lambda[indx]~Press[indx]~1~4~10 ;
  _psym = lambda[indx]~Press[indx]~8~3.5~4~1~10;
  _pmsgstr = "\202l\201[*]";
  _pmsgctl = 1.05*lambda[indx]~0.997*Press[indx]~0.2~0~1~4~10;
  xy(lambda,Press);



