new;
library frm,optmum,pgraph;
cls;

rndseed 123456;

n = 4;

let rho = 1.0 
          0.7  1.0
          0.2  0.2 1.0
          0.0  0.2 0.5 1.0;
let sigma = 0.20 0.20 0.20 0.20;
let mu  = 0.05 0.10 0.05 0.00;

rho = xpnd(rho);
call invpd(rho);

x0 = 100 * ones(n,1);
t = seqa(0,1/50,50*5);
nT = rows(t);
x = matrix_simulate_mGBM(x0,mu,sigma,rho,t);

ln_x = ln(x);
r = ln_x - lag(ln_x);
r[1,.] = zeros(1,n);

cov = vcx(r);
cov = sigma .* sigma' .* rho;
{lambda,beta,PCAmatrix} = regPCA(cov,1,0);

acp_factor = r*beta;
acp_price = ln(100*cumprodc(1 + cumsumc(acp_factor')'));

_nmf_maxIters = 10000;
_nmf_PrintIters = 0;

A = ln_x';

n = 1;
if n == 1;
  _nmf_B0 = ones(n,1);
  _nmf_C0 = meanc(A)';
endif;

{B,C,retcode} = regNMF(A,n,0);
{B_star,C_star} = NMF_scaling(B,C,maxc(B));
nmf_price = C_star';

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|1;
  _paxht = 0.25; _pnumht = 0.225; _ptitlht = 0.30;
  ytics(4,6,0.5,2);
  xtics(0,5,1,2);
  xlabel("\216t (in years)");

  setwind(1);
    title("\216Asset prices");
    _pcolor = 1|2|3|4;
    xy(t,ln_x);

  setwind(2);
    title("\216First factor (NMF)");
    _pcolor = 5;
    xy(t,nmf_price);

  setwind(3);
    _pcolor = 6;
    title("\216First factor (PCA)");
    xy(t,acp_price);

  endwind;

cls;

y = nmf_price~acp_price;
y = y - lag1(y);
y = packr(y);
c = submat(corrx(y),1,2); 
print 100*c;

