new;
library frm,pgraph,optmum;
cls;

generate_data = 0;

nS = 100;

if generate_data == 1;
  rndseed 123456;

  n = 5;
  K = 5;

  rho = diagrv(eye(n),0.75);
  mu = 0.20 * ones(n,1);
  sigma = 0.05 * ones(n,1);
  cov = rho .* sigma .* sigma';
  x1 = rndmvn_chol(mu,cov,K);

  rho = diagrv(eye(n),0.75);
  mu = 0.30 * ones(n,1);
  sigma = 0.05 * ones(n,1);
  cov = rho .* sigma .* sigma';
  x2 = rndmvn_chol(mu,cov,K);

  x = bootstrap(x1'|x2',0);

  x = trunc(1000*x)/10;
  print ftosa(x,"%lf",3,1);
else;
  let x[10,5] = 17.6             19.6             19.8             20.4             28.8 
                13.2             17.5             17.5             17.4             24.2 
                35.9             25.4             32.4             25.0             40.7 
                28.1             24.0             25.1             28.7             26.7 
                23.5             23.6             23.7             14.3             18.1 
                36.5             30.3             29.5             32.0             29.5 
                14.0             23.9             18.3             19.2             17.2 
                36.7             29.0             30.3             21.1             28.7 
                31.2             19.4             29.9             33.3             23.8 
                17.0             20.5             23.8             16.0             19.7;
endif;

n = rows(x);

__output = 0;

nC = 2;
{class,retcode} = K_means_Clustering(x,nC,0);
{new_class,coding} = K_means_Clustering_Ordering(class,0);
// {class,centroids,retcode} = dataset_Clustering_Kmeans(0,x,nC);

{Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
// Loss = K_means_Clustering_Loss2(x,class);

optimal_loss = loss;
optimal_class = new_class;
optimal_centroids = class_centroid;

iter = 1;
do until iter > nS;
  {class,retcode} = K_means_Clustering(x,nC,-1);
  {new_class,coding} = K_means_Clustering_Ordering(class,0);
  {Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
  if Loss < optimal_loss;
    print "New optimum";
    optimal_loss = loss;
    optimal_class = new_class;
    optimal_centroids = class_centroid;
  endif;
  iter = iter + 1;
endo;

print "--------------------------------------------------------------------";
print "Class = ";
print ftosa(optimal_class~seqa(1,1,n),"%lf",3,2);
print "Centroid = ";
print ftosa(optimal_centroids,"%lf",3,2);
print ftosa(optimal_loss,"Loss = %lf",3,2);

nC = 3;
{class,retcode} = K_means_Clustering(x,nC,0);
{new_class,coding} = K_means_Clustering_Ordering(class,0);
{Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
initial_loss = loss;
optimal_loss = loss;
optimal_class = new_class;
optimal_centroids = class_centroid;

iter = 1;
do until iter > nS;
  {class,retcode} = K_means_Clustering(x,nC,-1);
  {new_class,coding} = K_means_Clustering_Ordering(class,0);
  {Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
  if Loss < optimal_loss;
    print "New optimum";
    optimal_loss = loss;
    optimal_class = new_class;
    optimal_centroids = class_centroid;
  endif;
  iter = iter + 1;
endo;

print "--------------------------------------------------------------------";
print "Class = ";
print ftosa(optimal_class~seqa(1,1,n),"%lf",3,2);
print "Centroid = ";
print ftosa(optimal_centroids,"%lf",3,2);
print ftosa(optimal_loss,"Loss = %lf",3,2);
print ftosa(initial_loss,"Initial loss = %lf",3,2);

print ftosa(selif(x,optimal_class .== 2),"%lf",3,2);
print ftosa(selif(x,optimal_class .== 3),"%lf",3,2);

nC = 4;
{class,retcode} = K_means_Clustering(x,nC,0);
{new_class,coding} = K_means_Clustering_Ordering(class,0);
{Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
initial_loss = loss;
optimal_loss = loss;
optimal_class = new_class;
optimal_centroids = class_centroid;

iter = 1;
do until iter > nS;
  {class,retcode} = K_means_Clustering(x,nC,-1);
  {new_class,coding} = K_means_Clustering_Ordering(class,0);
  {Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,new_class);
  if Loss < optimal_loss;
    print "New optimum";
    optimal_loss = loss;
    optimal_class = new_class;
    optimal_centroids = class_centroid;
  endif;
  iter = iter + 1;
endo;

print "--------------------------------------------------------------------";
print "Class = ";
print ftosa(optimal_class~seqa(1,1,n),"%lf",3,2);
print "Centroid = ";
print ftosa(optimal_centroids,"%lf",3,2);
print ftosa(optimal_loss,"Loss = %lf",3,2);
print ftosa(initial_loss,"Initial loss = %lf",3,2);





