new;
library frm,pgraph,optmum;
cls;

rndseed 123456;

n = 1000;
K = 50;
nS = 10;

rho = diagrv(eye(n),0.75);
mu = 0.20 * ones(n,1);
sigma = 0.05 * ones(n,1);
cov = rho .* sigma .* sigma';
x1 = rndmvn_chol(mu,cov,K);

rho = diagrv(eye(n),0.75);
mu = 0.30 * ones(n,1);
sigma = 0.05 * ones(n,1);
cov = rho .* sigma .* sigma';
x2 = rndmvn_chol(mu,cov,K);

x = x1'| x2';

__output = 0;

nK = 10;
all_loss = zeros(nK,1);

nC = 1;
do until nC > nK;
  {class,retcode} = K_means_Clustering(x,nC,0);
  {Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,class);
  optimal_loss = loss;
  optimal_class = class;
  optimal_centroids = class_centroid;

  iter = 1;
  do until iter > nS;
    {class,retcode} = K_means_Clustering(x,nC,-1);
    {Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(x,class);
    if Loss < optimal_loss;
      optimal_loss = loss;
      optimal_class = class;
      optimal_centroids = class_centroid;
    endif;
    iter = iter + 1;
  endo;

  all_loss[nC] = optimal_loss;
  print /flush nC;
  nC = nC + 1;
endo;

graphset;
  xy(seqa(1,1,nK),all_loss);
