new;
library frm,pgraph,gwizard;
cls;

rndseed 12345670;

n = 5;
ns = 50;

rho = diagrv(eye(n),0.80);
mu = 0.20 * ones(n,1);
sigma = 0.05 * ones(n,1);
cov = rho .* sigma .* sigma';
x1 = rndmvn_chol(mu,cov,ns);

rho = diagrv(eye(n),0.80);
mu = 0.30 * ones(n,1);
sigma = 0.25 * ones(n,1);
cov = rho .* sigma .* sigma';
x2 = rndmvn_chol(mu,cov,ns);

x = x1' | x2';
// x = bootstrap(x,1);

algr = 1;
{c,table,gBuffer} = Hierarchical_Clustering(x,algr,1);

level = 4;
print Hierarchical_Clustering_Level(c,level);

graphset;
  gWizardSet(gBuffer,1);    
  title("");
  xtics(-0.5,2.5,0.5,2);
  ytics(0,10.5,10.5,0);

  _psym[.,4] = 0*_psym[.,4] + 4;
  _psym[.,3] = 0*_psym[.,3] + 8;
  _psym[.,5] = 0*_psym[.,5] + 1;

  _pmsgctl[.,1] = _pmsgctl[.,1] - 0.25;  
  _pmsgctl[.,2] = _pmsgctl[.,2] + 0.050;
  _pmsgctl[.,3] = 0 * _pmsgctl[.,3] + 0.15;
  _pmsgctl[.,6] = 0 * _pmsgctl[.,6] + 4;
  _pmsgctl[.,7] = 0 * _pmsgctl[.,7] + 10;
  _pline = _pline | 
           (1~3~1.85~0~1.85~11~1~2~10) |
           (1~6~0.0~0~0.0~11~1~1~10) ;
  xlabel("\216Dissimilarity measure");
  gWizardDraw(gBuffer,1);   