new;
library frm,pgraph,gwizard;
cls;

let data[6,3] = 10 10 10 
                18  8 12
                 4 17 12
                 6 10 17
                10 12 14
                10 12  8;
data = data[.,2 1 3];
n = rows(data) ;
K = cols(data);
mu = meanc(data);
sigma = sqrt((n-1) / n) * stdc(data);
x = (data - mu')./sigma';
cov = (x'x)/n;

{lambda,B,results} = regPCA(cov,0,0);
text_line("-",70);

Q = vread(results,"QLT_var");
Q = Q ~ sumr(Q);
print "Quality of representation of each variable";
print ftosa(Q,"%lf",3,2);
text_line("-",70);

C = vread(results,"CTR_var");
C = C | sumc(C)';
print "Contribution of each variable";
print ftosa(C,"%lf",3,2);
text_line("-",70);

Z = x * B;
Z2 = Z^2;
QLT_obs = 100 * Z2 ./ sumr(Z2);
CTR_obs = 100 * Z2 ./ sumc(Z2)';

print "Quality of representation of each observation";
print ftosa(QLT_obs,"%lf",3,2);
text_line("-",70);

print "Contribution of each observation";
print ftosa(CTR_obs,"%lf",3,2);
text_line("-",70);

S = vread(results,"SAT");

cos2 = S[.,1];
sin2 = S[.,2];
t = seqa(0,2*pi/100,101);

graphset;   
  _pnum = 2; _pdate = ""; _pcross = 1; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  fonts("simplex simgrma");
  _pmsgstr = "X]1[\000X]2[\000X]3[";
  _pmsgctl = cos2+(-0.1|0.05|0)~sin2+(0|0|-0.1)~ones(K,5).*(0.15~0~1~4~10); 
  _parrow =  ones(K,1).*(0~0)~0.975*(cos2~sin2)~ones(K,1).*(3~0.125~31~4~1~6~10);
  _psym = cos2~sin2~ones(K,5).*(8~3~4~1~1); 
  xtics(-1,1,0.5,0);
  ytics(-1,1,0.5,0);
  xlabel("\2161[st] PC   ");
  ylabel("\2162[nd] PC   ");
  xy(cos(t),sin(t)); 


