new;
library frm,pgraph,gwizard;
cls;

let data[10,5] = 17.6             19.6             19.8             20.4             28.8 
                 13.2             17.5             17.5             17.4             24.2 
                 35.9             25.4             32.4             25.0             40.7 
                 28.1             24.0             25.1             28.7             26.7 
                 23.5             23.6             23.7             14.3             18.1 
                 36.5             30.3             29.5             32.0             29.5 
                 14.0             23.9             18.3             19.2             17.2 
                 36.7             29.0             30.3             21.1             28.7 
                 31.2             19.4             29.9             33.3             23.8 
                 17.0             20.5             23.8             16.0             19.7;
n = rows(data);
K = cols(data);
mu = meanc(data);
sigma = sqrt((n-1) / n) * stdc(data);
x = (data - mu')./sigma';
cov = (x'x)/n;
print ftosa(cov,"%lf",5,3);
print ftosa(corrx(data),"%lf",5,3);

{lambda,B,results} = regPCA(cov,0,0);
text_line("-",70);

C = 100*vread(results,"SAT");
print "Correlation";
print ftosa(C,"%lf",3,2);
text_line("-",70);

Q = vread(results,"QLT_var");
Q = Q ~ sumr(Q);
print "Quality of representation of each variable";
print ftosa(Q,"%lf",3,2);
text_line("-",70);

C = vread(results,"CTR_var");
C = C | sumc(C)';
print "Contribution of each variable";
print ftosa(C,"%lf",3,2);
text_line("-",70);

Z = x * B;
Z2 = Z^2;
QLT_obs = 100 * Z2 ./ sumr(Z2);
CTR_obs = 100 * Z2 ./ sumc(Z2)';

print "Quality of representation of each observation";
print ftosa(QLT_obs,"%lf",3,2);
text_line("-",70);

print "Contribution of each observation";
print ftosa(CTR_obs,"%lf",3,2);
text_line("-",70);

S = vread(results,"SAT");

t = seqa(0,2*pi/100,101);

graphset;
  _pnum = 2; _pdate = ""; _pframe = 0; _pcross = 1;
  _pltype = 6; _plwidth = 10; _pcolor = 1; 
  _plctrl = -1; _pstype = 11; _psymsiz = 5.0;
  xtics(-3,3,1,2);
  ytics(-1.5,1.5,0.5,2);
  xlabel("\2161[st] PC");
  ylabel("\2162[nd] PC");
  _pmsgstr = "1\0002\0003\0004\0005\0006\0007\0008\0009\00010";
  _pmsgctl = Z[.,1]+0.125~Z[.,2]-0.05~ones(n,5).*(0.175~0~1~1~8); 
  xy(Z[.,1],Z[.,2]);

graphset; 
  begwind;
  window(2,2,1);

  _pnum = 2; _pdate = ""; _pcross = 1; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.30;
  fonts("simplex simgrma");
  _pmsgstr = "X]1[\000X]2[\000X]3[\000X]4[\000X]5[";
  xtics(-1,1,0.5,0);
  ytics(-1,1,0.5,0);

  cos2 = S[.,1];
  sin2 = S[.,2];

  setwind(1);  
    _pmsgctl = cos2+(-0.15|-0.05|-0.1|0.02|0.02)~sin2+(-0.15|0.1|0.1|0|0)~ones(K,5).*(0.25~0~1~2~8); 
    _parrow =  ones(K,1).*(0~0)~0.95*(cos2~sin2)~ones(K,1).*(3~0.125~31~4~1~6~8);
    _psym = cos2~sin2~ones(K,5).*(8~3~2~1~1); 
    title("\2161[st] PC / 2[nd] PC");
    xy(cos(t),sin(t)); 

  cos2 = S[.,2];
  sin2 = S[.,3];

  setwind(2);  
    _pmsgctl = cos2+(-0.1|0|0.1|0.02|0.02)~sin2+(-0.1|0.1|0.05|0|0)~ones(K,5).*(0.25~0~1~2~8); 
    _parrow =  ones(K,1).*(0~0)~0.95*(cos2~sin2)~ones(K,1).*(3~0.125~31~4~1~6~8);
    _psym = cos2~sin2~ones(K,5).*(8~3~2~1~1); 
    title("\2162[nd] PC / 3[rd] PC");
    xy(cos(t),sin(t)); 

  cos2 = S[.,3];
  sin2 = S[.,4];

  setwind(3);  
    _pmsgctl = cos2+(-0.15|-0.15|0.05|-0.15|0.05)~sin2+(0|0.05|0|0|0)~ones(K,5).*(0.25~0~1~2~8); 
    _parrow =  ones(K,1).*(0~0)~0.95*(cos2~sin2)~ones(K,1).*(3~0.125~31~4~1~6~8);
    _psym = cos2~sin2~ones(K,5).*(8~3~2~1~1); 
    title("\2163[rd] PC / 4[th] PC");
    xy(cos(t),sin(t)); 

  cos2 = S[.,4];
  sin2 = S[.,5];

  setwind(4);  
    _pmsgctl = cos2+(-0.1|0|-0.05|0|-0.075)~sin2+(0.1|-0.15|-0.15|0.05|0.05)~ones(K,5).*(0.25~0~1~2~8); 
    _parrow =  ones(K,1).*(0~0)~0.95*(cos2~sin2)~ones(K,1).*(3~0.125~31~4~1~6~8);
    _psym = cos2~sin2~ones(K,5).*(8~3~2~1~1); 
    title("\2164[th] PC / 5[th] PC");
    xy(cos(t),sin(t)); 

  endwind;
