new;
library frm,pgraph,optmum;

cls;

rndseed 123;

declare matrix x1,x2;

mu1 = 1 | 3;
mu2 = 4 | 1;

x = seqa(-3,9/100,101);
nX = rows(x);
y_LDA = miss(zeros(nX,4),0);
p_LDA = miss(zeros(nX,4),0);
y_QDA = miss(zeros(nX,4),0);
p_QDA = miss(zeros(nX,4),0);

/*
_opgtol = 1e-10;
_opmiter = 300;
*/
iter = 1;
do until iter > 4;

  if iter == 1;
    pi1 = 0.50;
    Sigma1 = xpnd(1|0.0|1);
    Sigma2 = 1.5*Sigma1;
  elseif iter == 2;
    pi1 = 0.50;
    Sigma1 = xpnd(1|0.0|1);
    Sigma2 = 2.0*Sigma1;
  elseif iter == 3;
    pi1 = 0.50;
    Sigma1 = xpnd(1|0.5|1);
    Sigma2 = 1.5*Sigma1;
  elseif iter == 4;
    pi1 = 0.95;
    Sigma1 = xpnd(1|0.0|1);
    Sigma2 = 1.5*Sigma1;
  endif;

  pi2 = 1 - pi1;
  Sigma = 0.5 * (Sigma1 + Sigma2);

  proc QDA_function(x);
    local inv_Sigma1,inv_Sigma2,p;

    inv_Sigma1 = invpd(Sigma1);
    inv_Sigma2 = invpd(Sigma2);

    p = 0.5 * ln( det(Sigma2) / det(Sigma1)) - 0.5 * (x - mu1)'inv_Sigma1*(x -mu1) + 0.5 * (x - mu2)'inv_Sigma2*(x -mu2) + ln(pi1 / pi2);
    retp(p);
  endp;

  proc LDA_function(x);
    local inv_Sigma,p;

    inv_Sigma = invpd(Sigma);
    p = (mu2 - mu1)'inv_Sigma*x - 0.5 * (mu2'inv_Sigma*mu2 - mu1'inv_Sigma*mu1) - ln(pi1 / pi2);
    retp(p);
  endp;

  proc LDA_boundary(x2);
    local x,p;

    x = x1 | x2;
    p = LDA_function(x);

    retp(p^2);
  endp;

  proc QDA_boundary(x2);
    local x,p;

    x = x1 | x2;
    p = QDA_function(x);

    retp(p^2);
  endp;

  i = 1;
  do until i > nX;
    x1 = x[i];
    {x2,fmin,grd,retcode} = optmum(&LDA_boundary,x1);
    p_LDA[i,iter] = LDA_function(x1|x2);
    if abs(p_LDA[i,iter]) <= 1e-5;
      y_LDA[i,iter] = x2;
    endif;
    {x2,fmin,grd,retcode} = optmum(&QDA_boundary,x1);
    p_QDA[i,iter] = QDA_function(x1|x2);
    if abs(p_QDA[i,iter]) <= 1e-1;
      y_QDA[i,iter] = x2;
    endif;
    i = i + 1;
  endo;

  iter = iter + 1;
endo;

indx = maxindc(y_QDA[.,2]);
y_QDA[indx+1,2] = y_QDA[indx,2] + 1.0;
y_QDA[indx+2,2] = y_QDA[indx,2] + 3.0;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _plwidth = 10; _pcolor = 2|3; _pltype = 6|3;
  _paxht = 0.30; _pnumht = 0.25; _ptitlht = 0.30;
  xtics(-3,6,3,1);
  ytics(-3,6,3,1);
  _psym = mu1[1]~mu1[2]~11~7.5~1~1~10 |
          mu2[1]~mu2[2]~11~7.5~4~1~10 ;
  _pmsgstr = "C]1[\000C]2[";
  _pmsgctl = -2~5~0.30~0~1~1~10 |
              4.5~-2~0.30~0~1~4~10 ;
  _plegstr = "LDA\000QDA";
  xlabel("\216X]1[");
  ylabel("\216X]2[");

  iter = 1;
  do until iter > 4;

    if iter == 4;
      title("\216\202p\201]1[ = 95%");
    elseif iter == 3;
      title("\216\202r\201 = 50%");
    elseif iter == 2;
      title("\216\202g\201 = 2.0");
    elseif iter == 1;
      title("\216\202g\201 = 1.5");
    endif;

    if iter == 4;
      _plegctl = {2 6 -1.0 4.0};
    else;
      _plegctl = 0;
    endif;

    setwind(iter);
      xy(x,y_LDA[.,iter]~y_QDA[.,iter]);

    iter = iter + 1;
  endo;

  endwind;  


