new;
library frm,pgraph,optmum;

cls;

rndseed 123;

declare matrix x1,x2;

let mu1 = 2 4;
let mu2 = 4 4;
let mu3 = 4 2;
let Sigma1[2,2] = 1.5 1 1 2;
let Sigma2[2,2] = 1.5 1 1 3;
let Sigma3[2,2] = 1 0 0 1;

N1 = 9;
N2 = 9;
N3 = 15;

C1 = rndmvn_chol(mu1,Sigma1,N1);
C2 = rndmvn_chol(mu2,Sigma2,N2);
C3 = rndmvn_chol(mu3,Sigma3,N3);
C1[2,1] = 0.5;
C1[6,2] = 6.86;
C1[.,2] = C1[.,2] - 0.30;
C2[.,2] = C2[.,2] - 0.30;
C3[.,2] = C3[.,2] - 0.20;
C1[.,1] = C1[.,1] - 0.30;
C2[.,1] = C2[.,1] - 0.30;
C3[.,1] = C3[.,1] - 0.20;

C1 = trunc(100*C1)/100;
C2 = trunc(100*C2)/100;
C3 = trunc(100*C3)/100;

C = C1 | C2 | C3;

indx_C = ones(N1,1)|2*ones(N2,1)|3*ones(N3,1);
C1_Square = C1~C1^2;
C2_Square = C2~C2^2;
C3_Square = C3~C3^2;
C_Square = C~C^2;

N = N1 + N2 + N3;

pi1 = N1 / N;
pi2 = N2 / N;
pi3 = N3 / N;

mu1 = meanc(C1);
mu2 = meanc(C2);
mu3 = meanc(C3);

mu1_Square = meanc(C1_Square);
mu2_Square = meanc(C2_Square);
mu3_Square = meanc(C3_Square);

Sigma1 = vcx(C1);
Sigma2 = vcx(C2);
Sigma3 = vcx(C3);
Sigma = vcx(C);
Sigma_Square = vcx(C_Square);

nS1 = 301;
nS2 = 301;
CS1 = seqa(-0.1,7.2/nS1,nS1) .* ones(1,nS2);
CS2 = seqa(-1.1,8.2/nS2,nS2)' .* ones(nS1,1);

Score_QDA = arrayinit(3|nS1|nS2,error(0));
Score_LDA = arrayinit(3|nS1|nS2,error(0));
Score_LDA_Square = arrayinit(3|nS1|nS2,error(0));

iter1 = 1;
do until iter1 > nS1;
  iter2 = 1;
  do until iter2 > nS2;
    x = CS1[iter1,iter2] | CS2[iter1,iter2];
    x_Square = x | x^2;
    j = 1;
    do until j > 3;
      if j == 1;
        pi_j = pi1;
        mu_j = mu1;
        mu_Square = mu1_Square;
        Sigma_j = Sigma1;
      elseif j == 2;
        pi_j = pi2;
        mu_j = mu2;
        mu_Square = mu2_Square;
        Sigma_j = Sigma2;
      elseif j == 3;
        pi_j = pi3;
        mu_j = mu3;
        mu_Square = mu3_Square;
        Sigma_j = Sigma3;
      endif;
      Score_QDA[j,iter1,iter2] = ln(pi_j) - 0.5*ln(det(Sigma_j)) - 0.5*(x-mu_j)'*invpd(Sigma_j)*(x-mu_j);
      Score_LDA[j,iter1,iter2] = ln(pi_j) + mu_j'*invpd(Sigma)*x - 0.5*mu_j'*invpd(Sigma)*mu_j;
      Score_LDA_Square[j,iter1,iter2] = ln(pi_j) + mu_Square'*invpd(Sigma_Square)*x_Square - 0.5*mu_Square'*invpd(Sigma_Square)*mu_Square;
      j = j + 1;
    endo;

    iter2 = iter2 + 1;
  endo;

  iter1 = iter1 + 1;
endo;

x1 = vecr(CS1);

x1_line = CS1[.,1];
x2_line = miss(zeros(nS1,4),0);

iter = 1;
do until iter > 3;
  if iter == 1;
    Score = Score_QDA;
  elseif iter == 2;
    Score = Score_LDA;
  elseif iter == 3;
    Score = Score_LDA_Square;
  endif;
  Score_C1 = arraytomat(Score[1,.,.]);
  Score_C2 = arraytomat(Score[2,.,.]);
  Score_C3 = arraytomat(Score[3,.,.]);
  e_C1 = (Score_C1 .>= Score_C2) .and (Score_C1 .>= Score_C3);
  e_C2 = (Score_C2 .>= Score_C1) .and (Score_C2 .>= Score_C3);
  e_C3 = (Score_C3 .>= Score_C1) .and (Score_C3 .>= Score_C2);

  e_C1 = miss(e_C1,0);
  e_C2 = miss(e_C2,0);
  e_C3 = miss(e_C3,0);
  
  x2 = vecr(CS2 .* e_C1)~vecr(CS2 .* e_C2)~vecr(CS2 .* e_C3);

  x2_C1 = CS2 .* e_C1;
  x2_C2 = CS2 .* e_C2;
  x2_C3 = CS2 .* e_C3;

  x2_line[.,1] = minc(x2_C1');
  x2_line[.,4] = maxc(x2_C3');

  x2_line = missex(x2_line,x2_line .< -1);

  if iter == 1;
    x1_QDA = x1;
    x2_QDA = x2;
    x1_line_QDA = x1_line;
    x2_line_QDA = x2_line;
    x2_line_QDA[.,2 3] = x2_line_QDA[.,1 4] +(-0.15~0.15);
  elseif iter == 2;
    x1_LDA = x1;
    x2_LDA = x2;
    x1_line_LDA = x1_line;
    x2_line_LDA = x2_line;
    x2_line_LDA[.,4] = x2_line_LDA[.,4]-0.10;
    x2_line_LDA[.,2 3] = missex(x2_line_LDA[.,1 4] + (-0.15~0.15),x1_line .<= 2.4);
  elseif iter == 3;
    x1_LDA_Square = x1;
    x2_LDA_Square = x2;
    x1_line_LDA_Square = x1_line;
    x2_line_LDA_Square = x2_line;
    x2_line_LDA_Square[.,4] = x2_line_LDA_Square[.,4]-0.10;
    x2_line_LDA_Square[.,2 3] = missex(x2_line_LDA_Square[.,1 4] + (-0.15~0.15),(x1_line .<= 1.65) .or (x1_line .>= 6.65));
  endif;

  iter = iter + 1;
endo;

graphset;
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pcolor = 1|2|2|4; _plctrl = 0; _pstype = 1; _psymsiz = 3;
  _paxht = 0.30; _pnumht = 0.25; _ptitlht = 0.30; _pltype = 6|6|6|6;

  xtics(0,7,1,0);
  ytics(-1,7,1,0);
  xlabel("\216X]1[");
  ylabel("\216X]2[");

  setwind(1);
    title("\216QDA");
    _pmsgstr = "C]1[\000C]2[\000C]3[";
    _pmsgctl = {1 5   0.35 0 1 1 10,
                4 4.5 0.35 0 1 2 10,
                5 0   0.35 0 1 4 10};
    generate_pline(x1_line_QDA,x2_line_QDA,1);
    xy(x1_line_QDA,x2_line_QDA);

  setwind(2);
    title("\216LDA");
    generate_pline(x1_line_LDA,x2_line_LDA,2);
    xy(x1_line_LDA,x2_line_LDA);

  setwind(3);
    title("\216LDA[2]");
    generate_pline(x1_line_LDA_square,x2_line_LDA_square,3);
    xy(x1_line_LDA_square,x2_line_LDA_square);

  endwind;  


proc (0) = generate_pline(x1,x2,mtd);
  local dx,ub,lb,data,x,y,z,n,e;

  dx = 0.125;

  // QDA
  data = packr(x1~x2[.,1]);
  x = data[.,1];
  y = data[.,2];
  if mtd == 1;
    lb = x[1]-1;
    ub = x[rows(x)];
  elseif mtd == 2;
    lb = x[1];
    ub = x[rows(x)];
  elseif mtd == 3;
    lb = x[1] - 1;
    ub = x[rows(x)];
  endif;
  n = (ub - lb) / dx + 1;
  z = seqa(lb,dx,n);
  y = spline(x,y,1,z);
  e = ones(n,1);
  _pline = e .* (1~6)~z~y~z~e.*(9~1~1~0);

  // LDA
  data = packr(x1~x2[.,4]);
  x = data[.,1];
  y = data[.,2];
  if mtd == 1;
    lb = x[1];
    ub = x[rows(x)];
  elseif mtd == 2;
    lb = x[1];
    ub = x[rows(x)];
  elseif mtd == 3;
    lb = x[1];
    ub = x[rows(x)];
  endif;
  n = (ub - lb) / dx + 1;
  z = seqa(lb,dx,n);
  y = spline(x,y,1,z);
  e = ones(n,1);
  _pline = _pline | e .* (1~6)~z~-e~z~y~e.*(1~4~0);

  retp;
endp;

  