new;
library frm,pgraph,optmum;

cls;

rndseed 123;

Let x1[7,2] = 1 2 
              1 4
              3 6 
              3 3
              4 2
              5 6
              5 5;

Let x2[6,2] = 1 0 
              2 1 
              4 1
              3 2
              6 4
              6 5;

x = x1|x2;
n1 = rows(x1);
n2 = rows(x2);
e1 = ones(n1,1);
e2 = ones(n2,1);

mu1 = meanc(x1);
mu2 = meanc(x2);
mu = meanc(x);

S1 = (x1-mu1')'(x1-mu1');
S2 = (x2-mu2')'(x2-mu2');
S = (x-mu')'(x-mu');
SW = S1 + S2;
SB = n1 * (mu1 - mu) * (mu1 - mu)' + n2 * (mu2 - mu) * (mu2 - mu)';

print ftosa(S1,"%lf",3,2);

print ftosa(S2,"%lf",3,2);

print ftosa(SW,"%lf",3,2);

print ftosa(SB,"%lf",3,2);

print ftosa(SB+SW,"%lf",3,2);

print ftosa(S,"%lf",3,2);

A = invpd(SW)*SB;
{va,ve} = eigv(A);
indx = maxindc(va);
lambda = va[indx];
beta = real(ve[.,indx]);

beta_star = invpd(sW) * (mu1 - mu2);

print ftosa(beta~beta_star~beta./beta_star,"%lf",4,5);

x = seqa(-1,10/100,101);
b = 6;
a = beta[1]/beta[2];
y = a*x + b;
y1 = x1*beta;
y2 = x2*beta;

{xp1,yp1} = projection_line(a,b,x1[.,1],x1[.,2]);
{xp2,yp2} = projection_line(a,b,x2[.,1],x2[.,2]);

x1p = xp1~yp1;
x2p = xp2~yp2;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6; _plwidth = 10; _pcolor = 2;
  xtics(-1,7,1,2);
  ytics(-1,7,1,2);
  xlabel("\216x]1[");
  ylabel("\216x]2[");

  _psym = x1~e1.*(8~5.5~1~1~10) |
          x2~e2.*(9~5.5~4~1~10) |
          x1p~e1.*(11~3.5~1~1~10) |
          x2p~e2.*(11~3.5~4~1~10) |
          mu1'~11~5.5~1~1~10 |
          mu2'~11~5.5~4~1~10 ;

  _pmsgstr = "\202m\201]1[\000\202m\201]2[\000optimal line\000direction";
  _pmsgctl = mu1'+(-0.15~0.3)~0.25~0~1~1~10 |
             mu2'+(-0.30~-0.35)~0.25~0~1~4~10 |
             5.5~1.7~0.175~-32.5~1~0~10 |
             5.5~1.2~0.175~-32.5~1~0~10 ;

  _pline = e1*(1~3)~x1~x1p~e1.*(1~2~10) |
           e2*(1~3)~x2~x2p~e2.*(1~2~10) |
           4~3~mu1'+(-0.00~0.2)~0.35~0~2*pi~0~10 |
           4~3~mu2'+(-0.05~-0.2)~0.35~0~2*pi~0~10 ;

  xy(x,y);

proc (2) = projection_line(a,b,x,y);
  local a2,d,y_tilde,x_tilde;

  a2 = a^2;
  d = y + x / a;
  y_tilde = (b + a2*d)./(1+a2);
  x_tilde = (y_tilde - b)/a;

  retp(x_tilde,y_tilde);
endp;




 


