new;
library frm,pgraph,optmum;

cls;

rndseed 123;

Let x1[7,2] = 1 2 
              1 4
              3 6 
              3 3
              4 2
              5 6
              5 5;

Let x2[6,2] = 1 0 
              2 1 
              4 1
              3 2
              6 4
              6 5;

x = x1|x2;
n1 = rows(x1);
n2 = rows(x2);
e1 = ones(n1,1);
e2 = ones(n2,1);

mu1 = meanc(x1);
mu2 = meanc(x2);
mu = meanc(x);

S1 = (x1-mu1')'(x1-mu1');
S2 = (x2-mu2')'(x2-mu2');
S = (x-mu')'(x-mu');
SW = S1 + S2;
SB = n1 * (mu1 - mu) * (mu1 - mu)' + n2 * (mu2 - mu) * (mu2 - mu)';

print ftosa(S1,"%lf",3,2);

print ftosa(S2,"%lf",3,2);

print ftosa(SW,"%lf",3,2);

print ftosa(SB,"%lf",3,2);

print ftosa(SB+SW,"%lf",3,2);

print ftosa(S,"%lf",3,2);

A = invpd(SW)*SB;
{va,ve} = eigv(A);
indx = maxindc(va);
lambda = va[indx];
beta = real(ve[.,indx]);

beta_star = invpd(sW) * (mu1 - mu2);

print ftosa(beta~beta_star~beta./beta_star,"%lf",4,5);

y1 = x1*beta;
y2 = x2*beta;
x = seqa(-6,10/200,201);
m1 = meanc(y1); s1 = stdc(y1);
m2 = meanc(y2); s2 = stdc(y2);
y = pdfn2(x,m1,s1)~pdfn2(x,m2,s2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = {1,0};
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(-6,4,1,2);
  ytics(-0.1,0.6,0.1,2);
  xlabel("\216y");
  _psym = y1~e1.*(0~8~2.5~1~1~10) |
          y2~e2.*(0~9~2.5~4~1~10) ;
  _pline = 1~6~m1~0~m1~1.0*pdfn2(m1,m1,s1)~1~1~10 |
           1~6~m2~0~m2~1.0*pdfn2(m2,m2,s2)~1~4~10 ;

  _plegctl = {2 6 1.5 5};
  _plegstr = "Class C]1[\000Class C]2[";
  xy(x,missex(y,abs(y) .<= 1e-3));

proc (2) = projection_line(a,b,x,y);
  local a2,d,y_tilde,x_tilde;

  a2 = a^2;
  d = y + x / a;
  y_tilde = (b + a2*d)./(1+a2);
  x_tilde = (y_tilde - b)/a;

  retp(x_tilde,y_tilde);
endp;




 


