new;
library frm,pgraph,optmum;

cls;

rndseed 123;

nS = 100;

r1 = 1;
r2 = 2;
r3 = 3;
r = 3;

x_training = r*(2*rndu(nS,2)-1);
rayon = sqrt(sumr(x_training^2));
indx = selif(seqa(1,1,nS),rayon .<= r3);
x_training = x_training[indx,.];
rayon = rayon[indx,.];

label_training = 1 * (rayon .<= r1) + 
                 2 * ((rayon .> r1) .and (rayon .<= r2)) +
                 3 * ((rayon .> r2) .and (rayon .<= r3)) ;

data1 = selif(x_training,rayon .<= r1);
data2 = selif(x_training,(rayon .> r1) .and (rayon .<= r2));
data3 = selif(x_training,(rayon .> r2) .and (rayon .<= r3));
{x1,x2} = Merge_Time_Series(data1[.,1],data1[.,2],data2[.,1],data2[.,2],0);
{x1,x2} = Merge_Time_Series(x1,x2,data3[.,1],data3[.,2],0);
x1_training = x1;
x2_training = x2;

t = seqa(0,2*pi/100,101);
x_circle = (r1~r2~r3) .* cos(t);
y_circle = (r1~r2~r3) .* sin(t);

nS = 1000;
x_test = r*(2*rndu(nS,2)-1);
rayon = sqrt(sumr(x_test^2));
indx = selif(seqa(1,1,nS),rayon .<= r3);
x_test = x_test[indx,.];
x1_test = x_test[.,1];
x2_test = x_test[.,2];

labels = KNN_algorihtm(x_training,label_training,x_test,1,0);
data1 = selif(x_test,labels .== 1);
data2 = selif(x_test,labels .== 2);
data3 = selif(x_test,labels .== 3);
{x1,x2} = Merge_Time_Series(data1[.,1],data1[.,2],data2[.,1],data2[.,2],0);
{x1,x2} = Merge_Time_Series(x1,x2,data3[.,1],data3[.,2],0);
x1_1NN = x1;
x2_1NN = x2;

labels = KNN_algorihtm(x_training,label_training,x_test,10,0);
data1 = selif(x_test,labels .== 1);
data2 = selif(x_test,labels .== 2);
data3 = selif(x_test,labels .== 3);
{x1,x2} = Merge_Time_Series(data1[.,1],data1[.,2],data2[.,1],data2[.,2],0);
{x1,x2} = Merge_Time_Series(x1,x2,data3[.,1],data3[.,2],0);
x1_10NN = x1;
x2_10NN = x2;

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/2,1);
  makewind(9/2,6.855/2,0,6.855/2,1);
  makewind(9/2,6.855/2,9/2,6.855/2,1);
  makewind(9/2,6.855/2,9/2,6.855/2,1);
  makewind(9/2,6.855/2,0,0,1);
  makewind(9/2,6.855/2,0,0,1);
  makewind(9/2,6.855/2,9/2,0,1);
  makewind(9/2,6.855/2,9/2,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {0,0};
  _plctrl = -1; _pstype = 9|10|11; _pcolor = 1|4|2; _psymsiz = 3.5;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;
  xtics(-3,3,1,0);
  ytics(-3,3,1,0);

  setwind(1);
    _plctrl = -1; _pstype = 9|10|11; _pcolor = 1|4|2; _psymsiz = 3.5;
    title("\216Training set (n]1[ = 100)");
    xy(x1_training,x2_training);

  setwind(2);
   _plctrl = 0; _pltype = 6|6|6; _plwidth = 15;
    xy(x_circle,y_circle);

  setwind(3);
    _plctrl = -1; _pstype = 1; _pcolor = 0|0; _psymsiz = 2.5;
    title("\216Test set (n]2[ = 1000)");
    xy(x1_test,x2_test);

  setwind(5);
    _plctrl = -1; _pstype = 9|10|11; _pcolor = 1|4|2; _psymsiz = 3.5;
    title("\2161-NN");
    xy(x1_1NN,x2_1NN);

  setwind(6);
   _plctrl = 0; _pltype = 6|6|6; _plwidth = 15;
    xy(x_circle,y_circle);

  setwind(7);
    _plctrl = -1; _pstype = 9|10|11; _pcolor = 1|4|2; _psymsiz = 3.5;
    title("\21610-NN");
    xy(x1_10NN,x2_10NN);

  setwind(8);
   _plctrl = 0; _pltype = 6|6|6; _plwidth = 15;
    xy(x_circle,y_circle);

  endwind;


proc (1) = KNN_algorihtm(x_training,label_training,x_test,k,mtd);
  local n,m,label_test,i,x,d,indx,y,y_unique,e;

  n = rows(x_test);
  m = cols(x_test);
  label_test = zeros(n,1);
  
  i = 1;
  do until i > n;
    x = x_test[i,.];
    d = sqrt(sumr((x - x_training)^2)/m);
    indx = sortind(d);
    indx = indx[1:k];
    d = d[indx];
    y = label_training[indx];
    y_unique = unique(y,1);
    e = y .== y_unique';
    e = sumc(e);
    indx = maxindc(e);
    label_test[i] = y_unique[indx];
    if label_test[i] == 0;
      print;
    endif;
    i = i + 1;
  endo;

  retp(label_test);
endp;
