new;
library frm,pgraph;

cls;

let x_p[8,2] =  0.5    2.5
                2.7    4.2 
                2.7    2.0
                1.7    4.2 
                1.5    0.7 
                2.3    5.3 
                4.0    6.9
                6.0    5.0; 
y_p = ones(8,1);                            
let x_m[9,2] =  6.4    4.5 
                7.7    2.2 
                8.8    6.0 
                7.4    6.5 
                6.5    1.7 
                8.3    1.3 
                6.0    1.3 
                5.0    0.5
                2.0    2.0;
y_m = -ones(9,1);
 
y = y_p | y_m;
x = x_p | x_m;
n = rows(x);

t = seqa(-1,9/100,151);

let C = 0.01 0.03 0.05 0.30;
iter = 1;
do until iter > 4;
  {beta0,beta,xi} = svm_classification_primal(y,x,C[iter],1);
  y_t = (-beta0+(-1~0~1) - beta[1]*t)/beta[2];
  if iter == 1;
    y1 = y_t;
  elseif iter == 2;
    y2 = y_t;
  elseif iter == 3;
    y3 = y_t;
  elseif iter == 4;
    y4 = y_t;
  endif;
  iter = iter + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 3|6|3; _plwidth = 10; _pcolor = 2|2|2;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  e = ones(n,1);
  e_p = (y .== 1);
  e_m = (y .== -1);
  xlabel("\216x]1[");
  ylabel("\216x]2[");
  ytics(-1,8,1,2);
  xtics(-1,9,1,2);
  _psym = x~e.*(8~5)~(e_p*1+e_m*4)~e.*(1~10);

  setwind(1);
    title("\216C = 0.01");
    xy(t,y1); 

  setwind(2);
    title("\216C = 0.03");
    xy(t,y2); 

  setwind(3);
    title("\216C = 0.05");
    xy(t,y3); 

  setwind(4);
    title("\216C = 0.30");
    xy(t,y4); 

  endwind;
    
