new;
library frm,pgraph;

n = 200;

rndseed 123;

theta = 2*pi*rndu(n,1);
r = 0 + rndu(n,1);

x1p = 0 + r .* cos(theta);
x2p = 0 + r .* sin(theta);
x_p = x1p~x2p;

r1 = 8 + rndu(n,1);
r2 = 2 + rndu(n,1);
x1m = 1 + r1 .* cos(theta);
x2m = 0 + r2 .* sin(theta);
x2m = abs(x2m) - 0.5;
x_m = x1m~x2m;

y_p = ones(n,1);
y_m = -ones(n,1);

x = x_p;
z = (x[.,1]^2 - 10)~(sqrt(2)*x[.,1].*x[.,2])~(x[.,2]^2);
z_p = z;

x = x_m;
z = (x[.,1]^2 - 10)~(sqrt(2)*x[.,1].*x[.,2])~(x[.,2]^2);
z_m = z;

y = y_p | y_m;
z = z_p | z_m;

{beta0,beta,xi1} = svm_classification_primal(y,z,0,1);
print ftosa(beta0|beta,"%lf",3,3);

{alpha1,sv1,beta0,beta,xi2} = svm_classification_dual(y,z,0,1);
print ftosa(beta0|beta,"%lf",3,3);

K = z*z';
{alpha2,sv2,beta02,beta2,y_hat2} = svm_kernel_classification_dual(y,K,0,1);
print ftosa(beta02|beta2,"%lf",3,3);

z1 = seqa(-50,5,50);
z2 = seqa(-20,0.5,81);
z1 = z1';
z2 = z2;
z3 = -(beta0 + beta[1]*z1 + beta[2]*z2)/beta[3];
e = ones(rows(z3),cols(z3));
z1 = z1 .* e;
z2 = z2 .* e;
z1 = vecr(z1);
z2 = vecr(z2);
z3 = vecr(z3);

z = z1~z2~z3;
z = delif(z,z[.,3] .>= 6);
z = delif(z,z[.,3] .<= 0);

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/4,1);
  makewind(9/2,6.855,9/2,0,1);
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plctrl = -1; _pstype = 1|2; _pcolor = 1|4; _psymsiz = 5;
  _pnumht = 0.225; _paxht = 0.25; _ptiltht = 0.30;

  setwind(1);
    xtics(-10,10,5,2);
    ytics(-1,3,1,2);
    xlabel("\216x]1[");
    ylabel("\216x]2[");
    _pmsgstr = "y = +1\000y = -1\000H";
    _pmsgctl = 5.5~2~0.3~0~2~1~10 |
               4.5~6.25~0.3~0~2~4~10;
    xy(x_p[.,1]~x_m[.,1],x_p[.,2]~x_m[.,2]);

  setwind(2);
    xlabel("\216z]1[");
    ylabel("\216z]2[");
    zlabel("\216z]3[");
    xtics(-50,100,50,2);
    ytics(-20,20,10,2);
    ztics(0,6,2,2);
    _pgrid = {3,1};
    e = ones(rows(z),1);
    _psym3d = z~e.*(4~2~2~0);
    view(-3,-4,3);
    _pmsgctl = 1.8~2.85~0.3~0~2~1~10 |
               6.0~4.0~0.3~0~2~4~10 |
               2.5~5.2~0.3~0~2~2~10 ;
    xyz(z_p[.,1]~z_m[.,1],z_p[.,2]~z_m[.,2],z_p[.,3]~z_m[.,3]);

endwind;


