new;
library frm,pgraph;

rndseed 123;

n = 200;
nx = 4;
nS = 500;

nK = 5;
loss_rate = zeros(nS,nK);

i = 1;
do until i > nS;
  x = rndn(n,nx);
  y = 2*(rndu(n,1) .> 0.5) - 1;
  K = x*x';
  {alpha,sv,beta0,beta,y_hat} = svm_kernel_classification_dual(y,K,0,1);
  loss = (y ./= y_hat);
  loss_rate[i,1] = meanc(loss);

  K = kernel_polynomial(x,0,2);
  {alpha,sv,beta0,beta,y_hat} = svm_kernel_classification_dual(y,K,0,1);
  loss = (y ./= y_hat);
  loss_rate[i,2] = meanc(loss);

  K = kernel_polynomial(x,0,3);
  {alpha,sv,beta0,beta,y_hat} = svm_kernel_classification_dual(y,K,0,1);
  loss = (y ./= y_hat);
  loss_rate[i,3] = meanc(loss);

  sigma = 50;
  K = kernel_rbf(x,sigma);
  {alpha,sv,beta0,beta,y_hat} = svm_kernel_classification_dual(y,K,0,1);
  loss = (y ./= y_hat);
  loss_rate[i,4] = meanc(loss);

  sigma = 20;
  K = kernel_rbf(x,sigma);
  {alpha,sv,beta0,beta,y_hat} = svm_kernel_classification_dual(y,K,0,1);
  loss = (y ./= y_hat);
  loss_rate[i,5] = meanc(loss);

  i = i + 1;
endo;

print ftosa(100*meanc(loss_rate),"%lf",3,2);

x = seqa(0.1,0.6/200,201);
y = zeros(rows(x),nK);
i = 1;
do until i > nK;
  {y[.,i],F} = regKernelDensity(loss_rate[.,i],x);
  i = i + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|6|3; _plwidth = 10; _pcolor = 1|2|3|4|5; _pstype = 8|8|8|8|9; _plctrl = 0|0|0|6|6;
  xtics(10,70,10,2);
  _plegstr = "Linear\000Quadratic\000Cubic\000RBF (\202s\201 = 50)\000RBF (\202s\201 = 20)";
  _plegctl = {2 5 6.25 4.5};
  xlabel("\216Error rate (in %)");
  xy(100*x,missex(y,y .<= 1e-5));


