new;
library frm,pgraph;

rndseed 123456;

n = 1000;
t = seqa(0,4/(n-1),n);
y0 = cos(2*pi*t); 
y = y0 + 0.5 * rndn(n,1);

p = 0.9999;
y1 = fspline(csspline(t,y,1,p),t);

nS = 500;
m = 300;
y2 = 0;
s = 1;
do until s > nS;
  data = sortc(rndu(n,1)~t~y,1);
  data = data[1:m,2 3];
  data = sortc(data,1);
  y2 = y2 + fspline(csspline(data[.,1],data[.,2],1,p),t)/nS;
  s = s + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;   

  ytics(-2,2,1,2);
  xtics(0,4,1,2);

  setwind(1);
    title("\216Signal");
    _pcolor = 1;
    xy(t,y0);

  setwind(2);
    title("\216Noisy signal");
    _pcolor = 2;
    xy(t,y);

  setwind(3);
    title("\216Spline prediction");
    _pcolor = 3;
    xy(t,y1);

  setwind(4);
    title("\216Bagging prediction");
    _pcolor = 4;
    xy(t,y2);

  endwind;