new;
library frm,pgraph;

rndseed 123456;

error_rate = seqa(0.001,0.001,9)|seqa(0.01,0.01,50);
omega = ln((1-error_rate)./error_rate);

w = 0.5~0.5;
e = 1~0;
w = w .* exp(omega .* e);
w = w ./ sumr(w);
w1 = w;

w = 0.2~0.8;
e = 1~0;
w = w .* exp(omega .* e);
w = w ./ sumr(w);
w2 = w;

w = 0.8~0.2;
e = 1~0;
w = w .* exp(omega .* e);
w = w ./ sumr(w);
w3 = w;

graphset;
  begwind;
  window(2,2,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;   
  _plwidth = 10;

  setwind(1);
    title("\216Classifier weight");
    _pcolor = 1; _pltype = 6;
    xtics(0,50,10,2);
    xlabel("\216Error rate (in %)");
    ytics(0,5,1,2);
    ylabel("\216\202w\201]s[");
    xy(100*error_rate,omega);

  setwind(2);
    title("\216Observation weight\L\216(w]1,s[ = 50%, w]2,s[ = 50%)");
    _pcolor = 2|4; _pltype = 1|3;
    xtics(0,50,10,2);
    xlabel("\216Error rate (in %)");
    ytics(0,100,25,2);
    ylabel("\216w]i,s+1[ (in %)");
    xy(100*error_rate,100*w1);

  setwind(3);
    title("\216Observation weight\L\216(w]1,s[ = 20%, w]2,s[ = 80%)");
    xy(100*error_rate,100*w2);

  setwind(4);
    title("\216Observation weight\L\216(w]1,s[ = 80%, w]2,s[ = 20%)");
    _plegstr = "w]1,s+1[\000w]2,s+1[";
    _plegctl = {2 5 4 2.5};
    xy(100*error_rate,100*w3);

  endwind;