new;
library frm,optmum,pgraph;

#define USE_OPTMUM

FileName = "..\\..\\data\\logit1";
data = loadd(FileName);
vnames = getname(FileName);

n = rows(data);
data = selif(data,rndu(n,1) .>= 0.5);

y = data[.,5];
x = ones(rows(y),1) ~ data[.,2:4];
n = rows(y);
K = cols(x);

y_logit = y;
y = 2*y - 1;

sv = inv(x'x)*x'y;

nS = 3;
w = zeros(n,nS+1);
w[.,1] = ones(n,1)/n;
beta = zeros(K,nS);
Pr = zeros(n,nS);
I = zeros(n,nS);
yhat = zeros(n,nS);
omega = zeros(nS,1);
Loss = zeros(nS,1);

s = 1;
do until s > nS;
  _reg_weight = w[.,s];
  {beta[.,s],stderr,cov,LogL} = regLOGIT(0,y_logit,x,sv,0,0);
  Pr[.,s] = cdfLogit(x*beta[.,s]);
  yhat[.,s] = 2*(Pr[.,s] .>= 0.5) - 1.0;
  I[.,s] = yhat[.,s] ./= y;
  Loss[s] = sumc(w[.,s] .* I[.,s])/sumc(w[.,s]); 
  omega[s] = ln( (1-Loss[s])/Loss[s] );
  w[.,s+1] = w[.,s] .* exp( omega[s] .* I[.,s] );
  w[.,s+1] = w[.,s+1] / sumc( w[.,s+1] );
  s = s + 1;
endo;

w = w[.,1:nS];
Results = zeros(n,3*nS);
s = seqa(1,3,nS);
Results[.,s] = w;
Results[.,s+1] = yhat;
Results[.,s+2] = I;

yhat_last = sumr(submat(omega' .* yhat,0,1|2));
yhat_last = 2*(yhat_last .> 0) - 1.0;
I_last = yhat_last ./= y;

cls;

Results = y ~ Results ~ yhat_last ~ I_last;
e = ones(1,3*nS+3);
s = seqa(2,3,nS);
e[.,s] = 100*ones(1,nS);
print ftosa(miss(e.*Results,0),"%lf",3,2);

results = beta | loss' | omega' | sumc(I)';
print ftosa(results,"%lf",3,4);

print ftosa(sumc(I~I_last),"%lf",3,0);

 
