new;
library frm,pgraph,optmum;

cls;

rndseed 123;

nn_set;

let x = {1 1,1 0,0 1,0 0};
let y = {0, 1, 1, 0};

nx = cols(x);
ny = cols(y);
f_xz = 1;
f_zy = 1;

nz = 3;
constant_xz = 0;
constant_zy = 0;
directlink_xy = 0;

_nn_SaveIters = 1;
_nn_SaveCoeffs = 0;
_nn_FileName = "nn4";
sv = rndu(nz*(nx+constant_xz)+ny*(nz+constant_zy+directlink_xy*nx),1);

results = 0;
yhat = zeros(4,6);
 
theta = zeros(rows(sv),6*2);

j = 1;
do until j > 2;
  f_loss = j;
  if j == 1;
    _nn_MaxIters = 5000;
  elseif j == 2;
    _nn_MaxIters = 2000;
  endif;

  iter = 1;
  do until iter > 6;

    _nn_opalgr = iter;
    if iter == 6;
      _nn_StopRule = {1,0.0001};
    else;
      _nn_StopRule = {1,0.001};
    endif;

    call nn_define(f_xz,f_zy,f_loss,constant_xz,constant_zy,directlink_xy,0,0);
    nn = nn_fit(0,x,y,1,1,sv,0,0,nz);
    yhat[.,iter] = nn_predict(nn,x);
    data = loadd(_nn_FileName);
    results = vput(results,data[.,1 2],itos("algr",iter));
    theta[.,(j-1)*6+iter] = vread(nn,"theta");  

    iter = iter + 1;
  endo;

  data1 = vread(results,"algr1");
  data2 = vread(results,"algr2");
  data3 = vread(results,"algr3");
  data4 = vread(results,"algr4");
  data5 = vread(results,"algr5");
  data6 = vread(results,"algr6");
  nIters = maxc(rows(data1)|rows(data2)|rows(data3)|rows(data4)|rows(data5)|rows(data6));
  loss = miss(zeros(nIters,6),0);
  loss[1:rows(data1),1] = data1[.,2];
  loss[1:rows(data2),2] = data2[.,2];
  loss[1:rows(data3),3] = data3[.,2];
  loss[1:rows(data4),4] = data4[.,2];
  loss[1:rows(data5),5] = data5[.,2];
  loss[1:rows(data6),6] = data6[.,2];

  if j == 1;
    loss1 = loss;
    yhat1 = yhat;
  elseif j == 2;
    loss2 = loss;
    yhat2 = yhat;
  endif;

  j = j + 1;
endo;

cls;
print ftosa(yhat1,"%lf",3,5);
print ftosa(yhat2,"%lf",3,5);
print ftosa(theta,"%lf",3,5);

graphset;
  begwind;
  window(2,1,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10|10|15|10|10|10; _pcolor = 1|2|3|4|5|6; _pltype = 6|1|2|6|1|3;
  _pstype = 8|9|10|8|9|10; _psymsiz = 7.5;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;   

  xlabel("\216Iteration");
  ylabel("\216Loss");

  setwind(1);
    _plctrl = 5*(100|100|0|0|0|0); 
    title("\216Least squares error");
    xtics(0,5000,1000,2);
    ytics(0,0.5,0.1,2);
    y1 = missex(loss1,(loss1 .>= 0.51) .or (loss1 .<= 0.001));
    y1 = _min_(y1,0.5);
    xy(0,y1);

  setwind(2);
    _plctrl = 2*(100|100|0|0|0|0); 
    title("\216Cross-entropy error");
    xtics(0,1500,500,2);
    ytics(0,2.8,0.6,2);
    y2 = missex(loss2,(loss2 .>= 2.775) .or (loss2 .<= 0.01));
    y2 = _min_(y2,2.775);
    _plegstr = "SD\000MOM\000AL\000AL II\000SD II\000BFGS";
    _plegctl = {2 5.5 7.25 2.75};
    xy(0,y2);

  endwind;