new;
library frm,optmum,pgraph;

cls;

#define USE_OPTMUM


FileName = "..\\..\\data\\logit1";
data = loadd(FileName);
vnames = getname(FileName);

y = data[.,5];
x = ones(rows(y),1) ~ data[.,2:4];

sv = inv(x'x)*x'y;

{beta,stderr,cov,LogL} = regLOGIT(0,y,x,sv,0,0);
Pr_logit = cdfLogit(x*beta);
yhat_logit = Pr_logit .>= 0.5;

nx = cols(x);
ny = cols(y);
f_xz = 3;
f_zy = 1;
f_loss = 2;

nz = 3;
constant_xz = 0;
constant_zy = 0;
directlink_xy = 1;

_nn_MaxIters = 5000;
_nn_opalgr = 6;
_opgtol = 1e-10;
_nn_StopRule = {1,0.0001};

sv = rndu(nz*(nx+constant_xz)+ny*(nz+constant_zy+directlink_xy*nx),1);
sv[rows(sv)-3] = 5;

call nn_define(f_xz,f_zy,f_loss,constant_xz,constant_zy,directlink_xy,0,0);
nn = nn_fit(0,x,y,1,1,sv,0,0,nz);
Pr_nn = nn_predict(nn,x);
yhat_nn = Pr_nn .>= 0.5;

print ftosa(y~100*Pr_logit~yhat_logit~100*Pr_nn~yhat_nn,"%lf",3,3);

{beta_matrix,f_xz,gamma_matrix,f_zy} = nn_parameters(nn);

print;
print ftosa(beta_matrix,"%lf",3,4);
print;
print ftosa(gamma_matrix,"%lf",3,4);
