new;
library frm,pgraph;

cls;

let x_p[8,2] =  0.5    2.5
                2.7    4.2 
                2.7    2.0
                1.7    4.2 
                1.5    0.7 
                2.3    5.3 
                4.0    6.9
                6.0    5.0; 
y_p = ones(8,1);                            
let x_m[9,2] =  6.4    4.5 
                7.7    2.2 
                8.8    6.0 
                7.4    6.5 
                6.5    1.7 
                8.3    1.3 
                6.0    1.3 
                5.0    0.5
                2.0    2.0;
y_m = -ones(9,1);
 
y = y_p | y_m;
x = x_p | x_m;
n = rows(x);

C = seqa(0.001,0.01,100);
nIters = rows(C);
theta = zeros(nIters,5);
iter = 1;
do until iter > nIters;
  {beta0,beta,xi} = svm_classification_primal(y,x,C[iter],1);
  M = 1/(beta'beta);
  theta[iter,.] = beta0~beta'~sumc(xi)~M;
  iter = iter + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  xtics(0,0.4,0.10,2);
  xlabel("\216C");

  setwind(1);
    title("\216\202b\201]0[");
    _pcolor = 1;
    ytics(0.0,1.75,0.25,2);
    xy(C,theta[.,1]);

  setwind(2);
    title("\216\202b\201]1[");
    _pcolor = 2;
    ytics(-0.6,0.0,0.2,2);
    xy(C,theta[.,2]);

  setwind(3);
    title("\216\202b\201]2[");
    _pcolor = 3;
    ytics(0,0.25,0.05,2);
    xy(C,theta[.,3]);

  setwind(4);
    title("\216\202S\201]i=1[[n]\202x\201]i[ and M");
    _pcolor = 4|5; _pltype = 6|3;
    ytics(2,14,2,2);
    _plegstr = "\216\202S\201]i=1[[n]\202x\201]i[\000\216M";
    _plegctl = {2 6 5 3};
    xy(C,theta[.,4 5]);

  endwind;
