new;
library frm,pgraph,optmum;

cls;

rndseed 123;

nS = 20000;

s = seqa(0,0.10,11);
Score = s' .* rndn(nS,1) + rndn(nS,1);
indx = 1 + trunc(10 * rndu(nS,1));
Score = subvec(Score,indx);
Y = abs(Score) .> 0.40 * (0.10 + 4 * rndu(nS,1));
S1 = abs(Score) + 0.80 * rndn(nS,1);
S2 = abs(Score + 1.20 * rndn(nS,1));

{Gini1,Performance1,Selection1,Discriminant1} = Score_Curves(Y,S1,0,0);
{Gini2,Performance2,Selection2,Discriminant2} = Score_Curves(Y,S2,0,0);

step = 100;
indx = seqa(1,step,nS/step) | nS;

graphset
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.275;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|4; 
  xtics(0,1,0.2,2);
  ytics(0,1,0.2,2);
  xlabel("\216x");

  setwind(1);
    title("\216Performance curve");
    ylabel("\216y = P(x)");
    xy(Performance1[indx,1]~Performance2[indx,1],Performance1[indx,2]~Performance2[indx,2]);

  setwind(2);
    title("\216Selection curve");
    ylabel("\216y = S(x)");
    xy(Selection1[indx,1]~Selection2[indx,1],Selection1[indx,2]~Selection2[indx,2]);

  setwind(3);
    title("\216Discriminant curve");
    ylabel("\216y = D(x)");
    _plegstr = "Score S]1[\000Score S]2[";
    _plegctl = {2 5 9 3};
    xy(Discriminant1[indx,1]~Discriminant2[indx,1],Discriminant1[indx,2]~Discriminant2[indx,2]);

  endwind;