new;
library frm,pgraph,optmum;

cls;

rndseed 123;

n = 5000;
GoodPercent = 0.4;

nGood = GoodPercent*n;
nBad = (1-GoodPercent)*n;

Y  = ones(nGood,1)|zeros(nBad,1);
S = (rndn(nGood,1)+1.0)|(rndn(nBad,1));

S_star = quantile(S,nBad/n);
YP = S .>= S_star;

x = seqa(0,1/200,201);
{FP,FP_0,FP_1} = Scoring_Distribution(YP,S,0,x);
{F,F0,F1} = Scoring_Distribution(Y,S,0,x);
{Gini,dataPerf,dataSelect,dataDiscr} = Score_Curves(Y,S,0,x);

graphset;
  window3d;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.275;
  _plwidth = 10; _pltype = 6|3; _pcolor = 1|4;
  xtics(0,1,0.2,2);
  ytics(0,1.0,0.2,2);
  xlabel("\216x");

  setwind(1);
    title("\216Selection curve");
    xlabel("\2161-F(s)");
    ylabel("\2161-F]0[(s)");
    _pline = 1~1~0~0~1~1~0~0~10;
    _pmsgstr = "A\000B";
    _pmsgctl = 0.48~0.40~0.30~0~1~0~10 |
               0.35~0.10~0.30~0~1~0~10 ;
    xy(1-(F~FP),1-(F0~FP_0));

  setwind(2);
    title("\216Precision curve");
    xlabel("\2161-F(s)");
    ylabel("\2161-F]1[(s)");
    _pmsgctl = 0.48~0.57~0.30~0~1~0~10 |
               0.48~0.85~0.30~0~1~0~10 ;
    xy(1-(F~FP),1-(F1~FP_1));

  setwind(3);
    title("\216ROC curve");
    xlabel("\2161-F]0[(s)");
    ylabel("\2161-F]1[(s)");
    _pmsgctl = 0.45~0.62~0.30~0~1~0~10 |
               0.20~0.80~0.30~0~1~0~10 ;
    xy(1-(F0~FP_0),1-(F1~FP_1));

  endwind;

G0 = 1 - nBad/n;

x = 1-F;
y = 1-F0;
c = csspline(x,y,1,1);
G = 1 - 2*intspline(c,1|0);

x = 1-FP;
y = 1-FP_0;
c = csspline(x,y,1,1);
GP = 1 - 2*intspline(c,1|0);

print ftosa(100*(G~GP~G./GP),"%lf",3,2);

x = 1-F;
y = 1-F1;
c = csspline(x,y,1,1);
G = 2*intspline(c,1|0) - 1;

x = 1-FP;
y = 1-FP_1;
c = csspline(x,y,1,1);
GP = 2*intspline(c,1|0) - 1;

print ftosa(100*(G~GP~G./GP),"%lf",3,2);

x = 1-F0;
y = 1-F1;
c = csspline(x,y,1,1);
G = 2*intspline(c,1|0) - 1;
GP = 1;

print ftosa(100*(G~GP~G./GP),"%lf",3,2);


