new;
library frm,pgraph,optmum;

cls;

rndseed 123;

n = 5000;
GoodPercent = 0.8;

nGood = GoodPercent*n;
nBad = (1-GoodPercent)*n;
nGood = 4000;
nBad = 1000;

Y  = ones(nGood,1)|zeros(nBad,1);
S1 = (rndn(nGood,1)+0.555)|(rndn(nBad,1));
S2 = (rndn(nGood,1)+0.560)|(rndn(nBad,1)-0.05);
S3 = (rndn(nGood,1)+0.545)|(rndn(nBad,1));

S4 = rndu(nGood,1)|(-rndu(nBad,1));
S_star = quantile(S4,nBad/n);
YP = S4 .> S_star;

S1 = (S1 - minc(S1)) / (maxc(S1) - minc(S1));
S2 = (S2 - minc(S2)) / (maxc(S2) - minc(S2));
S3 = (S3 - minc(S3)) / (maxc(S3) - minc(S3));
S4 = (S4 - minc(S4)) / (maxc(S4) - minc(S4));

x = 0.90|0.80|0.50;
F0 = zeros(12,1);
F1 = zeros(12,1);
{F,F0[1:3],F1[1:3]} = Scoring_Distribution(Y,S1,0,x);
{F,F0[4:6],F1[4:6]} = Scoring_Distribution(Y,S2,0,x);
{F,F0[7:9],F1[7:9]} = Scoring_Distribution(Y,S3,0,x);
{F,F0[10:12],F1[10:12]} = Scoring_Distribution(YP,S4,0,x);

F0 = round(1000*F0)/1000;
F1 = round(1000*F1)/1000;

Neg = 2000;
Pos = 8000;

True_Neg = Neg .* F0;
False_Neg = Pos .* F1;
False_Pos = Neg .* (1 - F0);
True_Pos = Pos .* (1 - F1);

{TPR,FNR,TNR,FPR,PPV,ACC,F} = Binary_Classification(True_Neg,False_Neg,False_Pos,True_Pos);

Table = {};
for i(1,12,1);
  Table = Table ~ ((True_Neg[i]~False_Neg[i]) | (False_Pos[i]~True_Pos[i]));
  if i % 3 == 0;
    print ftosa(Table,"%lf",10,0);;
    Table = {};
  endif;
endfor;

results = TPR~FNR~TNR~FPR~PPV~ACC~F;
print;
print ftosa(100*results,"%lf",10,1);

let max_ordering[1,7] = 1 0 1 0 1 1 1;

Best_scoring = zeros(3,7); 

j = 1;
do until j > 3;
  indx = (0|3|6) + j;
  data = results[indx,.];
  indx_max = maxindc(data)';
  indx_min = minindc(data)';
  indx_best = indx_max .* (max_ordering .== 1) + indx_min .* (max_ordering .== 0); 
  Best_scoring[j,.] = indx_best;
  j = j + 1;
endo;

print ftosa(Best_Scoring,"%lf",10,0);



