new;
library frm,optmum,pgraph;

cls;

rndseed 123;

N = 15;
K = 5;
sigma = 0.40;

x = trunc(100*rndu(N,K))/10;
u = rndu(N,1) * sigma;
beta3 = 3 + 2*rndu(N,1);

y = 3*x[.,1] - 1.5*x[.,2] + beta3 .* x[.,3] - 0.5*x[.,4] + 0.2* x[.,5] + u;
x = trunc(10*x)/10;
y = trunc(10*y)/10;

print ftosa(seqa(1,1,N)~y~x,"%lf",3,1);

m = cols(x);
y = regStandardize(y);
x = regStandardize(x);

alpha_vector = 0.0|0.25|0.5|1.0;
lambda = seqa(0.00,0.01,5001)|60|70|80|90|100|1000;
beta1 = zeros(m,rows(lambda));
beta2 = zeros(m,rows(lambda));
beta3 = zeros(m,rows(lambda));
beta4 = zeros(m,rows(lambda));
tau = zeros(rows(lambda),4);
iter = 1;
do until iter > 4;
  alpha = alpha_vector[iter];
  {beta,tau[.,iter],df,complexity} = regElasticNet(y,x,lambda,alpha);
  beta = missex(beta,abs(beta) .<= 1e-25);
  if iter == 1;
    beta1 = beta;
  elseif iter == 2;
    beta2 = beta;
  elseif iter == 3;
    beta3 = beta;
  elseif iter == 4;
    beta4 = beta;
  endif;

  iter = iter + 1;
endo;

s = tau ./ tau[1,.];

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pnum = 2; _pframe = 0; _pdate = "";
  _pltype = 6|1|3|2; _plwidth = 10; _pcolor = reshape(seqa(1,1,7),m,1);
  _plctrl = 0; _pstype = 8;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;  
  xtics(0,1,0.20,2);
  xlabel("\216\202t\201[*]");
  ylabel("\216\202b\201");

  setwind(1);
    _pcross = 1;
    title("\216\202a\201 = 0 (ridge)");
    ytics(-0.3,0.9,0.3,2);
    xy(s[.,1],beta1);

  setwind(2);
    title("\216\202a\201 = 0.25 (elastic net)");
    xy(s[.,2],beta2);

  setwind(3);
    title("\216\202a\201 = 0.5 (elastic net)");
    xy(s[.,3],beta3);

  setwind(4);
    title("\216\202a\201 = 1 (lasso)");
    _plegstr = "\202b\201]1[\000\202b\201]2[\000\202b\201]3[\000\202b\201]4[\000\202b\201]5[";
    _plegctl = {2 5 -1.25 5.5};
    xy(s[.,4],beta4);

  endwind;

