new;
library frm,pgraph,optmum;

cls;

data = loadd("logit1");

y = data[.,5];
x = ones(rows(y),1) ~ data[.,2:4];

fn pdfLogit(x) =  exp(-x) ./ ((1 + exp(-x))^2);
fn cdfLogit(x) = 1 ./ (1 + exp(-x));

proc LogL(beta);
  local Pr,Logl;

  Pr = cdfLogit(x*beta);
  LogL = y .* ln(Pr) + (1-y) .* ln(1-Pr);
 
  retp(LogL);
endp;

proc negLogL_sum(beta);
  retp( -sumc(LogL(beta)) );
endp;

beta_ols = inv(x'x)*x'y;
{beta_ml,fmin,grad,retcode} = optmum(&negLogL_sum,beta_ols);
cls;
{beta_ml,fmin,grad,retcode} = regML(0,0,&LogL,beta_ols,0,0);

print beta_ols~beta_ml;

Pr = cdfLogit(x*beta_ml);
yhat = Pr .>= 0.5;

print ftosa(y~100*Pr~yhat,"%lf",3,0~2~0);

results = 100*Pr~yhat;
save results;

x_bar = meanc(x);
marginal_effect = pdfn(x_bar'beta_ml)*beta_ml;
print marginal_effect;


