new;
library frm,pgraph,optmum;

cls;

data = loadd("logit1");

y = data[.,5];
x = ones(rows(y),1) ~ data[.,2:4];

fn pdfProbit(x) = pdfn(x);
fn cdfProbit(x) = cdfn(x);

proc LogL(beta);
  local Pr,Logl;

  Pr = cdfProbit(x*beta);
  LogL = y .* ln(Pr) + (1-y) .* ln(1-Pr);
 
  retp(LogL);
endp;

proc LogL_sum(beta);
  retp( sumc(LogL(beta)) );
endp;

proc negLogL_sum(beta);
  retp( -sumc(LogL(beta)) );
endp;

beta = inv(x'x)*x'y;
beta_ols = beta;

LogL_ols = LogL_sum(beta_ols);

{beta_ml,fmin,grad,retcode} = optmum(&negLogL_sum,beta_ols);

cls;
print beta_ols~beta_ml;

Pr = cdfProbit(x*beta_ml);
yhat = Pr .>= 0.5;

loadm results;

print ftosa(y~100*Pr~yhat~results,"%lf",3,0~2~0~2~0);

x_bar = meanc(x);
marginal_effect = pdfn(x_bar'beta_ml)*beta_ml;
print marginal_effect;

