new;
library frm,optmum,pgraph;

cls;

rndseed 1;

N = 20;
K = 5;
sigma = 0.40;

x = trunc(100*rndn(N,K))/10;
u = rndn(N,1) * sigma;
beta = 3|-1.5|1.0|-0.5|0.2;
beta = beta' .* rndu(N,K);
y = sumr(x .* beta) + u;
beta = invpd(x'x + 50.5 * eye(5))*x'y;
y = x*beta + u;
y = trunc(10*y)/10;

print ftosa(seqa(1,1,N)~y~x,"%lf",3,1);

beta_ols = y/x;

lambda = 3.0;

{beta_ridge,tau,df,complexity} = regRidge(y,x,lambda);
u = y - x*beta_ridge;
RSS = sumc(u^2);

beta_cv = zeros(K,N);
beta_cv2 = zeros(K,N);
y_hat = zeros(N,1);
h = zeros(N,1);

iter = 1;
do until iter > N;
  cnd = zeros(N,1);
  cnd[iter] = 1.0;
  y_cv = delif(y,cnd);
  x_cv = delif(x,cnd);
  {beta_cv[.,iter],tau,df,complexity} = regRidge(y_cv,x_cv,lambda);
  beta_cv2[.,iter] = beta_ridge - invpd(x'x + lambda * eye(K))*x[iter,.]'*u[iter]/(1 - x[iter,.]*invpd(x'x + lambda * eye(K))*x[iter,.]');
  y_hat[iter] = x[iter,.]*beta_cv[.,iter];
  h[iter] = x[iter,.]*invpd(x'x + lambda * eye(K))*x[iter,.]'; 
  iter = iter + 1;
endo;

print ftosa((seqa(1,1,n)~beta_cv')|(error(0)~beta_ridge'),"%lf",3,4);

print ftosa(seqa(1,1,n)~y~y_hat~(y-y_hat)~u~h,"%lf",3,4);

Press = meanc((y - y_hat)^2);
print ftos(Press,"Press = %lf",3,5);

Press = meanc( (u./(1-h))^2 );
print ftos(Press,"Press = %lf",3,5);

h_bar = meanc(h);
GCV = meanc( (u./(1-h_bar))^2 );
print ftos(GCV,"GCV =   %lf",3,5);

GCV = RSS ./ ((1-h_bar)^2) / N;
print ftos(GCV,"GCV =   %lf",3,5);

s_X = svd(X);
GCV =  N * (K^2) * RSS / (sumc(((N-K) * s_X^2 + n * lambda)./(s_X^2 + lambda))^2);
print ftos(GCV,"GCV =   %lf",3,5);

L = eye(n) - x*invpd(x'x + lambda * eye(K))*x'; 
trace_L = sumc(diag(L));
GCV =  N  / (trace_L^2) .* RSS;
print ftos(GCV,"GCV =   %lf",3,5);

L = inv(eye(n) + x*invpd(lambda * eye(K))*x'); 
trace_L = sumc(diag(L));
GCV =  N  / (trace_L^2) .* RSS;
print ftos(GCV,"GCV =   %lf",3,5);

s_XX = eigh(x*x');
trace_L = sumc(lambda./(lambda + s_XX));
GCV =  N  / (trace_L^2) .* RSS;
print ftos(GCV,"GCV =   %lf",3,5);

trace_L = (N - K) + sumc(lambda./(lambda + s_X^2));
GCV =  N  / (trace_L^2) .* RSS;
print ftos(GCV,"GCV =   %lf",3,5);

print ftos(h_bar,"h_bar = %lf",5,5);
print ftosa(s_X,"%lf",5,5);

