new;
library frm,pgraph,optmum;

cls;

rndseed 123;

declare matrix x1,x2;

let mu1 = 2 4;
let mu2 = 4 4;
let mu3 = 4 2;
let Sigma1[2,2] = 1.5 1 1 2;
let Sigma2[2,2] = 1.5 1 1 3;
let Sigma3[2,2] = 1 0 0 1;

N1 = 9;
N2 = 9;
N3 = 15;

C1 = rndmvn_chol(mu1,Sigma1,N1);
C2 = rndmvn_chol(mu2,Sigma2,N2);
C3 = rndmvn_chol(mu3,Sigma3,N3);
C1[2,1] = 0.5;
C1[6,2] = 6.86;
C1[.,2] = C1[.,2] - 0.30;
C2[.,2] = C2[.,2] - 0.30;
C3[.,2] = C3[.,2] - 0.20;
C1[.,1] = C1[.,1] - 0.30;
C2[.,1] = C2[.,1] - 0.30;
C3[.,1] = C3[.,1] - 0.20;

C1 = trunc(100*C1)/100;
C2 = trunc(100*C2)/100;
C3 = trunc(100*C3)/100;

C = C1 | C2 | C3;

indx_C = ones(N1,1)|2*ones(N2,1)|3*ones(N3,1);
C1_Square = C1~C1^2;
C2_Square = C2~C2^2;
C3_Square = C3~C3^2;
C_Square = C~C^2;

N = N1 + N2 + N3;

pi1 = N1 / N;
pi2 = N2 / N;
pi3 = N3 / N;

mu1 = meanc(C1);
mu2 = meanc(C2);
mu3 = meanc(C3);

mu1_Square = meanc(C1_Square);
mu2_Square = meanc(C2_Square);
mu3_Square = meanc(C3_Square);

Sigma1 = vcx(C1);
Sigma2 = vcx(C2);
Sigma3 = vcx(C3);
Sigma = vcx(C);
Sigma_Square = vcx(C_Square);

CS = C;
nS = rows(CS);

Score_QDA = zeros(nS,3);
Score_LDA = zeros(nS,3);
Score_LDA_Square = zeros(nS,3);

i = 1;
do until i > nS;
  x = CS[i,.]';
  x_Square = x | x^2;
  j = 1;
  do until j > 3;
    if j == 1;
      pi_j = pi1;
      mu_j = mu1;
      mu_Square = mu1_Square;
      Sigma_j = Sigma1;
    elseif j == 2;
      pi_j = pi2;
      mu_j = mu2;
      mu_Square = mu2_Square;
      Sigma_j = Sigma2;
    elseif j == 3;
      pi_j = pi3;
      mu_j = mu3;
      mu_Square = mu3_Square;
      Sigma_j = Sigma3;
    endif;
    Score_QDA[i,j] = ln(pi_j) - 0.5*ln(det(Sigma_j)) - 0.5*(x-mu_j)'*invpd(Sigma_j)*(x-mu_j);
    Score_LDA[i,j] = ln(pi_j) + mu_j'*invpd(Sigma)*x - 0.5*mu_j'*invpd(Sigma)*mu_j;
    Score_LDA_Square[i,j] = ln(pi_j) + mu_Square'*invpd(Sigma_Square)*x_Square - 0.5*mu_Square'*invpd(Sigma_Square)*mu_Square;
    j = j + 1;
  endo;

  i = i + 1;
endo;

indx_QDA = maxindc(Score_QDA');
C1_QDA = selif(Cs,indx_QDA .== 1);
C2_QDA = selif(Cs,indx_QDA .== 2);
C3_QDA = selif(Cs,indx_QDA .== 3);
indx_QDA_NC = selif(seqa(1,1,N),indx_QDA ./= indx_C);

indx_LDA = maxindc(Score_LDA');
C1_LDA = selif(Cs,indx_LDA .== 1);
C2_LDA = selif(Cs,indx_LDA .== 2);
C3_LDA = selif(Cs,indx_LDA .== 3);
indx_LDA_NC = selif(seqa(1,1,N),indx_LDA ./= indx_C);

indx_LDA_Square = maxindc(Score_LDA_Square');
C1_LDA_Square = selif(Cs,indx_LDA_Square .== 1);
C2_LDA_Square = selif(Cs,indx_LDA_Square .== 2);
C3_LDA_Square = selif(Cs,indx_LDA_Square .== 3);
indx_LDA_Square_NC = selif(seqa(1,1,N),indx_LDA_Square ./= indx_C);

N_max = maxc(N1|N2|N3);
X1_C = miss(zeros(N_max,3),0);
X2_C = miss(zeros(N_max,3),0);
X1_C[1:N1,1] = C1[.,1];
X1_C[1:N2,2] = C2[.,1];
X1_C[1:N3,3] = C3[.,1];
X2_C[1:N1,1] = C1[.,2];
X2_C[1:N2,2] = C2[.,2];
X2_C[1:N3,3] = C3[.,2];

results = seqa(1,1,N)~indx_C~C;
results = results[1:11,.]~results[12:22,.]~results[23:33,.];
print ftosa(results,"%lf",3,4);

results = pi1 ~ error(0) ~ pi2 ~ error(0) ~ pi3 ~ error(0) |
          mu1' ~ mu2' ~ mu3'     |
          Sigma1 ~Sigma2 ~ Sigma3;
print ftosa(results,"%lf",3,3);

results = seqa(1,1,N)~Score_QDA~Score_LDA~Score_LDA_Square;
print ftosa(results,"%lf",3,2);


N1 = rows(C1_QDA);
N2 = rows(C2_QDA);
N3 = rows(C3_QDA);
N_max = maxc(N1|N2|N3);
X1_C_QDA = miss(zeros(N_max,3),0);
X2_C_QDA = miss(zeros(N_max,3),0);
X1_C_QDA[1:N1,1] = C1_QDA[.,1];
X1_C_QDA[1:N2,2] = C2_QDA[.,1];
X1_C_QDA[1:N3,3] = C3_QDA[.,1];
X2_C_QDA[1:N1,1] = C1_QDA[.,2];
X2_C_QDA[1:N2,2] = C2_QDA[.,2];
X2_C_QDA[1:N3,3] = C3_QDA[.,2];

N1 = rows(C1_LDA);
N2 = rows(C2_LDA);
N3 = rows(C3_LDA);
N_max = maxc(N1|N2|N3);
X1_C_LDA = miss(zeros(N_max,3),0);
X2_C_LDA = miss(zeros(N_max,3),0);
X1_C_LDA[1:N1,1] = C1_LDA[.,1];
X1_C_LDA[1:N2,2] = C2_LDA[.,1];
X1_C_LDA[1:N3,3] = C3_LDA[.,1];
X2_C_LDA[1:N1,1] = C1_LDA[.,2];
X2_C_LDA[1:N2,2] = C2_LDA[.,2];
X2_C_LDA[1:N3,3] = C3_LDA[.,2];

N1 = rows(C1_LDA_Square);
N2 = rows(C2_LDA_Square);
N3 = rows(C3_LDA_Square);
N_max = maxc(N1|N2|N3);
X1_C_LDA_Square = miss(zeros(N_max,3),0);
X2_C_LDA_Square = miss(zeros(N_max,3),0);
X1_C_LDA_Square[1:N1,1] = C1_LDA_Square[.,1];
X1_C_LDA_Square[1:N2,2] = C2_LDA_Square[.,1];
X1_C_LDA_Square[1:N3,3] = C3_LDA_Square[.,1];
X2_C_LDA_Square[1:N1,1] = C1_LDA_Square[.,2];
X2_C_LDA_Square[1:N2,2] = C2_LDA_Square[.,2];
X2_C_LDA_Square[1:N3,3] = C3_LDA_Square[.,2];

{class,retcode} = K_means_Clustering(C,3,0);
let coding[3,2] = 1 3
                  2 1
                  3 2; 
{class,coding} = K_means_Clustering_Ordering(class,coding);
{Loss,class_Label,class_n,class_loss,class_centroid} = K_means_Clustering_Loss(C,class);

indx1 = selif(seqa(1,1,N),class .== 1);
indx2 = selif(seqa(1,1,N),class .== 2);
indx3 = selif(seqa(1,1,N),class .== 3);
N1 = rows(indx1);
N2 = rows(indx2);
N3 = rows(indx3);
N_max = maxc(N1|N2|N3);
X1_C_KM = miss(zeros(N_max,3),0);
X2_C_KM = miss(zeros(N_max,3),0);
X1_C_KM[1:N1,1] = C[indx1,1];
X1_C_KM[1:N2,2] = C[indx2,1];
X1_C_KM[1:N3,3] = C[indx3,1];
X2_C_KM[1:N1,1] = C[indx1,2];
X2_C_KM[1:N2,2] = C[indx2,2];
X2_C_KM[1:N3,3] = C[indx3,2];

indx_KM = class;
indx_KM_NC = selif(seqa(1,1,N),indx_KM ./= indx_C);

graphset;
  begwind;
  window(2,2,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pcolor = 1|2|4; _plctrl = -1; _pstype = 8|9|10; _psymsiz = 7;
  _paxht = 0.30; _pnumht = 0.25; _ptitlht = 0.30;

  xtics(0,6,1,0);
  ytics(-1,7,1,0);
  xlabel("\216X]1[");
  ylabel("\216X]2[");

  setwind(1);
    title("\216Observation");
    xy(X1_C,X2_C);

  setwind(2);
    title("\216QDA prediction");
    indx = indx_QDA_NC;
    e = ones(rows(indx),1);
    _pline = e.*(4~6)~C[indx,.]~e.*(0.2~0~2*pi~12~10); 
    xy(X1_C_QDA,X2_C_QDA);

  setwind(3);
    title("\216LDA prediction");
    indx = indx_LDA_NC;
    e = ones(rows(indx),1);
    _pline = e.*(4~6)~C[indx,.]~e.*(0.2~0~2*pi~12~10); 
    xy(X1_C_LDA,X2_C_LDA);

  setwind(4);
    title("\216K-means prediction");
    indx = indx_KM_NC;
    e = ones(rows(indx),1);
    _pline = e.*(4~6)~C[indx,.]~e.*(0.2~0~2*pi~12~10); 
    _plegstr = "Class C]1[\000Class C]2[\000Class C]3[";
    _plegctl = {2 5 -1 5.9};
    xy(X1_C_KM,X2_C_KM);

  endwind;  




