/*
**> Capital requirement for options
**
*/

new;
library frm,option,pgraph;

cls;

LS = 1;

S0 = 500;
K = 490;
sigma = 0.20;
tau = 1;
r = 0.08;
b = r;

C = EuropeanBS(S0,K,sigma,tau,b,r);
Delta = LS * EuropeanBS_Delta(S0,K,sigma,tau,b,r);
Gamma_ = LS * EuropeanBS_Gamma(S0,K,sigma,tau,b,r);
Vega = LS * EuropeanBS_Vega(S0,K,sigma,tau,b,r);

print "------------------------------";
print ftosa(C,"C = %lf",3,4);
print ftosa(Delta,"Delta = %lf",3,4);
print ftosa(Gamma_,"Gamma = %lf",3,4);
print ftosa(Vega,"Vega = %lf",3,4);
print "------------------------------";

K_Sp = 0.00;
K_Gen = 0.15;
K_Gamma = 0.15;

C_Sp = Delta * S0 * K_Sp; 
C_Gen = Delta * S0 * K_Gen;
C_Gamma = 0.5 * Gamma_ * (S0 * K_Gamma)^2;
C_Vega  = Vega * (0.25 * Sigma);

print ftosa(C_Sp,"C(Delta Sp) = %lf",3,4);
print ftosa(C_Gen,"C(Delta Gen) = %lf",3,4);
print ftosa(C_Gamma,"C(Gamma) = %lf",3,4);
print ftosa(C_Vega,"C(Vega) = %lf",3,4);

print "------------------------------";




