/*
**> Capital requirement for options
**
*/

new;
library frm,pgraph;

cls;

let Asset    =    1    1    2    2;
let Exposure =   -5  -10   10    8;
let CP       =    1    1    1   -1;
let S0       =  100  100  200  200;
let K        =  110  100  210  190;
let Sigma    = 0.20 0.20 0.30 0.35;
let tau      = 1.00 2.00 1.00 1.25;
let b        = 0.05;
let r        = 0.05;
let K_Sp     = 0.08;
let K_Gen    = 0.08;
let K_Gamma  = 0.08;

{C_Sp,C_Gen,C_Gamma,C_Vega,Capital,Results} = Compute_Capital_Delta_Plus(Asset,Exposure,CP,S0,K,Sigma,tau,b,r,K_Sp,K_Gen,K_Gamma);

print "------------------------------";
print ftosa(Results',"%lf",3,2);
print "------------------------------";
print ftosa(Capital,"%lf",3,2);
print "------------------------------";
print ftosa(C_Sp,"C(Delta Sp) = %lf",3,2);
print ftosa(C_Gen,"C(Delta Gen) = %lf",3,2);
print ftosa(C_Gamma,"C(Gamma) = %lf",3,2);
print ftosa(C_Vega,"C(Vega) = %lf",3,2);
print "------------------------------";
C = C_Sp + C_Gen + C_gamma + C_vega;
print ftosa(C,"C = %lf",3,2);
print "------------------------------";
