new;
library frm,pgraph;

nMin = 50;
nMax = 550;
alpha = 0.99;
p = 1 - alpha;

n = seqa(nMin,1,nMax-nMin+1);

zones = zeros(rows(n),2);

i = 1;
do until i > rows(n);
  m = seqa(0,1,n[i]+1);
  Pr = cdfb(m,p,n[i]);
  prc = 0.95;
  zones[i,1] = sumc(Pr .< 0.95);
  zones[i,2] = sumc(Pr .< 0.9999);
  i = i + 1;
endo;

zones = zones - 1;
zones[.,2] = zones[.,2] + 1.0;

indx = seqa(1,20,rows(n)/20);
x1 = n[indx];
x2 = n[indx];
y1 = zones[indx,1];
y2 = zones[indx,2];
e = ones(rows(x1),1);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6; _pframe = 0;
  _plwidth = 10; _pcolor = 2|4;
  
  xlabel("\216Number of trading days");
  ylabel("\216Number of exceptions");
  xtics(100,500,50,5);
  ytics(0,16,2,2);

  _pmsgstr = "Green zone\000Yellow zone\000Red zone";
  _pmsgctl = 300~2~0.20~0~1~2~8 |
             225~7~0.20~0~1~5~8 |
             150~13~0.20~0~1~4~8 ;

  xy(n,zones);

