new;
library frm,pgraph;

cls;

let ES_F_C =  100 75 34 12   6;
let ES_R_C =   88 63 30  7   5;
let ES_R_S =  112 83 47  9   7;

{ES,Results} = SA_ES_Basel3(ES_F_C,ES_R_C,ES_R_S);

print ftosa((ES_F_C~ES_R_C~ES_R_S)',"%lf",5,0);

print ftosa(Results,"%lf",5,2);
print ftosa(ES,"%lf",5,2);


proc (2) = SA_ES_Basel3(ES_F_C,ES_R_C,ES_R_S);
  local LH,Ratio_LH,ES,Results;
  local ES_F_C_Scaled,ES_R_C_Scaled,ES_R_S_Scaled,ES_T_F_C,ES_T_R_C,ES_T_R_S;
  local ES_F_S,ES_F_S_Scaled,ES_T_F_S;

  let LH =  10  20 40 60 120;
  Ratio_LH = (LH - lag1(LH))/10;
  Ratio_LH[1] = 1.0;

  ES_F_C_Scaled = ES_F_C .* sqrt(Ratio_LH);
  ES_R_C_Scaled = ES_R_C .* sqrt(Ratio_LH);
  ES_R_S_Scaled = ES_R_S .* sqrt(Ratio_LH);

  ES_T_F_C = sqrt(sumc(ES_F_C_Scaled ^ 2));
  ES_T_R_C = sqrt(sumc(ES_R_C_Scaled ^ 2));
  ES_T_R_S = sqrt(sumc(ES_R_S_Scaled ^ 2));

  ES = zeros(2,1);
  ES[1] = ES_T_R_S * ES_T_F_C / ES_T_R_C;

  ES_F_S = ES_R_S .* ES_F_C ./ ES_R_C;
  ES_F_S_Scaled = ES_F_S .* sqrt(Ratio_LH);
  ES_T_F_S = sqrt(sumc(ES_F_S_Scaled ^ 2));

  ES[2] = ES_T_F_S;

  Results = Ratio_LH~ES_F_C_Scaled~ES_R_C_Scaled~ES_R_S_Scaled~ES_F_S~ES_F_S_Scaled |
            error(0)~ES_T_F_C~ES_T_R_C~ES_T_R_S~error(0)~ES_T_F_S; 


  retp(ES,Results);
endp;