/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

rndseed 123;

proc (2) = Discrete_Convolution(x1,p1,x2,p2);
  local x_s,p_s,x,p;

  x_s = vecr(x1 + x2');
  p_s = vecr(p1 .* p2');

  x = unique(x_s,1);
  p = countwts(x_s,x,p_s);
  
  retp(x,p);
endp;

proc (2) = Risk_Mesaure(x,p,alpha);
  local indx,cdf,e,indx_VaR,VaR,ES;

  indx = sortind(x);
  x = x[indx];
  p = p[indx];
  cdf = cumsumc(p);

  e = (cdf .>= alpha);
  indx_VaR = maxindc(e);
  VaR = x[indx_VaR];
  x = selif(x,e);
  p = selif(p,e);
  p = p / sumc(p);
  ES = sumc(p .* x);

  retp(VaR,ES);
endp;

N = 100;
PD = 0.98;
let x_R = 0.75 0.25;
let p_R = 0.50 0.50;
LGD = 1 - x_R;
p_LGD = rev(P_R);

L1 = 0 | (N * LGD);
p1 = PD | ((1-PD) * p_LGD);
{VaR1,ES1} = Risk_Mesaure(L1,p1,0.99);

print ftosa(L1~100*p1,"%lf",3,2);
print ftosa(VaR1|ES1,"%lf",3,2);

L2 = L1;
p2 = p1;
{L,p} = Discrete_Convolution(L1,p1,L2,p2);
{VaR,ES} = Risk_Mesaure(L,p,0.99);

print ftosa(L~100*p~100*cumsumc(p),"%lf",3,3);
print ftosa(VaR|ES,"%lf",3,3);









