new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
print ftosa(Pt,"%lf",3,4);
let w = 10 20;
Pw_t = sumc(w .* Pt);
print ftosa(Pw_t,"Pw(t) = %lf",3,4);
print "-----------------------------------------------------";

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Ps = Prices[indx,.];
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pw_s = sumr(w' .* Pt_s);
Pi_s = Pw_s - Pw_t;

Results = Dates[indx]~Ps[.,1]~100*Rs[.,1]~Ps[.,2]~100*Rs[.,2]~Pt_s~Pw_s~Pi_s;

indx_os = sortind(Pi_s);

Loss = -Pi_s[indx_os];
VaR = 0.5 * (Loss[2] + Loss[3]);
print ftosa(VaR,"VaR = %lf",3,2);
K = 3 * sqrt(10) * VaR;
print ftosa(K,"K = %lf",3,2);
print (ftosa(100*K/Pw_t,"K/Pw(t) = %lf",3,2) $+ "%");
print "-----------------------------------------------------";

Loss = Pi_s;
VaR = -quantile(Loss,0.01);
print ftosa(VaR,"VaR = %lf",3,2);
K = 3 * sqrt(10) * VaR;
print ftosa(K,"K = %lf",3,2);
print (ftosa(100*K/Pw_t,"K/Pw(t) = %lf",3,2) $+ "%");
print "-----------------------------------------------------";

Results = Dates[indx]~Ps[.,1]~100*Rs[.,1]~Ps[.,2]~100*Rs[.,2]~100*Rs[.,1]~Pt_s[.,1]~100*Rs[.,2]~Pt_s[.,2]~Pw_s~Pi_s;

str_Results = stringDate(Results[.,1],0) $~ ftosa(Results[.,2:11],"%lf",3,2); 

indx = seqa(250,-1,10)|indx_os[1:6]|1; 
indx = rev(sortc(indx,1));
s = 250 - indx + 1;
str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1:5]; 
print str;
str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1 6:11]; 
print str;

indx = seqa(250,-1,250);
s = 250 - indx + 1;

str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1:5]; 
call saTabular(str,"chap2-2-2-2.tex");

str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1 6:11]; 
call saTabular(str,"chap2-2-2-2.tex");

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = s~GaussDate_to_ExcelDate(Results[indx,1])~Results[indx,2:11];
call SpreadSheetWrite(xls_Results,xlsFileName,"A4",1); 

indx = 250 - indx_os + 1;
indx = indx[1:10];
call saTabular(str[indx,.],"chap2-2-2-2.tex");
