new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
print ftosa(Pt,"%lf",3,4);
let w = 10 20;
Pw_t = sumc(w .* Pt);
print ftosa(Pw_t,"Pw(t) = %lf",3,4);
print "-----------------------------------------------------";

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Ps = Prices[indx,.];
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pw_s = sumr(w' .* Pt_s);
Pi_s = Pw_s - Pw_t;

Results = Dates[indx]~Ps[.,1]~100*Rs[.,1]~Ps[.,2]~100*Rs[.,2]~Pt_s~Pw_s~Pi_s;

indx_os = sortind(Pi_s);

Loss = -Pi_s[indx_os];
VaR = 0.5 * (Loss[2] + Loss[3]);
print ftosa(VaR,"VaR(99) = %lf",3,2);
ES = 0.5 * (Loss[1] + Loss[2]);
print ftosa(ES,"ES(99) = %lf",3,2);
ES = meanc(Loss[1:6]);
print ftosa(ES,"ES(97.5) = %lf",3,2);

print ftosa(Loss[1:6],"%lf",3,2);
