new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
let w = 10 20;
Pw_t = sumc(w .* Pt);

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Ps = Prices[indx,.];
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pw_s = sumr(w' .* Pt_s);
Pi_s = Pw_s - Pw_t;

alpha = 0.01;
VaR1 = quantile(Pi_s,alpha);
{x,d,F,pline} = regEmpiricalDistribution(Pi_s); 

indx_os = sortind(Pi_s);

x1 = Pi_s[indx_os[2]]; y1 = 2/250;
x2 = Pi_s[indx_os[3]]; y2 = 3/250;
a = (y1 - y2)/(x1 - x2);
b = y1 - a * x1;
x3 = -70; y3 = a * x3 + b;
x4 = -30; y4 = a * x4 + b;

x = seqa(-100,200/501,504);
{d,F} = regKernelDensity(Pi_s,x);
{VaR2,retcode} = regKernelVaR(Pi_s,alpha,-200,200);
s = _kernel_s;
h = _kernel_h;
{chk_d,chk_F} = regKernelDensity(Pi_s,VaR2);

print ftos(_kernel_s,"s = %lf",3,4);
print ftos(_kernel_h,"h = %lf",3,4);
print ftosa(-VaR2,"VaR2 = %lf",3,2);
print ftosa(chk_F,"check = %lf",3,4);

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = x~d~F;
call SpreadSheetWrite(xls_Results,xlsFileName,"A2",3); 

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9/2.5,6.855/2.5,1,3.8,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  xtics(-100,75,25,2);
  ytics(0,1,0.10,2);
  xlabel("\216\202P\201(x)");

  setwind(1);
    _plegstr = "Empirical\000Kernel";
    _plegctl = {2 5 6 2};
    _pline = 1~6~-70~0~-70~0.03~1~0~8 |
             1~6~-30~0~-30~0.03~1~0~8 |
             1~6~-70~0.03~-30~0.03~1~0~8 |
             1~6~-95~0.5~-95~1.00~1~0~8 |
             1~6~-10~0.5~-10~1.00~1~0~8 |
             1~6~-95~0.5~-10~0.50~1~0~8 |
             1~6~-95~1.0~-10~1.00~1~0~8 ; 
    _parrow = -50~0.05~-60~0.45~4~0.2~21~0~1~6~8;
    xy(pline[.,1]~x,pline[.,2]~F);

    _plegctl = 0;

  setwind(2);
    _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.25;
    xtics(-70,-30,10,2);
    ytics(0,0.03,0.01,2);
    _pline = 1~1~-70~0.01~-30~0.01~1~0~8 |
             1~1~VaR2~0~VaR2~0.02~1~4~5  |
             1~1~VaR1~0~VaR1~0.01~1~1~5  |
             1~3~x3~y3~x4~y4~1~1~5       ;
  _pmsgstr = "(D)\000(K)\000VaR";
  _pmsgctl = -29.5~0.0185~0.25~0~1~1~8 |
             -41~0.025~0.25~0~1~4~8 |
             VaR1-2~0.021~0.25~0~1~0~8 ;
    xy(pline[.,1]~x,pline[.,2]~F);
 
  endwind;



