new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
let w = 10 20;
Pw_t = sumc(w .* Pt);

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Ps = Prices[indx,.];
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pw_s = sumr(w' .* Pt_s);
Pi_s = Pw_s - Pw_t;

alpha = 0.01;

{VaR2,retcode} = regKernelVaR(Pi_s,alpha,-200,200);
s = _kernel_s;
h = _kernel_h;
{chk_d,chk_F} = regKernelDensity(Pi_s,VaR2);

print ftos(_kernel_s,"s = %lf",3,4);
print ftos(_kernel_h,"h = %lf",3,4);
print ftosa(-VaR2,"VaR2 = %lf",3,2);
print ftosa(chk_F,"check = %lf",3,4);

{ES2,VaR2} = regKernelES(Pi_s,alpha,-200,200);
print ftosa(-ES2,"ES2 = %lf",3,2);

alpha = 0.025;

{ES2,VaR2} = regKernelES(Pi_s,alpha,-200,200);
print ftosa(-VaR2,"VaR2 = %lf",3,2);
print ftosa(-ES2,"ES2 = %lf",3,2);

alpha = 0.005;

{ES2,VaR2} = regKernelES(Pi_s,alpha,-200,200);
print ftosa(-VaR2,"VaR2 = %lf",3,2);
print ftosa(-ES2,"ES2 = %lf",3,2);
