new;
library frm,pgraph;

cls;

n = 10000;
nS = 10;

alpha = 0.75|0.50|0.05|0.025|0.01;

ES = zeros(rows(alpha),nS);
VaR = zeros(rows(alpha),nS);

i = 1;
do until i > nS;
  y = rndn(n,1);
  {ES[.,i],VaR[.,i]} = regKernelES(y,alpha,-5,5);
  i = i + 1;
endo;

print ftosa(meanc(VaR')~meanc(ES'),"%lf",3,2);

print ftosa(cdfni(alpha)~-pdfn(cdfni(1-alpha))./alpha,"%lf",3,2);

proc (2) = regKernelES(y,alpha,x_min,x_max);
  local n,s,h,n_alpha,ES,VaR,i,u,retcode;

  y = packr(y);
  n = rows(y);

  s = stdc(y);
  h = 1.364*s*(n^(-0.2));

  if rows(_Kernel_h) == 2;
    h = _Kernel_h[2];
  else;
    _Kernel_s = s;
    _Kernel_h = h;
  endif;

  n_alpha = rows(alpha);
  ES = zeros(n_alpha,1);
  VaR = zeros(n_alpha,1);

  i = 1;
  do until i > n_alpha;
    {VaR[i],retcode} = regKernelVaR(y,alpha[i],x_min,x_max);
    u = (VaR[i]-y)/h;
    ES[i] = meanc(y .* cdfn(u));
    i = i + 1;
  endo;

  ES = ES ./ alpha;

  retp(ES,VaR);
endp;

