new;
library frm,pgraph,cml;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

let string selected_name = "SPX";
indx = indsav(selected_name,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = (R .== 0);
Dates = delif(Dates,cnd);
nDates = rows(Dates);
Prices = delif(Prices,cnd);
Rt = Prices ./ lag1(Prices) - 1;

BeginDate = 19980631;
LastDate = 20141231;
indx = selif(seqa(1,1,nDates), (Dates .>= BeginDate) .and (Dates .<= LastDate));
Rt = Rt[indx];
Dates = Dates[indx];
prices = prices[indx];
nDates = rows(dates);

t = dttodtv(1e6 * Dates);
Years = t[.,1];
t = t[.,1] + t[.,8]/365; 

// Garch ML
p = 1; q = 1;
{theta,cl,cov,logl} = regGarch(Rt,1,p,q,0);
vol1 = sqrt(_garch_h);

// 260 days volatility
vol2 = Rolling_Volatility(Dates,prices,260)/sqrt(260);

// EWMA
lambda = 0.94;
vol3 = EWMA_Volatility(Dates,Prices,lambda)/sqrt(260);

// 20 days volatility
vol4 = Rolling_Volatility(Dates,prices,20)/sqrt(260);

alpha = 0.99;
VaR = miss(zeros(nDates,10),0);

i = 1;
do until i > nDates;

  if i < 260;
    i = i + 1;
    continue;
  endif;

  VaR[i,1] = cdfni(alpha) * vol1[i];
  VaR[i,2] = cdfni(alpha) * vol2[i];
  VaR[i,3] = cdfni(alpha) * vol3[i];
  VaR[i,4] = cdfni(alpha) * vol4[i];
  VaR[i,5] = -quantile(Rt[i:i-259],1-alpha);

  VaR[i,6] = cdfni(alpha) * vol1[i];
  VaR[i,7] = cdfni(alpha) * vol2[i];
  VaR[i,8] = cdfni(alpha) * vol3[i];
  VaR[i,9] = cdfni(alpha) * vol4[i];
  VaR[i,10] = -quantile(-Rt[i:i-259],1-alpha);

  i = i + 1;
endo;

Rt = Rt .* ones(1,5);
Loss = (-lagn(Rt,-1)) ~ (lagn(Rt,-1));

Ex = Loss .> VaR;

Nex = zeros(15,11);
i = 1;
do until i > 15;
  cnd = selif(Ex,Years .== (1999+i));
  Nex[i,.] = (1999+i) ~ sumc(cnd)';
  i = i + 1;
endo;

print ftosa(Nex,"%lf",3,0);

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = selif(GaussDate_to_ExcelDate(Dates)~Rt[.,1]~VaR, Dates .>= 20000101);
call SpreadSheetWrite(xls_Results,xlsFileName,"A3",9); 
