new;
library frm,pgraph;

cls;

mu = 0;
sigma = 1;

x = seqa(-4,8/200,201);
pdf0 = pdfn2(x,mu,sigma);

proc edgeworth(varsigma,kappa,x);
  local y;
  y = 1 + 
      varsigma .* (x^3 - 3*x) / 6 +
      (kappa - 3) .* (x^4 - 6*x^2 + 3) / 24 +
      (varsigma^2) .* (x^5 - 10*x^3 + 15*x) / 72;
  retp( y .* pdfn2(x,mu,sigma) );
endp;

pdf1 = edgeworth(-0.7,3,x);
pdf2 = edgeworth( 0.9,3,x);  
pdf3 = edgeworth( 0,1.5,x);  
pdf4 = edgeworth( 0,4.5,x);  

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|4; _plwidth = 10;   _pcolor = 1|2|4; 
  _pnumht = 0.20; _ptitlht = 0.275;

  xtics(-4,4,1,2);
  ytics(0,0.5,0.1,10);

  h = 0.25;

  setwind(1);
    title("\216Gaussian distribution");
    xy(x,pdf0);

  setwind(2);
    title("\216Skewed distribution");

    _pmsgstr = "\201left skewed\000(\202g\201]1[=-0.7)\000right skewed\000(\202g\201]1[=0.7)";
    _pmsgctl =  1.1~0.35~h~0~1~2~6  |
                1.3~0.30~h~0~1~2~6  |
               -3.5~0.35~h~0~1~4~6 |
               -3.0~0.30~h~0~1~4~6  ;
    xy(x,pdf0~pdf1~pdf2);

  setwind(3);
    title("\216Heavy-tailed distribution");

    _pmsgstr = "\201thin tailed\000(\202g\201]2[=-1.5)\000fat tailed\000(\202g\201]2[=1.5)";
    _pmsgctl = -3.65~0.22~h~0~1~2~6|
               -3.65~0.17~h~0~1~2~6|
                0.55~0.425~h~0~1~4~6|
                0.70~0.375~h~0~1~4~6;
    xy(x,pdf0~pdf3~pdf4);

  endwind;