new;
library frm,pgraph,optmum;

cls;

proc root_s(alpha,s);
  local z,u;
  z = cdfni(alpha);
  u = z^2 - 1 - (2*z^3 - 5*z).*s/18;
  retp(u);
endp;

proc root_k(alpha);
  local z,u;
 
  z = cdfni(alpha);
  u = z^3 - 3*z;
  retp(u);
endp;

s = -2|-1|-0.5|0|0.5|1.0|2.0;
k = seqa(0,1,8)';
{z,VaR} = Compute_Cornish_Fisher_z(0,1,s,k,0.99);

s2 = s^2;
cnd = (s2/9) -4 * (k/8 - s2/6) .* (1 - k/8 + 5*s2/36);
cnd = cnd .<= 0;

results = (error(0) | s) ~ (k | z);
results = (error(0) | s) ~ (k | missex(z,1-cnd) );
print "------------------------------------------------------------";
print ftosa(results,"%lf",3,2);
print "------------------------------------------------------------";

gamma1 = seqa(-2.5,5/100,101);
gamma1 = sortc(gamma1,1);
s = (gamma1^2)/9;
s2 = s^2;
a = 4;
b = -4 - 11*s;
c = 7*s + 15/2*s2;
delta = (b^2) - 4 * a .* c;
delta = missex(delta, delta .< 0);
k1 = (-b - sqrt(delta)) ./ (2 * a);
k2 = (-b + sqrt(delta)) ./ (2 * a);
gamma2 = 8 * (k1~k2);

{x,y} = packr2(gamma1,gamma2);
e = ones(rows(x),1);
pline = e .* (1~6)~x~y[.,1]~x~y[.,2]~e.*(1~1~5);

gamma1 = seqa(-2.5,0.001,50)|seqa(-2.5,5/200,201)|seqa(2.5,-0.001,50);
gamma1 = sortc(gamma1,1);
s = (gamma1^2)/9;
s2 = s^2;
a = 4;
b = -4 - 11*s;
c = 7*s + 15/2*s2;
delta = (b^2) - 4 * a .* c;
delta = missex(delta, delta .< 0);
k1 = (-b - sqrt(delta)) ./ (2 * a);
k2 = (-b + sqrt(delta)) ./ (2 * a);
gamma2 = 8 * (k1~k2);

graphset;
  window3d;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 3|6; _pcolor = 1|4; _plwidth = 10;
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.275;
  xtics(0,100,10,2);
  xlabel("\216\202a\201 (in %)");

  alpha = seqa(0.01,0.01,99);

  setwind(1);
    title("\216\202\92\201z/\202\92g\201]1[");
    ytics(-2,6,2,0);
    _plegstr = "\202g\201]1[=3\000\202g\201]1[=-3";
    _plegctl = {2 5 3 4};
    xy(100*alpha,root_s(alpha,3~-3));

    _plegctl = 0;

  setwind(2);
    _pcolor = 2;
    title("\216\202\92\201z/\202\92g\201]2[");
    xlabel("\216\202a\201 (in %)");
    ytics(-5,5,2.5,0);
    xy(100*alpha,root_k(alpha));

  setwind(3);
    title("\216Definition domain of\L\216the Cornish-Fisher expansion");
    _pcolor = 1; _pcross = 1; _pltype = 6;
    xtics(-3,3,1,0);
    ytics(0,15,3,0);
    xlabel("\216\202g\201]1[");
    ylabel("\216\202g\201]2[");
    _pline = pline;
    xy(gamma1,gamma2);

  endwind;
 
