new;
library frm,pgraph;
frmSet;

cls;

let x      = 500   200    300;
let xi     = 0.01 -0.02   0.15;
let omega  = 0.05  0.10   0.20;
let eta    = 0.00  2.00  -5.00;
let C      = 1.00
             0.50    1.00
             0.25    0.15   1.00;
C = xpnd(C);             
Omega = C .* omega .* omega';             

// MSN

{mu,Sigma} = momMSN(xi,Omega,eta);
rho = corrvc(Sigma); sd = sqrt(diag(Sigma));

print "-------------------------------------------";
print "   MU    SD";
print ftosa(100*(mu~sd),"%lf",3,2);
print "-------------------------------------------";
print "Correlation matrix";
print ftosa(rho,"%lf",3,2);
print "-------------------------------------------";

{xi_PnL,Omega_PnL,eta_PnL} = linMSN(xi,Omega,eta,x');
omega_PnL = sqrt(Omega_PnL);
Param_PnL = xi_PnL | omega_PnL | eta_PnL;
print "SN parameters of the P&L";
print ftosa(Param_PnL,"%lf",3,3);
print "-------------------------------------------";

VaR = -cdfSNi(0.01,xi_PnL,omega_PnL,eta_PnL);
print ftos(VaR,"VaR SN = %lf",3,2);

// MST

let nu = 1 2 3 4 5 6 7 8 10 50 1000 1000000;
nIters = rows(nu);
VaR = zeros(nIters,1);

i = 1;
do until i > nIters;
  {xi_PnL,Omega_PnL,eta_PnL,nu_PnL} = linMST(xi,Omega,eta,nu[i],x'); 
  omega_PnL = sqrt(Omega_PnL);
  VaR[i] = -cdfSTi(0.01,xi_PnL,omega_PnL,eta_PnL,nu_PnL);
  i = i + 1;
endo;

print "-------------------------------------------";
print ftosa(nu~VaR,"%lf",3,2); 

