new;
library frm,pgraph;
frmSet;

cls;

rndseed 123;
nS = 500000;

let nu = 5;
let x      = 500   200    300;
let xi     = 0.01 -0.02   0.15;
let omega  = 0.05  0.10   0.20;
let eta    = 0.00  2.00  -5.00;
let C      = 1.00
             0.50    1.00
             0.25    0.15   1.00;
nAssets = rows(eta);

C = xpnd(C);             
cov = C .* omega .* omega';             

u = rndMST(nS,xi,cov,eta,nu);
{mu,Sigma} = momMST(xi,cov,eta,nu);
rho = corrvc(Sigma); sd = sqrt(diag(Sigma));

mu_hat = meanc(u); Sigma_hat = vcx(u);
rho_hat = corrvc(Sigma_hat); sd_hat = sqrt(diag(Sigma_hat));

print "-------------------------------------------";
print "mean";
print ftosa(mu~mu_hat~(mu-mu_hat),"%lf",3,5);
print "-------------------------------------------";
print "SD";
print ftosa(sd~sd_hat~(sd-sd_hat),"%lf",3,5);
print "-------------------------------------------";
print "rho";
print ftosa(rho,"%lf",3,3);
print ftosa(rho_hat,"%lf",3,3);
print ftosa(rho-rho_hat,"%lf",3,3);
print "-------------------------------------------";

R = u;
PnL = R*x;

mu = meanc(PnL); 
sigma = stdc(PnL); 
gamma1 = Estimate_Skewness(PnL);
gamma2 = Estimate_Kurtosis(PnL) - 3.0;
VaR = -quantile(PnL,0.01);
M1 = mu | sigma | gamma1 | gamma2 | VaR;

{xi_PnL,Omega_PnL,eta_PnL,nu_PnL} = linMST(xi,cov,eta,nu,x');
omega_PnL = sqrt(Omega_PnL);

Param_PnL = xi_PnL | omega_PnL | eta_PnL | nu_PnL;
print "SN parameters of the P&L";
print ftosa(Param_PnL,"%lf",3,5);
print "-------------------------------------------";

{mu,sigma,gamma1,gamma2} = momST(xi_PnL,omega_PnL,eta_PnL,nu_PnL);
VaR = -cdfSTi(0.01,xi_PnL,omega_PnL,eta_PnL,nu_PnL);
M2 = mu | sigma | gamma1 | gamma2 | VaR;

print "Moments";
print ftosa(M1~M2,"%lf",3,5);
print "-------------------------------------------";
