new;
library frm,pgraph;
frmSet;

cls;

let xi     = 0.01  -0.02    0.15;
let omega  = 0.05   0.10    0.20;
let eta    = 0.00   10.0  -15.50;
let C      = 1.00
             0.35     1.00
             0.20    -0.50   1.00;
C = xpnd(C);      
call invpd(C);       
Omega = C .* omega .* omega';             

// MSN

{mu,Sigma} = momMSN(xi,Omega,eta);
rho = corrvc(Sigma); sd = sqrt(diag(Sigma));

print "-------------------------------------------";
print "   MU    SD";
print ftosa(100*(mu~sd),"%lf",3,2);
print "-------------------------------------------";
print "Correlation matrix";
print ftosa(rho,"%lf",3,2);
print "-------------------------------------------";

xi_assets = zeros(3,1);
omega_assets = zeros(3,1);
eta_assets = zeros(3,1);

i = 1;
do until i > 3;
  x = zeros(3,1); x[i] = 1.0;
  {xi_assets[i],Omega_assets[i],eta_assets[i]} = linMSN(xi,Omega,eta,x');
  i = i + 1;
endo;
omega_assets = sqrt(Omega_assets);

x = seqa(-0.50,0.90/250,251);
nX = rows(x);
nAssets = 3;
xi = xi_assets;
omega = omega_assets;
eta = eta_assets;

pdf = zeros(nX,nAssets);

i = 1;
do until i > nAssets;
  pdf[.,i] = pdfSN(x,xi[i],omega[i],eta[i]);
  i = i + 1;
endo;

{mu,sigma,gamma1,gamma2} = momSN(xi,omega,eta);
M = 100*mu ~ 100*sigma ~ gamma1 ~ gamma2;

print "-------------------------------------------------------------";
print ftosa(M,"%lf",3,2);
print "-------------------------------------------------------------";

pdf = missex(pdf, pdf .<= 1e-5);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;

  xtics(-50,40,10,2);
  xlabel("\216Return (in %)");
  _plegstr = "Asset 1\000Asset 2\000Asset 3";
  _plegctl = {2 5 1.5 5};
  xy(100*x,pdf);

