/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

let alpha = 0.95 0.96 0.97 0.975 0.98 0.985 0.99 0.995; 
c_VaR = cdfni(alpha);
c_ES = pdfn(cdfni(alpha))./(1-alpha);

results = 100*alpha' |
          c_VaR'    |
          c_ES'     ;
print ftosa(results,"%lf",3,2);
print;

declare matrix alpha_var;

proc rss(alpha);
  local u;
  u = cdfni(alpha_var) - pdfn(cdfni(alpha))/(1-alpha);
  retp(u);
endp;

let alpha = 0.90 0.95 0.99 0.999;
n_alpha = rows(alpha);
alpha_ES = zeros(n_alpha,1);

i = 1;
do until i > n_alpha;
  alpha_var = alpha[i];
  alpha_ES[i] = bisection(&rss,0.50,0.999999);
  i = i + 1;
endo;
alpha_VaR = alpha;
print ftosa(100*(alpha_VaR~alpha_ES),"%lf",3,4);


