new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
nDates = rows(Dates);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
print ftosa(Pt,"%lf",3,4);
let w = 10 20;
W_t = w .* Pt;
print ftosa(W_t,"W(t) = %lf",3,4);
print "-----------------------------------------------------";

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Rs = R[indx,.];

Cov = vcx(Rs);
sd = stdc(Rs);
corr = corrx(Rs);

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = cov;
call SpreadSheetWrite(xls_Results,xlsFileName,"C4",4); 

print "Standard deviation";
print ftosa(100*sd,"%lf",3,6);
print ftosa(100*corr[1,2],"Correlation = %lf",3,6);

sigma2_Pi = (1093.3^2) * (1.3611/100)^2 + (842.8^2) * (0.9468/100)^2 +
            2 * (12.0787/100) * 1093.3 * (1.3611/100) * 842.8 * (0.9468/100);  
print ftosa(sigma2_Pi,"sigma2(PI) = %lf",3,4);
sigma_PI = sqrt(sigma2_PI);
print ftosa(sigma_Pi,"sigma(PI) = %lf",3,4);

sigma_w = sqrt(W_t'*Cov*W_t);
print ftosa(sigma_w,"sigma(W) = %lf",3,4);

alpha = 0.99;
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR = %lf",3,2);
print "-----------------------------------------------------";

Begin_Date = 20071009;
End_Date = 20090309;

indx = selif(seqa(1,1,nDates),(Dates .>= Begin_Date) .and (Dates .<= End_Date));
nS = rows(indx);
Rs = R[indx,.];

Cov = vcx(Rs);
sd = stdc(Rs);
corr = corrx(Rs);

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = cov;
call SpreadSheetWrite(xls_Results,xlsFileName,"C10",4); 

print "Standard deviation";
print ftosa(100*sd,"%lf",3,4);
print ftosa(100*corr[1,2],"Correlation = %lf",3,4);

sigma_w = sqrt(W_t'*Cov*W_t);
print ftosa(sigma_w,"sigma(W) = %lf",3,4);

alpha = 0.99;
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR = %lf",3,2);




