new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO" "SPX";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
nDates = rows(Dates);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,1:2]';
print ftosa(Pt,"%lf",3,4);
let w = 10 20;
W_t = w .* Pt;
print ftosa(W_t,"W(t) = %lf",3,4);
print "-----------------------------------------------------";

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Rs = R[indx,.];

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = GaussDate_to_ExcelDate(Dates[indx])~Rs;
call SpreadSheetWrite(xls_Results,xlsFileName,"A3",5); 

y = Rs[.,1 2];
x = Rs[.,3];
c = ones(nS,1);
beta = zeros(2,1);
sigma_tilde = zeros(2,1);
sigma_m = stdc(x);
i = 1;
do until i > 2;
  b_ols = y[.,i]/(c~x);
  u = y[.,i] - c*b_ols[1] - x*b_ols[2];
  std = stdc(u);
  beta[i] = b_ols[2];
  sigma_tilde[i] = std;
  i = i + 1;
endo;

cov = vcx(y);
D = cov - beta*beta'*(sigma_m^2);
D = diagrv(eye(2),diag(D));
sd = sqrt(diag(D));

print "Standard deviation";
print ftosa(100*(sigma_tilde~sd),"%lf",3,4);
print "Beta";
print ftosa(Beta,"%lf",3,4);
print ftosa(100*sigma_m,"sigma_m = %lf",3,4);

alpha = 0.99;

cov = beta * beta' * (sigma_m)^2 + D;
sigma_w = sqrt(W_t'*Cov*W_t);
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR(+SR) = %lf",3,2);
print "-----------------------------------------------------";
cov = beta * beta' * (sigma_m)^2;
sigma_w = sqrt(W_t'*Cov*W_t);
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR(-SR) = %lf",3,2);
print "-----------------------------------------------------";

Begin_Date = 20071009;
End_Date = 20090309;

indx = selif(seqa(1,1,nDates),(Dates .>= Begin_Date) .and (Dates .<= End_Date));
nS = rows(indx);
Rs = R[indx,.];

y = Rs[.,1 2];
x = Rs[.,3];
c = ones(nS,1);
beta = zeros(2,1);
sigma_tilde = zeros(2,1);
sigma_m = stdc(x);
i = 1;
do until i > 2;
  b_ols = y[.,i]/(c~x);
  u = y[.,i] - c*b_ols[1] - x*b_ols[2];
  std = stdc(u);
  beta[i] = b_ols[2];
  sigma_tilde[i] = std;
  i = i + 1;
endo;

cov = vcx(y);
D = cov - beta*beta'*(sigma_m^2);
D = diagrv(eye(2),diag(D));
sd = sqrt(diag(D));

print "Standard deviation";
print ftosa(100*(sigma_tilde~sd),"%lf",3,6);
print "Beta";
print ftosa(Beta,"%lf",3,6);

cov = beta * beta' * (sigma_m)^2 + D;
sigma_w = sqrt(W_t'*Cov*W_t);
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR(+SR) = %lf",3,2);
print "-----------------------------------------------------";
cov = beta * beta' * (sigma_m)^2;
sigma_w = sqrt(W_t'*Cov*W_t);
VaR = cdfni(alpha) * sigma_w;
print ftosa(VaR,"VaR(-SR) = %lf",3,2);
print "-----------------------------------------------------";



