new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "zc";
loadm maturity = ^datFileName;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = selif(data,(data[.,1] .>= 20140101) .and (data[.,1] .<= 20141231));
R = data[.,2:cols(data)];
nR = cols(R);
cnd = sumr(R .== lag1(R)) .== nR;
data = delif(data,cnd);

Dates = data[.,1];
nDates = rows(Dates);
R = data[.,2:cols(data)]/100;

tau = seqa(1,1,5);
indx = indnv(tau,Maturity);
R = R[.,indx];

Notional = 100;
Coupon = 5;
Maturity = 5;
Ct_m = Coupon * ones(Maturity,1);
Ct_m[Maturity] = Ct_m[Maturity] + Notional;
t_m = seqa(1,1,Maturity);

Current_Date = Dates[nDates];
Rt_m = R[nDates,.]';
print stringDate(Current_Date,0);

P0 = Bond_Price(t_m,Ct_m,Rt_m);
nB = 10000;
Nominal = nB * P0;

dR = R - lag1(R);
{gVaR1,gVaR2,hVaR1,hVaR2,hVaR3,ES,results} = Compute_Bond_VaR(t_m,Ct_m,Rt_m,dR,0.99,1/260);

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = GaussDate_to_ExcelDate(Dates)~R~dR;
call SpreadSheetWrite(xls_Results,xlsFileName,"A3",6); 

Results = Results .* (1~1~100~1~1~1);

print ftos(P0,"Bond Price = %lf",5,2);
print ftosa(Nominal,"Nominal = %lf",3,2);
print;
print ftosa(Results,"%lf",3,3);
print;
print "---------------------------------------------------------------";
std = sqrt(diag(_frm_Sigma));
rho = _frm_Sigma ./ std ./ std';
print ftosa(1e4*std',"%lf",3,3);
print ftosa(100*rho,"%lf",3,3);
print "---------------------------------------------------------------";

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = _frm_Sigma;
call SpreadSheetWrite(xls_Results,xlsFileName,"C4",7); 

print ftos(nB*gVaR1,"Gaussian VaR                              = %lf",5,2);
print ftos(nB*gVaR2,"Gaussian VaR (without mean)               = %lf",5,2);
print ftos(nB*hVaR1,"Historical VaR                            = %lf",5,2);
print ftos(nB*hVaR2,"Historical VaR (with kernel smoothing)    = %lf",5,2);
print ftos(nB*hVaR3,"Historical VaR (with elliptic correction) = %lf",5,2);
print ftos(nB*ES,   "Expected Shortfall                        = %lf",5,2);
print "---------------------------------------------------------------";

VaR = Nb*gVaR2;
print VaR/Nominal;
K = 3 * sqrt(10) * VaR;
print ftosa(K,"K(VaR) = %lf",3,0);
print ftosa(100*K/Nominal,"K(VaR) = %lf",3,2);