new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "zc";
loadm maturity = ^datFileName;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = selif(data,(data[.,1] .>= 20140101) .and (data[.,1] .<= 20141231));
R = data[.,2:cols(data)];
nR = cols(R);
cnd = sumr(R .== lag1(R)) .== nR;
data = delif(data,cnd);

Dates = data[.,1];
nDates = rows(Dates);
R = data[.,2:cols(data)]/100;

tau = seqa(1,1,5);
indx = indnv(tau,Maturity);
R = R[.,indx];

Notional = 100;
Coupon = 5;
Maturity = 5;
Ct_m = Coupon * ones(Maturity,1);
Ct_m[Maturity] = Ct_m[Maturity] + Notional;
t_m = seqa(1,1,Maturity);

Current_Date = Dates[nDates];
Rt_m = R[nDates,.]';
print stringDate(Current_Date,0);

P0 = Bond_Price(t_m,Ct_m,Rt_m);
nB = 10000;
Nominal = nB * P0;

dR = R - lag1(R);
{gVaR1,gVaR2,hVaR1,hVaR2,hVaR3,ES,results} = Compute_Bond_VaR(t_m,Ct_m,Rt_m,dR,0.99,1/260);
{RC_gVaR1,RC_gVaR2,RC_hVaR1,RC_hVaR2,Rc_hVaR3,Rc_ES} = Compute_Bond_VaR_PCA(t_m,Ct_m,Rt_m,dR,0.99,1/260);

print "---------------------------------------------------------------";
std = sqrt(diag(_frm_Sigma));
rho = _frm_Sigma ./ std ./ std';
print ftosa(1e4*std',"%lf",3,3);
print ftosa(100*rho,"%lf",3,3);
pca = _frm_pca;
Lambda = vread(pca,"Lambda");
V = vread(pca,"V");
print;
print ftosa(1e8*diag(Lambda)',"%lf",3,3);
print ftosa(V,"%lf",3,3);

print "--------------------------------------------------------------------------------------------------------";
print ftosa(nB*(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES),"%lf",5,1);
print ftosa(nB*(sumc(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES)'),"%lf",5,1);
print ftosa(nB*(gVaR1~gVaR2~hVaR1~hVaR2~hVaR3~ES),"%lf",5,1);
print "--------------------------------------------------------------------------------------------------------";

results = nB*(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES) |
          nB*(sumc(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES)');
print ftosa(results',"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = _frm_Sigma;
call SpreadSheetWrite(xls_Results,xlsFileName,"C4",7); 

xls_Results = Lambda * 10^4;
call SpreadSheetWrite(xls_Results,xlsFileName,"C13",7); 
xls_Results = V;
call SpreadSheetWrite(xls_Results,xlsFileName,"C23",7); 

