new;
library frm,pgraph;

rndseed 123456;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "zc";
loadm maturity = ^datFileName;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = selif(data,(data[.,1] .>= 20140101) .and (data[.,1] .<= 20141231));
R = data[.,2:cols(data)];
nR = cols(R);
cnd = sumr(R .== lag1(R)) .== nR;
data = delif(data,cnd);

Dates = data[.,1];
nDates = rows(Dates);
R = data[.,2:cols(data)]/100;

tau = maturity;
let tau = 0.5 1.0 1.5 2.0 3.0 4.0 5.0 6.0 7.0 10.0 15.0 30.0;
nTau = rows(tau);
indx = indnv(tau,Maturity);
R = R[.,indx];

let tau  = 0.5  1.0  1.5   2.0   3.0  4.0  5.0  6.0  7.0  10.0 15.0 30.0;
let Ct_m = 400  300  200  -200  -300 -500   50  50  -600  700  300  200 ;
let Ct_m = 400  300  200  -200  -300 -500  500  400 -300 -700  300  700 ;
//let Ct_m = 1400 1000  1200  200  -300 -500  -500  -400 -300 -700  300  700 ;

t_m = tau;

Current_Date = Dates[nDates];
Rt_m = R[nDates,.]';
print stringDate(Current_Date,0);

P0 = Bond_Price(t_m,Ct_m,Rt_m);
nB = 1;
Nominal = nB * P0;

dR = R - lag1(R);
{gVaR1,gVaR2,hVaR1,hVaR2,hVaR3,ES,results} = Compute_Bond_VaR(t_m,Ct_m,Rt_m,dR,0.99,1/260);
{RC_gVaR1,RC_gVaR2,RC_hVaR1,RC_hVaR2,Rc_hVaR3,Rc_ES} = Compute_Bond_VaR_PCA(t_m,Ct_m,Rt_m,dR,0.99,1/260);

print "--------------------------------------------------------------------------------------------------------";
print ftosa(nB*(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES),"%lf",5,2);
print ftosa(nB*(sumc(RC_gVaR1~RC_gVaR2~RC_hVaR1~RC_hVaR2~RC_hVaR3~RC_ES)'),"%lf",5,2);
print ftosa(nB*(gVaR1~gVaR2~hVaR1~hVaR2~hVaR3~ES),"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

gVaR_PCA = cumsumc(RC_gVaR2);
hVaR_PCA = cumsumc(RC_hVaR1);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _pcolor = 1; _plwidth = 10;
  _pbarwid = -0.5;
  _pbartyp = {6 1,5 4};
  ytics(4,7,0.5,2);
  xtics(0,13,1,2);
  _plegstr = "Gaussian VaR\000Historical VaR";
  _plegctl = {2 5 7 5};
  xlabel("\216Number of risk factors");
  _pline = 1~3~0~gVaR2~15~gVaR2~1~1~10 |
           1~3~0~hVaR1~15~hVaR1~1~4~10 ;
  bar(0,gVaR_PCA~hVaR_PCA);