new;
library frm,pgraph,cml;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

let string selected_name = "SPX";
indx = indsav(selected_name,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = (R .== 0);
Dates = delif(Dates,cnd);
nDates = rows(Dates);
Prices = delif(Prices,cnd);
Rt = Prices ./ lag1(Prices) - 1;

BeginDate = 19991231;
LastDate = 20141231;
indx = selif(seqa(1,1,nDates), (Dates .>= BeginDate) .and (Dates .<= LastDate));
Rt = Rt[indx];
Dates = Dates[indx];
prices = prices[indx];
nDates = rows(dates);

t = dttodtv(1e6 * Dates);
t = t[.,1] + t[.,8]/365; 

// 260 days volatility
vol0 = 100 * Rolling_Volatility(Dates,prices,260);

// Garch ML
p = 1; q = 1;
{theta,cl,cov,logl} = regGarch(Rt,1,p,q,0);
vol1 = 100 * sqrt(_garch_h) * sqrt(260);

print ftosa(theta,"%lf",3,4);

// EWMA
lambda = 0.94;
vol2 = 100 * EWMA_Volatility(Dates,Prices,lambda);

// 20 days volatility
vol3 = 100 * Rolling_Volatility(Dates,prices,20);

x2 = vol1; y2 = vol0;
{x2,y2} = packr2(x2,y2);
indx2 = delif_closed_points(x2,y2,0.03);

x3 = vol1; y3 = vol2;
{x3,y3} = packr2(x3,y3);
indx3 = delif_closed_points(x3,y3,0.03);

x4 = vol1; y4 = vol3;
{x4,y4} = packr2(x4,y4);
indx4 = delif_closed_points(x4,y4,0.03);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pdate = 0; _pframe = 0; _pnum = 2;
  _plwidth = 10; _pltype = 6; _pcolor = 1;
  _paxht = 0.25; _pnumht = 0.20; _ptitlht = 0.275; 

  _pcolor = 1;
  setwind(1);
    title("\216GARCH(1,1)");
    ytics(0,100,20,2);
    xtics(2000,2015,3,2);
    let xlab = "2000" "03" "06" "09" "12" "15";
    asclabel(xlab,0);
    xy(t,vol1);

  _pline = 0; _plctrl = -1; _pstype = 4;
  xtics(0,100,20,2); 
  ytics(0,100,20,2);
  asclabel(0,0); 
  _pline = 1~3~0~0~100~100~1~0~10;

  _pcolor = 2;
  setwind(2);
    title("\216one-year volatility");
    xlabel("\216GARCH");
    ylabel("\2161Y");
    xy(x2[indx2],y2[indx2]);

  _pcolor = 3;
  setwind(3);
    title("\216EMWA (\202l\201 = 0.94)");
    xlabel("\216GARCH");
    ylabel("\216EMWA");
    xy(x3[indx3],y3[indx3]);

  _pcolor = 4; 
  setwind(4);
    title("\216Twenty-day volatility");
    xlabel("\216GARCH");
    ylabel("\21620D");
    xy(x4[indx4],y4[indx4]);

  endwind;

xlsFileName = "..\\results\\chap1-var.xlsx";
xls_Results = GaussDate_to_ExcelDate(Dates)~Rt~((vol1~vol0~vol2~vol3)/100);
call SpreadSheetWrite(xls_Results,xlsFileName,"A3",8); 


