new;
library frm,pgraph;
frmSet;

cls;

rndseed 1235;
rndseed 123456;

let x      = 500   200    300;
let xi     = 0.01  -0.02    0.15;
let omega  = 0.05   0.10    0.20;
let eta    = 0.00   10.0  -15.50;
let C      = 1.00
             0.35     1.00
             0.20    -0.50   1.00;
C = xpnd(C);             
Omega = C .* omega .* omega'; 

{xi_PnL,Omega_PnL,eta_PnL} = linMSN(xi,Omega,eta,x');
omega_PnL = sqrt(Omega_PnL);

VaR0 = -cdfSNi(0.01,xi_PnL,omega_PnL,eta_PnL);
print ftos(VaR0,"VaR SN = %lf",3,2);
            
nS = 10000; nR = 4;
VaR = miss(zeros(nS,nR),0);

iter = 1;
do until iter > 4;
  R = rndMSN(nS,xi,Omega,eta);
  PnL = R*x;
  i = 100;
  do until i > nS;
    VaR[i,iter] = -quantile(PnL[1:i],0.01);
    i = i + 1;
  endo;
  iter = iter + 1;
endo;

s = 5;
s = seqa(1,s,nS/s);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.275;

  xlabel("\216Number of simulations");
  ylabel("\216VaR");
  _pline = 1~3~0~VaR0~nS~VaR0~1~5~10;
  ytics(100,200,20,2);

  iter = 1;
  setwind(iter);
    title("\216First replication");
    xy(s,VaR[s,iter]);

  iter = 2;
  setwind(iter);
    title("\216Second replication");
    xy(s,VaR[s,iter]);

  iter = 3;
  setwind(iter);
    title("\216Third replication");
    xy(s,VaR[s,iter]);

  iter = 4;
  setwind(iter);
    title("\216Fourth replication");
    xy(s,VaR[s,iter]);

  endwind;
