new;
library frm,pgraph;

cls;

rndseed 123;

// Historical scenarios for the asset return

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var-option";
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
R_S = data[.,2];
Delta_Sigma = data[.,3];
nS = rows(R_S);

nC = 100;
S0 = 100;
K = 100;
Sigma0 = 0.20;
tau = 52/252;
b = 0.05;
r = 0.05;
C0 = 4.14;

// Value-at-risk

h = 1;
tau = tau - h/252;

S1 = S0 .* (1 + R_S);
Sigma1 = Sigma0 + Delta_Sigma;
C1 = EuropeanBS(S1,K,Sigma1,tau,b,r);
PnL = nC * (C1 - C0);

sc = seqa(1,1,nS);
Results = sc~100*R_S~S1~100*Delta_Sigma~100*Sigma1~C1~PnL;

print "-----------------------------------------------------------";
print ftosa(Results[1:9,.],"%lf",10,2);
print "-----------------------------------------------------------";
indx = sortind(PnL);
print ftosa(Results[indx[1:10],.],"%lf",10,2);
print "-----------------------------------------------------------";

alpha = 0.99;
VaR = -quantile(PnL,1-alpha);

print ftos(VaR,"VaR = %lf",10,2);

alpha = 0.975;
ES = Compute_ES(PnL,alpha);
print ftos(ES,"ES = %lf",10,2);


xls_results = sc~R_S~S1~Delta_Sigma~Sigma1~C1~PnL;
xlsFileName = "..\\results\\chap1-var.xlsx";
call SpreadSheetWrite(xls_Results,xlsFileName,"A3",11); 
