new;
library frm,pgraph;

cls;

rndseed 123;

S0 = 100;
K = 100;
Sigma = 0.20;
tau = 52/252;
b = 0.05;
r = 0.05;

C0 = EuropeanBS(S0,K,Sigma,tau,r,r);
Delta0 = EuropeanBS_Delta(S0,K,Sigma,tau,b,r);
Gamma0 = EuropeanBS_Gamma(S0,K,Sigma,tau,b,r);

h = 1;
tau = tau - h/252;

nX = 200;
x = seqa(-0.20,0.40/nX,nX);
S = S0 .* (1 + x);
C = EuropeanBS(S,K,Sigma,tau,b,r);
D = C0 + Delta0 * (S - S0);
G = C0 + Delta0 * (S - S0) + 0.5 * Gamma0 * (S - S0)^2;

h = 29;
tau = tau - h/252;
C2 = EuropeanBS(S,K,Sigma,tau,b,r);

graphset;
  _pdate = ""; _pnum =2; _pframe = 0;
  _pltype = 6|1|3|2; _plwidth = 10|10|10|15; _pcolor = 1|4|2|5; 
  _plctrl = 0|0|0|-2; _pstype = 8; _psymsiz = 1;
  xlabel("\216S]t+h[");
  ylabel("\216C]t+h[");
  xtics(80,120,5,2);
  ytics(-4,20,2,2);
  _plegstr = "Re-pricing\000Delta\000Delta-gamma\000Re-pricing (h = 30 days)";
  _plegctl = {2 5 1.5 5};
  _pline = 1~3~S0~-4~S0~C0~1~0~10 |
           1~3~80~C0~S0~C0~1~0~10;
  _psym = S0~C0~8~2~0~1~10;
  xy(S,C~D~G~C2);


