/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
print ftosa(Pt,"%lf",3,4);
let w = 10 20;
Pw_t = sumc(w .* Pt);
print ftosa(Pw_t,"Pw(t) = %lf",3,4);
print "-----------------------------------------------------";

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Ps = Prices[indx,.];
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pi1_s = w[1] * (Pt_s[.,1] - Pt[1]);
Pi2_s = w[2] * (Pt_s[.,2] - Pt[2]);
Pi_s = Pi1_s + Pi2_s;

Results = Dates[indx]~Ps[.,1]~100*Rs[.,1]~Ps[.,2]~100*Rs[.,2]~Pt_s~Pi1_s~Pi2_s~Pi_s;

indx_os = sortind(Pi_s);
Loss = -Pi_s;
VaR = 0.5 * (Loss[indx_os[2]] + Loss[indx_os[3]]);
print ftosa(VaR,"VaR = %lf",3,2);
RC1 = -0.5 * (Pi1_s[indx_os[2]] + Pi1_s[indx_os[3]]);
RC2 = -0.5 * (Pi2_s[indx_os[2]] + Pi2_s[indx_os[3]]);
rc = rc1|rc2;

mr = rc ./ w;
prc = rc / VaR;
Results = miss(zeros(3,4),0);
Results[1:2,1:4] = (w~mr~rc~100*prc);
Results[3,3] = sumc(rc);
print ftosa(Results,"%lf",3,2);

w = (w .* Pt)/Pw_t;
mr = rc ./ w;
prc = rc / VaR;
Results = miss(zeros(3,4),0);
Results[1:2,1:4] = (100*w~mr~rc~100*prc);
Results[3,3] = sumc(rc);
print ftosa(Results,"%lf",3,2);

RC1 = -(1/2)*(10*(105.16-109.33)+10*(104.72-109.33));
RC2 = -(1/2)*(20*(41.65-42.14)+20*(42.28-42.14));

print ftosa(RC1|RC2,"%lf",3,2);

Results = Dates[indx]~Ps[.,1]~100*Rs[.,1]~Ps[.,2]~100*Rs[.,2]~100*Rs[.,1]~Pt_s[.,1]~100*Rs[.,2]~Pt_s[.,2]~Pi1_s~Pi2_s~Pi_s;

str_Results = stringDate(Results[.,1],0) $~ ftosa(Results[.,2:12],"%lf",3,2); 

indx = seqa(250,-1,10)|indx_os[1:5]|1; 
indx = rev(sortc(indx,1));
s = 250 - indx + 1;
str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1:5]; 
print str;
str = ftosa(s,"%lf",3,0) $~ str_Results[indx,1 6:12]; 
print str;



