/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

cls;

rndseed 123;

theta = 2;

mu1 = 0.10;
sigma1 = 0.20;
nu1 = 6;
w1 = 100.00;

mu2 = 0.10;
sigma2 = 0.25;
nu2 = 4;
w2 = 200.00;

w = w1|w2;

alpha = 0.90;
nS = 5000;
nR = 10000;

m1 = nS;
indx_alpha = m1 * alpha;
varpi = zeros(m1,1);
varpi[indx_alpha] = 1.0;
varpi1 = varpi;

m1 = nS;
indx_alpha = m1 * alpha;
h = 2.5/100;
h = h * m1;
indx = seqa(indx_alpha-h,1,2*h+1);
varpi = zeros(m1,1);
varpi[indx] = ones(2*h+1,1)/(2*h+1);
varpi2 = varpi;

m2 = 1000;
indx_alpha = m2 * alpha;
h = 2.5/100;
h = h * m2;
indx = seqa(indx_alpha-h,1,2*h+1);
varpi = zeros(m2,1);
varpi[indx] = ones(2*h+1,1)/(2*h+1);
varpi3 = varpi;

RC_VaR = zeros(nR,6);

k = 1;
do until k > nR;
  {u1,u2} = rndCopulaClayton(theta,nS);

  L1 = mu1 + sigma1 * cdfti(u1,nu1);
  L2 = mu2 + sigma2 * cdfti(u2,nu2);

  L1 = w1 * L1;
  L2 = w2 * L2;
  L = L1~L2;

  {VaR,RC} = Compute_RC_Historical_VaR(L,varpi1);
  RC_VaR[k,1] = RC[1];
  Historical_VaR = VaR;

  {VaR,RC} = Compute_RC_Historical_VaR(L,varpi2);
  RC_VaR[k,2] = RC[1];
  Historical_VaR = VaR;

  {VaR,RC} = Compute_RC_Historical_VaR(L[1:m2,.],varpi3);
  RC_VaR[k,3] = RC[1];

  {VaR,RC} = Compute_RC_Historical_VaR(L,alpha);
  RC_VaR[k,4] = RC[1];

  {VaR,RC} = Compute_RC_Historical_VaR(L,-Historical_VaR);
  RC_VaR[k,5] = RC[1];

  mu = meanc(L);
  cov = vcx(L);
  {VaR,mr,RC,prc} = Compute_RC_Gaussian_VaR(1|1,mu,cov,alpha);
  RC_VaR[k,6] = RC[1];

  k = k + 1;
endo;

x = seqa3(0,20,40,60,100,200,50);
{d,F} = regKernelDensity(RC_VaR,x);

d = missex(d,d .<= 0.000001);

RC1 = meanc(RC_VaR[.,1]);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.25;  _ptitlht = 0.275;  _pnumht = 0.20; 
  _pltype = 6|1|3; _plwidth = 10; 
  xtics(0,0.50,0.10,2);

  setwind(1);
    xtics(0,60,10,2);
    ytics(0,0.3,0.1,2);
    _pcolor = 4|1|2; _pltype = 1|6|3;
    _plegstr = "n]S[ = 5000, h = 0%\000n]S[ = 5000, h = 2.5%\000n]S[ = 1000, h = 2.5%";
    _plegctl = {2 5 7 3};
    _pline = 1~6~RC1~0~RC1~1~1~0~10;
    xy(x,d[.,1 2 3]);

  setwind(2);
    xtics(20,35,5,2);
    ytics(0,0.6,0.1,2);
    _pcolor = 1|2|4; _pltype = 6|1|3;
    _plegstr = "Weighting\000Elliptical\000Kernel";
    _plegctl = {2 5 6 3};
    xy(x,d[.,2 4 5]);

  setwind(3);
    xtics(0,40,10,2);
    ytics(0,0.6,0.1,2);
    _plegstr = "Weighting\000Gaussian";
    _plegctl = {2 5 6.5 5};
    xy(x,d[.,2 6]);

  endwind;    
