/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
let w = 10 20;

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pi1_s = w[1] * (Pt_s[.,1] - Pt[1]);
Pi2_s = w[2] * (Pt_s[.,2] - Pt[2]);
L1_s = -Pi1_s;
L2_s = -Pi2_s;
Li_s = L1_s~L2_s;

Results = zeros(3,5);
alpha = 0.99;

let mu = 0.0 0.0;
cov = vcx(Rs);
{VaR,mr,RC,prc} = Compute_RC_Gaussian_VaR(w .* Pt,mu,cov,alpha);
Results[.,1] = RC|VaR;

w = zeros(nS,1);
w[248:249] = 0.5|0.5;

{VaR,RC} = Compute_RC_Historical_VaR(Li_s,w);
Results[.,2] = RC|VaR;
Historical_VaR = VaR;

w = zeros(nS,1);
w[247:250] = 0.25|0.25|0.25|0.25;

{VaR,RC} = Compute_RC_Historical_VaR(Li_s,w);
Results[.,3] = RC|VaR;

{VaR,RC} = Compute_RC_Historical_VaR(Li_s,0.99);
Results[.,4] = RC|VaR;

{VaR,RC} = Compute_RC_Historical_VaR(Li_s,Historical_VaR);
Results[.,5] = RC|VaR;

print ftosa(Results,"%lf",3,2);



