/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

datPathName = "..\\..\\Data\\";
datFileName = datPathName $+ "var";
loads info = ^datFileName;

data = loadd(datFileName);
data = selif(data,data[.,1] .>= 20070531);
vnames = "" $+ getname(datFileName);

let string selected_tickers = "AAPL" "KO";
n = rows(selected_tickers);
indx = indsav(selected_tickers,vnames);
Prices = data[.,indx];
Dates = data[.,1];
R = Prices./lag1(Prices) - 1.0;
cnd = sumr(R .== 0) .== n;
Dates = delif(Dates,cnd);
Prices = delif(Prices,cnd);
R = Prices ./ lag1(Prices) - 1;

t = 20150102;
indx_t = indnv(t,Dates);
Pt = Prices[indx_t,.]';
let w = 10 20;
Pw_t = sumc(w .* Pt);

nS = 250;
indx = seqa(indx_t-nS+1,1,nS);
Rs = R[indx,.];
Pt_s = Pt' .* (1 + Rs);
Pi1_s = w[1] * (Pt_s[.,1] - Pt[1]);
Pi2_s = w[2] * (Pt_s[.,2] - Pt[2]);
L1_s = -Pi1_s;
L2_s = -Pi2_s;
Li_s = L1_s~L2_s;

Results = zeros(3,4);

let mu = 0.0 0.0;
cov = vcx(Rs);
{VaR,mr,RC_VaR,prc} = Compute_RC_Gaussian_VaR(w .* Pt,mu,cov,0.99);
Results[.,1] = RC_VaR|VaR;
{ES,mr,RC_ES,prc} = Compute_RC_Gaussian_ES(w .* Pt,mu,cov,0.99);
Results[.,2] = RC_ES|ES;
{ES,RC_ES} = Compute_RC_Historical_ES(Li_s,0.99);
Results[.,3] = RC_ES|ES;
{ES,RC_ES} = Compute_RC_Historical_ES(Li_s,0.975);
Results[.,4] = RC_ES|ES;

print ftosa(Results,"%lf",3,2);

w = (w .* Pt)/Pw_t;

{ES,RC_ES} = Compute_RC_Historical_ES(Li_s,0.99);
MR_ES = RC_ES ./ w;
PRC_ES = RC_ES / ES;
Results = miss(zeros(3,4),0);
Results[1:2,1:4] = (100*w~MR_ES~RC_ES~100*PRC_ES);
Results[3,3] = sumc(RC_ES);
print ftosa(Results,"%lf",3,2);

{ES,RC_ES} = Compute_RC_Historical_ES(Li_s,0.975);
MR_ES = RC_ES ./ w;
PRC_ES = RC_ES / ES;
Results = miss(zeros(3,4),0);
Results[1:2,1:4] = (100*w~MR_ES~RC_ES~100*PRC_ES);
Results[3,3] = sumc(RC_ES);
print ftosa(Results,"%lf",3,2);

alpha = 0.99;
L_s = sumr(Li_s);
VaR = -quantile(-L_s,1-alpha);
Li_s = selif(Li_s, L_s .>= VaR);
print ftosa(Li_s,"%lf",3,2);







