/*
**> Thierry Roncalli
**
**> Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??
**
*/

new;
library frm,pgraph;

cls;

cls;

rndseed 123;

theta = 2;

mu1 = 0.10;
sigma1 = 0.20;
nu1 = 6;
w1 = 100.00;

mu2 = 0.10;
sigma2 = 0.25;
nu2 = 4;
w2 = 200.00;

w = w1|w2;

alpha = 0.99;
nS = 5000;
nR = 10000;

m1 = nS;
indx_alpha = m1 * alpha;
varpi = zeros(m1,1);
varpi[indx_alpha] = 1.0;
varpi1 = varpi;

m1 = nS;
indx_alpha = m1 * alpha;
h = 0.5/100;
h = h * m1;
indx = seqa(indx_alpha-h,1,2*h+1);
varpi = zeros(m1,1);
varpi[indx] = ones(2*h+1,1)/(2*h+1);
varpi2 = varpi;

RC_VaR = zeros(nR,2);
RC_ES = zeros(nR,1);

k = 1;
do until k > nR;
  {u1,u2} = rndCopulaClayton(theta,nS);

  L1 = mu1 + sigma1 * cdfti(u1,nu1);
  L2 = mu2 + sigma2 * cdfti(u2,nu2);

  L1 = w1 * L1;
  L2 = w2 * L2;
  L = L1~L2;

  {VaR,RC} = Compute_RC_Historical_VaR(L,varpi1);
  RC_VaR[k,1] = RC[1];

  {VaR,RC} = Compute_RC_Historical_VaR(L,varpi2);
  RC_VaR[k,2] = RC[1];

  {ES,RC} = Compute_RC_Historical_ES(L,0.975);
  RC_ES[k,1] = RC[1];

  k = k + 1;
endo;

RC = RC_VaR~RC_ES;

x = seqa3(0,20,40,60,100,200,50);
{d,F} = regKernelDensity(RC,x);
d = missex(d,d .<= 0.000001);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4;
  _plegstr = "VaR 99%\000VaR 99% (weighting)\000ES 97.5%";
  _plegctl = {2 5 5.75 5};
  ytics(0,0.15,0.025,2);
  xy(x,d);