/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 2.4.10
**
*/

new;
library frm,pgraph;


cls;

/*
**> Question 1
**
*/

print;
print "=====================  Question 1  =======================================";

let sigma = 0.25 0.20;
let rho[2,2] =  1.00 -0.20
               -0.20  1.00;
cov = rho .* sigma .* sigma';

let w = 400 600;
sigma_PI = sqrt(w'cov*w);
print ftos(sigma_PI^2,"var(P&L) = %lf",3,2);
print ftos(sigma_PI,"sigma(PI) = %lf",3,2);

ES_1Y = 2.34 * sigma_PI;
ES_10D = sqrt(10/260) * ES_1Y;
print ftos(ES_1Y,"ES(1-year) = %lf",3,2);
print ftos(ES_10D,"ES(10-day) = %lf",3,2);

/*
**> Question 2
**
*/

print;
print "=====================  Question 2  =======================================";

let R_A = -3 -4 -3 -5 -6  3  1 -1;
let R_B = -4  1 -2 -1  2 -7 -3 -2;
R_A = R_A / 100;
R_B = R_B / 100;

PI_s = 400*R_A + 600*R_B;
s = seqa(1,1,8);
Pi_sorted = sortc(Pi_s,1);
ES_1D = -meanc(Pi_sorted[1:6]);
ES_10D = sqrt(10) * ES_1D;

print ftosa(s~Pi_s~Pi_sorted,"%lf",3,0~2~2);
print ftos(ES_1D,"ES(1-day) = %lf",3,2);
print ftos(ES_10D,"ES(10-day) = %lf",3,2);

