new;
library qam,frm,pgraph,optmum;

rndseed 123;

cls;

P_A = 50;
n_A = 2;

P_B = 20;
n_B = 5;

sigma_A = 0.25;
sigma_B = 0.20;
rho_AB = 0.125;

W_A = n_A * P_A;
W_B = -n_B * P_B;

sigma_x = sqrt(W_A^2 * sigma_A^2 + W_B^2 * sigma_B^2 + 2 * W_A * W_B * rho_AB * sigma_A * sigma_B);
print ftos(sigma_x^2,"var(x) = %lf",3,2);
print ftos(sigma_x,"sigma(x) = %lf",3,2);

sigma_x = sigma_x * sqrt(10/260);
print ftos(sigma_x,"sigma(x) = %lf",3,2);
print;

alpha_VaR = 0.99;
VaR_x = cdfni(alpha_VaR) * sigma_x;
alpha_ES = 0.975;
ES_x = pdfn(cdfni(alpha_ES))/(1-alpha_ES) * sigma_x;
print ftos(VaR_x,"VaR(x) = %lf",3,2);
print ftos(ES_x,"ES(x) = %lf",3,2);

sigma = sigma_A | sigma_B;
sigma = sigma * sqrt(1/260);
cov = xpnd(1|rho_AB|1) .* sigma .* sigma';
R = rndmn(0,cov,250);

nu = 7;
{u1,u2} = rndCopulaStudent2(rho_AB,nu,250);
R_A = sigma[1] * cdfti(u1,nu);
R_B = sigma[2] * cdfti(u2,nu);
R_A = trunc(1000*R_A)/1000;
R_B = trunc(1000*R_B)/1000;

PnL = R_A - R_B;
indx = sortind(PnL);
n = 10;
indx = indx[1:n];
results = R_A~R_B~PnL;
results = results[indx,.];
print ftosa(100*results',"%lf",3,1);

PnL = 100*PnL;
VaR_x = -quantile(PnL,0.01);
print ftos(VaR_x,"VaR(x) = %lf",3,2);
ES_x = -meanc(PnL[indx[1:6]]);
print ftos(ES_x,"ES(x) = %lf",3,2);

VaR_x = sqrt(10) * VaR_x;
ES_x = sqrt(10) * ES_x;
print ftos(VaR_x,"VaR(x) = %lf",3,2);
print ftos(ES_x,"ES(x) = %lf",3,2);

m = 3.0;
CC1 = m * VaR_x;
SVaR_x = 2*VaR_x;
CC2 = m * (VaR_x + SVaR_x);
CC3 = m * 3 * ES_x;
CC = CC1|CC2|CC3;
print ftosa(CC,"%lf",3,2);






