/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 2.4.2
**
*/

new;
library frm,pgraph;

cls;

print;
print "=====================  Question 1.  =======================================";

let cov[3,3] = 0.04  0.03  0.02
               0.03  0.05 -0.01
               0.02 -0.01  0.06;
               
sigma = sqrt(diag(cov));
print ftosa(100*sigma,"%lf",3,2);
rho = cov ./ sigma ./ sigma';
print ftosa(100*rho,"%lf",3,2);

print;
print "=====================  Question 2.  =======================================";

let sigma = 0.10 0.20 0.30;
let rho   = 1.00 
            0.50  1.00
            0.25  0.00  1.00;
rho = xpnd(rho);               
cov = rho .* sigma .* sigma';
print ftosa(100*cov,"%lf",3,3);

vol = zeros(3,1);
let w = 0.50  0.50 0.0;
vol[1] = sqrt(w'cov*w);

let w = 0.60 -0.40 0.0;
vol[2] = sqrt(w'cov*w);

let w = 150 500 -200;
vol[3] = sqrt(w'cov*w);

print ftosa(vol~vol^2,"%lf",3,4);

print;
print "=====================  Question 3.  =======================================";

let beta = 0.9 1.3 0.1;
sigma_m = 0.20;
let sigma_tilde = 0.05 0.05 0.15;
D = diagrv(eye(3),sigma_tilde^2);
cov = beta*beta' * (sigma_m^2) + D;
sigma = sqrt(diag(cov));
rho = cov ./ sigma ./ sigma';

print ftosa(100*sigma,"%lf",3,2);
print ftosa(100*rho,"%lf",3,2);

print;
print "=====================  Question 4.  =======================================";

let sigma = 0.10 0.20 0.30;
let rho   = 1.00 
            0.50  1.00
            0.25  0.00  1.00;
rho = xpnd(rho);               
cov_X = rho .* sigma .* sigma';
let mu_X = 0.00 0.00 0.00;

sigma = sqrt(1/12) * ones(3,1);
cov_Y = eye(3) .* sigma .* sigma';
let mu_Y = 0.50 0.50 0.50;

nS = 1000000;
X = rndmvn_chol(mu_X,cov_X,nS);
Y = rndu(nS,3);
Z = X .* Y;
cov_Z = vcx(Z);

print ftosa(100*cov_Z,"%lf",3,3);

mu_Z = mu_X .* mu_Y;
cov_Z = cov_X .* cov_Y + 
        cov_X .* mu_Y .* mu_Y' + 
        cov_Y .* mu_X .* mu_X';
        
print ftosa(100*cov_Z,"%lf",3,3);        
  
        alpha = 0.99;
let w = 150 500 -200;
vol = sqrt(w'cov_Z*w);
VaR = cdfni(alpha) * vol;

print ftos(VaR,"VaR = %lf",3,2);

PnL = Z*w;
VaR = -quantile(PnL,1-alpha);
print ftos(VaR,"VaR = %lf",3,2);

x = seqa(-300,600/200,201);
{d1,F} = regKernelDensity(PnL[1:50000],x);
d2 = pdfn2(x,0,vol);
d = d1~d2;

graphset;
  _pdate = ""; _pnum =2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xlabel("\216P&L (in $)");
  xtics(-300,300,100,0);
  _plegstr = "Exact distribution\000Normal approximation";
  _plegctl = {2 5 5.5 5.5};
  xy(x,d);
  


