/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 2.4.3
**
*/

new;
library frm,pgraph;

cls;

print;
print "=====================  Question 1.d  =======================================";

proc approx(x,n); 
  local y;
  if n == 6;
    y = pdfn(x)./x - pdfn(x)./(x^3) + 3 * pdfn(x)./(x^5) - 3 * 5 * pdfn(x)./(x^7) + 3 * 5 * 7 * pdfn(x)./(x^9) - 3 * 5 * 7 * 9 * pdfn(x)./(x^11) ;
  elseif n == 5;
    y = pdfn(x)./x - pdfn(x)./(x^3) + 3 * pdfn(x)./(x^5) - 3 * 5 * pdfn(x)./(x^7) + 3 * 5 * 7 * pdfn(x)./(x^9) ;
  elseif n == 4;
    y = pdfn(x)./x - pdfn(x)./(x^3) + 3 * pdfn(x)./(x^5) - 3 * 5 * pdfn(x)./(x^7) ;
  elseif n == 3;
    y = pdfn(x)./x - pdfn(x)./(x^3) + 3 * pdfn(x)./(x^5) ;
  elseif n == 2;
    y = pdfn(x)./x;
  else;
    y = pdfn(x)./x;
  endif;

  retp(y);
endp;

x = seqa(2,0.1,301);
y = cdfnc(x)~approx(x,1)~approx(x,4)~approx(x,5);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|4; _pcolor = 1|2|3|4|5; _plwidth = 10;
  xtics(1.5,4.0,0.5,2);
  ytics(0,3,0.5,2);
  xlabel("\216x");
  ylabel("\216Probability (in %)");
  _plegstr = "1-\202F\201(x)\000order 1\000order 4\000order 5";
  _plegctl = {2 5 5 4};
  xy(x,100*y);

print;
print "=====================  Question 3.b  =======================================";

let L = 0   1   2   3   4   5   6   7   8;
let p = 0.2 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;

L1 = L;
p1 = P;

L2 = L;
p2 = P;

p = diagrv(zeros(9,9),p);
p[7:9,7:9] = (0~0~0.1) |
             (0~0.1~0) |
             (0.1~0~0.0) ;
if not ( (sumc(p) == p1) and (sumr(p) == p2) );
  errorlog "error";
  end;
endif;

L = L2 + L1';
data = vecr(L)~vecr(p);
data = delif(data,data[.,2] .== 0);

L12 = unique(data[.,1],1);
pdf12 = countwts(data[.,1],L12,data[.,2]);
cdf12 = cumsumc(pdf12);
Results = L12~pdf12~cdf12;
print ftosa(Results',"%lf",3,2);

