/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 2.4.6
**
*/

new;
library frm,pgraph;

cls;

print "=====================  Question 1.a  =======================================";

S0 = 100; K = 108;
sigma0 = 0.20;
tau = 1;
r = 0.05;
b = r;

C0 = EuropeanBS(S0,K,sigma0,tau,b,r);
Delta0 = EuropeanBS_Delta(S0,K,sigma0,tau,b,r);
Gamma0 = EuropeanBS_Gamma(S0,K,sigma0,tau,b,r);
Vega0 = EuropeanBS_Vega(S0,K,sigma0,tau,b,r);
print ftosa(C0|Delta0|Gamma0|Vega0,"%lf",3,2);
print "-----------------------------------------------";

Delta0 = 0.49;
Gamma0 = 0.02;
Vega0 = 40;

S1 = 97;
Sigma1 = Sigma0;
C1 = EuropeanBS(S1,K,sigma1,tau,b,r);
PnL = -1 * (C1 - C0);
print /flush ftos(Pnl,"P&L(t,t+1) = %lf",3,2);
print "-----------------------------------------------";

dS = S1 - S0;
dSigma = Sigma1 - Sigma0;

PnL_Delta = -Delta0 .* dS;
PnL_Gamma = -0.5 * Gamma0 .* dS^2;
PnL_Vega = -Vega0 .* dSigma;

print ftosa(PnL_Delta|PnL_Gamma|Pnl_Vega,"%lf",3,2);
print;
print ftos(PnL_Delta + PnL_Gamma + PnL_Vega,"P&L(t,t+1) = %lf",3,2);
print;

print "=====================  Question 1.b  =======================================";

Delta1 = EuropeanBS_Delta(S1,K,sigma1,tau,b,r);
Gamma1 = EuropeanBS_Gamma(S1,K,sigma1,tau,b,r);
Vega1 = EuropeanBS_Vega(S1,K,sigma1,tau,b,r);
print ftosa(C1|Delta1|Gamma1|Vega1,"%lf",3,3);
print "-----------------------------------------------";

S2 = S1;
Sigma2 = 0.22;
C2 = EuropeanBS(S2,K,sigma2,tau,b,r);
PnL = -1 * (C2 - C1);
print /flush ftos(Pnl, "P&L(t+1,t+2) = %lf",3,2);
C1 = 6.78 - 1.37;
C2 = 6.17;
PnL = -1 * (C2 - C1);
print /flush ftos(Pnl, "P&L(t+1,t+2) = %lf",3,2);
print "-----------------------------------------------";

Delta1 = 0.43;
Gamma1 = 0.02;
Vega1 = 38;

dS = S2 - S1;
dSigma = Sigma2 - Sigma1;

PnL_Delta = -Delta1 .* dS;
PnL_Gamma = -0.5 * Gamma1 .* dS^2;
PnL_Vega = -Vega1 .* dSigma;

print ftosa(PnL_Delta|PnL_Gamma|Pnl_Vega,"%lf",3,2);
print;

print ftos(PnL_Delta + PnL_Gamma + PnL_Vega,"P&L(t,t+1) = %lf",3,2);
print;

print "=====================  Question 1.c  =======================================";

Delta2 = EuropeanBS_Delta(S2,K,sigma2,tau,b,r);
Gamma2 = EuropeanBS_Gamma(S2,K,sigma2,tau,b,r);
Vega2 = EuropeanBS_Vega(S2,K,sigma2,tau,b,r);
print ftosa(C2|Delta2|Gamma2|Vega2,"%lf",3,3);
print "-----------------------------------------------";

S3 = 95;
Sigma3 = 0.19;
C3 = EuropeanBS(S3,K,sigma3,tau,b,r);
PnL = -1 * (C3 - C2);
print /flush ftos(Pnl, "P&L(t+2,t+3) = %lf",3,2);
print "-----------------------------------------------";

Delta2 = 0.44;
Gamma2 = 0.018;
Vega2 = 38;

dS = S3 - S2;
dSigma = Sigma3 - Sigma2;

PnL_Delta = -Delta2 .* dS;
PnL_Gamma = -0.5 * Gamma2 .* dS^2;
PnL_Vega = -Vega2 .* dSigma;

print ftosa(PnL_Delta|PnL_Gamma|Pnl_Vega,"%lf",3,2);
print;

print ftos(PnL_Delta + PnL_Gamma + PnL_Vega,"P&L(t,t+1) = %lf",3,3);
print;
