/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 2.4.7
**
*/

new;
library frm,pgraph;

cls;

print "=====================  Question 3.a  =======================================";

S0 = 100; 
let K[1,5] = 80 95 100 105 120;
sigma = 0.20;
tau0 = 1;
r = 0.05;
b = r;

C0 = EuropeanBS(S0,K,sigma,tau0,b,r);
Delta0 = EuropeanBS_Delta(S0,K,sigma,tau0,b,r);
Gamma0 = EuropeanBS_Gamma(S0,K,sigma,tau0,b,r);
Theta0 = EuropeanBS_Theta(S0,K,sigma,tau0,b,r);
print ftosa(C0|Delta0|Gamma0|Theta0,"%lf",3,3);
print;

print "=====================  Question 3.b  =======================================";
print;

tau1 = tau0 - 1/260;
S1 = 102;
C1 = EuropeanBS(S1,K,sigma,tau1,b,r);
print ftosa(C1,"%lf",3,3);
print "----------------------------------------------------------------------------";
PnL = C1 - C0;
print ftosa(PnL,"%lf",3,3);
print;

print "=====================  Question 3.c  =======================================";
print;

dS = S1 - S0;
dT = -(tau1 - tau0);

PnL_Delta = Delta0 .* dS;
PnL_Gamma = 0.5 * Gamma0 .* dS^2;
PnL_Theta = Theta0 .* dT;

PnL = PnL_Delta | (PnL_Delta + PnL_Gamma) | (PnL_Delta + PnL_Theta) | (PnL_Delta + PnL_Gamma + PnL_Theta);
print ftosa(PnL,"%lf",3,3);
print;
 
print "=====================  Question 3.d  =======================================";
print;

tau2 = tau0 - 6/12;
S2 = 148;
C2 = EuropeanBS(S2,K,sigma,tau2,b,r);
print ftosa(C2,"%lf",3,3);
print "----------------------------------------------------------------------------";
PnL = C2 - C0;
print ftosa(PnL,"%lf",3,3);
print;

dS = S2 - S0;
dT = -(tau2 - tau0);

PnL_Delta = Delta0 .* dS;
PnL_Gamma = 0.5 * Gamma0 .* dS^2;
PnL_Theta = Theta0 .* dT;

PnL = PnL_Delta | (PnL_Delta + PnL_Gamma) | (PnL_Delta + PnL_Theta) | (PnL_Delta + PnL_Gamma + PnL_Theta);
print ftosa(PnL,"%lf",3,3);
 




