new;
library frm,pgraph,optmum;

cls;

rndseed 123;

N = 7;
K = 5;

T = 6;

__output = 1;

declare matrix alpha = 0.12;

proc (1) = f(t,state,control);
  local y;
  y = -1/state - (alpha/t)*(control - state)^2;
  retp(y);
endp;

proc (1) = g(t,state,control);
  local new_state;
  new_state = state + 2;
  if new_state > N;
    new_state = 1;
  endif;
  retp(new_state);
endp;

hT = rndu(N,1);

output file = app-1-3-1.out reset;

{H,V} = Bellman_Optimize(N,K,T,&f,&g,hT);

{H,V,Bell,Commandes,Etats} = Bellman_PrintTree(Bellman_Optimize(N,K,T,&f,&g,hT),&g,0);

{H,V,Bell,Commandes,Etats} = Bellman_PrintTree(Bellman_Optimize(N,K,T,&f,&g,hT),&g,1);

state = seqa(1,1,N);
control = seqa(1,1,K);

proc hT_proc(T,state);
  retp(hT);
endp;

{t,H_t,V_t} = Bellman_Optimize2(state,control,T,&f,&g,&hT_proc);

if not (H == H_t);
  errorlog("error");
  end;
endif;

if not (V == V_t);
  errorlog("error");
  end;
endif;

print ftosa(H,"%lf",10,3);

print ftosa(V,"%lf",10,3);

output off;