new;
library frm,pgraph,optmum;

cls;

N = 4; 
K = 8;
T = 5;

alpha = 0.02;
beta = 0.01;
gamma_ = 0.01;

proc (1) = f_proc(t,state,control);
  local y;
  y = -1/state * ln(state) - (alpha/t)*(control-state)^2 + beta*control + gamma_ * sqrt(state) * exp(sin(state));
  retp(y);
endp;

proc (1) = g_proc(t,state,control);
  local new_state;
  new_state = state;
  retp(new_state);
endp;

state = seqa(1,0.5,N);
control = seqa(1,1,K);

proc hT_proc(T,state);
  local hT;
  hT = 2*state - 1;
  retp(hT);
endp;

output file = app-1-3-2.out reset;

{t,H,V} = Bellman_Optimize2(state,control,T,&f_proc,&g_proc,&hT_proc);

print ftosa(H,"%lf",3,2);
print ftosa(V,"%lf",1,0);

output off;