new;
library frm,pgraph,optmum;

cls;

N = 100; 
K = 25;
T = 100; 

alpha = 0.02;
beta = 0.01;
gamma_ = 0.01;

proc (1) = f_proc(t,state,control);
  local y;
  y = -1/state * ln(state) - (alpha/t)*(control-state)^2 + beta*control + gamma_ * sqrt(state) * exp(sin(state));
  retp(y);
endp;

proc (1) = g_proc(t,state,control);
  local new_state;
  new_state = state;
  retp(new_state);
endp;

state = seqa(1,0.5,N);
control = seqa(1,1,K);

proc hT_proc(T,state);
  local hT;
  hT = 2*state - 1;
  retp(hT);
endp;

{t,H,V} = Bellman_Optimize2(state,control,T,&f_proc,&g_proc,&hT_proc);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.275; _pnumht = 0.225; _ptitlht = 0.30;
  _pltype = 6; _plwidth = 10; _pcolor = 1;

  setwind(1);
    _psurf = {0,4}; _pzclr = seqa(1,1,7);
    title("\216h(t,e(t))");
    xlabel("\216t");
    ylabel("\216e]n[");
    xtics(0,100,25,2);
    ytics(0,50,10,2);
    ztics(-50,100,50,2);
    volume(1,1,0.8);
    _pnumht = 0.25;
    surface(t'-1,state-1,H);

  _pnumht = 0.22;
  setwind(2);
    title("\216t = 1");
    xlabel("\216e]n[");
    ylabel("\216h(t,e(t))");
    xtics(0,50,10,2);
    ytics(-25,100,25,2);
    xy(state,H[.,1]);

  setwind(3);
    _pcolor = 3;
    title("\216e(1) = 2.5");
    xlabel("\216t");
    ylabel("\216v[*](t)");
    xtics(0,100,25,2);
    ytics(0,25,5,0);
    xy(t,V[5,.]');

  endwind;