new;
library frm,pgraph,optmum;

cls;

rndseed 123;

nK = 6;
nS = 7;
nC = 5;

__output = 1;

declare matrix alpha = 0.12;

proc (1) = fProc(k,S,C);
  local y;
  y = -1/S - (alpha/k)*(C - S)^2;
  retp(y);
endp;

proc (1) = gProc(k,S,C);
  retp(S);
endp;

f_end = rndu(nS,1);

{J,C} = Bellman_Optimize(nK,nS,nC,&gProc,&fProc,f_end);

print ftosa(J,"%lf",3,2);
print ftosa(C,"%lf",3,2);

{J,C,opt_J,opt_C,opt_S} = Bellman_PrintTree(Bellman_Optimize(nK,nS,nC,&gProc,&fProc,f_end),&gProc,0);

{J,C,opt_J,opt_C,opt_S} = Bellman_PrintTree(Bellman_Optimize(nK,nS,nC,&gProc,&fProc,f_end),&gProc,1);

k = seqa(1,1,nK);
state = seqa(1,1,nS);
control = seqa(1,1,nC);

proc fK_Proc(K,S);
  retp(f_end);
endp;

{k,J2,C2} = Bellman_Optimize2(k,state,control,&gProc,&fProc,&fK_Proc);

if (J /= J2) or (C /= C2[.,nK-1]);
  errorlog "error";
  end;
endif;

print ftosa(J2,"%lf",5,4);
print ftosa(C2,"%lf",5,4);