new;
library frm,pgraph,optmum;

cls;

nK = 100;
nS = 100;  
nC = 25;

alpha = 0.02;
beta = 0.01;
gamma_ = 0.01;

proc (1) = fProc(k,s,c);
  local y;
  y = - 1/s * ln(s) - (alpha/k)*((c-s)^2) + beta*c + gamma_ .* sqrt(s) .* exp(sin(s));
  retp(y);
endp;

proc (1) = gProc(k,s,c);
  retp(s);
endp;

proc fK_Proc(nK,s);
  local fK;
  fK = 2*s - 1;
  retp(fK);
endp;

state = seqa(1,0.5,nS);
control = seqa(1,1,nC);

{k,J,C} = Bellman_Optimize2(nK,state,control,&gProc,&fProc,&fK_Proc);

graphset;
  window3u;

    _pdate = ""; _pnum = 2; _pframe = 0;
    _paxht = 0.275; _pnumht = 0.225; _ptitlht = 0.30;
    _pltype = 6; _plwidth = 10; _pcolor = 1;

  setwind(1);
    _psurf = {0,4}; _pzclr = seqa(1,1,7);
    zlabel("\216J(k,s(k))");
    xlabel("\216k");
    ylabel("\216s]k[");
    xtics(0,100,25,2);
    ytics(0,50,10,2);
    ztics(-50,100,50,2);
    volume(1,1,0.8);
    _pnumht = 0.25;
    surface(k'-1,state-1,J);

  _pnumht = 0.22;
  setwind(2);
    xlabel("\216s]k[");
    ylabel("\216J(1,s]k[)");
    xtics(0,50,10,2);
    ytics(-25,100,25,2);
    xy(state,J[.,1]);

  setwind(3);
    _pcolor = 1|2|4; _pltype = 6|3|1;
    xlabel("\216k");
    ylabel("\216c[*](k)");
    xtics(0,100,25,2);
    ytics(0,25,5,0);
    _plegstr = "s(k) = 3\000s(k) = 13\000s(k) = 22";
    _plegctl = {2 5 5 2};
    xy(k,C[5 25 43,.]');

  endwind;

indx = maxindc(J[.,1]);
s_opt = state[indx];
print ftos(s_opt,"s* = %lf",5,3);