new;
library frm,pgraph;

cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "us-credit-2019";

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

let string selected_names = "h-total" "h-home" "h-cc"
                            "b-total" "c-total"
                            "cc-total" "cc-rev" "cc-nrev"
                            "student" "car";
indx = indsav(selected_names,vnames);

dates = data[.,1];
yyyy = trunc(dates/10000);
mm = (dates - yyyy*10000 - 1)/100;
t = yyyy + (mm - 1)/12;

data = data[.,indx] / 1e6;

graphset;
  window(2,2,0);

  _pdate = ""; _pframe = 0; _pnum = 2;
  _plwidth = 10; _pltype = 6|1|3; _pcolor = 1|4|2;
  _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.275;

  xtics(1960,2020,10,2);
  let xlab = "1960" "70" "80" "90" "2000" "10" "20";
  asclabel(xlab,0);
  _plegctl = {2 5 1.5 4};

  setwind(1);
    title("\216Households");
    ytics(0,15,3,3);
    _plegstr = "Total\000Home mortgage\000Consumer credit";
    xy(clean_miss(t,data[.,1 2 3]));

  setwind(2);    
    title("\216Non-financial business");
    ytics(0,15,3,3);
    _plegstr = "Total\000Corporate";
    xy(clean_miss(t,data[.,4 5]));

  setwind(3);
    title("\216Consumer credit");
    ytics(0,4,1,2);
    _plegstr = "Total\000Revolving\000Non-revolving";
    xy(clean_miss(t,data[.,6 7 8]));

  setwind(4);
    title("\216Other loans");
    ytics(0,1.5,0.25,2);
    _plegstr = "Student loans\000Auto loans";
    xy(clean_miss(t,data[.,9 10]));

  endwind;

proc (2) = clean_miss(x,y);
  local n,e;

  n = sumr(y .== error(0));
  e = n .== cols(y);
  x = delif(x,e);
  y = delif(y,e);

  retp(x,y);
endp;
