/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.1.2
**
*/

new;
library frm,pgraph;
frmSet;

cls;

_Continuous_Time = 1;

declare matrix lambda;
let params = 0.05 -0.05 0.06 10;
fn Survival_Function(t) = exp(-lambda*t);
fn Density_Function(t) = lambda * exp(-lambda*t);
fn YieldCurve_Function(t) = NelsonSiegel_Spot_Rate(params,t);

Coupon = 4.5;
Maturity = 10;
Notional = 100;
t = seqa(1,1,Maturity);
Ct = Coupon * ones(Maturity,1);
Ct_star = Ct;
Ct_star[Maturity] = Ct_star[Maturity] + Notional;

Results = zeros(4,6);
Recovery_Rate = 0.00;
let lambdaVector = 0.00 0.0010 0.02 0.10;

i = 1;
do until i > 4;
  lambda = lambdaVector[i];
  PD = 1 - exp(-lambda);
  P = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
  YTM = Bond_YTM(t,Ct_star,P);
  if i == 1;
    YTM0 = YTM;
  endif;
  Spread = YTM - YTM0;
  Results[i,.] = Recovery_Rate~lambda~PD~P~YTM~Spread;
  i = i + 1;
endo;

Result1 = Results;

Results = zeros(4,6);
Recovery_Rate = 0.40;
let lambdaVector = 0.00 0.0010 0.02 0.10;

i = 1;
do until i > 4;
  lambda = lambdaVector[i];
  PD = 1 - exp(-lambda);
  P = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
  YTM = Bond_YTM(t,Ct_star,P);
  Spread = YTM - YTM0;
  Results[i,.] = Recovery_Rate~lambda~PD~P~YTM~Spread;
  i = i + 1;
endo;

Result2 = Results;

Results = zeros(4,6);
Recovery_Rate = 0.80;
let lambdaVector = 0.00 0.0010 0.02 0.10;

i = 1;
do until i > 4;
  lambda = lambdaVector[i];
  PD = 1 - exp(-lambda);
  P = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
  YTM = Bond_YTM(t,Ct_star,P);
  Spread = YTM - YTM0;
  Results[i,.] = Recovery_Rate~lambda~PD~P~YTM~Spread;
  i = i + 1;
endo;

Result3 = Results;

Results = Result1 .* (1e2~1e4~1e4~1~1e2~1e4);
print ftosa(Results,"%lf",3,2);

Results = Result2 .* (1e2~1e4~1e4~1~1e2~1e4);
print ftosa(Results,"%lf",3,2);

Results = Result3 .* (1e2~1e4~1e4~1~1e2~1e4);
print ftosa(Results,"%lf",3,2);


