/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.1.2
**
*/

new;
library frm,pgraph;

cls;

let params = 0.05 -0.05 0.06 10;

_Continuous_Time = 1;

Results = zeros(5,6);

nt = 1;
do until nt > 5;
  t = seqa(1,1,nt);
  Ct = 5 * ones(nt,1);
  Ct[nt] = 100 + Ct[nt];
  Rt = NelsonSiegel_Spot_Rate(params,t);
  Bt = NelsonSiegel_ZC_Bond(params,t);

  Results[nt,1] = nt;
  Results[nt,2] = 100*Rt[nt];
  Results[nt,3] = 100*Bt[nt];  

  P = Bond_Price(t,Ct,Rt);
  YTM = Bond_YTM(t,Ct,P);
  D = Bond_Duration(t,Ct,YTM);

  Results[nt,4] = P;  
  Results[nt,5] = 100*YTM;  
  Results[nt,6] = D;  

  nt = nt + 1;
endo;

print ftosa(Results,"%lf",3,2);






