/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.1.2
**
*/

new;
library frm,pgraph;
frmSet;

cls;

_Continuous_Time = 1;

declare matrix r0,lambda;

fn Survival_Function(t) = exp(-lambda*t);
fn Density_Function(t) = lambda * exp(-lambda*t);
fn YieldCurve_Function(t) = r0 * ones(rows(t),1);

Coupon = 4.5;
Nominal = 100;
Maturity = 10;
t = seqa(1,1,Maturity);
Ct = Coupon * ones(Maturity,1);
Notional = 100;
Recovery_Rate = 0.40;

lambda = 0.00;
r0 = 0.00;
P0 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
P1 = sumc(Ct) + Notional;
print "Bond Price = ";
print ftosa(P0~P1,"%lf",3,2);

r0 = 0.05;
P0 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
P1 = sumc(Ct .* exp(-r0 .* t)) + Notional .* exp(-r0 .* Maturity);
print ftosa(P0~P1,"%lf",3,2);

lambda = 0.02;
P0 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
P1 = sumc(Ct .* exp(-(r0+lambda) .* t)) + Notional .* exp(-(r0+lambda) .* Maturity) +
      Recovery_Rate .* Notional .* lambda ./ (r0 + lambda) .* (1 - exp(-(r0+lambda) .* Maturity));
print ftosa(P0~P1,"%lf",3,2);

lambda = 0.10;
P0 = Risky_Bond_Price(t,Ct,Notional,Maturity,Recovery_Rate,&YieldCurve_Function,&Survival_Function,&Density_Function);
P1 = sumc(Ct .* exp(-(r0+lambda) .* t)) + Notional .* exp(-(r0+lambda) .* Maturity) +
     Recovery_Rate .* Notional .* lambda ./ (r0 + lambda) .* (1 - exp(-(r0+lambda) .* Maturity));
print ftosa(P0~P1,"%lf",3,2);





