/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.1.2
**
*/

new;
library frm,pgraph;

cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "cds-spread";
 
data = loadd(datFileName);
dates = data[.,1];
nDates = rows(dates);
data = data[.,2:cols(data)];
vnames = "" $+ getname(datFileName);
vnames = vnames[2:rows(vnames)];
t = seqa(2005,1/12,nDates);

let indx = 8 9 13 14;
let indx = 2 3 4 5;

graphset;
  begwind;
  window(2,2,0);
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; 
  _paxht = 0.22; _pnumht = 0.22; _ptitlht = 0.275;
  xtics(2005,2016,1,1);
  let xlab = "2006" "" "08" "" "10" "" "12" "" "14" "" "16";
  asclabel(xlab,0);
  
  _pysci = 4;
  i = 1;
  cn = indx[i];
  setwind(i);
    _pcolor = i; _pbartyp = 6~i; 
    title("\216" $+ vnames[cn]);
    bar(t,data[.,cn]);
  
  _pysci = 4;  
  i = 2;
  cn = indx[i];
  setwind(i);
    _pcolor = i; _pbartyp = 6~i;
    title("\216" $+ vnames[cn]);
    bar(t,data[.,cn]);

  i = 3;
  cn = indx[i];
  setwind(i);
    _pcolor = i; _pbartyp = 6~i;
    title("\216" $+ vnames[cn]);
    bar(t,data[.,cn]);

  i = 4;
  cn = indx[i];
  setwind(i);
    _pcolor = i; _pbartyp = 6~i;
    title("\216" $+ vnames[cn]);
    ytics(0,150,25,2);
    bar(t,data[.,cn]);

  endwind;