/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.1.2
**
*/

new;
library frm,pgraph;

cls;

datPathName = "..\\..\\data\\";
datFileName = datPathName $+ "cds-curve";
 
data = loadd(datFileName);
tenor = data[.,1];
data = data[.,2:cols(data)];
nCols = cols(data)/2;
vnames = "" $+ getname(datFileName);
vnames = trimr(vnames,1,0);

mid = zeros(rows(tenor),nCols);
i = 1;
do until i > nCols;
  mid[.,i] = meanc(data[.,2*(i-1)+1:2*i]');
  i = i + 1;
endo;

graphset;
  window3u;
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _plctrl = 1; _pstype = 8|9|10; _pgrid = {3,1};
  _paxht = 0.22; _pnumht = 0.22; _ptitlht = 0.275; _psymsiz = 6.5;
  xtics(0,11,1,1);
  xlabel("\216Time to maturity (in years)");
  
  i = 1;
  setwind(i);
    _pcolor = 1|2|3; 
    _plegstr = "Germany\000US\000Japan";
    _plegctl = {2 5 2 4.5};
    ytics(0,80,20,2);
    xy(tenor,mid[.,1 2 3]);

  i = 2;
  setwind(i);
    _pcolor = 4|5; 
    _plegstr = "Italy\000Walmart";
    _plegctl = {2 5 2 5};
    ytics(0,180,30,3);
    xy(tenor,mid[.,4 5]);

  i = 3;
  setwind(i);
    _pcolor = 6|7; 
    _plegstr = "Google\000Apple";
    ytics(0,100,20,2);
    xy(tenor,mid[.,6 7]);
  
  endwind;