/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.2.4
**
*/

new;
library frm,pgraph;

cls;

n = 100;
EAD = 1 * ones(n,1);
LGD = 0.5 * ones(n,1);
PD = 0.05 * ones(n,1);
rho = 0.10;

let loss = 0.1 1 2 3 4 5;
nLoss = rows(Loss);
p = Compute_Vasicek_Model_CDF(EAD,LGD,PD,rho,loss);
d = Compute_Vasicek_Model_PDF(EAD,LGD,PD,rho,loss);
let alpha = 0.10 0.25 0.50 0.75 0.90 0.95;
q = Compute_Vasicek_Model_invCDF(EAD,LGD,PD,rho,alpha);

results = 100*alpha' | q' | loss' | 100 * p' | 100*d';
print ftosa(results,"%lf",3,2);

end;

loss = 0.0001|seqa(0.01,0.01,99)|seqa(1.00,0.3,30)|10;
nLoss = rows(Loss);
p = Compute_Vasicek_Model_CDF(EAD,LGD,PD,rho,loss);
alpha = seqa(0.0001,0.9999/nLoss,nLoss);
q = Compute_Vasicek_Model_invCDF(EAD,LGD,PD,rho,alpha);
d = Compute_Vasicek_Model_PDF(EAD,LGD,PD,rho,loss);

loss[1] = 0.0;
p[1] = 0.0;
d[1] = 0.0;

alpha1 = alpha; q1 = q; p1 = p; d1 = d;

rho = 0.30;

loss = 0.0001|seqa(0.01,0.01,99)|seqa(1.00,0.3,30)|10;
nLoss = rows(Loss);
p = Compute_Vasicek_Model_CDF(EAD,LGD,PD,rho,loss);
alpha = seqa(0.0001,0.9999/nLoss,nLoss);
q = Compute_Vasicek_Model_invCDF(EAD,LGD,PD,rho,alpha);
d = Compute_Vasicek_Model_PDF(EAD,LGD,PD,rho,loss);

d[1] = error(0);

alpha2 = alpha; q2 = q; p2 = p; d2 = d;

graphset;
  window3u;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  _pnumht = 0.22; _paxht = 0.22; _ptitlht = 0.275;

  setwind(1);
    xtics(0,1,0.2,2);
    ytics(0,16,2,2);
    xlabel("\216\202a\201");
    title("\216Quantile function");
    _plegstr = "\202r\201 = 10%\000\202r\201 = 30%";
    _plegctl = {2 5 9.5 3.5};
    xy(alpha1~alpha2,q1~q2);

    _plegctl = 0;

  setwind(2);
    title("\216Cumulative distribution function");
    xtics(0,10,2,2);
    ytics(0,1.0,0.2,2);
    xlabel("\216Loss");
    xy(loss,p1~p2);

  setwind(3);
    title("\216Probability density function");
    ytics(0,0.8,0.2,2);
    xy(loss,d1~d2);

  endwind;
