/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.2.4
**
*/

new;
library frm,pgraph;

cls;

EAD = 100;
LGD = 0.70~0.30;
PD = seqa(1e-7,0.001,100)|seqa(0.10,0.05,18);
rho = 0.20;
alpha = 0.90;
rc = Compute_Vasicek_Model_RC(EAD,LGD,PD,rho,alpha);
x1 = PD; y1 = rc;

LGD = 0.70;
alpha = 0.90~0.995~0.40;
rc = Compute_Vasicek_Model_RC(EAD,LGD,PD,rho,alpha);
x2 = PD; y2 = rc;

alpha = 0.90;
LGD = 0.70;
PD = 0.05~0.10;
rho = seqa(1e-7,0.9999/100,101);
rc = Compute_Vasicek_Model_RC(EAD,LGD,PD,rho,alpha);
x3 = rho; y3 = rc;

rho_star = _max_(0,-cdfni(alpha)./cdfni(PD));
rho_star = rho_star^2;
print ftosa(100*rho_star,"%lf",3,2);

alpha = 0.999;
LGD = 0.70;
PD = 0.05~0.10;
rho = seqa(1e-7,0.9999/100,101);
rc = Compute_Vasicek_Model_RC(EAD,LGD,PD,rho,alpha);
x4 = rho; y4 = rc;

graphset;
  begwind;
  window(2,2,0);
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2;
  _pnumht = 0.22; _paxht = 0.22; _ptitlht = 0.275;

  setwind(1);
    title("\216\202a\201 = 90%");
    _plegstr = "E\202@[\201LGD\202@]\201 = 70%\000E\202@[\201LGD\202@]\201 = 30%";
    _plegctl = {2 5 1.25 5.5};
    xlabel("\216p]i[ (in %)");
    xtics(0,100,20,2);
    xy(100*x1,y1);

  setwind(2);
    title("\216\202a\201 = 90%");
    _plegstr = "\202a\201 = 90%\000\202a\201 = 99.5%\000\202a\201 = 40%";
    _plegctl = {2 5 5.5 1.75};
    xy(100*x2,y2);

  setwind(3);
    title("\216\202a\201 = 90%");
    _plegstr = "p]i[ = 5%\000p]i[ = 10%";
    _plegctl = {2 5 1.25 5};
    xlabel("\216\202r\201 (in %)");
    ytics(0,35,5,2);
    xy(100*x3,y3);

  setwind(4);
    title("\216\202a\201 = 99%");
    _plegstr = "p]i[ = 5%\000p]i[ = 10%";
    _plegctl = {2 5 5.5 2.0};
    xlabel("\216\202r\201 (in %)");
    ytics(0,70,10,2);
    xy(100*x4,y4);

  endwind;
