new;
library frm,pgraph,optmum;
frmSet;

let lgd = 68 90 22 45 17 25 89 65 75 56 87 92 46;
lgd = lgd / 100;
mu_lgd = meanc(lgd);
sigma_lgd = stdc(lgd);

{alpha1,beta1} = calibrate_Beta_MM(mu_lgd,sigma_lgd);

proc mlProc(theta);
  local alpha,beta,logl;
  theta = sqrt(theta^2);
  alpha = theta[1];
  beta = theta[2];
  logl = ln( pdfbeta(LGD,alpha,beta) );
  retp(-sumc(logl));
endp;

sv = alpha1|beta1;
{theta,grd,fmin,retcode} = optmum(&mlProc,sv);
theta = sqrt(theta^2);
alpha2 = theta[1];
beta2 = theta[2];

x = seqa(0,1/1000,1001);
pdf1 = pdfBeta(x,alpha1,beta1);
pdf2 = pdfBeta(x,alpha2,beta2);

cls;

print ftosa(100*(mu_lgd|sigma_lgd),"%lf",3,2);

theta = (alpha1|beta1)~(alpha2|beta2);
print ftosa(theta,"%lf",3,2);


graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10; _pcolor = 1|4;
  fonts("simplex simgrma");
  xtics(0,1,0.2,2);
  ytics(0,2.0,0.5,2);
  xlabel("\216LGD");
  _plegstr = "MM\000ML";
  _plegctl = {2 5 1.5 5.5};
  xy(x,pdf1~pdf2);
