/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.3.1
**
*/

new;
library frm,pgraph;

let lambda1[5,2] = 1  100 
                   2  150 
                   3  200
                   4  250
                   10 300;
let lambda2[5,2] = 1 1000 
                   2  700 
                   5  500
                   7  450
                   10 600;
lambda3 = 400;

pline1 = xy_piecewise_constant_function(lambda1[.,1],lambda1[.,2],6,1,10);
pline2 = xy_piecewise_constant_function(lambda2[.,1],lambda2[.,2],3,4,10);
pline3 = xy_piecewise_constant_function(10,lambda3,1,2,10);

lambda1[.,2] = lambda1[.,2] / 1e4;
lambda2[.,2] = lambda2[.,2] / 1e4;
lambda3 = lambda3 /1e4;
t = seqa(0,1/100,2001);

S1 = survivalExponential(t,lambda1);
S2 = survivalExponential(t,lambda2);
S3 = survivalExponential(t,lambda3);

d1 = pdfExponential(t,lambda1);
d2 = pdfExponential(t,lambda2);
d3 = pdfExponential(t,lambda3);

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2; 
  _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.275;

  xlabel("\216t (in years)");
  xtics(0,20,5,2);

  setwind(1);
    title("\216Hazard function S(t)");
    ytics(0,1000,200,2);
    _pline = pline1|pline2|pline3;
    _plegstr = "\202l\201]1[(t)\000\202l\201]2[(t)\000\202l\201]3[(t)";
    _plegctl = {2 6 9 3.0};
    xy(t,-(S1~S2~S3));
    draw;

  _plegctl = 0;

  setwind(2);
    title("\216Survival function S(t)");
    ytics(0.20,1,0.20,2);
    xy(t,S1~S2~S3);

  setwind(3);
    title("\216Density function f(t)");
    ytics(0,0.10,0.02,2);
    xy(t,d1~d2~d3);

  endwind;

proc (1) = xy_piecewise_constant_function(x_m,y_m,pltype,pcolor,plwidth);
  local M,pline,e;

  M = rows(x_m);
  e = ones(M,1);
  x_m[M] = 2*x_m[M];

  x_m = lag1(x_m)~x_m ;
  x_m[1,1] = 0;
  pline = e .* (1~pltype)~x_m[.,1]~y_m~x_m[.,2]~y_m~e.*(1~pcolor~plwidth);
  retp(pline);
endp;

  

