new;
library frm,pgraph,optmum;
frmSet;

sigma = 0.015;

nt = 5001; 
h = 10 / nt;
t = seqa(0,h,nt);

rndseed 123;
w = recserar(sigma * rndn(nt,1)*sqrt(h),0,1);
lambda = w^2;

Int_Lambda = zeros(nt,1);

k = 2;
do until k > nt;
  wgt = ones(k,1); 
  wgt[1] = 0.5; 
  wgt[k] = 0.5;
  Int_Lambda[k] = sumc(wgt .* lambda[1:k]);
  k = k + 1;
endo;

Barrier = rndExponential(1,1,1);
tau = t[maxindc(Int_lambda .> Barrier)];

Int_Lambda2 = Int_Lambda .* (Int_Lambda .< Barrier) + Barrier .* (Int_Lambda .> Barrier);

indx = seqa(1,20,nt/20);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10;
  xtics(0,10,2,2);
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xlabel("\216t");

  setwind(1);
    _pcolor = 1;
    ylabel("\216W(t)");
    ytics(-0.02,0.05,0.01,2);
    xy(t[indx],w[indx]);
  setwind(2);
    _pcolor = 4;
    ylabel("\216\202l\201(t) (in %)");
    ytics(0,0.25,0.05,2);
    xy(t[indx],100*lambda[indx]);
  setwind(3);
    _pcolor = 2;
    ylabel("\216\202L\201(t)");
    ytics(0,1.50,0.25,2);
    _pline = 1~4~0~Barrier~10~Barrier~1~0~5 |
             1~4~tau~0~tau~Barrier~1~0~5 ;
    _parrow = 0~Barrier~tau~Barrier~1~0.125~21~3~1~1~10 |
              tau~Barrier~tau~0~1~0.125~21~3~1~1~10 ;
    _pmsgstr = "B\000\202t\201";
    _pmsgctl = -0.75~0.95*Barrier~0.3~0~1~3~10 |
               tau*0.90~-0.15~0.3~0~1~3~10 ;
    xy(t,Int_Lambda);
  setwind(4);
     ylabel("\216\202L\201(t)");
     ytics(0,1.50,0.25,2);
    _parrow = tau~Barrier~0~Barrier~1~0.125~21~3~1~1~10 |
              tau~0~tau~Barrier~1~0.125~21~3~1~1~10 ;
    xy(t,Int_Lambda2);
  endwind;