/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

// Kavvathas rounded matrix

let P[8,8] = 92.82  6.50  0.56  0.06  0.06  0.00  0.00   0.00
              0.63 91.87  6.64  0.65  0.06  0.11  0.04   0.00
              0.08  2.26 91.66  5.11  0.61  0.23  0.01   0.04
              0.05  0.27  5.84 87.74  4.74  0.98  0.16   0.22
              0.04  0.11  0.64  7.85 81.14  8.27  0.89   1.06
              0.00  0.11  0.30  0.42  6.75 83.07  3.86   5.49
              0.19  0.00  0.38  0.75  2.44 12.03 60.71  23.50
              0.00  0.00  0.00  0.00  0.00  0.00  0.00 100.00;

P = P ./ sumr(P);

K = rows(P);
Pn = P;
nMax = 1500;
t = seqa(0,1,nMax);
PD = zeros(nMax,K);

n = 1;
do until n > nMax;
  PD[n,.] = Pn[.,K]';
  Pn = Pn * P;
  n = n + 1;
endo;
 
S = 1 - PD;

S = ones(1,K) | S;
S = miss(S,0);
lambda = ln(S) - ln(lagn(S,-1));
lambda = 1e4*lambda[1:nMax,1:K-1];

graphset;
  begwind;
  window(2,2,0);
  makewind(9/4,6.855/4,6.5,1.5,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xlabel("\216t");
  ylabel("\216\202l\201]i[(t)");
  xtics(0,150,25,2);
  _plegctl = {2 5.5 6.5 3};
  _paxht = 0.25; _pnumht = 0.225;

  setwind(1);
    ytics(0,125,25,2);
    _plegstr = "AAA\00AA"; 
    xy(t,lambda[.,1:2]);

  setwind(2);
    _plegstr = "A\00BBB"; 
    ytics(0,125,25,2);
    xy(t,lambda[.,3:4]);

  setwind(3);
    _plegstr = "BB\00B"; 
    ytics(0,700,100,2);
    xy(t,lambda[.,5:6]);

  setwind(4);
    _plegstr = "CCC"; 
    _plegctl = {2 5.5 6.5 1.75};
    ytics(0,2500,500,2);
    xy(t,lambda[.,7]);

  _plegctl = 0;

  setwind(5);
    _paxht = 0.30; _pnumht = 0.30; 
    _plegstr = "CCC"; _pbox = 8;
    xlabel(""); ylabel("");
    xtics(0,10,2,2);
    ytics(0,2500,500,2);
    _pline = xy_piecewise_constant_function(t,lambda[.,7],6,1,8);
    xy(t,-lambda[.,7]);

  endwind;



