/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

// Kavvathas rounded matrix

let P[8,8] = 92.82  6.50  0.56  0.06  0.06  0.00  0.00   0.00
              0.63 91.87  6.64  0.65  0.06  0.11  0.04   0.00
              0.08  2.26 91.66  5.11  0.61  0.23  0.01   0.04
              0.05  0.27  5.84 87.74  4.74  0.98  0.16   0.22
              0.04  0.11  0.64  7.85 81.14  8.27  0.89   1.06
              0.00  0.11  0.30  0.42  6.75 83.07  3.86   5.49
              0.19  0.00  0.38  0.75  2.44 12.03 60.71  23.50
              0.00  0.00  0.00  0.00  0.00  0.00  0.00 100.00;

P = P ./ sumr(P);

__macheps = 1e-300;
{Lambda1,lambda2} = Compute_Markov_Generator(P);

print ftosa(1e4*Lambda1,"%lf",3,2);
print;
print ftosa(1e4*Lambda2,"%lf",3,2);
print;

P1 = expMatrix(Lambda1);
P2 = expMatrix(Lambda2);
print sumc(lambda1')~sumc(lambda2')~sumc(P1')~sumc(P2');

norm1 = sumc(sumc(abs(P-P1)));
norm2 = sumc(sumc(abs(P-P2)));
print norm1|norm2;

{Lambda3,lambda4} = Estimate_Markov_Generator(Lambda1);

print ftosa(1e4*Lambda3,"%lf",3,2);
print;
print ftosa(1e4*Lambda4,"%lf",3,2);
print;

P3 = expMatrix(Lambda3);
P4 = expMatrix(Lambda4);
print sumc(lambda3')~sumc(lambda3')~sumc(P3')~sumc(P4');

norm3 = sumc(sumc(abs(P-P3)));
norm4 = sumc(sumc(abs(P-P4)));
print norm3|norm4;

print ftosa(100*P4,"%lf",3,2);
print;

print ftosa(100*P,"%lf",3,2);
print;

t = 207/365;
P12 = expMatrix(t * Lambda4);

print ftosa(100*P12,"%lf",3,2);
print;




