/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 3.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

// Kavvathas rounded matrix

let P[8,8] = 92.82  6.50  0.56  0.06  0.06  0.00  0.00   0.00
              0.63 91.87  6.64  0.65  0.06  0.11  0.04   0.00
              0.08  2.26 91.66  5.11  0.61  0.23  0.01   0.04
              0.05  0.27  5.84 87.74  4.74  0.98  0.16   0.22
              0.04  0.11  0.64  7.85 81.14  8.27  0.89   1.06
              0.00  0.11  0.30  0.42  6.75 83.07  3.86   5.49
              0.19  0.00  0.38  0.75  2.44 12.03 60.71  23.50
              0.00  0.00  0.00  0.00  0.00  0.00  0.00 100.00;

P = P ./ sumr(P);

__macheps = 1e-300;
{Lambda1,lambda2} = Compute_Markov_Generator(P);
{Lambda3,lambda4} = Estimate_Markov_Generator(Lambda1);
Lambda = Lambda4;

t = seqa(0,1/5,2001);
pdf = Density_Markov_Generator(t,Lambda);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4; _pysci = 0;
  xlabel("\216t");
  ylabel("\216f]i[(t)");
  _plegctl = {2 5.5 6 4};
  _paxht = 0.25; _pnumht = 0.225;

  setwind(1);
    _plegstr = "AAA\00AA"; 
    xtics(0,300,50,2);
    ytics(0,8e-3,2e-3,2);
    xy(t,pdf[.,1:2]);

  setwind(2);
    _plegstr = "A\00BBB"; 
    ytics(0,1.25e-2,0.25e-2,2);
    xy(t,pdf[.,3:4]);

  xtics(0,100,25,2);

  setwind(3);
    _plegstr = "BB\00B"; 
    ytics(0,6e-2,1e-2,2);
    xy(t,pdf[.,5:6]);

  setwind(4);
    _plegstr = "CCC"; 
    ytics(0,0.30,0.10,2);
    xy(t,pdf[.,7]);

  endwind;