new;
library frm,pgraph;
frmSet;

cls;

rndseed 123456;

let PD = 0.2;
let rho[1,4] = 0.00 0.20 0.50 0.90;
n = 1000;
nS = 1000000;

nD = zeros(nS,cols(rho));
X = rndn(nS,1);
i = 1;
do until i > nS;
  epsilon = rndn(n,1);
  D = (sqrt(rho) .* X[i] + sqrt(1-rho) .* epsilon) .< cdfni(PD);
  nD[i,.] = sumc(D)';
  i = i + 1;
endo;

freq_D = nD / n;

stats = meanc(freq_D)~stdc(freq_D)~quantile(freq_D,0.01|0.10|0.25|0.50|0.75|0.90|0.99)';
print ftosa(100*stats,"%lf",3,1);

graphset;
  begwind;
  window(2,2,0);
  xtics(0,1,0.2,2); 

  _pdate = ""; _pframe = 0; _pnum = 2;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.30;
  v = 50;
  xlabel("\000"); 
  ylabel("\000");
  fonts("simplex simgrma");
  xtics(0,100,10,2);

  i = 1;
  setwind(i);
    ytics(0,10,2,2);
    title("\216\202r\201 = 0%");
    _pbartyp = 6~1;
    call histp(100*freq_D[.,i],v);

  i = 2;
  setwind(i);
    ytics(0,7,1,2);
    title("\216\202r\201 = 20%");
    _pbartyp = 6~2;
    call histp(100*freq_D[.,i],v);

  i = 3;
  setwind(i);
    ytics(0,20,5,2);
    title("\216\202r\201 = 50%");
    _pbartyp = 6~5;
    call histp(100*freq_D[.,i],v);

  i = 4;
  setwind(i);
    ytics(0,60,15,2);
    title("\216\202r\201 = 90%");
    _pbartyp = 6~4;
    call histp(100*freq_D[.,i],v);

  endwind;