new;
library frm,pgraph,optmum;
frmSet;

cls;

SetTransitionMatrix(1);
P = _frm_P;

__macheps = 1e-300;
{Lambda,tmp} = Compute_Markov_Generator(P);
{tmp,Lambda} = Estimate_Markov_Generator(Lambda);

dt = 1/10;
t = seqa(0,dt,1001);
S = Survival_Markov_Generator(t,Lambda);
f = Density_Markov_Generator(t,Lambda);
lambda_rate = f ./ S;

Rating = 7;
t0 = 10;

let rho = 0.50;
S0 = Survival_Markov_Generator(t0,Lambda);
Sc = cndCopulaNormal2(S,S0[Rating],rho);
cnd_lambda_rate = (lag1(Sc) - Sc) ./ Sc ./ dt ;
cnd_lambda_rate = missrv(missex(cnd_lambda_rate, t .<= t0),lambda_rate);
cnd_lambda_rate = 1e4*cnd_lambda_rate;

graphset;
  begwind;
  window(2,2,0);

  _pline = 1~6~t0~0~t0~1e4~1~0~10;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xlabel("\216t");
  ylabel("\216\202l\201(t)");
  xtics(0,100,25,5);
  _plegctl = {2 6 5 5.5};
  _paxht = 0.30; _pnumht = 0.20; _ptitlht = 0.25;

  setwind(1);
    _plegstr = "AAA\00AA"; 
    ytics(0,120,40,4);
    xy(t,cnd_lambda_rate[.,1:2]);

  setwind(2);
    _plegstr = "A\00BBB"; 
    ytics(0,150,50,5);
    xy(t,cnd_lambda_rate[.,3:4]);

  _plegctl = {2 6 5 3};


  setwind(3);
    _plegstr = "BB\00B";
    ytics(0,750,150,1); 
    xy(t,cnd_lambda_rate[.,5:6]);

  setwind(4);
    _plegstr = "CCC"; 
    ytics(0,3000,1000,2);
    xy(t,cnd_lambda_rate[.,7]);

  endwind;
