new;
library frm,pgraph;

cls;

EAD = 1;
LGD = 0.5;
alpha = 0.90|0.99|0.999;
let n = 50 100 500;
nS = 100|1e5;
seed = 123456;

PD = 1000/1e4;
rho = 0.20;
{VaR1,VaR2,RC} = compute_var_and_rc(EAD,LGD,PD,rho,n,alpha,nS,seed);
print ftosa(100*(VaR1./RC-1)~100*(VaR2./RC-1),"%lf",3,1);

PD = 1000/1e4;
rho = 0.10;
{VaR1,VaR2,RC} = compute_var_and_rc(EAD,LGD,PD,rho,n,alpha,nS,seed);
print ftosa(100*(VaR1./RC-1)~100*(VaR2./RC-1),"%lf",3,1);

PD = 100/1e4;
rho = 0.20;
{VaR1,VaR2,RC} = compute_var_and_rc(EAD,LGD,PD,rho,n,alpha,nS,seed);
print ftosa(100*(VaR1./RC-1)~100*(VaR2./RC-1),"%lf",3,1);

proc (3) = compute_var_and_rc(EAD,LGD,PD,rho,n,alpha,nS,seed);
  local L1,L2,VaR1,VaR2,RC;
  local iter,j,D;
    
  if rows(nS) == 1;
    nS = 1 | nS;
  endif;  
  
  L1 = zeros(nS[1]*nS[2],1);
  L2 = zeros(nS[1]*nS[2],1);
  VaR1 = zeros(rows(alpha),rows(n));
  VaR2 = zeros(rows(alpha),rows(n));
  RC = zeros(rows(alpha),rows(n));
    
  iter = 1;
  do until iter > rows(n);
    if seed > 0;
      rndseed seed;
    endif;
    j = 1;
    do until j > nS[1];
      D = ( sqrt(rho) .* rndn(1,nS[2]) + sqrt(1-rho) .* rndn(n[iter],nS[2]) ) .< cdfni(PD);      
      L1[1+(j-1)*nS[2]:j*nS[2]] = sumc(EAD .* LGD .* D);
      L2[1+(j-1)*nS[2]:j*nS[2]] = sumc(EAD .* rndu(n[iter],nS[2]) .* D);
      j = j + 1;
    endo;         
    VaR1[.,iter] = quantile(L1,alpha)/n[iter];
    VaR2[.,iter] = quantile(L2,alpha)/n[iter];
    RC[.,iter] =  EAD .* LGD .* cdfn( ( cdfni(PD) + cdfni(alpha).*sqrt(rho) ) ./ sqrt(1-rho) );    
    iter = iter + 1;
  endo;
  
  retp(VaR1,VaR2,RC);
endp;
