/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 3.4.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

// Nelson-Siegel parameters

let params = 0.05 -0.05 0.06 10;

// CDS parameters

lambda = 750/1e4;
Recovery = 0.40;
Notional = 1e6;
Maturity = 1.25;

_Continuous_Time = 1;

proc DF(t);
  retp( NelsonSiegel_ZC_Bond(params,t) );
endp;

proc Survival_Fn(t);
  retp( exp(-lambda * t) );
endp;

proc Density_Fn(t);
  retp( lambda .* exp(-lambda * t) );
endp;

_intord = 128;
c = 450/1e4;
t_m = seqa(0.25,0.25,4*Maturity);
{Price,Spread,RPV01} = CDS_Price(&DF,&Survival_Fn,&Density_Fn,Notional,Recovery,c,Maturity,t_m);

print ftos(Price,"Price = %lf",3,2);
print ftos(1e4*Spread,"Spread = %lf",3,2);
print ftos(RPV01,"RPV01 = %lf",3,3);

Notional = 1e6;
Delta_t = 0.25;
Recovery = 0.40;
Spread = 150/1e4;
Maturity = 2;

print;
print "=====================  Question 2.a  =======================================";

PL = Delta_t * Spread * Notional;
print ftos(PL,"Quarterly premium interest = %lf",3,0);

PnL = Maturity * Spread * Notional;
print ftos(PnL,"P&L of the protection seller = %lf",3,0);

end;

DL = (1 - Recovery) * Notional;
print ftos(DL,"Default leg = %lf",3,0);

PnL = (1 - Recovery) * Notional - 4 * PL;
print ftos(PnL,"P&L of the protection buyer = %lf",3,0);

print;
print "=====================  Question 2.b  =======================================";

PD = Spread / (1-Recovery);
print ftos(100*PD,"PD = %lf",3,2);

PD = 1 - exp(-Spread / (1-Recovery));
print ftos(100*PD,"PD = %lf",3,2);

print;
print "=====================  Question 2.c  =======================================";

newSpread = 450/1e4;
PD = newSpread / (1-Recovery);
print ftos(100*PD,"PD = %lf",3,2);

MtM = Notional * (newSpread - Spread) * RPV01;
print ftos(MtM,"MtM = %lf",3,2);

print;
print "=====================  Question 3.b  =======================================";

let Spread = 150 600 80;
PD = Spread / (1 - 0.40);
print ftosa(PD/100,"%lf",3,2);

