/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Exercise 3.4.5
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

print;
print "=====================  Question 2  =======================================";

let pi_2Y[4,4] = 0.94 0.03 0.02 0.01
                 0.10 0.80 0.05 0.05
                 0.10 0.10 0.60 0.20 
                 0.00 0.00 0.00 1.00;

pi_4Y = pi_2Y * pi_2Y;
pi_6Y = pi_2Y * pi_4Y;
print "pi(2Y) = " ftosa(100*pi_2Y,"%lf",3,3);
print "pi(4Y) = " ftosa(100*pi_4Y,"%lf",3,3);
print "pi(6Y) = " ftosa(100*pi_6Y,"%lf",3,3);

S0 = 1;
S2 = 1 - pi_2Y[1:3,4]';
S4 = 1 - pi_4Y[1:3,4]';
S6 = 1 - pi_6Y[1:3,4]';

print;
print "=====================  Question 3  =======================================";

lambda1 = ln(S0./S2)/(2-0);
lambda2 = ln(S2./S4)/(4-2);
lambda3 = ln(S4./S6)/(6-4);
lambda = lambda1 | lambda2 | lambda3;
print "Lambda = ";
print ftosa(1e4*lambda,"%lf",3,1);

Lambda_Matrix = lnMatrix(pi_2Y)/2;
print "Markov generator = ";
print ftosa(100*Lambda_Matrix,"%lf",3,3);
print "pi(2Y) = ";
print ftosa(100*expMatrix(2*Lambda_Matrix),"%lf",3,2);

print;
print "=====================  Question 4  =======================================";

t = seqa(0,1/12,10*12);
S_t = Survival_Markov_Generator(t,Lambda_Matrix);
f_t = Density_Markov_Generator(t,Lambda_Matrix);
lambda_Markov = f_t ./ S_t;

TM = eye(4);
PD = zeros(6,4);

i = 1;
do until i > rows(PD);
  PD[i,.] = TM[.,4]';
  TM = TM * pi_2Y;
  i = i + 1;
endo;
 
S_t = 1 - PD;
S_t = miss(S_t,0);
lambda_Exponential = (ln(S_t) - ln(lagn(S_t,-1)))/2;
lambda_Exponential = lambda_Exponential[.,1:3];
lambda_Exponential = trimr(lambda_Exponential,0,1);
lambda_Exponential = lambda_Exponential .*. ones(12*2,1);

graphset;  
  window3d;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pltype = 3|6; _plwidth = 10; _pcolor = 1|4;
  xtics(0,10,1,2);
  xlabel("\216t (in years)");
  i = 1;
  do until i > 3;
    setwind(i);
    if i == 1;
      title("\216Rating A");
      ytics(20,120,20,2);
    elseif i == 2;
      title("\216Rating B");
      ytics(230,280,10,2);
    elseif i == 3;
      title("\216Rating C");
      ytics(200,1400,200,2);
      _plegstr = "Piecewise constant function\000Markov generator";
      _plegctl = {2 5 7 5};
    endif;
    xy(t,1e4*(lambda_Exponential[.,i]~lambda_Markov[.,i]));
    i = i + 1;
  endo;

  endwind;

t = seqa(0,0.001,10000);
S_t = Survival_Markov_Generator(t,Lambda_Matrix);
f_t = Density_Markov_Generator(t,Lambda_Matrix);
lambda_Markov = f_t ./ S_t;
t_max = t[maxindc(lambda_Markov[.,2])];

t = 300;
S_t = Survival_Markov_Generator(t,Lambda_Matrix);
f_t = Density_Markov_Generator(t,Lambda_Matrix);
lambda_infinity = f_t ./ S_t;

print ftosa(1e4*Lambda_infinity',"%lf",3,3);




