new;
library frm,optmum,pgraph;

cls;

let P = {94   3   2    1,
         10  80   7    3,
          5  15   60  20,
          0   0   0  100};
P = P / 100;

{lambda,V} = eigv(P);
D = real(diagrv(eye(4),lambda));
V = real(V);

P1 = eye(4);

n = 1;
do until n > 5;
  P1 = P1 * P;
  P2 = V * (D^n) * inv(V);
  print ftosa(100*P1,"%lf",3,2);
  print ftosa(100*P2,"%lf",3,2);
  print ftosa(100*(P2-P1),"%lf",3,2);
  print "----------------------------------------------------------";
  n = n + 1;
endo;

Lambda_Matrix = lnMatrix(P);
print ftosa(100*Lambda_Matrix,"%lf",3,4);

t = 0.5;
P3 = expMatrix(t*Lambda_Matrix);
P4 = eye(4) + 
     1.0 * (t*Lambda_Matrix) + 
     (1/2) * (t^2) * (Lambda_Matrix*Lambda_Matrix) + 
     (1/(3!)) * (t^3) * (Lambda_Matrix*Lambda_Matrix*Lambda_Matrix) + 
     (1/(4!)) * (t^4) * (Lambda_Matrix*Lambda_Matrix*Lambda_Matrix*Lambda_Matrix);

print ftosa(100*P3,"%lf",3,4);
print ftosa(100*P4,"%lf",3,4);

print;
print "=====================  Question 4  =======================================";

t = seqa(0,1/12,10*12);
S_t = Survival_Markov_Generator(t,Lambda_Matrix);
f_t = Density_Markov_Generator(t,Lambda_Matrix);
lambda_Markov = f_t ./ S_t;

TM = eye(4);
PD = zeros(11,4);

i = 1;
do until i > rows(PD);
  PD[i,.] = TM[.,4]';
  TM = TM * P;
  i = i + 1;
endo;
 
S_t = 1 - PD;
S_t = miss(S_t,0);
lambda_Exponential = (ln(S_t) - ln(lagn(S_t,-1)))/1;
lambda_Exponential = lambda_Exponential[.,1:3];
lambda_Exponential = trimr(lambda_Exponential,0,1);
lambda_Exponential = lambda_Exponential .*. ones(12,1);

graphset;  
  window3d;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pltype = 3|6; _plwidth = 10; _pcolor = 1|4;
  xtics(0,10,1,2);
  xlabel("\216t (in years)");
  i = 1;
  do until i > 3;
    setwind(i);
    if i == 1;
      title("\216Rating A");
      ytics(50,300,50,2);
    elseif i == 2;
      title("\216Rating B");
      ytics(230,480,50,2);
    elseif i == 3;
      title("\216Rating C");
      ytics(0,2500,500,2);
      _plegstr = "Piecewise constant function\000Markov generator";
      _plegctl = {2 5 7 5};
    endif;
    xy(t,1e4*(lambda_Exponential[.,i]~lambda_Markov[.,i]));
    i = i + 1;
  endo;

  endwind;

t = 300;
S_t = Survival_Markov_Generator(t,Lambda_Matrix);
f_t = Density_Markov_Generator(t,Lambda_Matrix);
lambda_infinity = f_t ./ S_t;

print ftosa(1e4*Lambda_infinity',"%lf",3,3);



