/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.1.2
**
*/

new;
library frm,pgraph,option,optmum;
frmSet;

cls;

rndseed 123;

nb = 1000;
nS = 2;

S0 = 100;
K = 100;
tau = 1;
mu = 0.10;
sigma = 0.20;
r = 0.05;

C0 = EuropeanBS(S0,K,sigma,Tau,r,r);

t = seqa(1/12,1/12,12);

St = simulate_GBM(S0,mu,sigma,t,nS);
Ct = EuropeanBS(St,K,sigma,Tau-t,r,r);
MtM = nb * (Ct - C0);
EAD = _max_(MtM,0);

results = {};
i = 1;
do until i > nS;
  results = results $~ ftosa(St[.,i]~Ct[.,i]~MtM[.,i]~EAD[.,i],"%lf",3,2~2~0~0);
  i = i + 1;
endo;

print results;

