new;
library frm,pgraph;

rndseed 123;

nb = 1000;

S0 = 100;
K = 100;
Tau = 1;
mu = 0.10;
sigma = 0.20;
r = 0.05;

C0 = EuropeanBS(S0,K,sigma,Tau,r,r);

nt = 12*20;
t = seqa(0,1/nt,nt+1);

nS = 50000;
St = simulate_GBM(S0,r,sigma,t,nS);
Ct = EuropeanBS(St,K,sigma,Tau-t,r,r);

MtM = nb * (Ct' - C0);
et = _max_(MtM,0);

nt = nt + 1;
indx_t = seqa(1,1,rows(t));

let alpha = 0.75 0.90;
PE = quantile(et,alpha)';
MPE = maxc(PE);
EE = meanc(et);
EPE = cumsumc(EE) ./ indx_t;
EEE = zeros(nt,1);
EEE[1] = EE[1];
i = 2;
do until i > rows(t);
  EEE[i] = _max_(EEE[i-1],EE[i]);
  i = i + 1;
endo;
EEPE = cumsumc(EEE)./ indx_t;

data = PE~EE~EPE~EEE~EEPE;
t_smooth = seqa(0,1/1000,1001);
data_smooth = zeros(rows(t_smooth),cols(data));
i = 1;
do until i > cols(data);
  data_smooth[.,i] = fspline(csspline(t,data[.,i],1,0.99999),t_smooth);
  i = i + 1;
endo;
data_smooth[1,.] = 0.0 * data_smooth[1,.];
MPE = maxc(data[.,1]);

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pysci = 1;

  xtics(0,1,0.2,2);
  ytics(0,2.5e4,0.5e4,2);
  xlabel("\216t");

  setwind(1);
    title("\216PE");
    _plegstr = "\202a\201 = 75%\000\202a\201 = 90%";
    _plegctl = {2 5 9 3};
    xy(t_smooth,data_smooth[.,1 2]);

  _plegctl = {2 5 1.8 4.20};
  ytics(0,7e3,1e3,2);

  setwind(2);
    _plegstr = "EE\000EPE";
    title("\216EE & EPE");
    xy(t_smooth,data_smooth[.,3 4]);

  setwind(3);
    _plegstr = "EEE\000EEPE";
    title("\216EEE & EEPE");
    xy(t_smooth,data_smooth[.,5 6]);

  endwind;


