/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.1.3
**
*/

new;
library frm,pgraph;

cls;

let MtM =  3.0  -2.0  2.0  -1.0;
let   N =  100    40   20    10;
let add_on = 0.5 1.5 8.0    8.0;
add_on = add_on/100;

CE = _max_(MtM,0);
A = N .* add_on;
results = CE~add_on~A;
results = results | sumc(results)';
results[rows(MtM)+1,2] = error(0);
print ftosa(results',"%lf",3,2);
EAD = sumc(CE) + sumc(A);
print ftos(EAD,"EAD = %lf",3,3);

print "-----------------------";

CE_G = sumc(CE);
A_G = sumc(A);

CE_N = _max_(sumc(MtM[1:2]),0) + _max_(sumc(MtM[3:4]),0); 
NGR = CE_N / CE_G;
A_N = (0.4 + 0.6 * NGR) .* A_G;
EAD = CE_N + A_N;

print ftos(CE_N,"Net CE = %lf",3,3);
print ftos(NGR,"NGR = %lf",3,3);
print ftos(A_N,"A_N = %lf",3,3);
print ftos(EAD,"EAD = %lf",3,3);