/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.1.3
**
*/

new;
library frm,pgraph;

cls;

Let MtM         =    30   -20    50;
let Notional    = 10000 10000  5000;
let M           = 10.00  4.00 10.00;
let Start_Date  =  0.00  0.00  1.00;
let End_Date    = 10.00  4.00 11.00;
let Time_Bucket =  3.00  2.00  3.00;
let Hedging_Set =  1.00  1.00  2.00;
S0_Swaption = 0.06;
K_Swaption = 0.05;
Sigma_Swaption = 0.50;
tau_Swaption = 1.00;
alpha = 1.4;

V = sumc(MtM);
RC = _max_(V,0.0); 

print ftosa(RC,"RC = %lf",3,2);

SD = SA_CCR_SD(Start_Date,End_Date);
d = SD .* Notional;
{delta,Delta_Swaption} = SA_CCR_Option_Delta(S0_Swaption,K_Swaption,Sigma_Swaption,tau_Swaption);

Delta = 1|-1|Delta_Swaption;
MF =  SA_CCR_MF(M,1);
Effective_Notional = SA_CCR_Effective_Notional(Delta,d,MF);
print ftosa(Start_Date~End_Date~SD~Delta~d~MF~Effective_Notional,"%lf",3,2);
print "-----------------------------------------";

Add_On = SA_CCR_Interest_Rate(Effective_Notional,Time_Bucket,Hedging_Set);

print ftosa(Add_On,"%lf",3,2);

AddOn_IR = sumc(Add_On);
m = SA_CCR_Multiplier(V,AddOn_IR);
PFE = m * AddOn_IR;

print ftos(PFE,"PFE = %lf",3,2);
EAD = alpha * (RC + PFE);
print ftos(EAD,"EAD = %lf",3,2);
print "-----------------------------------------";
AddOn_Aggregate = AddOn_IR;
{EAD,PFE} = SA_CCR_EAD(RC,V,AddOn_Aggregate);
print ftos(PFE,"PFE = %lf",3,2);
print ftos(EAD,"EAD = %lf",3,2);

