new;
library frm,pgraph,optmum;
frmSet;

rndseed 123;

copula_mtd = 0;

nS = 20000;
t = 1;
PD = 0.01~0.99;
lambda = -ln(1 - PD);
mu = 0;
sigma = 1;
rho = 0~0.25~0.50~0.748;

St = exp(-lambda*t);
x = seqa(-4,8/128,129);

if copula_mtd == 1;

  MtM = simulate_wwr_mtm(mu,sigma,PD[1],rho,nS);
  d = zeros(rows(x),cols(MtM));
  i = 1;
  do until i > cols(MtM);
    {d[.,i],F} = regKernelDensity(MtM[.,i],x);
    i = i + 1;
  endo;
  d1 = d;

  MtM = simulate_wwr_mtm(mu,sigma,PD[2],rho,nS);
  d = zeros(rows(x),cols(MtM));
  i = 1;
  do until i > cols(MtM);
    {d[.,i],F} = regKernelDensity(MtM[.,i],x);
    i = i + 1;
  endo;
  d2 = d;

else;

  B = cdfni(PD[1]);
  mu_B = mu + rho .* sigma .* sqrt(t) .* B;
  sigma_B = sqrt(1 - rho.^2) .* sigma .* sqrt(t);
  d1 = pdfn2(x,mu_B,sigma_B);

  B = cdfni(PD[2]);
  mu_B = mu + rho .* sigma .* sqrt(t) .* B;
  sigma_B = sqrt(1 - rho.^2) .* sigma .* sqrt(t);
  d2 = pdfn2(x,mu_B,sigma_B);

endif;

rho = 0.50;
PD = 0.01~0.10~0.50~0.99;
B = cdfni(PD);
mu_B = mu + rho .* sigma .* sqrt(t) .* B;
sigma_B = sqrt(1 - rho.^2) .* sigma .* sqrt(t);
d3 = pdfn2(x,mu_B,sigma_B);

graphset;
  window3d;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|1|3|5; _plwidth = 10; _pcolor = 1|2|3|4;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.30;
  _plegstr = "\202r\201 = 0\000\202r\201 = 25%\000\202r\201 = 50%\000\202r\201 = 75%";
  xtics(-4,4,1,2);
  ytics(0,0.6,0.1,2);
  xlabel("\216MtM");

  setwind(1);  
    title("\216PD = 1%");
    _plegctl = {2 5 7.8 3};
    xy(x,d1);

  setwind(2);  
    title("\216PD = 99%");
    _plegctl = 0;
    xy(x,d2);

  setwind(3);  
    title("\216\202r\201 = 50%");
    _plegstr = "PD = 1%\000PD = 10%\000PD = 50%\000PD = 99%";
    _plegctl = {2 5 7 3};
    xy(x,d3);

  endwind;


proc (1) = simulate_wwr_mtm(mu,sigma,PD,rho,nS);
  local B,u_tau,u,u_w,w,MtM;

  B = cdfni(PD);
  u_tau = cdfn(B);
  u = rndu(nS,1);
  u_w = cdfn(rho .* B + sqrt(1-rho^2) .* cdfni(u) );
  w = sqrt(t) * cdfni(u_w);
  MtM = mu + sigma * w;

  retp(MtM);
endp;


