new;
library frm,pgraph,optmum;
frmSet;

declare matrix t,lambda;

Notional = 1000;
F0 = 0.05;
mu = 0.02;
sigma = 0.25;
r = 0.05;
Maturity = 10;

all_lambda = 0.01~0.0020;
all_Recovery = 0.50;
all_Spread = (1 - all_Recovery) * all_lambda;

proc CVA_integral(u);
  local psi_u,EpE,g_u;
  
  psi_u = (1 - exp(-r*(Maturity - u))) ./ r;
  EpE = Notional .* F0 .* psi_u .* (exp(mu .* u) .* cdfn( (mu./sigma + 0.5 * sigma) .* sqrt(u)) - 
        cdfn( (mu./sigma - 0.5 * sigma) .* sqrt(u)));
  g_u = exp(-(r+lambda) .* (u-t)) .* EpE; 
  
  retp(g_u);
endp;

all_t = seqa(0,Maturity/200,201);
nT = rows(all_t);
CVA = zeros(nT,2);

i = 1;
do until i > nT;
  t = all_t[i];
  
  lambda = all_lambda[1];
  CVA[i,1] = quadLegendre1(&CVA_integral,Maturity|t,128);  

  lambda = all_lambda[2];
  CVA[i,2] = quadLegendre1(&CVA_integral,Maturity|t,128);  
  
  i = i + 1;
endo;

CVA = all_Spread .* CVA;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xlabel("\216t (in years)");
  ylabel("\216CVA(t)");
  xtics(0,10,1,2);  
  ytics(0,2,0.5,2);
  _plegstr = "\202l\201 = 100 bps\000\202l\201 = 20 bps";
  _plegctl = {2 5 6 5};
  xy(all_t,CVA);




  
  
  
