/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.2.2
**
*/

new;
library frm,pgraph;

cls;

let RW_j = 0.05 0.05 0.12;

let C_k   = 1    1    2    3   ; 
let EAD_k = 100  50   70   20  ;
let M_k   = 1    1    0.5  0.5 ;

let SH_h     =  1     2    ;
let varrho_h =  1.00  0.80 ;
let N_h      =  75    10   ;
let M_h      =  1.0   0.5  ;

RW_hprime = 0.7 * 0.12;
N_hprime  = 10;
M_hprime  = 0.5;

{K,K_reduced,K_hedged,results} = BA_CVA(RW_j,C_k,error(0),EAD_k,M_k,SH_h,varrho_h,N_h,M_h,RW_hprime,N_hprime,M_hprime);

DF_k = vread(results,"DF_k");
EAD_j = vread(results,"EAD_j");
SCVA_j = vread(results,"SCVA_j");
SNH_j = vread(results,"SNH_j");
HMA_j = vread(results,"HMA_j");
IH = vread(results,"IH");
K1 = vread(results,"K1");
K2 = vread(results,"K2");
K3 = vread(results,"K3");

print ftosa(DF_k,"%lf",5,4);
results = SCVA_j~SNH_j~HMA_j;
print ftosa(results,"%lf",5,3);
print ftosa(IH,"IH = %lf",5,3);
results = K1|K2|K3;
print ftosa(results,"%lf",5,3);
results = K_reduced|K_hedged|K;
print ftosa(results,"%lf",5,3);


