/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.2.4
**
*/

new;
library frm,pgraph,optmum;

cls;

let mu_t  = 0 1 2 3 4;
let var_t = 4 3 2 1 0;
sigma_t = sqrt(var_t);

n = rows(mu_t);
w = ones(n,1);

let H_vector  =  0 5 10 20;
let rho_vector = 0.00 0.50 0.90;
nH = rows(H_vector);
nRho = rows(rho_vector);
H_vector = H_vector .*. ones(nRho,1);
rho_vector = ones(nH,1) .*. rho_vector;
nIters = nH * nRho;

results = zeros(nIters,2+n+2+3);

iter = 1;
do until iter > nIters;
  H = H_vector[iter];
  rho = diagrv(rho_vector[iter]*ones(n,n),1.0);
  {mu_w,sigma_w,gamma_t,e_t,ec_mu,ec_sigma,ec_H,ec_t} = counterparty_collateral_EpE(w,mu_t,sigma_t,rho,H);
  ec_t = ec_t/e_t;
  results[iter,.] = mu_w~sigma_w~e_t~100*(ec_t'~sumc(ec_t))~100*(ec_mu~ec_sigma~ec_H)/e_t;
  iter = iter + 1;
endo;

print ftosa(H_vector~100*rho_vector~results,"%lf",10,3);

