/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.2.4
**
*/

new;
library frm,pgraph,optmum;

cls;

let mu_t    = 1 1;
let sigma_t = 1 1;
H = 0;

n = rows(mu_t);
w = ones(n,1);
params = seqa(-4,0.1,80);
nIters = rows(params);

rho_vector = -0.90|0.00|0.50|0.9999;
results = arrayinit(4|nIters|3,0);

iter = 1;
do until iter > nIters;
  mu_t[2] = params[iter];

  j = 1;
  do until j > 4;
    rho = diagrv(rho_vector[j]*ones(n,n),1.0);
    {mu_w,sigma_w,gamma_t,e_t,ec_mu,ec_sigma,ec_H,ec_t} = counterparty_collateral_EpE(w,mu_t,sigma_t,rho,H);
    results[j,iter,.] = e_t~ec_mu~ec_sigma;
    j = j + 1;
  endo;

  iter = iter + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _plwidth = 10; _pcolor = 1|4|2; _pltype = 6|1|3;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;
  xtics(-4,4,2,1);
  xlabel("\216\202m\201]2[(t)");
  _plegstr = "EpE(t)\000EpE]\202m\201[(t)\000EpE]\202s\201[(t)";
  _plegctl = 0;

  j = 1;
  setwind(j);
    title("\216\202r\201]1,2[ = -90%");
    xy(params,arraytomat(results[j,.,.]));

  j = 2;
  setwind(j);
    title("\216\202r\201]1,2[ = 0%");
    xy(params,arraytomat(results[j,.,.]));

  j = 3;
  setwind(j);
    title("\216\202r\201]1,2[ = 50%");
    xy(params,arraytomat(results[j,.,.]));

  j = 4;
  setwind(j);
    title("\216\202r\201]1,2[ = 100%");
    _plegctl = {2 5 1 4};
    xy(params,arraytomat(results[j,.,.]));

  endwind;