/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.2.4
**
*/

new;
library frm,pgraph,optmum;

cls;

let mu_t    = 1 1;
let sigma_t = 1 1;
H = 0;
rho1 = 0.00;

n = rows(mu_t);
w = ones(n,1);
params = 0.001|seqa(0.1,0.1,80);
nIters = rows(params);

results = zeros(nIters,2+1+n+3);

iter = 1;
do until iter > nIters;
  H = params[iter];

  rho = diagrv(rho1*ones(n,n),1.0);
  {mu_w,sigma_w,gamma_t,e_t,ec_mu,ec_sigma,ec_H,ec_t} = counterparty_collateral_EpE(w,mu_t,sigma_t,rho,H);
  ec_t = ec_t/e_t;
  results[iter,.] = mu_w~sigma_w~e_t~100*ec_t'~ec_mu~ec_sigma~ec_H;

  iter = iter + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _plwidth = 10; _pcolor = 1|4|2|3; _pltype = 6|1|3|5; _pstype = 8; 
  _plctrl = 0|0|0|10;
  xtics(0,7,1,1);
  xlabel("\216H");
  let xlab = "8" "7" "6" "5" "4" "3" "2" "1" "0";
  asclabel(xlab,0);
  ytics(-0.4,2.4,0.4,2);
  xtics(0,8,1,2);
  indx = 3|(3+n+1)|(3+n+2)|(3+n+3);
  _plegstr = "EpE(t;w)\000EpE]\202m\201[(t;w)\000EpE]\202s\201[(t;w)\000EpE]H[(t;w)";
  _plegctl = {2 5 1.5 3.5};
  xy(params,rev(results[.,indx]));
