/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 4.2.4
**
*/

new;
library frm,pgraph,optmum;

cls;

let mu_t    = 1 1;
let sigma_t = 1 1;
H = 0;
rho1 = 0.00;

n = rows(mu_t);
w = ones(n,1);
params = 0.001|seqa(0.1,0.1,80);
nIters = rows(params);

results = zeros(nIters,1);

iter = 1;
do until iter > nIters;
  H = params[iter];

  rho = diagrv(rho1*ones(n,n),1.0);
  {mu_w,sigma_w,gamma_t,e_t,ec_mu,ec_sigma,ec_H,ec_t} = counterparty_collateral_EpE(w,mu_t,sigma_t,rho,H);
  results[iter] = e_t;

  iter = iter + 1;
endo;

H = params;
Delta = 1 - Results ./ Results[nIters]; 

Delta_star = seqa(0.0001,0.999/(nIters-1),nIters);
H_star = mu_w - sigma_w .* cdfni(ec_mu/mu_w * Delta_star);
//H_star = mu_w - sigma_w .* cdfni(Delta_star);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pcolor = 1|4|2|3; _pltype = 6|1|3|5; _pstype = 8; 
  ytics(0,5,1,2);
  xtics(0,100,10,2);
  xlabel("\216\202d\201[*]");
  ylabel("\216H[*]");
  _plegstr = "True solution\000Approximated solution\000Rule of thumb";
  _plegctl = {2 5 5.0 5};
  xy(100*(Delta~Delta_star~Delta_star),H~H_star~0.70*H_star);
