new;
library frm,pgraph;
frmset;

sigma = 0.50;
t = seqa(0.001,0.01,2001);

fn EE(t) = exp(0.5 * sigma^2 .* t);

proc fn_EE(h);
  retp(EE(h));
endp;

Bounds = t'|zeros(1,rows(t));
num_EPE = quadLegendre1(&fn_EE,Bounds,64)./t;

fn EPE(h) = (exp(0.5 * sigma^2 .* h) - 1) ./ h ./ (0.5 * sigma^2);

fn EEE(t) = EE(t);

proc fn_EEE(h);
  retp(EEE(h));
endp;

num_EEPE = quadLegendre1(&fn_EEE,Bounds,64)./t;
EEPE = EPE(t);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6|1|3|5; _plwidth = 10; _pcolor = 1|2|3|4;
  _paxht = 0.25; _pnumht = 0.22; _ptitlht = 0.275;

  xtics(0,20,5,0);

  setwind(1);
    _pcolor = 1;
    title("\216EE(t)");
    xlabel("\216t (in years)");
    ytics(0,15,5,0);
    xy(t,EE(t));

  setwind(2);
    _pcolor = 2;
    title("\216EPE(0;t)");
    xlabel("\216t (in years)");
    ytics(0,5,1,0);
    xy(t,EPE(t));

  setwind(3);
    _pcolor = 3;
    title("\216EEE(0)");
    xlabel("\216t (in years)");
    ytics(0,15,5,0);
    xy(t,EEE(t));

  setwind(4);
    _pcolor = 4;
    title("\216EEPE(0;t)");
    xlabel("\216t (in years)");
    ytics(0,5,1,0);
    xy(t,num_EEPE);

  endwind;
