new;
library frm,pgraph,optmum;
frmSet;

Tau = 5;

sigma = 0.5;
t = seqa(0.001,Tau/500,501);

fn f(t) = (t^3) - 7/3 .* Tau .* (t^2) + 4/3 * (Tau^2) .* t;
fn df(t) = 3*(t^2) - 14/3 .* Tau .* t + 4/3 * (Tau^2) ;

g1 = df(t);
g2 = gradp1(&f,t);

fn f_min(x) = f(x);
fn f_max(x) = -f(x);
{tmin,fmin,grd,retcode} = optmum(&f_min,Tau);
t_min = Tau/3 * (14 + 2*sqrt(13))/6;
{tmax,fmax,grd,retcode} = optmum(&f_max,Tau);
t_max = Tau * (7 - sqrt(13))/9;

cls;

c = 3|(-14/3*Tau)|(4/3 * (Tau^2));
r = real(polyroot(c));
print ftosa(tmin~t_min~r[1],"%lf",3,5);
print ftosa(tmax~t_max~r[2],"%lf",3,5);

fn EE(t) = 0.5 * sigma .* f(t);

proc fn_EE(h);
  retp(EE(h));
endp;

Bounds = t'|zeros(1,rows(t));
num_EPE = quadLegendre1(&fn_EE,Bounds,64)./t;

fn EPE(h) = sigma ./ 72 .* ( 9*(h^3) - 28 .* Tau .* (h^2) + 24 * (Tau^2) .* h );
fn EEE(t) = EE(t) .* (t .< t_max) + EE(t_max) .* (t .>= t_max);

proc fn_EEE(h);
  retp(EEE(h));
endp;

num_EEPE = quadLegendre1(&fn_EEE,Bounds,64)./t;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6|1|3|5; _plwidth = 10; _pcolor = 1|2|3|4;
  _paxht = 0.25; _pnumht = 0.22; _ptitlht = 0.275;

  xtics(0,5,1,0);
  ytics(0,8,2,2);
 
  setwind(1);
    _pcolor = 1;
    title("\216EE(t)");
    xlabel("\216t (in years)");
    xy(t,EE(t));

  setwind(2);
    _pcolor = 2;
    title("\216EPE(0;t)");
    xlabel("\216t (in years)");
    xy(t,EPE(t));

  setwind(3);
    _pcolor = 3;
    title("\216EEE(t)");
    xlabel("\216t (in years)");
    xy(t,EEE(t));

  setwind(4);
    _pcolor = 4;
    title("\216EEPE(0;t)");
    xlabel("\216t (in years)");
    xy(t,num_EEPE);

  endwind;