/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.4.5
**
*/

new;
library frm,pgraph;
frmset;

Notional = 1e6;
sigma = 0.50;
T = 1;

/*
**> Question 1
**
*/

print;
print "=====================  Question 1  =======================================";

nS = 10000;
U = 2*rndu(nS,1) - 1.0;

MtM = Notional * sigma .* sqrt(t) .* U;
e_plus = _max_(0,MtM);
e_minus = -_min_(0,MtM);

x = seqa(-Notional,2*Notional/100,101);
F_plus = meanc(e_plus .<= x');
F_minus = meanc(e_minus .<= x');
F = _min_((0.5 + 0.5*x/(Notional*sigma*sqrt(t))) .* (x .>= 0),1.0);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|6;
  xy(x,F_plus~F_minus~F);

/*
**> Question 4
**
*/

print;
print "=====================  Question 4  =======================================";

lambda = 0.1;
s = 3/2;

proc fnProc(t);
  local y;
  y = sqrt(t) .* exp(-lambda .* t);
  retp(y);
endp;

I1 = quadLegendre1(&fnProc,T|0,128);
I2 = gamma(s) * cdfgam(s,lambda*T) / (lambda^s);
print I1|I2;
print "-------------------------------------------------";

print ftos(gamma(s),"gamma(3/2) = %lf",3,2);
I = (gamma(s) * cdfgam(s,lambda*T));
print ftosa(I,"gamma(s,lambda*T) = %lf",3,2);
print "-------------------------------------------------";

/*
**> Question 5
**
*/

print;
print "=====================  Question 5  =======================================";

lambda = seqa(1,1,2000);
lambda = lambda / 1e4;
R_B = 0.40;
Notional = 1e6;
sigma = 0.30;
T = 5~40;
 
CVA = Notional .* (1 - R_B) .* sigma .* gamma(s) .* cdfgam(s,lambda*T) ./ (4 *sqrt(lambda) );
CVA_limit = Notional .* (1 - R_B) .* sigma .* gamma(s) ./ (4 * sqrt(lambda) );

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
  xlabel("\216\202l\201]B[ (in %)");
  ytics(0,3e5,0.5e5,2);
  _plegstr = "T = 1\000T = 5\000T = \202\56\201";
  _plegctl = {2 5 6 5};
  xy(100*lambda,CVA~CVA_limit);
