/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.2.2
**
*/

new;
library frm,pgraph;
frmSet;

cls;

print "======================================================================================";

let GI_A[4,3] =  10  15 -30
                250 230 205
                 10  10  12
                 70  65  72;

let GI_B[4,3] = 200 300  150
                 50  45  -30
                  0   0    0
                 12   8   -4;

let alpha = 0.15;
let beta =  0.18 0.12 0.15 0.12;

/*
**> BIA
**
*/

sum_GI_A = sumc(GI_A);
sum_GI_B = sumc(GI_B);

{K_A,mean_GI_A} = Compute_BIA_Capital(sum_GI_A,alpha);
{K_B,mean_GI_B} = Compute_BIA_Capital(sum_GI_B,alpha);

results = (sum_GI_A|mean_GI_A)~(sum_GI_B|mean_GI_B);

print "------------------------------------------";
print ftosa(results,"%lf",3,2);
print "------------------------------------------";
print ftosa(K_A~K_B,"%lf",3,2);

/*
**> TSA
**
*/

{K_A,sum_K_A} = Compute_TSA_Capital(GI_A,beta);
{K_B,sum_K_B} = Compute_TSA_Capital(GI_B,beta);

results = sum_K_A~sum_K_B;

print "------------------------------------------";
print ftosa(results,"%lf",3,2);
print "------------------------------------------";
print ftosa(K_A~K_B,"%lf",3,2);

print "======================================================================================";

let GI_A[4,3] =  10  15 -30
                250 230 205
                 10  10  12
                 70  65  72;

let GI_B[4,3] = 200 300  -150
                 50  45   -30
                  0   0     0
                 12   8    -4;

let alpha = 0.15;
let beta =  0.18 0.12 0.15 0.12;

/*
**> BIA
**
*/

sum_GI_A = sumc(GI_A);
sum_GI_B = sumc(GI_B);

{K_A,mean_GI_A} = Compute_BIA_Capital(sum_GI_A,alpha);
{K_B,mean_GI_B} = Compute_BIA_Capital(sum_GI_B,alpha);

results = (sum_GI_A|mean_GI_A)~(sum_GI_B|mean_GI_B);

print "------------------------------------------";
print ftosa(results,"%lf",3,2);
print "------------------------------------------";
print ftosa(K_A~K_B,"%lf",3,2);

/*
**> TSA
**
*/

{K_A,sum_K_A} = Compute_TSA_Capital(GI_A,beta);
{K_B,sum_K_B} = Compute_TSA_Capital(GI_B,beta);

results = sum_K_A~sum_K_B;

print "------------------------------------------";
print ftosa(results,"%lf",3,2);
print "------------------------------------------";
print ftosa(K_A~K_B,"%lf",3,2);



