/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.1
**
*/

new;
library frm,pgraph;
frmSet;

cls;

mu = 8;
sigma = sqrt(5);
lambda = 50;
nS = 50000;

nPoisson = seqa(0,1,101);
prPoisson = pdfp(nPoisson,50);

xLN = seqa(-5,0.1,50) | seqa(0.005,0.005,499) | seqa(2.5,0.1,700);
xLN = exp(xLN);
dLN = pdfLN(xLN,mu,sigma);

rndseed 123;
S = rndLDA_LN(lambda,mu,sigma,nS);
x = seqa(10,1/10,101);
{d,F} = regKernelDensity(ln(S),x);

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/2,0);
  makewind(9/2,6.855/2,9/2,6.855/2,0);
  makewind(9/2,6.855/2,9/4,0,0);
  
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  _pltype = 6; _plwidth = 10; _pysci = 0;

  setwind(1);
    title("\216Loss frequency distribution");
    xtics(0,100,10,0);
    xlabel("\216N");
    _pbartyp = {6 1};
    bar(nPoisson,prPoisson);

  setwind(2);
    title("\216Loss severity distribution");
    xtics(0,20,5,5);
    _pcolor = 2;
    xlabel("\216ln X");
    xy(ln(xLN),dLN);

  setwind(3);
    title("\216Compound distribution");
    _pcolor = 4;
    xtics(10,20,2.5,5);
    xlabel("\216ln S");
    xy(x,d);

  endwind;

