/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.2
**
*/

new;
library frm,pgraph;
frmSet;

cls;

print "-------------------- Gamma ---------------------------------";

alpha = 5; beta = 0.2~0.1~0.03;
x = 1|3|10|50|17|25|250;
p = cdfGamma(x,alpha,beta);
y = invGamma(p,alpha,beta);

print ftosa(x~100*p~y,"%lf",3,2);

x = seqa(1,1,250);
y = pdfGamma(x,alpha,beta);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|4;
  xy(x,y);

end;

print "-------------------- Log-Gamma ---------------------------------";

alpha = 3.5; beta = 0.2~0.1~0.03;
x = 1|3|10|50|17|25|250;
p = cdfLogGamma(x,alpha,beta);
y = invLogGamma(p,alpha,beta);

print ftosa(x~100*p~y,"%lf",3,2);

x = seqa(1,1,250);
y = pdfLogGamma(x,alpha,beta);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|4;
  xy(x,y);

print "-------------------- Log-Logistic ---------------------------------";

alpha = 3.5; beta = 2~3~0.010;
x = 1|3|10|50|17|25|250;
p = cdfLogLogistic(x,alpha,beta);
y = invLogLogistic(p,alpha,beta);

print ftosa(x~100*p~y,"%lf",3,2);

x = seqa(1,1,250);
y = pdfLogLogistic(x,alpha,beta);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|4;
  xy(x,y);

print "-------------------- Pareto ---------------------------------";

alpha = 3.5; beta = 2~3~0.010;
x = 1|3|10|50|17|25|250;
p = cdfPareto(x,alpha,beta);
y = invPareto(p,alpha,beta);

print ftosa(x~100*p~y,"%lf",3,2);

x = seqa(1,1,250);
y = pdfPareto(x,alpha,beta);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|2|4;
  xy(x,y);
