/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.2
**
*/

new;
library frm,pgraph;
frmSet;

cls;

rndseed 123;

nS = 100;
mu = 8; sigma = 2;

rndseed 123;
u1 = rndt(100,1,8);
rndseed 123;
u2 = rndt(100,1,3);
e = (u1 .<= 1);
u = e .* u1 + (1-e) .* u2;
data = exp(mu + sigma .* u);
fn cdf(x) = cdfLN(x,mu,sigma);

{x,y} = qqplot(data,&cdf);

z = missex(y,y .<= 0.81);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1|4|4; _pstype = 1|1|8; _psymsiz = 3.5|3.5|1.5;
  _plctrl = 0~-1~-1;
  xlabel("\216Empirical quantile (in %)");
  ylabel("\216Theoretical quantile (in %)");
  _pline = 1~6~0~100~100~100~0~0~10 |
           1~6~100~100~100~0~0~0~10 |
           1~3~0~81~100~81~1~0~10 |
           1~3~81~100~81~0~1~0~10 ;
  xtics(0,100,10,0);
  ytics(0,100,10,0);
  xy(100*x,100*(x~y~z));
