/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.2
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

lambda = 5;
r = 7.3;
p = 0.2;

n = seqa(0,1,31);

print "-------------------- Poisson ----------------------";

pdf_p = pdfp(n,lambda);
cdf_p = cdfp(n,lambda);
rate_p = (n + 1) .* lagn(pdf_p,-1) ./ pdf_p;

results = n~100*pdf_p~100*cdf_p~rate_p |
          (error(0)~100*sumc(pdf_p)~error(0)~error(0));
print ftosa(results,"%lf",3,0~2~2~2); 

print "-------------------- NB ----------------------";

pdf_nb = pdfNB(n,r,p);
cdf_nb = cdfNB(n,r,p);
{x,retcode} = invcdfNB(cdf_nb,r,p);
rate_nb = (n + 1) .* lagn(pdf_nb,-1) ./ pdf_nb;

results = n~x~100*pdf_nb~100*cdf_nb~rate_nb |
          (error(0)~retcode~100*sumc(pdf_nb)~error(0)~error(0));
print ftosa(results,"%lf",3,0~2~2~2~2); 

y = p * n + p * r;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2;
  xy(n,rate_p~rate_nb~y);
  
print "-------------------- NB simulation ----------------------";  

mean_nb = sumc(pdf_nb .* n);
var_nb = sumc(pdf_nb .* (n - mean_nb)^2);

nS = 100000;
x = rndnb(ns,1,r,p);
results = mean_nb~(p * r / (1-p))~meanc(x)   |
          var_nb~(p * r / (1-p)^2)~stdc(x)^2 ;
print ftosa(results,"%lf",3,3);

print "-------------------- Gamma ----------------------";

alpha = r;
beta = (1-p)/p;
g = rndgam(nS,1,alpha)./beta;
results = meanc(g)~(alpha/beta)    |
          stdc(g)^2~(alpha/beta^2) ;
print ftosa(results,"%lf",3,4);

x = rndp(nS,1,g);

results = meanc(x)~(p * r / (1-p))    |
          stdc(x)^2~(p * r / (1-p)^2) ;
print ftosa(results,"%lf",3,4);