/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

lambda = 5;
mu = 9;
sigma = 2;

n = 100;
U = rndu(n-1,1);
T_n = -ln(1-U)/lambda;
T_n = 0|T_n;
tau_n = cumsumc(T_n);
N_t = seqa(0,1,n);
X_n = 0|rndLN(mu,sigma,n-1,1);

x = 20000;
indx = selif(seqa(1,1,n),X_n .>= x);
e = ones(rows(indx),1);
e1 = e; indx1 = indx;

x = 50000;
indx = selif(seqa(1,1,n),X_n .>= x);
e = ones(rows(indx),1);
e2 = e; indx2 = indx;

t = seqa(0,1/10,101);
cdf = cdfLN(20000~50000,mu,sigma);
lambda_prime = lambda .* (1 - cdf);
print ftosa(100*cdf|lambda_prime,"%lf",3,3);

pdf = lambda_prime .* exp(-lambda_prime .* t);

graphset;
  window3d;
  
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _pcolor = 2; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xtics(0,10,1,2);
  ytics(0,50,10,2);  
  
  setwind(1);
    title("\216x = 20000");
    {_pline,tmp} = xy_step_function(tau_n,N_t,6,2,10,1);    
    _psym = tau_n[indx1]~N_t[indx1]~e1.*(1~6.5~4~1~10);
    xlabel("\216Time t");
    ylabel("\216N(t)");
    draw;
   
  setwind(2);
    title("\216x = 50000");
    _psym = tau_n[indx2]~N_t[indx2]~e2.*(2~6.5~1~1~10);
    draw;

  setwind(3);
    title("\216PDF of T]n[(x)");
    xlabel("\216Duration");
    ylabel("\216PDF");
    xtics(0,10,2,2);
    ytics(error(0),0,0,0);
    _pline = 0; _psym = 0;
    _pltype = 1|3; _pcolor = 4|1;
    _plegstr = "x = 20000\000x = 50000";
    _plegctl = {2 5 6.5 3};
    ytics(0,2,0.5,2);
    xy(t,pdf);

  endwind;


