/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;
__output = 0;

rndseed 123;

mu = 9;
sigma = 2.0;
lambda = 500;

let x_s = 1.00  2.5  5.0  7.5  10  20;
x_s = x_s * 1e6;
let d_s = 0.25  1.0  3.0  6.0  10  40; 

d0 = 1 ./ (lambda * (1-cdfLN(x_s,mu,sigma)));

/*
**> w_s = 1
**
*/

sv = mu|sigma|40;
{mu,sigma,lambda,d1} = Scenario_Analysis(x_s,d_s,1,0,sv);
print ftosa(mu|sigma|lambda,"%lf",3,3);
theta1 = lambda|mu|sigma;

/*
**> w_s = 1/d_s
**
*/

w_s = 1./d_s;
{mu,sigma,lambda,d2} = Scenario_Analysis(x_s,d_s,w_s,0,sv);
print ftosa(mu|sigma|lambda,"%lf",3,3);
theta2 = lambda|mu|sigma;

/*
**> w_s optimal
**
*/

d3 = d2;
iter = 1;
do until iter > 6; 
  sv = mu|sigma|lambda;
  w_s = 1./d3;
  {mu,sigma,lambda,d3} = Scenario_Analysis(x_s,d_s,w_s,0,sv);
  iter = iter + 1;
endo;
print ftosa(mu|sigma|lambda,"%lf",3,3);
theta3 = lambda|mu|sigma;

print "----------------------------------------------";
print ftosa(theta1~theta2~theta3,"%lf",3,3);
print ftosa(d1'|d2'|d3',"%lf",3,3);
