/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

nS = 1e6; 
lambda = 4;
mu = 8;
sigma = 2;

loadm CaR;

nR = 100;
if nR > 0;
  CaR = zeros(nR,1)|CaR;
endif;

i = 1;
do until i > nR;
  S = rndLDA_LN(lambda,mu,sigma,nS);
  CaR[i] = quantile(S,0.999);
  i = i + 1;
endo;

save CaR;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _pcolor = 1; _plwidth = 10;
  _pbartyp = {6 1};
  xlabel("\216CaR");
  ylabel("\216Frequency (in %)");
  xtics(3.05e6,3.45e6,0.05e6,2);
  call histp(CaR,15);