/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

alpha = seqa(0.99,0.0001,100);
nAlpha = rows(alpha);
let lambda = 100  500  1000;
let mu     =   5   10     8;
let sigma  = 2.0  2.5   1.0;
let nS     = 1e6  1e6   1e6;

nIters = rows(lambda);
CaR_MC = zeros(nAlpha,nIters);
CaR_SLA = zeros(nAlpha,nIters);

loadm CaR_MC,CaR_SLA;

/*
i = 1; 
do until i > nIters;

  S = rndLDA_LN(lambda[i],mu[i],sigma[i],nS[i]);
  CaR_MC[.,i] = quantile(S,alpha);

  i = i + 1;
endo;
*/

CaR_SLA = SLA_LogNormal(lambda',mu',sigma',alpha,0);
CaR_SLA2 = SLA_LogNormal(lambda',mu',sigma',alpha,1);

save CaR_MC,CaR_SLA;

graphset;
  window3d;
  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _pcolor = 1|4|2; _plwidth = 10;
  _pnumht = 0.225; _paxht = 0.225; _ptitlht = 0.275;
  xlabel("\216\202a\201 (in %)");

  i = 1;
  setwind(i);
    str = "\202l\201 = "   $+ ftos(lambda[i],"%lf",1,0) $+ 
          ", \202m\201 = " $+ ftos(mu[i],"%lf",1,1) $+ 
          ", \202s\201 = " $+ ftos(sigma[i],"%lf",1,1);
    title("\216" $+ str);
    ytics(0,2.5e6,0.5e6,2);
    xy(100*alpha,CaR_SLA[.,i]~CaR_MC[.,i]);

  i = 2;
  setwind(i);
    str = "\202l\201 = "   $+ ftos(lambda[i],"%lf",1,0) $+ 
          ", \202m\201 = " $+ ftos(mu[i],"%lf",1,1) $+ 
          ", \202s\201 = " $+ ftos(sigma[i],"%lf",1,1);
    title("\216" $+ str);
    ytics(0,8e9,2e9,2);
    xy(100*alpha,CaR_SLA[.,i]~CaR_MC[.,i]);

  i = 3;
  setwind(i);
    str = "\202l\201 = "   $+ ftos(lambda[i],"%lf",1,0) $+ 
          ", \202m\201 = " $+ ftos(mu[i],"%lf",1,1) $+ 
          ", \202s\201 = " $+ ftos(sigma[i],"%lf",1,1);
    title("\216" $+ str);
    _plegstr = "SLA\000MC\000SLA[*]";
    _plegctl = {2 5 10 3.5};
    ytics(5e6,6e6,0.2e6,2);
    xy(100*alpha,CaR_SLA[.,i]~CaR_MC[.,i]~CaR_SLA2[.,i]);

  endwind;
