/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.3.3
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

sigma2 = 0.5~1~2;
sigma1 = 0.0001|seqa(0.1,0.1,40);
rho_plus = exp(-0.5*sigma1^2-0.5*sigma2^2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2;
  fonts("simplex simgrma");
  xlabel("\216\202\s\201]X[");
  ylabel("\216\202r\201[+] (in %)");
  xtics(0,3,0.5,5);
  ytics(0,100,20,2);
  _plegstr = "\202s\201]Y[ = 0.5\000\202s\201]Y[ = 1\000\202s\201]Y[ = 2";
  _plegctl = {2 5 6.5 5};
  xy(sigma1,100*rho_plus);

sigma1 = 2;
sigma2 = 2;
rho_plus = exp(-0.5*sigma1^2-0.5*sigma2^2);
print ftos(100*rho_plus,"rho+ = %lf",3,2);

sigma1 = 1.25;
sigma2 = 1.25;
rho_plus = exp(-0.5*sigma1^2-0.5*sigma2^2);
print ftos(100*rho_plus,"rho+ = %lf",3,2);

rho_plus = 0.20;
sigma1 = sqrt(-ln(rho_plus));
sigma2 = sigma1;
rho_plus = exp(-0.5*sigma1^2-0.5*sigma2^2);
print ftos(sigma1,"sigma- = %lf",3,2);





