/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.4.4
**
*/

new;
library frm,pgraph;
frmSet;

cls;

RW = zeros(5,1);
RWA = zeros(5,1);
K = zeros(5,1);
b = zeros(5,1);
psi = zeros(5,1);
rho = zeros(5,1);
K_star = zeros(5,1);

// Bank

i = 1;
EAD = 80;
PD = 0.01;
LGD = 0.75;
M = 1.0;

{RW[i],RWA[i],K[i]} = IRB_RWA_Corporate(EAD,LGD,PD,M,error(0));
b[i] = _irb_b;
psi[i] = _irb_psi;
rho[i] = _irb_rho;
K_star[i] = _irb_K_star;

// Corporate

i = 2;
EAD = 200;
PD = 0.05;
LGD = 0.60;
M = 2.0;
S = 500;

{RW[i],RWA[i],K[i]} = IRB_RWA_Corporate(EAD,LGD,PD,M,S);
b[i] = _irb_b;
psi[i] = _irb_psi;
rho[i] = _irb_rho;
K_star[i] = _irb_K_star;

// SME

i = 3;
EAD = 50;
PD = 0.02;
LGD = 0.40;
M = 4.5;
S = 30;

{RW[i],RWA[i],K[i]} = IRB_RWA_Corporate(EAD,LGD,PD,M,S);
b[i] = _irb_b;
psi[i] = _irb_psi;
rho[i] = _irb_rho;
K_star[i] = _irb_K_star;

// Mortgage

i = 4;
EAD = 50;
PD = 0.09;
LGD = 0.45;

{RW[i],RWA[i],K[i]} = IRB_RWA_Retail(EAD,LGD,PD,1);
b[i] = error(0);
psi[i] = error(0);
rho[i] = _irb_rho;
K_star[i] = _irb_K_star;

// Retail

i = 5;
EAD = 100;
PD = 0.04;
LGD = 0.85;

{RW[i],RWA[i],K[i]} = IRB_RWA_Retail(EAD,LGD,PD,3);
b[i] = error(0);
psi[i] = error(0);
rho[i] = _irb_rho;
K_star[i] = _irb_K_star;

Results = b~psi~100*rho~100*K_star~100*RW~RWA~K;
print ftosa(Results,"%lf",3,2);

RWA_Credit = sumc(RWA);
print ftosa(RWA_Credit,"RWA = %lf",3,2);

K_Credit = sumc(K);
print ftosa(K_Credit,"K = %lf",3,2);

