/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.4.4
**
*/

new;
library frm,pgraph;
frmSet;

cls;

rndseed 123;

u = rndu(1,1);
e = (u .<= 0.60);
N = e .* 5 + (1-e) .* 10;
print ftosa(u~N,"%lf",1,4);

u = rndu(N,1);
G = cdfni(u);
L = exp(8 + 2 * G);
Ls = sumc(L);
print ftosa(u~G~L,"%lf",1,4~4~2)';
print;
print ftosa(Ls,"%lf",1,2);


nR = 250;
/*
all_VaR = zeros(nR,1);

iter = 1;
do until iter > nR;

  nS = 1e6;
  u = rndu(nS,1);
  e = (u .<= 0.60);
  N = e .* 5 + (1-e) .* 10;

  e = ones(nS,10) .* seqa(1,1,10)';
  e = e .<= N;

  L = rndLN(8,2,nS,10);
  Ls = sumr(L .* e);
  VaR = quantile(Ls,0.999)/1e6;
  all_VaR[iter] = VaR;
  
  print /flush iter;
  
  iter = iter + 1;
endo;
  
save all_VaR;
  
print ftos(meanc(all_VaR),"VaR = %lf",3,2);
*/

loadm all_VaR;

print ftos(meanc(all_VaR),"VaR = %lf",3,2);
print ftos(quantile(all_VaR,0.05),"q(5) = %lf",3,2);
print ftos(quantile(all_VaR,0.95),"q(95) = %lf",3,2);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plype = 6; _plwidth = 10; _pcolor = 1|2|4;
  _pbartyp = {6 1};
  xlabel("\216VaR (in $ mn)");
  ylabel("\216Frequency (in %)");
  xtics(4.15,4.60,0.05,2);
  call histp(all_VaR,40);

