/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 5.4.5
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

rndseed 123;

alpha = 3430; beta = 3.32;
loss = 4000 + 2000*rndn(10,1);
loss = trunc(loss);
print ftosa(loss,"%lf",3,2);
Threshold = 500;

/*
**> Question 1
**
*/

print;
print "=====================  Question 1  =======================================";

fn cdf(x) = cdfLogLogistic(x,alpha,beta);
pdf1 = gradp1(&cdf,loss);
pdf2 = pdfLogLogistic(loss,alpha,beta);

print ftosa(pdf1./pdf2,"%lf",3,5);

/*
**> Question 2
**
*/

print;
print "=====================  Question 2  =======================================";

fn sumc_ln(x) = sumc(ln(x));

proc mlProc1(theta);
  local alpha,beta,pdf,LogL;

  theta = sqrt(theta^2);

  alpha = theta[1]; 
  beta = theta[2];
  pdf = pdfLogLogistic(loss,alpha,beta);
  LogL = sumc(ln(pdf));

  retp(-Logl);
endp;

proc mlProc2(theta);
  local alpha,beta,n,LogL;

  theta = sqrt(theta^2);

  alpha = theta[1]; 
  beta = theta[2];
  n = rows(loss);
  LogL = n * ln(beta) - n * beta * ln(alpha) + (beta-1) * sumc_ln(loss) -
         2 * sumc_ln(1 + (loss/alpha)^beta); 

  retp(-Logl);
endp;

theta = alpha|beta;
Logl = mlProc1(theta)|mlProc2(theta);

print Logl;

/*
**> Question 3
**
*/

print;
print "=====================  Question 3  =======================================";

__output = 0;
let sv = 2 2;
_opgtol = 1e-7;
{theta,fmin,grd,retcode} = optmum(&mlProc2,sv);
theta = sqrt(theta^2);
alpha = theta[1]; 
beta = theta[2];
print ftos(alpha,"alpha = %lf",3,3);
print ftos(beta,"beta = %lf",3,3);
eq1 = sumc(cdfLogLogistic(loss,alpha,beta))~rows(loss)/2;
eq2 = sumc((2*cdfLogLogistic(loss,alpha,beta)-1).*ln(loss))~rows(loss)/beta;
print ftosa(eq1|eq2,"%lf",3,5);

alpha = 3430.05; 
beta = 3.315;
print ftos(alpha,"alpha = %lf",3,3);
print ftos(beta,"beta = %lf",3,3);
eq1 = 2*sumc(cdfLogLogistic(loss,alpha,beta))~rows(loss);
eq2 = beta*sumc((2*cdfLogLogistic(loss,alpha,beta)-1).*ln(loss))~rows(loss);
print ftosa(eq1|eq2,"%lf",3,5);

/*
**> Question 4
**
*/

print;
print "=====================  Question 4  =======================================";

proc mlProc3(theta);
  local alpha,beta,pdf,LogL;

  theta = sqrt(theta^2);

  alpha = theta[1]; 
  beta = theta[2];
  pdf = pdfLogLogistic(loss,alpha,beta);
  LogL = sumc(ln(pdf) - ln(1-cdfLogLogistic(Threshold,alpha,beta)));

  retp(-Logl);
endp;

proc mlProc4(theta);
  local alpha,beta,n,LogL;

  theta = sqrt(theta^2);

  alpha = theta[1]; 
  beta = theta[2];
  n = rows(loss);
  LogL = n * ln(beta) - n * beta * ln(alpha) + (beta-1) * sumc_ln(loss) -
         2 * sumc_ln(1 + (loss/alpha)^beta) + n*sumc_ln(1 + (Threshold/alpha)^beta); 

  retp(-Logl);
endp;

theta = alpha|beta;
Logl = mlProc3(theta)|mlProc4(theta);

print Logl;


