/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 6.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

let data[5,4] = 
 65201 26.325  70201 26.340
 85201 26.320 116201 26.345
105201 26.315 107365 26.350
 76500 26.310  35000 26.355
 20000 26.305  35178 26.360;

P_Bid = 26.325;
P_Ask = 26.340;
P_Mid = (P_Bid + P_Ask)/2;
Spread = (P_Ask - P_Bid)/P_Mid;

print ftos(P_Mid,"P_Mid = %lf",3,6);
print ftos(1e4*Spread,"Spread = %lf",3,6);

e = miss(zeros(5,1),0);
x = rev(data[.,2])|data[.,4];
y = (rev(data[.,1])|e)~(e|data[.,3]);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  setwind(1);
    _pdate = ""; _pnum = 2; _pframe = 0;
    _pbartyp = {6 1,6 4}; _pbarwid = 0.3;
    xtics(26.30,26.37,0.01,2);
    ytics(0,1.2e5,0.2e5,2);
    _plegstr = "Bid\000Ask";
    _plegctl = {2 6 7.5 5};
    xlabel("\216Quote");
    ylabel("\216Quantity");
    _pmsgstr = "Spread";
    _pmsgctl = 26.3275~71000~0.20~0~1~0~10;
    bar(x,y);

  setwind(2);
    _paxes = 0; _plegctl = 0; _pmsgctl = 0; xlabel(""); ylabel("");
    _parrow = 26.329~6.75~26.3404~6.75~5~0.20~22~0~1~6~10;
    ytics(0,12,2,2);
    draw;

  endwind; 