/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 6.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

let v = 200 100   200   300   200  500;
let h = 0.0 0.0  0.15  0.15  0.25 0.50;

{x,x_HQLA,x_results} = Calculate_HQLA(v,h);

all_results = v~100*h~x;
print ftosa(all_results,"%lf",3,2);

print ftosa(x_results,"%lf",3,2);

let v = 15000  2800  5000  1000   200; 
let r =  0.03  0.05   0.0  0.05  0.40;

x = v .* r;
x_outflows = sumc(x);
results = v~100*r~x;
print ftosa(results,"%lf",3,2);

let v =  100   10; 
let r = 0.50 1.00;

x = v .* r;
x_inflows = sumc(x);
results = v~100*r~x;
print ftosa(results,"%lf",3,2);

x_net = x_outflows - x_inflows;
results = x_HQLA|x_outflows|x_inflows|x_net;
print ftosa(results,"%lf",3,2);


LCR = x_HQLA/(x_outflows - x_inflows);
print ftos(100*LCR,"LCR = %lf",3,2);


proc (3) = Calculate_HQLA(x,h);
  local x1,x2,x2A,x2B,x_HQLA,x1_star,x2_star,x2A_star,x2B_star,x_sum;

  x = x .* (1-h);
  x1 = selif(x,h .== 0);
  x2A = selif(x,h .== 0.15);
  x2B = selif(x,(h .== 0.25) .or (h .== 0.50));

  x1 = missrv(sumc(x1),0);
  x2A = missrv(sumc(x2A),0);
  x2B = missrv(sumc(x2B),0);
  x2 = x2A + x2B;

  x_HQLA = _min_(5/3*x1,x1+x2);
  x1_star = x1;
  x2_star = x_HQLA - x1_star;
  x2A_star = _min_(x2_star,x2A);
  x2B_star = x2_star - x2A_star;

  x_sum = (x1|x2|x2A|x2B|(x1+x2))~(x1_star|x2_star|x2A_star|x2B_star|x_HQLA);

  retp(x,x_HQLA,x_sum);
endp;

  


