new;
library frm,pgraph,optmum;

cls;

let Notional = 100.0 50.00 40.00 110.0      120.0  80.0 70.00 30.00;
let Maturity =  10.0 16.00  8.00  7.00       10.0   5.0 10.00 20.00;
let IR       =  5.00  8.00  3.00  2.00       5.00  3.00  4.00  0.00;
IR = IR / 100;
let Schedule1 =  1     1     1     1          1     1     1     0   ;
let Schedule2 =  2     2     2     2          2     2     2     0   ;
let Schedule3 =  3     3     3     3          3     3     3     0   ;
let Schedule4 =  2     2     1     3          2     1     3     0   ;
let Weight =   -1    -1    -1    -1          1     1     1     1   ;
   
p = 12;
Maturity = Maturity*p;
IR = IR / p;

Schedule = Schedule1~Schedule2~Schedule3~Schedule4;
Gap = zeros(20*12+1,4);

iter = 1;
do until iter > 4;
  {t,Gap[.,iter],Outstanding} = alm_amortization(Notional,Maturity,IR,Schedule[.,iter],Weight);
  iter = iter + 1;
endo;

results = outstanding[.,1:4]~sumr(outstanding[.,1:4])~outstanding[.,5:8]~sumr(outstanding[.,5:8])~sumr(outstanding[.,5:8])-sumr(outstanding[.,1:4])~Gap[.,4];
t_star = seqa(1,1,12)|seqa(0,12,17);
indx = indnv(t_star,t);
t_star = seqa(1,1,12)|seqa(0,1,17);
print ftosa(t_star~results[indx,.],"%lf",3,0~1~1~1~0~1~1~1~0~0~1~2~2);

t = t / p;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5; _pcolor = 1|4|2|3; _plwidth = 10;
  _pnumht = 0.22; _paxht = 0.25; _ptitlht = 0.270;
  xtics(0,20,2,2);
  //let xlab = "0" "" "" "" "" "5" "" "" "" "" "10" "" "" "" "" "15" "" "" "" "" "20" "";
  // asclabel(xlab,0);
  xlabel("\216Time t (in years)");
  e = ones(rows(t),1);

  iter = 1;
  do until iter > 4;
    setwind(iter);
    if iter == 1;
      title("\216Constant amortization"); 
      ytics(-30,40,10,2);
    elseif iter == 2;
      title("\216Constant annuity"); 
      ytics(-30,40,10,2);
    elseif iter == 3;
      title("\216Bullet repayment"); 
      ytics(-80,80,20,2);
    elseif iter == 4;
      title("\216Mixed schedule"); 
      ytics(-80,80,20,2);
    endif;

    _pbartyp = 6~iter;
 // _psym = t~gap[.,iter]~e .*(8~0.5~4~1~10);
    _pline = add_lines(t,gap[.,iter],3,0,10);
    bar(t,Gap[.,iter]);
    iter = iter + 1;
  endo;

  endwind;

