new;
library frm,pgraph,optmum;

cls;

t = seqa(0,0.1,301);

params = 0.08|-0.07|0.06|10;
R0 = NelsonSiegel_Spot_Rate(params,t);
R0 = R0 .* ones(1,6);

S0 = 200;
S1 = 250;
S2 = 100;
stress1 = standardized_ir_shock(S0,S1,S2,t);
R1 = R0 + 1e-4 * stress1;

S0 = 400;
S1 = 500;
S2 = 300;
stress2 = standardized_ir_shock(S0,S1,S2,t);
R2 = R0 + 1e-4 * stress2;

graphset;
  begwind;
  window(2,2,1);
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 0;
  _pltype = 6|3|1; _pcolor = 1|4|2; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
1
  xtics(0,30,5,2);
  xlabel("\216Maturity (in years)");

  indx = 1;
  setwind(1);
    title("\216Parallel shock up");
    ytics(0,12,2,2);
    xy(t,100*(R0[.,indx]~R1[.,indx]~R2[.,indx]));

  indx = 3;
  setwind(2);
    title("\216Steepener shock");
    ytics(-2,10,2,2);
    xy(t,100*(R0[.,indx]~R1[.,indx]~R2[.,indx]));

  indx = 4;
  setwind(3);
    title("\216Flattener shock");
    ytics(0,8,2,2);
    xy(t,100*(R0[.,indx]~R1[.,indx]~R2[.,indx]));

  indx = 5;  
  setwind(4);
    title("\216Short rates shock up");
    ytics(0,8,2,2);
    _plegstr = "Initial yield curve\000Stressed yield curve (EUR)\000Stressed yield curve (EM)";
    _plegctl = {2 5 2.5 1.5};
    xy(t,100*(R0[.,indx]~R1[.,indx]~R2[.,indx]));

  endwind;
