new;
library frm,pgraph,optmum;

cls;

params = 0.08|-0.07|0.06|10;
S0 = 200;
S1 = 300;
S2 = 150;

print "-------------------- Assets ----------------------";

let   Assets =   200   700    100;
let t_Assets = 0.875   4.5   12.5;

R_Assets = NelsonSiegel_Spot_Rate(params,t_Assets);
EV_Assets = Assets .* exp(-R_Assets .* t_Assets);
results = t_Assets~Assets~100*R_Assets~EV_Assets |
          error(0)~error(0)~error(0)~sumc(EV_Assets);
print ftosa(results,"%lf",3,2);

print "---------------- Liabilities ----------------------";

let   Liabilities =    100    50  450   100   100;
let t_Liabilities = 0.0028 0.625  2.5   3.5   7.5;

R_Liabilities = NelsonSiegel_Spot_Rate(params,t_Liabilities);
EV_Liabilities = Liabilities .* exp(-R_Liabilities .* t_Liabilities);
results = t_Liabilities~Liabilities~100*R_Liabilities~EV_Liabilities |
          error(0)~error(0)~error(0)~sumc(EV_Liabilities);
print ftosa(results,"%lf",3,2);

print "--------------------- EVE -------------------------";
EVE = sumc(EV_Assets) - sumc(EV_Liabilities); 
print ftos(EVE,"EVE = %lf",3,2);

print "-------------- Stressed Assets --------------------";

stress = standardized_ir_shock(S0,S1,S2,t_Assets);
stressed_R_Assets = R_Assets + 1e-4 * stress;
stressed_EV_Assets = Assets .* exp(-stressed_R_Assets .* t_Assets);
results = 100*stressed_R_Assets|
          stressed_EV_Assets |
          sumc(stressed_EV_Assets)';
print ftosa(results,"%lf",3,2);

print "-------------- Stressed Liabilities --------------------";

stress = standardized_ir_shock(S0,S1,S2,t_Liabilities);
stressed_R_Liabilities = R_Liabilities + 1e-4 * stress;
stressed_EV_Liabilities = Liabilities .* exp(-stressed_R_Liabilities .* t_Liabilities);
results = 100*stressed_R_Liabilities|
          stressed_EV_Liabilities |
          sumc(stressed_EV_Liabilities)';
print ftosa(results,"%lf",3,2);

print "--------------------- Delta EVE -------------------------";
stressed_EVE = sumc(stressed_EV_Assets) - sumc(stressed_EV_Liabilities); 
Delta_stressed_EVE = EVE - stressed_EVE;
results = stressed_EVE' | Delta_stressed_EVE';
print ftosa(results,"%lf",3,2);

Delta_EVE = maxc(Delta_stressed_EVE);

print Delta_EVE;


