/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

beta0 =   1.02;
beta1 =   0.2; 
beta2 =  -7;
beta3 =   5.0;
beta4 =   0.0;

i = 0.03~0.05~0.07;
r = seqa(0,0.08/200,201);
g3 = ln(beta0 + beta1 * arctan(beta2 + beta3 * (i./r) ) + beta4 .* i);

delta = 0.299;
mu_star = 0.05;
sigma_star = 0.01;
delta_minus = 0.10;
g2 = delta .* cdfn((mu_star - r)./sigma_star) - delta_minus;

beta2 = -4;
g1 = beta2*(r - i);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|1|3; _pcolor = 1|4|2; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xtics(0,8,1,2);

  xlabel("\216r(t) (in %)");
  ylabel("\216g(t) (in %)");
  _plegstr = "i(t) = 3%\000i(t) = 5%\000i(t) = 7%";
  _plegctl = {2 5 9 3.5};

  setwind(1);
    title("\216O'Brien model");
    ytics(-20,30,10,2);
    xy(100*r,100*g1);

  _plegctl = 0;

  setwind(2);
    title("\216Frachot model");
    ytics(-10,20,10,2);
    xy(100*r,100*g2);

  setwind(3);
    title("\216OTS model");
    ytics(-30,30,10,2);
    xy(100*r,100*g3);

  endwind;


