/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

dataset = "..\\..\\data\\FRED-MORTGAGE.dat";
y = loadd(dataset);

rate30y = y[.,2];
rate15y = y[.,3];
diff = lagn(rate30y,15) - rate15y;

t = y[.,1];
dt = etdays2(lag1(t),t);
dt[1] = 0;
dt0 = etdays2(19710101,t[1]);
t0 = 1971 + dt0/365.25;
t = t0 + cumsumc(dt)/365.25;

graphset;
  window3d;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|4|2; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  setwind(1);
    _pcolor = 1;
    title("\21630Y mortgage rate (in %)");
    ytics(0,20,4,2);
    xtics(1970,2020,10,2);
    xy(t,rate30y);

  setwind(2);
    _pcolor = 2;
    title("\21615Y mortgage rate (in %)");
    ytics(0,10,2,2);
    xtics(1990,2020,5,2);
    xy(t,rate15y);

  setwind(3);
    _pcolor = 1|2; _pgrid = {3,1}; _pbartyp = {6 4};
    title("\216\202D\201i(t) = i]30Y[(t-15Y)-i]15Y[(t)");
    ytics(0,12,2,2);
    bar(t,lagn(rate30y,15*52)-rate15y);

  endwind;


