/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

age = seqa(0,1/12,6*12);
lambda_age = _min_(0.4*age,1);

month = seqa(0,0.1,240);
lambda_season = 1 + 0.20 * sin(1.571 .* ((12 + month - 3)/3) - 1.0);

i0 = 0.04~0.05~0.06;
i3 = seqa(0,0.12/100,101);
lambda_rate = 0.2406 - 0.1389 * arctan(5.952 * (1.089 - i0./i3));

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|4|2; _plwidth = 10;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;

  setwind(1);
    xtics(0,6,1,2);
    ytics(0,1,0.2,2);
    xlabel("\216Age (in years)");
    title("\216\202l\201]age[");
    xy(age,lambda_age);

  setwind(2);
    xtics(1,24,6,2);
    let xlab = "Jan" "Jul" "Jan" "Jul" "Jan";
    asclabel(xlab,0);
    ytics(0.8,1.2,0.1,2);
    xlabel("\216Month");
    title("\216\202l\201]seasonality[");
    xy(month,lambda_season);

  setwind(3);
    xtics(0,12,2,2);
    asclabel(0,0);
    ytics(0,0.5,0.1,2);
    xlabel("\216Current mortage rate (in %)");
    _plegstr = "i]0[ = 4%\000i]0[ = 5%\000i]0[ = 6%";
    _plegctl = {2 5.5 6 4};
    title("\216\202l\201]rate[");
    xy(100*i3,lambda_rate);

  endwind;


