/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

Maturity = 10;
months = seqa(0,1,12*Maturity+1);
u = months/12;
age = u;
lambda_age = _min_(0.4*age,1);
lambda_season = 1 + 0.20 * sin(1.571 .* ((12 + months - 3)/3) - 1.0);

i0 = 0.05;
t3 = 6;
i3 = 0.05 .* (u .<= t3) + 0.01 .* (u .> t3);
lambda_rate = 0.2406 - 0.1389 * arctan(5.952 * (1.089 - i0./i3));

lambda = Lambda_age .* lambda_season .* lambda_rate;
lambda = 1.0 * lambda;

lambda_int = zeros(rows(u),1);
i = 2;
do until i > rows(u);
  lambda_int[i] = lambda_int[i-1] + lambda[i]*1/12;
  i = i + 1;
endo;

S = exp(-lambda_int);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|4|2; _plwidth = 10;
  xtics(0,10,1,2);
  ytics(0,1,0.2,2);
  xlabel("\216u (in years)");
  ylabel("\216S]p[(t,u)");
  _pline = 1~1~2.5~0~2.5~1~1~4~10| 
           1~3~t3~0~t3~1~1~4~10;
  xy(u,S);

