/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

Maturity = 3;
months = seqa(0,1,12*Maturity+1);
u = months/12;
i0 = 0.02;
itau = 0.03;
tau = seqa(0,1/12,3*12+1); 
rho = 0.0;

{V1,V2} = compute_V(100,Maturity,i0,tau,itau,rho,0.00);
rho = 1 - Months/(12*Maturity);
{V1,V3} = compute_V(100,Maturity,i0,tau,itau,rho,0.00);
{V1,V4} = compute_V(100,Maturity,i0,tau,itau,rho,0.02*rho);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5; _pcolor = 1|4|2|5; _plwidth = 10;
  ytics(105,110,1,2);
  xtics(0,3,0.5,2);
  xlabel("\216t (in years)");
  _plegstr = "V]0[\000\216\202f\201=0, c=0\000\216\202f\201=1-t/m,c=0\000\216\202f\201=1-t/m,c=0.02\202f\201";
  _plegctl = {2 5 5.5 5};
  xy(Months/12,(V1~V2~V3~V4));

proc (2) = compute_V(N0,m,i0,tau,itau,rho_i,fee);
  local V1,V2,e;

  i0 = i0/12;
  itau = itau/12;
  V1 = N0 .* (1+i0)^(12*m);
  V2 = N0 .* ((1 + (1-rho_i).*i0).^(12*tau)) .* ((1 + itau) .^ (12*(m-tau))) - fee .* N0;

  e = ones(rows(V2),cols(V2));
  V1 = V1 .* e;

  retp(V1,V2);
endp;


