/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

Maturity = 3;
months = seqa(0,1,12*Maturity+1);
i0 = 0.02;
itau = 0.03;
t = seqa(0,1/12,3*12); 
rho = 1 - t/Maturity;

i1 = compute_it(Maturity,i0,t,rho,0.00);
i2 = compute_it(Maturity,i0,t,rho,0.02);
i3 = compute_it(Maturity,i0,t,rho,0.02*rho);
i4 = compute_it(Maturity,0.05,t,rho,0.02*rho);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|5; _pcolor = 1|4|2|5; _plwidth = 10;
  ytics(2,8,2,2);
  xtics(0,3,0.5,2);
  xlabel("\216t (in years)");
  ylabel("\216i[*](t) (in %)");
  _plegstr = "\216c(t)=0\000\216c(t)=2%\000\216c(t)=2%\202\46\201(1-t/m)";
  _plegctl = {2 5 1.5 5};
  xy(t,100*(i1~i2~i3));

proc (1) = compute_it(m,i0,t,rho,ct);
  local it;

  t = missex(t,t .== m);
  it = (((1+i0/12)^(12*m) + ct) ./ ((1 + (1-rho) .* (i0/12))^(12*t))) ^ (1/(12*(m-t))) - 1;
  it = 12*it;

  retp(it);
endp;


