/*
** Thierry Roncalli
** Lectures Notes on Risk Management & Financial Regulation
**
**> Page ??, Section 7.1.1
**
*/

new;
library frm,pgraph,optmum;
frmSet;

cls;

declare matrix i,t,u,m;

proc fn1(s);
  retp(1 - exp(-i*(s+m-u)));
endp;

proc fn2(s);
  retp(1 - exp(-i*(s+m-t)));
endp;

proc g1(s);
  retp( s + exp(-i*(s+m-u))./i);
endp;

proc f1(t,u);
  retp( t+m - u + ( exp(-i*(t+m-u)) - 1)./i);
endp;

proc f2(t,u);
  retp( m + ( exp(-i*m) - 1)./i);
endp;

proc g2(s);
  retp( s + exp(-i*(s+m-t))./i);
endp;

proc S_CAM(t,u);
  local Stu;
  Stu = (i*(t + m - u) + exp(-i*(t+m-u)) - 1)./(i*m + exp(-i*m) - 1);
  retp(Stu);
endp;

i = 0.05;
t = 2;
u = 5.0;
m = 5.3;

xl = t | u-m;
I1 = quadLegendre1(&fn1,xl,64);
print I1~(g1(t)-g1(u-m))~f1(t,u);

xl = t | t-m;
I2 = quadLegendre1(&fn2,xl,64);
print I2~(g2(t)-g2(t-m))~f2(t,u);

S1 = I1./I2;
S2 = S_CAM(t,u);

print S1~S2;

