new;
library frm,pgraph,optmum;

cls;

proc compute_it(t,r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
  local y;
  y = i0 + (1 - exp(-beta.*t)) .* (r0 + alpha./beta - i0);
  retp(y);
endp;

alpha = -0.01~0.00~0.01;
beta = 0.5;
gamma_ = 0.7;
delta = 0.5;
i0 = 0.05;
r0 = 0.10;
D0 = 100;
D_inf = 150;

t = seqa(0,0.1,101);
nt = rows(t);
e = ones(nt,1);

it =  compute_it(t,r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
i_inf = r0 + alpha ./ beta;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2;
  xlabel("\216t (in years)");
  ylabel("\216i(t) (in %)");
  _plegstr = "\202a\201 = -1%\000\202a\201 = 0\000\202a\201 = 1%";
  _plegctl = {2 5 6 1.5};
  _pline = 1~6~0~100*r0~10~100*r0~1~0~10;
  xy(t,100*it);
 
 