new;
library frm,pgraph,optmum;
frmset;

cls;

declare matrix alpha,beta,gamma_,delta;
declare matrix r0,i0,D0,D_inf;

proc proc_it(t);
  local y;
  y = i0 + (1 - exp(-beta.*t)) .* (r0 + alpha./beta - i0);
  retp(y);
endp;

proc proc_margin(t);
  local y;
  y = exp(-beta.*t) .* (r0  - i0) - alpha./beta .* (1 - exp(-beta.*t));
  retp(y);
endp;

proc proc_Dt(t);
  local y;
  y = D_inf + exp(-gamma_.*t) .* (D0  - D_inf) - 
      delta .* (exp(-beta.*t) - exp(-gamma_.*t)) .* (r0 - i0) ./ (gamma_ - beta) - 
      alpha .* delta ./ beta .* ( (1-exp(-gamma_.*t))./gamma_ - (exp(-beta.*t) - exp(-gamma_.*t)) ./ (gamma_ - beta) );
  retp(y);
endp;

proc _proc_V0(t);
  local y;
  y = exp(-r0.*t) .* proc_margin(t) .* proc_Dt(t);
  retp(y);
endp;

proc proc_V0(mtd);
  local y;

  if mtd == 1;
    y = quadLegendre1(&_proc_V0,10|0,64);
  else;
    y = (r0 - i0) .* D_inf ./ (r0 + beta) + (r0 - i0) .* (D0 - D_inf) ./ (r0 + beta + gamma_) +
        delta .* ((r0 - i0)^2) ./ (r0 + beta + gamma_) ./ (gamma_ - beta) - 
        delta .* ((r0 - i0)^2) ./ (r0 + 2*beta) ./ (gamma_ - beta); 
  endif;
  retp(y);
endp;

alpha = 0.00;
beta = 0.5;
gamma_ = 0.7;
delta = 0.5;
i0 = 0.05;
r0 = 0.10;
D0 = 100;
D_inf = 150;

V1 = proc_V0(0);
V2 = proc_V0(1);

print V1|V2;

 