new;
library frm,pgraph,optmum;
frmset;

cls;

proc (4) = compute_Dt(t,r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
  local y1,y2,y3,y;
  y1 = D_inf + exp(-gamma_.*t) .* (D0  - D_inf);
  y2 = -delta .* (exp(-beta.*t) - exp(-gamma_.*t)) .* (r0 - i0) ./ (gamma_ - beta);
  y3 = alpha .* delta ./ beta .* ( (1-exp(-gamma_.*t))./gamma_ - (exp(-beta.*t) - exp(-gamma_.*t)) ./ (gamma_ - beta) );
  y = y1 + y2 + y3;
  retp(y,y1,y2,y3);
endp;

alpha = -0.01;
beta = 0.5;
gamma_ = 0.3~0.7;
delta = 0.5;
i0 = 0.05;
r0 = 0.10;
D0 = 100;
D_inf = 150;

t = seqa(0,0.1,101);
nt = rows(t);
e = ones(nt,1);

{Dt,D1,D2,D3} =  compute_Dt(t,r0,i0,D0,D_inf,alpha,beta,gamma_,delta);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|4|2;
  xlabel("\216t (in years)");
  ylabel("\216Deposits");
  _plegstr = "\202g\201 = 0.3\000\202g\201 = 0.7";
  _plegctl = {2 5 5 3};
  xy(t,Dt);
 
 