new;
library frm,pgraph,optmum;
frmset;

cls;

proc proc_V0(r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
  local y;
  y = (r0 - i0) .* D_inf ./ (r0 + beta) + (r0 - i0) .* (D0 - D_inf) ./ (r0 + beta + gamma_) +
      delta .* ((r0 - i0)^2) ./ (r0 + beta + gamma_) ./ (gamma_ - beta) - 
      delta .* ((r0 - i0)^2) ./ (r0 + 2*beta) ./ (gamma_ - beta); 
  retp(y);
endp;

proc proc_S0(r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
  local y;
  y = (i0 + beta) .* D_inf ./ ((r0 + beta)^2) + (i0 + gamma_ + beta) .* (D0 - D_inf) ./ ((r0 + beta + gamma_)^2) +
      delta .* (r0 - i0) .* (r0 + i0 + 2*(gamma_ + beta)) ./ ((r0 + beta + gamma_)^2) ./ (gamma_ - beta) - 
      delta .* (r0 - i0) .* (r0 + i0 + 4 *beta) ./ ((r0 + 2*beta)^2) ./ (gamma_ - beta); 
  retp(y);
endp;

alpha = 0.00;
beta = 0.5;
gamma_ = 0.7;
delta = 0.5;
i0 = 0.05;
D0 = 100;
D_inf = 150;

r0 = seqa(0,0.20/100,101);

V0 = proc_V0(r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
S0 = proc_S0(r0,i0,D0,D_inf,alpha,beta,gamma_,delta);
Duration = - S0./V0;
Duration = missex(Duration,abs(V0) .<= 0.1);

graphset;
  window3u;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4;
  _paxht = 0.225; _pnumht = 0.225; _ptitlht = 0.275;
  xlabel("\216r]0[ (in %)");
  xtics(0,20,5,2);
  
  setwind(1);
    _pcolor = 1;
    title("\216Mark-to-market");
    ytics(-15,30,15,2);
    xy(100*r0,V0);
 
  setwind(2);
    _pcolor = 2;
    title("\216Sensitivity");
    ytics(100,300,50,2);
    xy(100*r0,S0);

  setwind(3);
    _pcolor = 4;
    title("\216Duration");
    ytics(-200,200,100,2);
    xy(100*r0,Duration);

  endwind; 
